//TABLE JavaScript Control
// by k1park(06.12.20)
//------------------------- GENERAL FUNC --------------------------------
//-----------------------------------------------------------------------

function line_compare (a_line, b_line)
{

	var is_asc = _Gtable_info.asc;
	var sort_by = _Gtable_info.sortedBy;
	
	var a_value = null;
	var b_value = null;
	
	if(sort_by==-1)//no로 소팅
	{
		a_value = a_line.serial;
		b_value = b_line.serial;
	}
	else
	{
		var str_a_value = a_line.recordArr[sort_by];
		var str_b_value = b_line.recordArr[sort_by];
		var fld_type = _Gtable_info.typeField[sort_by];
	
		if (fld_type=='I' || fld_type=='i')
		{
			a_value = Number(str_a_value);
			b_value = Number(str_b_value);
		}
		else if (fld_type=='D' || fld_type=='d')
		{
			str_a_value = str_a_value.replace(/,/gi,""); //컴마지우기
			str_b_value = str_b_value.replace(/,/gi,""); //컴마지우기
			a_value = Number(str_a_value);
			b_value = Number(str_b_value);
		}
		else
		{
			a_value = str_a_value;
			b_value = str_b_value;
		}
		
	}

	if(is_asc	== true )
	{
		if(a_value < b_value)
			return 1;
		else if(a_value > b_value)
			return -1;
		else
			return 0;
	}
	else
	{
		if(a_value < b_value)
			return -1;
		else if(a_value > b_value)
			return 1;
		else
			return 0;		
	}
	
}
	
	
function getCellId(row_num, col_num) {
	return row_num + "-" + col_num;
}

function refreshTable() {
	_Gtable_info.CheckCombo();
	_Gtable_info.setHtml('table_output');
}
	
function refreshChkBox(i, obj) {

	var is_checked = 	obj.checked;
	
	var pos = _Gtable_info.GetLinePos(i);
	var line = _Gtable_info.GetLine(pos);
	
	if(is_checked==true)
	{
		line.toggle_on();
		_Gtable_info.quanSelected ++;
	}
	else
	{
		line.toggle_off();
		_Gtable_info.quanSelected --;
	}
}


function clickCheckAll()
{	

	var lo_form = 	_Gtable_info.form;
	var is_checked = 	lo_form.checkAll.checked;
	
	var quanRcd = _Gtable_info.quanRecord;

	for(i=0; i<quanRcd; i++)
	{
		var line = _Gtable_info.recordLine[i];
		if(is_checked==true)
		{
			line.toggle_on();
			_Gtable_info.quanSelected ++;
		}
		else
		{
			line.toggle_off();
			_Gtable_info.quanSelected --;
		}
	}
	
	if(is_checked==true)
		_Gtable_info.setCheckAll();
	else 
		_Gtable_info.setClearAll();


}

//------------------------- COMMAND CLASS --------------------------------
//-----------------------------------------------------------------------
var TableCmdObj = Class.create();
TableCmdObj.prototype = {

	initialize: function(label, fc, args) {
		this.lavel = label;
		this.fc = fc;
		this.args = args;
		this.disabled = false;
	},
	
	getHtml: function() {

		var cmd_line = '<a href=\'javascript:';
		
		
		cmd_line = cmd_line + this.fc + '(';


		for(i=0; i< this.args.length; i++)
		{
			var arg_val = this.args[i];
			var arg_type = typeof(arg_val);
			if(i!=0)
			{
				cmd_line = cmd_line + ', ';
			}
		
			if(arg_type=='string')
			{
				if(arg_val == '#THIS')
				{
					cmd_line = cmd_line + 'this';
				}
				else
				{
					cmd_line = cmd_line + '"' + arg_val + '"';
				}
			}
			else
			{
				cmd_line = cmd_line + arg_val;
			}

		}

		cmd_line = cmd_line + ' );\'>[' + this.lavel + ']</a>';

		return cmd_line;
	}
}

//------------------------- TABLE CLASS ---------------------------------
//-----------------------------------------------------------------------
var TableInfo = Class.create();
TableInfo.prototype = {
	initialize: function(  ) {
		this.form = document.GeneralBaseForm1;
		this.quanField = 0;
		this.quanRecord = 0;
		this.quanSelected = 0;
		this.classHead = 'table_title';
		this.nameField = [];
		this.typeField = [];			//S:String, I:Integer, D:Double
		this.sumField  = [];
		this.subSumField  = [];
		this.recordLine = [];
		this.checkedUids = [];
		this.hasChkBoxAll = true;
		this.inputName = 'checkAll';
		this.sortedBy = -1;
		this.asc	  = false;
		this.hasCmd		= true;
		this.checkBoxFc = 'javascript:clickCheckAll();';
		this.TDE = '</td>';
	},
	
	checkTableSum: function() {
		for(k=0; k<this.quanField; k++)
		{
			var fld_type = this.typeField[k];
			if (fld_type=='D' || fld_type=='d')
			{
				this.checkFieldSum(k);
			}
		}
	},
	
	checkFieldSum: function(field_id) {
		var sum = 0.0;
		for(i=0; i<this.quanRecord; i++)
		{
			var strVal = this.recordLine[i].getValue(field_id);
			strVal = strVal.replace(/,/gi,""); //컴마지우기
			var dblVal = Number(strVal);
			sum = sum + dblVal;
		}
		this.sumField[field_id] = sum;
	},
	
	//배열일때 와 배열이 아닐때
	chkObj: function(name , i){
		var objID   = this.form.elements[name];
		return (objID.length > 0 ? objID[i] : objID);
	},
	
	isChecked: function(row_num) {
		if(this.chkObj("chkBox",row_num).checked)
		{
			return true;
		}
		
		return false;
	},
	
	setCheckAll: function() {
	
		this.checkedUids.clear();

		for(i=0; i<this.quanRecord; i++)
		{
			this.checkedUids.push(this.unique_id);
			var obj = this.chkObj("chkBox",i);
			obj.checked = true;
		}
		
	},
	
	setClearAll: function() {
	
		this.checkedUids.clear();

		for(i=0; i<this.quanRecord; i++)
		{
			var obj = this.chkObj("chkBox",i);
			obj.checked = false;
		}
		
	},
	
	isCheckedValue: function(row_num) {
		var obj = this.chkObj("chkBox",row_num);
		if(obj.checked)
		{
			return obj.value;
		}
		
		return null;
	},
	
	isCheckedUid: function(unique_id) {
		for(l=0; l< this.checkedUids.length; l++)
		{
			if(this.checkedUids[l]==unique_id)
				return true;
		}
		
		return false;
	},
	
	RefreshColor: function() {

		if( this.sortedBy != -1)
		{
			var h_id = 'H' + this.sortedBy;
			var back_color = '#CCFFCC';
				
			if(this.asc == false)
				back_color = '#FFFFCC';
					
			$(h_id).style.background = back_color;
		}
		
		for(i=0; i<this.quanRecord; i++)
		{
			var record = this.recordLine[i];
			var uid = record.unique_id;

			if( this.isCheckedUid(uid) == true )
			{
				back_color = '#FFCCCC';
				record.refreshMe(i, this.quanField, back_color);
			}
			
		}


	},
	
	CheckCombo: function() {

		this.checkedUids.clear();

		for(i=0; i<this.quanRecord; i++)
		{
			var uid = this.isCheckedValue(i);
			if( uid != null)
			{
				this.checkedUids.push(uid);
			}
		}
	},

	ReSetSerial: function() {
	
		for(var i=0; i<this.quanRecord; i++)
		{
			var line = this.recordLine[i];
			line.serial = i;
		}
			
	},
	
	Sort: function(by) {

		if(this.sortedBy != by)//새로찍으면
		{
			this.asc = false;
		}
		else//원래 찍은 것 찍으면
		{
			if(this.asc == false)
				this.asc = true;
			else
				this.asc = false;
		}
		this.sortedBy = by;
		
		this.recordLine.sort( line_compare );
		
		//serial 재셋팅
		//this.ReSetSerial();

		//check combo box
		this.CheckCombo();
		
		this.setHtml('table_output');
		
	},
	
	GetLine: function(serial)
	{
		for(i=0; i< this.quanRecord; i++)
		{
			var line = this.recordLine[i];
			if(line.serial == serial)
			{
				return line;
			}
		}
		
		return null;
	},
	
	GetLinePos: function(serial)
	{	
		for(j=0; j< this.quanRecord; j++)
		{
			var line = this.recordLine[j];
			if(line.serial == serial)
			{
				return j;
			}
		}
		return -1;
	},
	
	TDS_T: function(col_num)
	{
		var id = 'H' + col_num;
		return ( '<td id=' + id + ' class=' + this.classHead + '>');
	},
	
	CHKBOX_T: function()
	{
		var type = 'checkbox';
		if(this.hasChkBoxAll ==false)
		{
			type = 'hidden';
		}
		
		var retStr = this.TDS_T('C')
		+  '<p title=\'unique_id\'>'
		+
		'<a href=\'javascript:_Gtable_info.Sort(-1);\'>' + 'sn' + '</a>' +
		 '<input type=' + type + ' name=' + this.inputName +
		 ' onclick=\'' + this.checkBoxFc + '\'>'
		+ '</p>'
	
		return retStr;
	},
		
	setHtml: function(target)
	{	
		DWRUtil.setValue(target , this.getFullHtml());
		this.RefreshColor();
	},
	addField: function(name)
	{
		var fld_key = name.split(':');
		if(fld_key.length==1)
		{
			this.nameField.push(name);
			this.typeField.push('S');
		}
		else
		{
			this.nameField.push(fld_key[1]);
			this.typeField.push(fld_key[0]);
		}
		
		this.sumField.push(0.0);
		this.subSumField.push(0.0);
		
		this.quanField++;
	},
	
	addLine: function(line)
	{
		line.parent = this;
		this.recordLine.push(line);
		this.quanRecord++;
	},
	
	getFullHtml: function() {
	
		var strHtml = '<table width=990 border=1 cellpadding=0 cellspacing=0 bordercolor=#CCCCCC style=\'border-collapse:collapse\'><tr>';
		
		strHtml = strHtml + this.CHKBOX_T();

		for(i=0; i<this.quanField; i++)
		{
			strHtml = strHtml + this.TDS_T(i);
			
			if(this.typeField[i] == 'D' || this.typeField[i] == 'd')
			{
				var strSum = '총합계: ';
				strSum = strSum + addComma(this.sumField[i].toString() );
				
				/*
				if(this.quanSelected > 0)
				{
					strSum = strSum + '\n선택합계:';
					strSum = strSum + addComma(this.subSumField[i].toString() );
				}
				*/
				
				strHtml = strHtml + '<p title=\'' + strSum +'\'>';
				
			}
			
			strHtml = strHtml + '<a href=\'javascript:_Gtable_info.Sort('+ i +');\'>';
			strHtml = strHtml + this.nameField[i] + '</a>';
			
			if(this.typeField[i] == 'D' || this.typeField[i] == 'd')
			{
				strHtml = strHtml + '&nbsp;&nbsp;<label class=\'sigma_token\'>∑</label>';
				strHtml = strHtml + '</p>';
			}
			
			strHtml = strHtml + this.TDE;
		}
		if(this.hasCmd == true)
		{
			strHtml = strHtml + this.TDS_T(i) + '<b>명령</b>' + this.TDE;
		}
		
		for(var i=0; i<this.quanRecord; i++)
		{
			var line = this.recordLine[i];
			var checked = this.isCheckedUid(line.unique_id);
			
			if(checked==false)//체크되지 않았으면
			{
				var class_name = 'table_body_line1';
				var background = '#FFFFFF';
				if(i%2==0)
				{
					 class_name = 'table_body_line2';
					 background = '#EEEEEE';
				}
				line.background = background;
				line.classLine  = class_name;
			}
			
			strHtml = strHtml + line.getHtml(i, true, this.quanField, checked);
		}
		strHtml = strHtml + '</tr></table>';
		
		return strHtml;
	}
}


//------------------------- RECORD CLASS --------------------------------
//-----------------------------------------------------------------------


var RecordLine = Class.create();
RecordLine.prototype = {
	initialize: function( serial, unique_id, td_class, background, rcdArr, cmd_objs ) {
		this.serial = serial;
		this.unique_id = unique_id;
		this.classLine = td_class;
		this.background = background;
		this.original = background;
		this.highlight = '#FFCCCC';
		this.recordArr = rcdArr;
		this.inputName = 'chkBox';
		this.checkBoxFc = 'javascript:refreshChkBox(' + serial + ', this);';
		this.parent = null;
		this.is_clicked = false;
		this.TDE = '</td>';
		this.cmd_objs = cmd_objs;
	},
	
	getValue: function(i)
	{
		return this.recordArr[i];
	},
	
	Print: function()
	{
		var strRet =
			'this.serial = ' + this.serial	+
			'\nthis.unique_id = ' + this.unique_id	+
			'\nthis.classLine = ' + this.classLine	+
			'\nthis.background = ' + this.background	+
			'\nthis.original = ' + this.original	+
			'\nthis.highlight = ' + this.highlight	+
			'\nthis.inputName = ' + this.inputName	+
			'\nthis.checkBoxFc = ' + this.checkBoxFc	+
			'\nthis.is_clicked = ' + this.is_clicked;
		alert(strRet);
	},
	
	
	toggle_on: function()
	{
		this.background = this.highlight;
		this.is_clicked = true;
		this.redrawLine();
	},

	toggle_off: function()
	{
		this.background = this.original;
		this.is_clicked = false;
		this.redrawLine();
	},
	
	redrawLine: function()
	{
		var c_id = '';
		for(j=0; j< this.parent.quanField; j++)
		{
			c_id = getCellId(this.serial, j);
			$(c_id).style.background = this.background;
		}

		c_id = getCellId(this.serial, 'C');
		$(c_id).style.background = this.background;
		c_id = getCellId(this.serial, 'M');
		$(c_id).style.background = this.background;

		
	},
	
	//사용안함--이유: 오동작발생함
	toggle: function()
	{
		if(this.is_clicked == true)
		{
			this.toggle_off();
			_Gtable_info.quanSelected --;
		}
		else //최초
		{
			this.toggle_on();
			_Gtable_info.quanSelected ++;
		}
	},
	
	refreshMe: function(rcd_num, quanField, selected)
	{
		this.background = selected;
		this.is_clicked = true;
		
		var c_id = '';
		for(j=0; j<quanField; j++)
		{
			c_id = getCellId(rcd_num, j);
			$(c_id).style.background = this.highlight;
		}
		c_id = getCellId(rcd_num, 'C');
		$(c_id).style.background = this.highlight;
		c_id = getCellId(rcd_num, 'M');
		$(c_id).style.background = this.highlight;

	},	
	
	refreshParent: function()
	{
		parent.RefreshColor();
	},
	
	TDS: function(row_num, col_num)
	{
		var id = getCellId(row_num, col_num);
		return ( '<td id=' + id + ' class=' + this.classLine + '>');
	},
	TDCMD: function(row_num, col_num)
	{
		var strLine = this.TDS(row_num, col_num);

		for(m=0; m< this.cmd_objs.length; m++)
		{
			if(m!=0)
			{
				strLine = strLine + '&nbsp;';
			}

			var object = this.cmd_objs[m];	
			strLine = strLine + object.getHtml();

		}

		strLine = strLine + '</td>';
		
		return strLine;
	},
	
	
	CHKBOX: function(row_num, hasChkBox, is_checked)
	{
		var type = 'checkbox';
		if(hasChkBox ==false)
		{
			type = 'hidden';
		}
		
		var _serial = this.serial + 1;
		var serial = '';
		
		if(_serial < 10)
			serial = '0' + _serial;
		else
			serial = serial + _serial;
		
		var retStr = 
			this.TDS(row_num, 'C') 
			+ '<p title=\'' + this.unique_id + '\'>'
			+ serial
			+ '<input type=' + type + ' name=' + this.inputName +
		 	' value =' + this.unique_id;
		if(is_checked==true && hasChkBox==true )
		{
			retStr = retStr + ' checked ';
		}
		
		retStr = retStr + ' onclick=\'' + this.checkBoxFc + '\' ';
		
		retStr = retStr + '>' 
		+ '</p>'
		+  this.TDE;
	
		return retStr;
	},
	
	getHtml: function(row_num, hasChkBox, quan, is_checked) {

		var retStr = '<tr>' + this.CHKBOX(row_num, hasChkBox, is_checked);

		for(var j=0; j < quan; j++)
		{
			retStr = retStr + this.TDS(row_num, j) + this.recordArr[j] + '</td>';
		}
		retStr = retStr + this.TDCMD(row_num, 'M');
		retStr = retStr + '</tr>';
		
		retStr = retStr + '<tr><td height=1 id=' + this.unique_id
		 + ' colspan=' + this.parent.quanField+2 + '></td></tr>';

		return retStr;
	}
}

var _Gtable_info;

