function Vector(array) {
    
    this.elementData = (array != null) ? array : new Array();

 

    this.add = function(index, obj) {
        if (index <= this.elementData.length && index >= 0) {
            this.elementData.splice(index, 0, obj);
        } else {
            throw new Exception("Array Index Error. vector.add"); 
        }
    }
    
    this.addElement = function(obj) {
        this.elementData.splice(this.elementData.length, 0, obj);
    }
    
    this.remove = function(index) {
        if (index < this.elementData.length && index >= 0) {
            this.elementData.splice(index, 1);
        } else {
            throw new Exception("Array Index Error. vector.remove()"); 
        }
    }
    
    this.removeElement = function(obj) {
        var index = this.indexOf(obj);
        if (index >= 0) {
            this.remove(index);
        }
    }
    
    this.get = function(index) {
        if (index < this.elementData.length && index >= 0) {
            return this.elementData[index];
        } else {
            throw new Exception("Array Index Error. vector.elementAt()"); 
        }
    }
    
    this.set = function(index, obj) {
        this.add(index, obj);
    }
    
    this.elementAt = function(index) {
        return this.get(index);
    }


    this.clear = function() {
        this.elementData.splice(0, this.elementData.length);
    }

 

    this.size = function() {
        return this.elementData.length;
    }

 

    this.isEmpty = function() {
        return (this.size() == 0);
    }

 

    this.contains = function(obj) {
        return (this.indexOf(obj) >= 0)
    }


    this.indexOf = function(obj, startIndex) {
        if (startIndex == null) {
            startIndex = 0;
        }
        
        if (startIndex < this.elementData.length && startIndex >= 0) {
            for (var i=startIndex; i < this.elementData.length; i++) {
                if (this.elementData[i] == obj) {
                    return i;
                }
            }
            return -1;
        } else {
            throw new Exception("Array Index Error. vector.indexOf()");
        }
    }

 

    this.toString = function() {
        return this.elementData.join(",");
    }
}

