package com.rfxsoft.justrfx;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import java.net.URLEncoder;

public class DownloadUtil {

  private static final String CONSTANT = "application/octet-stream;"; //$NON-NLS-1$

/** ٿε  ũ */
  private static final int BUFFER_SIZE = 8192; // 8kb

  /**  ڵ */
  private static final String CHARSET = "UTF-8";

  /**
   *  - ü  Ұ
   */
  private DownloadUtil() {
    // do nothing;
  }

  /**
   *   ٿε Ѵ.
   * Ķ : request, response, ϸ, ü, Ȯ
   * 
   */
  public static boolean download(HttpServletRequest request, HttpServletResponse response, String fileName, String filePath, String fileType)
      throws ServletException, IOException {
	 
	String files = null;
	if(fileType != null){ //Ȯڰ   ٿش.
		files = filePath+fileType;
	}else{					// üθ .
		files = filePath;
	}
	//System.out.println(files);
	
    File file = new File(files);
    String mimetype = request.getSession().getServletContext().getMimeType(file.getName());
    
    if (file == null || !file.exists() || file.length() <= 0 || file.isDirectory()) {
      //throw new IOException(" ü Null Ȥ  ʰų ̰ 0, Ȥ  ƴ 丮̴.");
      return false;
    }

    InputStream is = null;
    try {
      is = new FileInputStream(file);
      download(request, response, is, fileName, file.length(), mimetype);
    } finally {
      try {
        is.close();
      } catch (Exception ex) {
      }
    }
    return true;
  }

  /**
   * ش Է Ʈκ  ͸ ٿε Ѵ.
   * 
   * @param request
   * @param response
   * @param is
   *            Է Ʈ
   * @param filename
   *             ̸
   * @param filesize
   *             ũ
   * @param mimetype
   *            MIME Ÿ 
   * @throws ServletException
   * @throws IOException
   */
  public static void download(HttpServletRequest request, HttpServletResponse response, InputStream is,
      String fileName, long filesize, String mimetype) throws ServletException, IOException {
    String mime = mimetype;

    if (mimetype == null || mimetype.length() == 0) {
      mime = CONSTANT;
    }
    

    byte[] buffer = new byte[BUFFER_SIZE];

    response.setContentType(mime);
    
    //String filename = new String(fileName.getBytes("ISO8859-1"),"UTF-8");
    String filename = fileName;
    

    /*
    //System.out.println(URLEncoder.encode(filename, "EUC-KR"));
    //System.out.println(URLEncoder.encode(filename, "8859_1"));
    //System.out.println(URLEncoder.encode(filename, "KSC5601"));
    */
 
    // Ʒ κп euc-kr  utf-8  ٲٰų URLEncoding ϰų  ׽Ʈ
    // ؼ ѱ  ٿε Ǵ  Ѵ.
    String userAgent = request.getHeader("User-Agent");
    
    if (userAgent.indexOf("MSIE 5.5") > -1) { // MS IE 5.5 
        response.setHeader("Content-Disposition", "filename=" + URLEncoder.encode(filename, "UTF-8") + ";");
      } else if (userAgent.indexOf("MSIE") > -1) { // MS IE ( 6.x ̻ )
    	  //System.out.println("browser");
        response.setHeader("Content-Disposition", "attachment; filename="
            + URLEncoder.encode(filename, "UTF-8") + ";");
      } else { //  
        response.setHeader("Content-Disposition", "attachment; filename="
            + new String(filename.getBytes(CHARSET), "latin1") + ";");
      }

    
    //   Ȯ  ƿ  ʴ´.
    if (filesize > 0) {
      response.setHeader("Content-Length", "" + filesize);
    }
    
    BufferedInputStream fin = null;
    BufferedOutputStream outs = null;
    
    try {
      fin = new BufferedInputStream(is);
      outs = new BufferedOutputStream(response.getOutputStream());
      int read = 0;

      while ((read = fin.read(buffer)) != -1) {
        outs.write(buffer, 0, read);
      }
    } finally {
      try {
        outs.close();
      } catch (Exception ex1) {
      }

      try {
        fin.close();
      } catch (Exception ex2) {

      }
    } // end of try/catch
  }
}

 

 


