package com.rfxsoft.justrfx.business.a_rfml;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.BeanCreationException;
import org.springframework.beans.factory.InitializingBean;

import com.rfxsoft.justrfx.domain.RfqAst;
import com.rfxsoft.justrfx.domain.RfqMap;
import com.rfxsoft.justrfx.domain.RtgAst;

public class DefaultRfmlManager extends AbstractDaoBasedRfmlManager implements
		InitializingBean {

	public void afterPropertiesSet() throws Exception {
		if (srcahdDao == null)	throw new BeanCreationException("Must set srcahdDao on DefaultRfmlManager");
		if (assymapDao == null)	throw new BeanCreationException("Must set assymapDao on DefaultRfmlManager");
		if (tableInfoDao == null)	throw new BeanCreationException("Must set tableInfoDao on DefaultRfmlManager");
		if (rtgastDao == null)	throw new BeanCreationException("Must set rtgastDao on DefaultRfmlManager");
		if (sysinfoDao == null) throw new BeanCreationException("Must set sysinfoDao on DefaultRfmlManager");
		if (rfqastDao == null) throw new BeanCreationException("Must set rfqastDao on DefaultRfmlManager");

	}

	public void addOfficialMail() {
		// TODO Auto-generated method stub

	}

	public List addRegisteredDocu() {
		// TODO Auto-generated method stub
		return null;
	}
	

	public Integer addRequest(String creator, String name, String content, Integer item_quan,
				String item_abst, Date aprv_date, Date req_date, String wa_code, Integer work_quan, Integer po_user_uid) {
		//rtgast 
		//assymap rf_uid rtgast unique_id 
		// Ͽ rfqst insert
		
		String rtg_type ="Q";
		Integer last_no = this.getSysinfoDao().GetLastUnChecked(rtg_type);

		RtgAst rtgast = new RtgAst(rtg_type, last_no);
		rtgast.setCreator(creator);
		rtgast.setName(name);
		rtgast.setContent(content);
		rtgast.setChange_date(rtgast.getCreate_date());
		rtgast.setChanger(rtgast.getCreator());
		rtgast.setState("I");	// û 	
		rtgast.setItem_quan(item_quan);
		rtgast.setItem_abst(item_abst);
		rtgast.setUser_id(creator);		
		rtgast.setAccp_quan(0);//Ȯ ޻
		rtgast.setDeni_quan(-1);//Reserved
		rtgast.setWork_quan(work_quan);//û ޻ 
		rtgast.setStep_quan(0);// ޻ 
		rtgast.setCoord_key(-1);// ޻
		rtgast.setCoord_key1(-1);//  uid
		rtgast.setRtg_type(rtg_type);
		rtgast.setPo_user_uid(po_user_uid);

		rtgast.setAprv_date(aprv_date);
		rtgast.setReq_date(req_date);
		rtgast.setWa_code(wa_code);
		
		//rtgastDao.insert(creator, rtgast);
		this.baseLineDao.insert(creator, "rtgast-deleted", rtgast);
		
		return rtgast.getUnique_id();

	}
	
	public void sendRfqByAssyMapUniquId(Integer rf_uid, Integer[] assymap_uid_list, Integer item_quan) {

		List<Integer> unique_id_list = new ArrayList<Integer>();
		
		for(int i=0; i< item_quan; i++ )
			unique_id_list.add(assymap_uid_list[i]);
		
		//assymap 
		Map<String, Object> cond = new HashMap<String, Object>();
		cond.put("unique_id_list", unique_id_list);
		cond.put("rf_uid", rf_uid);
		assymapDao.update("sendrfq-assymap-iter", cond);
		
	}
	
	private void makeRfqMap(RfqAst rfqast, Integer supast_quan, Integer[] supast_uid, String[] supast_code, String creator) {
		
		
		for(int i=0; i<supast_quan; i++) {
			RfqMap rfqmap = new RfqMap();
			rfqmap.setSupast_uid(supast_uid[i]);
			rfqmap.setRfq_no(rfqast.getRfq_no());
			rfqmap.setRfqast_uid(rfqast.getUnique_id());
			rfqmap.setCreate_date(new Date());
			rfqmap.setCreator(rfqast.getCreator());
			rfqmap.setChange_date(new Date());
			rfqmap.setChanger(rfqast.getCreator());
			rfqmap.setFrom_date(rfqast.getRfq_create_date());
			rfqmap.setTo_date(rfqast.getRfq_closing_date());
			rfqmap.setItem_code(rfqast.getItem_code());
			rfqmap.setQuan(rfqast.getPredict_qty());
			rfqmap.setSp_code(supast_code[i]);
			rfqmap.setContract_uid(-1);//not null
			
			this.getBaseLineDao().insert(creator, "rfqmap", rfqmap);
		}
	}
	
	
	public boolean doRfqListInsert(String creator, Integer[] assy_uids, int item_quan, Double predict_qty[], Double target_price[], Integer supast_quan, Integer[] supast_uid,
			String[] 	supast_code) {
		
		for(int i=0; i<item_quan; i++) {
			RfqAst rfqast = (RfqAst)rfqastDao.select_uid("rfqast-assymap",	assy_uids[i]);
			rfqast.setCreate_date(new Date());
			rfqast.setCreator(creator);
			rfqast.setPredict_qty(predict_qty[i]);
			rfqast.setRfq_price(target_price[i]);
			
			rfqastDao.insert(creator, rfqast);
			
			makeRfqMap( rfqast, supast_quan, supast_uid, supast_code, creator);

		}
		
		return true;
	}

	public void addRfq() {
		// TODO Auto-generated method stub

	}

	public void addTaxSheet() {
		// TODO Auto-generated method stub

	}

	public List getPendedBox() {
		// TODO Auto-generated method stub
		return null;
	}

	public List getSendedOfficialMail() {
		// TODO Auto-generated method stub
		return null;
	}

	public List getSendedRequest(int user_uid) {
		Map<String, Comparable> condition = new HashMap<String, Comparable>();
		condition.put("po_user_uid", user_uid);
		condition.put("rtg_type", "Q");
		return rtgastDao.select_cond("rtgast", condition);
	}

	public List getSendedRfq() {
		// TODO Auto-generated method stub
		return null;
	}

	public List getTemporaryBox() {
		// TODO Auto-generated method stub
		return null;
	}

	public Integer checkRoutingState(Integer rtgast_uid) {
		Integer last_no = this.getSysinfoDao().GetLastUnChecked("Q");
		this.getSysinfoDao().SetLastValue("Q", last_no);
		return this.rtgastDao.recover(rtgast_uid);
	}

}
