package com.rfxsoft.justrfx.business.b_rtng;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import org.springframework.beans.factory.BeanCreationException;
import org.springframework.beans.factory.InitializingBean;

import com.rfxsoft.justrfx.RtgType;
import com.rfxsoft.justrfx.domain.Routing;
import com.rfxsoft.justrfx.domain.RtgAst;
import com.rfxsoft.justrfx.domain.RtgWrk;
import com.rfxsoft.justrfx.domain.UsrAst;
import com.rfxsoft.justrfx.domain.SrcCst;
import com.rfxsoft.justrfx.domain.XpoBhd;

public class DefaultRtngManager extends AbstractDaoBasedRtngManager implements
		InitializingBean {
	
	public void afterPropertiesSet() throws Exception {		
		if (rtgastDao == null) throw new BeanCreationException("Must set rtgastDao on DefaultRtngManager");
		if (rtgwrkDao == null) throw new BeanCreationException("Must set rtgwrkDao on DefaultRtngManager");
		if (rtgappDao == null) throw new BeanCreationException("Must set rtgappDao on DefaultRtngManager");
		if (sysinfoDao == null) throw new BeanCreationException("Must set sysinfoDao on DefaultRtngManager");
		
	}

	//selectuid
    public RtgAst getselectuid(String table,int unique_id)
    {
    	return (RtgAst)rtgastDao.select_uid(table,unique_id);
    }

    public RtgAst getRtgAstById(int unique_id) {
    	return (RtgAst)this.baseLineDao.select_uid("rtgast", unique_id);
    }
    
    public XpoBhd getXpoBhdById(int unique_id) {
    	return (XpoBhd)this.baseLineDao.select_uid("xpobhd", unique_id);
    }
    
    public Routing getRoutingById(int unique_id) {
    	return (Routing)this.baseLineDao.select_uid("routing", unique_id);
    }
    
	// rtgapp α  شǴ   о´.
	public List getMyApprvList(String user_id) {

		List apvrs = new Vector();

		apvrs = rtgappDao.getByUserId(user_id);
		
		return apvrs;
	}
	
	// rtgwrk    о´.
	public List getRtgWrkApprvList(int routing_id) {

		List apvrs = new Vector();

		apvrs = rtgwrkDao.getByRoutId(routing_id);
		
		return apvrs;
	}
	
	// prڰ ſû
	/*
	public int pr_addRouting(int item_quan, String item_abst, int user_uid, int po_user_uid) {
		int int_unique_id = -1;
		int tmp = 0;
		
		UsrAst usrast = (UsrAst)this.baseLineDao.select_uid("usrast", user_uid );
		
		RtgAst rtgast = new RtgAst("R");
		
		rtgast.setPo_user_uid(po_user_uid);
		rtgast.setCreator(usrast.getUser_id());
		rtgast.setName( usrast.getUser_name() + "   ſû");
		rtgast.setContent(usrast.getUser_name() + " Բ ſûϼ̽ϴ.");
		rtgast.setChange_date(rtgast.getCreate_date());
		rtgast.setChanger(rtgast.getCreator());
		rtgast.setState("I");
		rtgast.setUser_id(usrast.getUser_id());
		rtgast.setUser_name(usrast.getUser_name());
		rtgast.setItem_quan(new Integer(item_quan));
		rtgast.setWork_quan(0);
		rtgast.setAccp_quan(0);
		rtgast.setDeni_quan(0);
		rtgast.setRtg_type("R");
		rtgast.setPo_type("MN");
		rtgast.setWa_code(usrast.getWa_code());
		tmp = item_quan - 1;
		
		if (tmp > 0) {
			rtgast.setItem_abst(item_abst+" "+tmp+"");
		}else{
			rtgast.setItem_abst(item_abst);
		}		
		
		rtgastDao.insert(usrast.getUser_id(), rtgast);
		
		int_unique_id = rtgast.getUnique_id();
		
		return int_unique_id;
	}
	*/
	// RtgAst (addRouting) RtgWrk 
	public boolean addRouting(String creator, RtgAst rtgast, int user_uid, int po_user_uid) {	
		// ̸ ãƼ  Ѵ.
		UsrAst usrast = (UsrAst)this.baseLineDao.select_uid("usrast", user_uid );
		
		rtgast.setUser_name(usrast.getUser_name());
		rtgast.setWa_code(usrast.getWa_code());
		rtgast.setPo_user_uid(po_user_uid);		
		
		if (rtgastDao.insert(creator, rtgast) != null) {
			return true;
		}else{
			return false;
		}
	}
	
	
	
	
	public boolean modifyRouting(String creator, RtgAst rtgast, int user_uid, int po_user_uid) {
		// ̸ ãƼ  Ѵ.
		UsrAst usrast = (UsrAst)this.baseLineDao.select_uid("usrast", user_uid );
		
		rtgast.setUser_name(usrast.getUser_name());
		rtgast.setWa_code(usrast.getWa_code());
		rtgast.setPo_user_uid(po_user_uid);
		rtgast.setChanger(creator);
		rtgast.setCreator(creator);
		rtgast.setChange_date(new Date());
		rtgast.setCreate_date(new Date());
		
		if (rtgastDao.update("rtgast-deleted2live", rtgast) != null) {
			return true;
		}else{
			return false;
		}
	}
	
	
	

	public boolean addRtgwrk(String creator, RtgWrk rtgwrk) {
		if (rtgwrkDao.insert(creator, rtgwrk) != null) {
			return true;
		}else{
			return false;
		}
	}
	
	public void addPurchaseInternalRequest() {
		// TODO Auto-generated method stub

	}

	// , ̰, Կ 
	public List getRoutingBoxCheck(List rtgast_list, String gubun) {
		ArrayList<Routing> G_or_P_list = new ArrayList<Routing>();
		
		if ("S".equals( gubun )) { // Կ 
			for(Iterator i=rtgast_list.iterator(); i.hasNext();) {
				Routing routing = (Routing)i.next();
				
				String state    = routing.getState();
//				String trg_type = routing.getRtg_type();
				
				if (state != null && state.compareToIgnoreCase("P") != 0 /*&& state.compareToIgnoreCase("S") != 0*/) {
						G_or_P_list.add(routing);
				}	
			}
		}else{
			for(Iterator i=rtgast_list.iterator(); i.hasNext();) {
				Routing routing = (Routing)i.next();
				
				String state = routing.getState();
//				String trg_type = routing.getRtg_type();
				
				if (state != null && state.compareToIgnoreCase("P") != 0 /*&& state.compareToIgnoreCase("S") != 0*/ && state.compareToIgnoreCase("F") != 0) {
						G_or_P_list.add(routing);
				}	
			}
		}
		
		return G_or_P_list;
	}
	
	// 
	public List getSendedRoutingBox(Map condition) {
		List rtgast_list = rtgastDao.select_cond("routing", condition);
		
		
		ArrayList<Routing> rtgast_filtered = new ArrayList<Routing>();
		

		for(Iterator i=rtgast_list.iterator(); i.hasNext();) {
			Routing routing = (Routing)i.next();
			
			String state    = routing.getState();
			
			if (state != null && state.compareToIgnoreCase("P")!=0) {
				rtgast_filtered.add(routing);
			}	
		}
		
		return rtgast_filtered;
	}
	
	// (rtgwrk ڸ   )
	public void delSendedRoutingBox(int routing_id) {
		rtgwrkDao.delete_routing_id(routing_id);
	}
	
	// (rtgast  (F))
	public void changeSendedRoutingState(Map condition) {
		rtgastDao.ChangeStateIter(condition);
	}	
	
	//PR Ÿ 縸...
	
	private List getSendedRoutingBoxOnly(String user_id, String type) {
		Map<String, String> condition = new HashMap<String, String>();
		condition.put("user_id", user_id);
		
		List rtgast_list = rtgastDao.getDynamic(condition);
		ArrayList<RtgAst> onlypr_list = new ArrayList<RtgAst>();

		for(Iterator i=rtgast_list.iterator(); i.hasNext();) {
			RtgAst rtgast = (RtgAst)i.next();
			
			String rtg_type = rtgast.getRtg_type();
			String state    = rtgast.getState();
			
			if( rtg_type!=null && rtg_type.compareToIgnoreCase( type ) == 0 ) {
				if (state != null && state.compareToIgnoreCase("P") != 0/* && state.compareToIgnoreCase("S") != 0*/) {
					onlypr_list.add(rtgast);
				}				
			}
		}
		
		return onlypr_list;
	}
	
	public List getSendedRoutingBoxOnlyPR(String user_id) {
		
		return getSendedRoutingBoxOnly(user_id, "R");
	}
	
	public List getSendedRoutingBoxOnlyPO(String user_id) {

		return getSendedRoutingBoxOnly(user_id, "O");
	}

	// 
	public List getReservedRoutingBox(Map condition) {
		return rtgastDao.getDynamic(condition);
	}


	//	 ̰
	public List getNotconcludedBox(int user_uid){
		Map<String, Comparable> condition = new HashMap<String, Comparable>();
		condition.put("owner", user_uid);
		//condition.put("result", "P");
		condition.put("state", "I");
		return rtgastDao.select_cond("routing-in-mytray", condition);
	}

	/*
	// ̰
	public List getNotconcludedBox(Map condition) {
		List rtgast_list = rtgastDao.select_cond("routing", condition);
		
		List routing_list = this.getRoutingBoxCheck(rtgast_list, "N");
		ArrayList G_or_P_list = new ArrayList();
		
		for(Iterator i=routing_list.iterator(); i.hasNext();) {
			Routing routing = (Routing)i.next();
			
			String result = routing.getResult();
			String role   = routing.getRole();
			int    routing_id = routing.getRouting_id();
			int    serial     = routing.getSerial();
			
			if (role != null && (role.compareToIgnoreCase("W") != 0 && role.compareToIgnoreCase("I") != 0)) {
				int chk = getNotconcludedCheck(routing_id, serial);
				
				if (chk == 0) {
					G_or_P_list.add(routing);
				}
			}
		}
		
		return G_or_P_list;
	}
	*/
	// 
	public List getConcludedBox(int user_uid){
		
		Map<String, Comparable> condition = new HashMap<String, Comparable>();
		condition.put("owner", user_uid);
		condition.put("rtgwrk_delete_flag", "N");
		List routing_list =  rtgastDao.select_cond("routing", condition);
		
		ArrayList<Routing> concluded_list = new ArrayList<Routing>();

		for(Iterator i=routing_list.iterator(); i.hasNext();) {
			Routing routing = (Routing)i.next();
			
			String result = routing.getResult();
			String state  = routing.getState();
			
			if( result!=null
					&&	result.compareToIgnoreCase("P") != 0
//					&&	result.compareToIgnoreCase("I") != 0
			)
				concluded_list.add(routing);
			
			
//			)//ۼ̾ƴϰ
//				if( 	state.compareToIgnoreCase("A") == 0 //
//					|| 	state.compareToIgnoreCase("F") == 0 //
//					/*&&	state!=null && state.compareToIgnoreCase("I") != 0*/	)
//			{
//				concluded_list.add(routing);
//			}
		}

		return concluded_list;
	}

	public int getNotconcludedCheck(int routing_id, int serial) {
		List rtgwrk_list = rtgwrkDao.getByRoutId(routing_id);
		int cnt = 1;
		int chk = 0;
		
		for(Iterator i=rtgwrk_list.iterator(); i.hasNext();) {
			RtgWrk rtgwrk = (RtgWrk)i.next();
			
			if (cnt < serial) {
				if (rtgwrk.getResult().equals("P")) {
					chk = 1;
				}
			}
			
			cnt += 1;
		}
		
		return chk;
	}
	
	// 
	public List getConcludedBox(Map condition) {
		
		List rtgast_list = rtgastDao.select_cond("routing", condition);
		
		List routing_list = this.getRoutingBoxCheck(rtgast_list, "C");
		ArrayList<Routing> G_or_P_list = new ArrayList<Routing>();
		
		for(Iterator i=routing_list.iterator(); i.hasNext();) {
			Routing routing = (Routing)i.next();
			
			String result = routing.getResult();
			String role   = routing.getRole();
			
			if (role != null && (role.compareToIgnoreCase("W") != 0 && role.compareToIgnoreCase("I") != 0)) {
				if (result != null && result.compareToIgnoreCase("P") != 0) {
					G_or_P_list.add(routing);
				}
			}
		}
		
		return G_or_P_list;
	}
	
	// 뺸
	public List getTongboBox(Map condition) {
		List rtgast_list = rtgastDao.select_cond("routing", condition);
		
		ArrayList<Routing> G_or_P_list = new ArrayList<Routing>();
		
		for(Iterator i=rtgast_list.iterator(); i.hasNext();) {
			Routing routing = (Routing)i.next();
			
//			String state = routing.getState();
			String trg_type = routing.getRtg_type();
			
			if (trg_type != null && trg_type.compareToIgnoreCase("R") != 0) {
				G_or_P_list.add(routing);
			}
		}
		
		return G_or_P_list;

	}

	
	// ŵ 뺸
	public List getSendDetailView(Map condition) {
		return rtgastDao.select_cond("routing", condition);
	}
	
	@SuppressWarnings("unchecked")
	public List getSendDetailView(int rtgast_unique_id) {
		
		Map cond = new HashMap();
		cond.put("routing_id", rtgast_unique_id);
		cond.put("rtgwrk_delete_flag", "N");
		
		return getSendDetailView(cond);
	}

	
	public int getWorkCursor(int rtgast_uid, int step_cursor) {

		List rtgwrk_list = rtgwrkDao.getByRoutId(rtgast_uid);
		if(rtgwrk_list==null)
			return -1;
		
		if(step_cursor>rtgwrk_list.size())
			return -1;
		RtgWrk rtgwork = (RtgWrk)rtgwrk_list.get(step_cursor);
		return rtgwork.getUnique_id();
	}
	
	//
	// -1: 
	//  1:  
	//  0:   ƴ.
	public int isLastChecker(int rtgast_uid) {
		
		RtgAst rtgast = getRtgAstById(rtgast_uid);
		if(rtgast==null)
			return -1;
		
		int work_quan = rtgast.getWork_quan();
		int step_quan = rtgast.getStep_quan();
		step_quan++;
		
		if(work_quan==step_quan)
			return 1;
		else
			return 0;
		
	}
	//
	public boolean doApprove(int rtgast_uid, String comment, boolean wrkType,
			String aprv_user_id, String aprv_name, Date aprv_date) {
		
		RtgAst rtgast = getRtgAstById(rtgast_uid);
		if(rtgast==null)
			return false;
		
     	String result="";
     	if(wrkType==true)
     		result = "Y";
     	else
     		result = "N";
		
     	//RtgWork ݿ
		Map<String, Comparable> condition = new HashMap<String, Comparable>();
		condition.put("submit_date", new Date());
		condition.put("comment", comment);
		condition.put("result", result);
		condition.put("unique_id", rtgast.getWork_cursor());
		rtgwrkDao.update("result-rtgwrk", condition);
		
		int work_quan = rtgast.getWork_quan();
		int step_quan = rtgast.getStep_quan();
		
		step_quan++;
		rtgast.setStep_quan(step_quan);
		
		if(wrkType==false) {//ݷ̸
			rtgast.setState("D");
			rtgast.setWork_cursor(-1);
		}
		else {//̸
			
			if(work_quan==step_quan) {//̸- 
				rtgast.setState("A");
				rtgast.setWork_cursor(-1);
				rtgast.setAprv_user_id(aprv_user_id);
				rtgast.setAprv_name(aprv_name);
				rtgast.setAprv_date(aprv_date);
				rtgastDao.update(rtgast);
				
				//ڸ RtgAst Ʈ
				return true;
			}
			else
			{
				int cursor = getWorkCursor(rtgast_uid, step_quan);
				rtgast.setWork_cursor(cursor);
			}
		}
		rtgastDao.update(rtgast);
		
		return false;
		
		//"update-result-rtgwrk"
	}

	
	// Կ Ž Ʈ
	public void editRouting(String title,String content,int rtg_unique_id, String rtgast_state){
		Map<String, Comparable> cond = new HashMap<String, Comparable>();
		cond.put("name",title);
		cond.put("content",content);
		cond.put("unique_id",rtg_unique_id);
		cond.put("state",rtgast_state);
		rtgastDao.update("general-routing",cond);
	}

	///뺸Ի
	/*
	public void deleteOrderComplete(String table, String[] po_uid){
		int li_po_uid = -1;
		
		for(int i=0; i<po_uid.length; i++){
			li_po_uid = Integer.parseInt(po_uid[i]);
			baseLineDao.delete(table,li_po_uid);
		}
	}
	*/
	
	public void deleteOrderComplete(String table, Integer[] po_uid){
		for(int i=0; i<po_uid.length; i++){
			baseLineDao.delete(table, po_uid[i]);
		}
	}
	
	public int deleteRtgworkByUnique_id(Integer[] unique_id) {
		int ret_value=0;
		
		for(int i=0; i<unique_id.length; i++){
			ret_value = ret_value+ deleteRtgworkByUnique_id(unique_id[i]);
		}

		return ret_value;
	}
	public int deleteRtgworkByRtgast_id(Integer[] routing_id) {
		int ret_value=0;
		
		for(int i=0; i<routing_id.length; i++){
			ret_value = ret_value+ deleteRtgworkByRtgast_id(routing_id[i]);
		}

		return ret_value;
	}
	public int deleteRtgworkByRtgastNRoleisW(Integer[] routing_id) {
		int ret_value=0;
		
		for(int i=0; i<routing_id.length; i++){
			ret_value = ret_value+ deleteRtgworkByRtgastNRoleisW(routing_id[i]);
		}

		return ret_value;
	}
	
	public int deleteRtgworkByUnique_id(Integer unique_id) {
		return baseLineDao.delete("rtgwrk", unique_id);
	}
	public int deleteRtgworkByRtgast_id(Integer routing_id) {
		return baseLineDao.delete("routing-id", routing_id);
	}
	public int deleteRtgworkByRtgastNRoleisW(Integer routing_id) {
		return baseLineDao.delete("routing-id-all", routing_id);
	}
	
	
	
	//( .)
	public void addFileInsert(String user_id, int file_length,String[] file_f_name,Integer[] file_group_code,String[] file_item_code){
		
		for(int i=0; i<file_length; i++){
			SrcCst srcCst = new SrcCst();
			srcCst.setGroup_code(file_group_code[i]);
			srcCst.setItem_code(file_item_code[i]);
			srcCst.setFile_path(file_f_name[i]);
			this.baseLineDao.insert(user_id,"srccst",srcCst);
		}
		
	}
	
	//ϸƮ
	public List getFileList(int file_group_code){
		Map<String, Comparable> srccstMap = new HashMap<String, Comparable>();
		srccstMap.put("group_code",file_group_code);
		return this.baseLineDao.select_cond("srccst",srccstMap);
	}

	//DB Է ʰ ... 
	public RtgAst NewRtgAst(Integer rtgast_uid, String  user_id, String name, String content,
			String state, Integer item_quan, String item_abst, 
			String rtg_type, Integer po_user_uid, Integer coord_key_uid,
			Date aprv_date, Date req_date) {

		Integer last_no = this.getSysinfoDao().GetLastUnChecked(rtg_type);

		RtgAst rtgast = new RtgAst(rtg_type, last_no);

		if( rtgast.getRtg_type_enum() == RtgType.UKN )
			return null;
		
		if(rtgast_uid > 0)
			rtgast.setUnique_id(rtgast_uid);
		
		if(coord_key_uid > 0)
			rtgast.setCoord_key(coord_key_uid);
		else
			rtgast.setCoord_key(0);
		
		rtgast.setCreator(user_id);
		rtgast.setName(name);
		rtgast.setContent(content);
		rtgast.setChange_date(rtgast.getCreate_date());
		rtgast.setChanger(rtgast.getCreator());
		rtgast.setState(state);		
		rtgast.setItem_quan(item_quan);
		rtgast.setItem_abst(item_abst);
		rtgast.setUser_id(user_id);		
		rtgast.setAccp_quan(0);
		rtgast.setDeni_quan(0);
		rtgast.setStep_quan(1);//ܰ 1 Ѵ.
		rtgast.setCoord_key(coord_key_uid);
		rtgast.setRtg_type(rtg_type);
		rtgast.setPo_user_uid(po_user_uid);
		rtgast.setAprv_date(aprv_date);
		rtgast.setReq_date(req_date);
		
		return rtgast;		
	}
	
	//ݷ ÷
	public void editRtgD(){
		
		RtgAst rtgAst = null;
		Map<String, Object> cond = new HashMap<String, Object>();

		List<Integer> unique_id_list = new ArrayList<Integer>();
		
		List list_D = this.baseLineDao.select_all("rtgast-refresh-de");
		
		for(Iterator i=list_D.iterator(); i.hasNext();) {
			
			rtgAst = (RtgAst)i.next();
			System.out.println(rtgAst.getUnique_id());
			unique_id_list.add(rtgAst.getUnique_id());
			
		}
		
		cond.put("state","D");
		cond.put("unique_id_list",unique_id_list);

		if(list_D.size()>0){
			this.baseLineDao.update("state-rtgast-iter",cond);
		}
	}
	
	//ýۻ ÷
	public void editRtgS(){
		
		RtgAst rtgAst = null;
		Map<String, Object> cond = new HashMap<String, Object>();
		
		List list_S = this.baseLineDao.select_all("rtgast-refresh-gr");
		List listPo = null;
		List<Integer> unique_id_list = new ArrayList<Integer>();
		
		for(Iterator i=list_S.iterator(); i.hasNext();) {
			
			rtgAst = (RtgAst)i.next();
			
			cond.put("gr_uid", rtgAst.getUnique_id());
			listPo = this.baseLineDao.select_cond("partline",cond);
			
			if(listPo.size()==0)
				unique_id_list.add(rtgAst.getUnique_id());
			
		}
		
		cond.clear();
		cond.put("rtg_type","S");
		cond.put("unique_id_list",unique_id_list);
		if(list_S.size()>0){
			this.baseLineDao.update("rtgtype-rtgast-iter",cond);	
		}
	}

	public void setWorkCursor(Integer rtgast_uid, Integer work_cursor) {
		rtgastDao.setWorkCursor(rtgast_uid, work_cursor );
	}
}
