package com.rfxsoft.justrfx.business.d_mtrl;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Random;

import org.springframework.beans.factory.BeanCreationException;
import org.springframework.beans.factory.InitializingBean;

import com.rfxsoft.justrfx.domain.AssyLine;
import com.rfxsoft.justrfx.domain.PartLine;
import com.rfxsoft.justrfx.domain.Project;
import com.rfxsoft.justrfx.domain.SrcAhd;
import com.rfxsoft.justrfx.domain.AssyMap;
import com.rfxsoft.justrfx.domain.RtgAst;
import com.rfxsoft.justrfx.domain.SrcMap;

public class DefaultMtrlManager extends AbstractDaoBasedMtrlManager implements
		InitializingBean {
	
	public void afterPropertiesSet() throws Exception {
		if (srcahdDao == null)	throw new BeanCreationException("Must set srcahdDao on DefaultMtrlManager");
		if (assymapDao == null)	throw new BeanCreationException("Must set assymapDao on DefaultMtrlManager");
		if (tableInfoDao == null)	throw new BeanCreationException("Must set tableInfoDao on DefaultMtrlManager");
		if (cartDao == null)	throw new BeanCreationException("Must set cartDao on DefaultMtrlManager");
		if (rtgastDao == null)	throw new BeanCreationException("Must set rtgastDao on DefaultMtrlManager");
		if (srcmapDao == null)	throw new BeanCreationException("Must set srcmapDao on DefaultMtrlManager");
		if (systemInfo == null)	throw new BeanCreationException("Must set SystemInfo on DefaultMtrlManager");
	}

	public int getCountSrcAhd() {
		return this.tableInfoDao.getCountSrcAhd();
	}

	public SrcAhd getMaterialByUnique_id(int unique_id) {
		return srcahdDao.getById(unique_id);
	}
	
	public SrcAhd getMaterialByItem_code(String item_code) {
		Map<String, String> map = new HashMap<String, String>();
		String img_path = systemInfo.getImagePath();

		if(item_code != null && item_code.length()>0)
			map.put("item_code",	item_code);
		
		List list = this.getMtrlDynamic(map);

		for(Iterator i=list.iterator(); i.hasNext();) {
			SrcAhd srcahd = (SrcAhd)i.next();
			if(srcahd.getImage_path()!=null)
				srcahd.setImage_path(img_path+"/"+srcahd.getImage_path());
			else
				srcahd.setImage_path(img_path+"/"+"noimage.gif");
			return srcahd;

		}
		return null;
	}
	
	public List getSelectcond(String tableName, Map condition, int start, int record_quan, String order_by)
	{
		return srcahdDao.getSelectcond(tableName, condition, start, record_quan, order_by);
	}
	
	public int getSrcAhdTatalCnt(Map condition){
		return tableInfoDao.getSrcAhdTatalCnt(condition);
	}
	
	public List getAllMtrl() {
		return srcahdDao.getAll();
	}
	
	public List getAllMtrl(Map limit) {
		return srcahdDao.getAll(limit);
	}

	public List getMtrlDynamic(Map condition) {
		return srcahdDao.getDynamic(condition);
	}

	public void deleteMtrl(String item_code) {
		srcahdDao.delete(item_code);
	}
	
	
	public void deleteMtrl(int unique_id) {
		srcahdDao.delete(unique_id);
	}

	public void addMtrl(String creator, SrcAhd srcahd) {
		srcahdDao.insert(creator, srcahd);

	}
	
	public void insertSrcMap(String creator, SrcMap srcmap)
	{
		srcmapDao.insert(creator, srcmap);
	}

	public void modifyMtrl(SrcAhd srcahd) {
		srcahdDao.update(srcahd);

	}
	
	 public SrcAhd getDetail(String item_code, Integer combst_uid)
    {
		 if(combst_uid==100) { //Master User Group
			 return getMaterialByItem_code( item_code);
		 }
		 
		 
    	Map<String, Comparable> condition = new HashMap<String, Comparable>();
    	condition.put("item_code" ,	    item_code		);
    	condition.put("combst_uid"   ,	combst_uid		);
    	String img_path = systemInfo.getImagePath();
    	List list = srcahdDao.getDetail(condition);
    	
    	for(Iterator i=list.iterator(); i.hasNext();) {
			SrcAhd srcahd = (SrcAhd)i.next();
			if(srcahd.getImage_path()!=null)
				srcahd.setImage_path(img_path+"/"+srcahd.getImage_path());
			else
				srcahd.setImage_path(img_path+"/"+"noimage.gif");
			return srcahd;

		}
    	
    	return null;
    }
     
     public SrcAhd getDetail(String buyer_item_code, String company_code, String wa_code)
        {
            Map<String, Comparable> condition = new HashMap<String, Comparable>();
            condition.put("buyer_item_code", buyer_item_code);
            condition.put("company_code",  company_code);
            condition.put("wa_code", wa_code);
            String img_path = systemInfo.getImagePath();
            List list = srcahdDao.getDetail(condition);
            
            for(Iterator i=list.iterator(); i.hasNext();) {
                SrcAhd srcahd = (SrcAhd)i.next();
                if(srcahd.getImage_path()!=null)
                	srcahd.setImage_path(img_path+"/"+srcahd.getImage_path());
                else
        			srcahd.setImage_path(img_path+"/"+"noimage.gif");
                return srcahd;
            }
            
            return null;
        }
	 
	 public SrcAhd getDetail(Integer item_uid, Integer combst_uid)
	 {
		 if(combst_uid==100) { //Master User Group
			 return getMaterialByUnique_id(item_uid);
		 }
		 
	    	Map<String, Comparable> condition = new HashMap<String, Comparable>();
	    	condition.put("srcahd_uid" ,	    item_uid	);
	    	condition.put("combst_uid"   ,	combst_uid		);
	    	String img_path = systemInfo.getImagePath();
	    	List list = srcahdDao.getDetail(condition);
	    	
	    	for(Iterator i=list.iterator(); i.hasNext();) {
				SrcAhd srcahd = (SrcAhd)i.next();
				if(srcahd.getImage_path()!=null)
					srcahd.setImage_path(img_path+"/"+srcahd.getImage_path());
				else
					srcahd.setImage_path(img_path+"/"+"noimage.gif");
				return srcahd;

			}
	    	
	    	return null;
	 }
	
	 /*--clon   .
	public void removeRelation(int parent_id, int child_id) {	
		assymapDao.delete(parent_id, child_id);
	}
	*/
	
	private void removeRelation(int assy_uid) {	
		assymapDao.delete(assy_uid);
	}
	
	public void removeRelation2Assembly(int assy_uid, int parent_id, int child_id) {
		removeRelation(assy_uid);
		addParentMiMi(parent_id);
		addRefrenceMiMi(child_id);
		
	}
	public void removeRelation2Project(/*int pj_uid, */int assy_uid) {
		//project assy  Ʈ  Ǹ ߰ ؾ.
		removeRelation(assy_uid);
	}


	public void addRelation2Assembly(String creator, int cur_user_uid, int parent, int child, String pl_code, Double quan, String is_new,
			int pj_uid,	String item_code, Double sales_price, Double source_price, int hierachy_level){
		addRelation(creator, cur_user_uid, parent, child, pl_code, quan, is_new, "BM", pj_uid, item_code, sales_price, source_price, hierachy_level);
		addParentPlPl(parent);
		//  Refrence Count  Ų.
		addRefrencePlPl(child);
	}
	
	public void addRelation2Project(String creator, int cur_user_uid, int parent, int child, String pl_code, Double quan,
			String item_code, Double sales_price, Double source_price) {
		addRelation(creator, cur_user_uid, parent, child, pl_code, quan, "Y", "BM", parent, item_code, sales_price, source_price, 1);//Project ѻ "Y"̴.
		//  Refrence Count  Ų.
		addRefrencePlPl(child);
	}
	
	public void addParentPlPl(int parent) {
		
		srcahdDao.setChildQaunPlPl(parent);
		
	}
	public void addRefrencePlPl(int refred) {
		
		srcahdDao.setRefQaunPlPl(refred);
	}
	public void addParentMiMi(int parent) {
		
		srcahdDao.setChildQaunMiMi(parent);
		
	}
	public void addRefrenceMiMi(int refred) {
		
		srcahdDao.setRefQaunMiMi(refred);
	}
	
	private void addRelation(String creator, int cur_user_uid, int parent, int child, String pl_code, Double quan, String is_new, String status, int pj_uid, String item_code,
			Double sales_price, Double source_price, int hierachy_level) {
//		int cur_user_uid	= SessionSecurityManager.getThis_useruid();//α ̵
		AssyMap map = new AssyMap();
		map.setParent(parent);
		map.setChild(child);
		map.setPl_no(pl_code);
		map.setQuan(quan);
		map.setBm_quan(quan);
		map.setPr_quan(quan);
		map.setIs_new(is_new);
		map.setStatus(status);
		map.setPr_user_uid(cur_user_uid);
		map.setPo_user_uid(cur_user_uid);
		map.setAc_uid(pj_uid);//Ʈȣ ȣ .
		map.setItem_code(item_code);
		map.setSales_price(sales_price);
		map.setSource_price(source_price);
		map.setPo_sec(map.getUnique_id());//po_sec unique_id 
		map.setCoord_key1(hierachy_level);
		assymapDao.insert(creator, map);		
	}
	
	/*
	public void addRelation(SrcAhd parent, SrcAhd child){
		addRelation(parent.getUnique_id(), child.getUnique_id(), "UKN", -1, "Y", "BM");
	}
	public void addRelation(Project parent, SrcAhd child) {
		int cur_user_uid	= SessionSecurityManager.getThis_useruid();//α ̵
		
		AssyMap map = new AssyMap();
		map.setParent(parent.getUnique_id());
		map.setChild(child.getUnique_id());
		map.setPr_user_uid(cur_user_uid);
		map.setPo_user_uid(cur_user_uid);		//ֹڴ ó īƮ  ȴ.
		assymapDao.insert(map);
	}
	*/
	
	public List getAssyListByPjUnique(int pj_unique) {
		
		List assymap = assymapDao.getByParent(pj_unique);
		
		List<SrcAhd> assys = new ArrayList<SrcAhd>();

		for(Iterator i=assymap.iterator(); i.hasNext();) {
			AssyMap linker = (AssyMap)i.next();
			SrcAhd part = this.getMaterialByUnique_id(linker.getChild());
			if(part!=null)
				assys.add(part);
		}

		return assys;
	}
	
	public List getPartListByParent(int parent)
	{
		
		List assymaps = assymapDao.getPartListByParent(parent);

		List<PartLine> assys =new ArrayList<PartLine>();
		
		for(Iterator i=assymaps.iterator(); i.hasNext();) {
			PartLine Part = (PartLine)i.next();
			if(Part != null) {
				assys.add(Part);
			}
		}

		return assys;
	}
	
	/**
	 *
	 * hyun-suk oh
	 * method content:
	 * īƮƮ ҷ.
	 
	
	public List getCartList(Map cartMap)
	{
		return this.baseLineDao.select_cond("mycart", cartMap, 0, 100, "create_date desc");
		//return assymapDao.getCartList(cartMap);
	}
	*/
	
	/*
	 *  06.3.17 hyun suk oh
	 *  īƮ 󼼺
	 */
	public List getCartDetail(Integer unique_id)
	{
		return assymapDao.getCartDetail(unique_id);
	}
	//Cart item ϳ ߰
	private void addCart(String cur_user_name, String creator, int cur_user_uid, int child, Integer combst_uid) {
		
		SrcAhd srcahd = getDetail(child, combst_uid);
		
		Double sales_price = srcahd.getSales_price();
		Double source_price = srcahd.getSource_price();
		
		if(sales_price==null)
			sales_price =0.0;
		if(source_price==null)
			source_price=0.0;
		
//		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd");
		Date date = new Date();		
		//int cur_user_uid	= SessionSecurityManager.getThis_useruid();//α ̵
		
  		AssyMap map 	= new AssyMap();
  		map.setChild(child);					//ڵ
  		map.setParent(cur_user_uid);			//īƮ  ó īƮ  parent ȴ.
  		map.setPr_user_uid(cur_user_uid);		// īƮ owner
  		map.setPo_user_uid(cur_user_uid);		//ֹڴ ó īƮ  ȴ.
  		map.setStatus("CR");					//
  		map.setQuan(1.0);							// :: ó 1 .
  		map.setMquan(0.0);						//
  		map.setAc_uid(0);						//ac_uid 0̸ īũ ȴ.
  		map.setRcvr_uid(cur_user_uid);
  		map.setRcvr_name(cur_user_name);
  		map.setReq_date(date);
  		map.setSales_price(sales_price);
  		map.setSource_price(source_price);
		assymapDao.insert(creator, map);	
	}
	
	//BOM īƮ ̵
	@SuppressWarnings("unused")
	private void Bom2Cart(int user_uid, int assymap_unique_id) {
		
		Map<String, Integer> cond = new HashMap<String, Integer>();

		cond.put("user_uid", user_uid);	//û
		//where
		cond.put("unique_id", assymap_unique_id );

		assymapDao.update("bm2cr-assymap", cond);
	}
	
	public void deleteCart(int child, int owner) {
		assymapDao.deleteByChild(child, owner);
	}
	
	//īƮ 
	public void deleteCart(List item_uid_list, int owner) {
		List my_cart_list = getCartList(owner);
		
		for(Iterator i=item_uid_list.iterator(); i.hasNext();) {
			int candidate = (Integer)i.next();
			if(isAleadySelected(my_cart_list, candidate) == true)
				deleteCart(candidate, owner);
		}
		
	}
	
	public void deleteCart2Bom(int item_quan, Integer[] assymap_uids, String changer) {
		
		List<Integer> unique_id_list = new ArrayList<Integer>();
		
		for(int i=0; i< item_quan; i++ )
			unique_id_list.add(assymap_uids[i]);
		
		//assymap 
		Map<String, Object> cond = new HashMap<String, Object>();
		cond.put("changer", changer);	//
		cond.put("change_date", new Date());	//
		cond.put("unique_id_list", unique_id_list);
		assymapDao.update("cr2bm-assymap-iter", cond);
	}

	
	
	
	//item Ѳ ߰
	public void addCart(String cur_user_name, String creator, int cur_user_uid, int[] item_uid_list, int item_quan, Integer combst_uid) {
		List my_cart_list = getCartList(cur_user_uid);
		for(int i=0; i<item_quan; i++) {
			if(isAleadySelected(my_cart_list, item_uid_list[i]) == false)
				addCart(cur_user_name, creator, cur_user_uid, item_uid_list[i], combst_uid);
		}
		
	}
	

	//assymap unique_id 
	//BOM īƮ ̵
	public void addCartByAssyMapUniquId(Integer cur_user_uid, Integer[] assymap_uid_list, Integer item_quan) {

		List<Integer> unique_id_list = new ArrayList<Integer>();
		
		for(int i=0; i< item_quan; i++ )
			unique_id_list.add(assymap_uid_list[i]);
		
		//assymap 
		Map<String, Object> cond = new HashMap<String, Object>();
		cond.put("user_uid", cur_user_uid);	//û
		cond.put("unique_id_list", unique_id_list);
		assymapDao.update("bm2cr-assymap-iter", cond);
		
	}


	// īƮƮ
	//	pr_id_uid ˻

	public List /*PartLine*/getCartList(int pr_user_uid) { //PR/PO Unique id ˻
		
		Map<String, Object> cond = new HashMap<String, Object>();
		cond.put("pr_user_uid", new Integer(pr_user_uid) );
		cond.put("status", "CR");
		//return assymapDao.select_cond("partline", cond);//PartLine Class ¹޴´.
		return this.baseLineDao.select_cond("pj-partline", cond);

	}
	
	public List /*PartLine*/getPoCartList(int pr_user_uid) {//PO Unique id ˻ /  
	
		Map<String, Object> cond = new HashMap<String, Object>();
		cond.put("pr_user_uid", new Integer(pr_user_uid) );
		cond.put("status", "CR");
		//return assymapDao.select_cond("partline", cond);//PartLine Class ¹޴´.
		return this.baseLineDao.select_cond("po-rf-partline", cond);
	}
	public List /*PartLine*/getMyNeedList(int pr_user_uid) {//PR/PO Unique id ˻
		Map<String, Object> cond = new HashMap<String, Object>();
		cond.put("pr_user_uid", new Integer(pr_user_uid) );
		cond.put("status", "CR");
		cond.put("ac_uid", 0);
		//return assymapDao.select_cond("partline", cond);//PartLine Class ¹޴´.
		return this.baseLineDao.select_cond("partline", cond);

	}
	//̹ īƮƮ ִ ..
	private boolean isAleadySelected(List cartlist, int candidate) {
		
		for(Iterator i=cartlist.iterator(); i.hasNext();) {
			/*AssyMap assymap = (AssyMap)i.next();
			if(assymap.getChild() == candidate)
				return true;
				*/
			PartLine partLint = (PartLine)i.next();
			if(partLint.getUnique_uid() == candidate) //assy ũ̵ srcahd  ũ̵ ˻.
				return true;
							
		}
		return false;
	}

	@SuppressWarnings("unused")
	private AssyMap getSimpleCondition(AssyMap from) {
		
		//AssyMap cond = new AssyMap("NULLα϶");// NULLα Ʈ
		AssyMap cond = new AssyMap();
		cond.setChild(from.getChild());			//ڵ
		cond.setQuan(from.getQuan());			//
		cond.setMquan(from.getQuan());
		cond.setPr_quan(from.getQuan());		//û
		cond.setAc_uid(from.getAc_uid());		//
		cond.setReq_date(from.getReq_date());	//԰
		cond.setRcvr_uid(from.getRcvr_uid());	//μ ũ̵
		cond.setRush_order_flag(from.getRush_order_flag());//ֹ
		cond.setDelivery_info(from.getDelivery_info());//ǰ
		cond.setDel_info_flag(from.getDel_info_flag());//ǰ
		cond.setReq_info(from.getReq_info());	//û
		cond.setReq_flag(from.getReq_flag());	//û 
		


		return cond;
	}
	
	
	//ſû ۼ   ߰ϴ 
	public void addPurchageRequestPartline(String changer, String rcvr_name, Integer user_uid, Integer user_pouid, Integer pr_uid, Integer po_user_uid,
			Integer[] item_uid, Integer item_quan, Double[] quans,
			Integer[] ac_uid, Date[] req_date, String[] req_info
			
	) throws Exception {
		
		if(pr_uid==-1) {
			throw new Exception("ſû pr_uid -1   ϴ.");
		}
			
		
		for(int i=0; i < item_quan; i++)
		{
			AssyMap assymap = new AssyMap();
			
			//assymap update
			assymap.setPr_uid(pr_uid);
			assymap.setPr_quan(quans[i]);
			assymap.setQuan(quans[i]);
			assymap.setAc_uid(ac_uid[i]);  // 
			assymap.setRcvr_uid( user_uid );// μ ̵
			assymap.setRcvr_name(rcvr_name);
			assymap.setRush_order_flag("N");
			assymap.setReq_date( req_date[i] );
			assymap.setReq_flag("Y");
			assymap.setDelivery_info("");
			assymap.setDel_info_flag("N");
			assymap.setReq_info(req_info[i]);
			assymap.setUnique_id(item_uid[i]);                       // unique_id 
			assymap.setPr_user_uid(user_pouid);			// POڷ pr_user_uid 
			assymap.setStatus("PR");						//û status setting
			assymap.setChange_date(new Date());
			assymap.setChanger(changer);
			
			assymapDao.update("cr2pr-assymap", assymap);
		}

	
	}

	//ſû  ڰ Ͽ ߻
	public Integer confirmPurchageRequestList(int pr_uid, int user_pouid ) {
		
		Map<String, Comparable> cond = new HashMap<String, Comparable>();
		
		cond.put("pr_user_uid", user_pouid);			// POڷ pr_user_uid 
		//cond.put("status", "PR");						//û status setting
		//cond.put("pr_uid", pr_uid);
		cond.put("unique_id", pr_uid);

		return	assymapDao.update("pr-confirm-assymap", cond);

	}
	
	//ſû
	public void editPurchangeRequestList(List assymap_list)
	{
		for(Iterator i = assymap_list.iterator(); i.hasNext();)
		{
			AssyMap condition = (AssyMap)i.next();
			assymapDao.update("editpurchange-assymap", condition);
		}
	}
	
	
	public List getPurchageRequestList(int user_uid) {

		Map<String, Object> cond = new HashMap<String, Object>();
//		cond.put("user_uid", SessionSecurityManager.getThis_useruid());
		cond.put("user_uid", user_uid);
		return assymapDao.select_cond("pr-partline", cond);//PartLine Class ¹޴´.		

	}
	
	public List getPurchageRequestHeadList(String user_id) {

		Map<String, Object> cond = new HashMap<String, Object>();
//		cond.put("user_id", SessionSecurityManager.getThis_userid()); //prڰ ȸ
		cond.put("user_id", user_id); //prڰ ȸ

		cond.put("rtg_type", "R"); // pr ſû 'R'
		return rtgastDao.select_cond("rtgast",cond);
	}
	

	public List getPurchageRequestHeadListbyPO(int po_user_uid) {

		Map<String, Object> cond = new HashMap<String, Object>();
		cond.put("po_user_uid", po_user_uid); //poڰ ȸ
		cond.put("rtg_type", "R"); // pr ſû 'R'
		return rtgastDao.select_cond("rtgast",cond);
	}
	
	
	
	public void deletePurchageRequestList(int pr_id, List item_uid_list) {
		
	}

	//prϱ.
	public Map cancelPurchageRequest(String[] item_list,int unique_id) {

		Map<String, Integer> map 		= new HashMap<String, Integer>();
//		List list 		= new ArrayList();
		int pr_uid 		= -1;	
		int item   		= -1;
		AssyMap assyMap = null;
		int itemCnt 	= item_list.length;
		int item_quan 	= 0;
		int item_del	= 0;
		for(int i=0; i<itemCnt; i++)
		{
			item 	= Integer.parseInt(item_list[i]);
			assyMap = (AssyMap)this.getAssyMap(item);	
			
			if(i==0){ //pr_uid ϱ.
				pr_uid 	= assyMap.getPr_uid();
				
				//   rtgast .
				map.put("pr_uid",pr_uid);
				item_quan	=	this.tableInfoDao.getCountPruid("getCountPruid",map);
				
				//System.out.println("list size"+item_quan);
				//System.out.println("itemCnt size"+itemCnt);					
			}

			if("PR".equals( assyMap.getStatus() )){ //pr϶ .
				this.assymapDao.delete(item);
				item_del++;
			}		
		}
		
		if(item_del == item_quan){
			rtgastDao.delete("rtgast",pr_uid);//rtgast
		}else{
			this.prListEdit(pr_uid,item_quan-item_del);
		}

		return null;
	}
	
	//rtgast item_abst, item_quan .
	private void prListEdit(int pr_uid, int item_quan){
		Map<String, Object> map = new HashMap<String, Object>();
		List list = new ArrayList();
		PartLine partLine = null;
		map.put("pr_uid",pr_uid);
		map.put("offset",0);
		map.put("row_count",1);
		
		list = this.assymapDao.select_cond("partline",map); //ũ̵ ѰǸ .
		String item_abst = null;
		int item_num = 0;

		Iterator i = list.iterator();
		partLine = (PartLine)i.next();

		if(item_quan>1){
			item_num = item_quan-1;
			item_abst = partLine.getItem_name()+""+item_num+"";
		}else{
			item_abst = partLine.getItem_name();
		}

		map.put("item_quan",item_quan);
		map.put("item_abst",item_abst);
		map.put("unique_id",pr_uid);
		
		rtgastDao.update("general-routing",map);
	}
	
	//po īƮ 簡 ִ.
	@SuppressWarnings("unused")
	private RtgAst poCartaddRequest(String item)
	{
		Map<String, String> aMap = new HashMap<String, String>();
		aMap.put("pr_uid",item);
		return (RtgAst)baseLineDao.select_uid("rtgast",Integer.parseInt(item));
	}
	
	// PR μڵ.. update
	public void addChangeReciver(AssyMap assyMap)
	{
		assymapDao.update("changeRcv-assymap",assyMap);
	}
	

	/*
	 *  06.3.20 hyun suk oh
	 *  īƮ
	 */
	public void removeCart(int unique_id)
	{
		baseLineDao.delete("assymap",unique_id);
	}

	@SuppressWarnings("unused")
	private String getWhereinString(List unique_id_iist) {
		
		String strItemList = "";
		
		int j=0;
		for(Iterator i=unique_id_iist.iterator(); i.hasNext(); j++) {
			Integer candidate = (Integer)i.next();

			if(j==0)
				strItemList = candidate.toString();
			else
				strItemList = strItemList + ", " + candidate.toString();

		}
		
		return strItemList;
	}

	public void modifyRelation(int cur_user_uid, int parent, int child, String pl_no, Double quan, Double sales_price) {
		
		//int cur_user_uid	= SessionSecurityManager.getThis_useruid();//α ̵

		Map<String, Comparable> cond = new HashMap<String, Comparable>();
		cond.put("pr_user_uid", cur_user_uid);
		cond.put("parent", parent);		//
		cond.put("child", child);		//
		cond.put("pl_no", pl_no);		//PL No
		cond.put("quan", quan);			//
		cond.put("bm_quan", quan);		//BOM
		cond.put("pr_quan", quan);		//BOM
		cond.put("sales_price", sales_price);		//ǰ

		assymapDao.update("parent-child-assymap", cond);

	}
	
	public void modifyRelation(int assy_uid, String pl_no, Double quan, Double sales_price) {
		
		//int cur_user_uid	= SessionSecurityManager.getThis_useruid();//α ̵

		Map<String, Comparable> cond = new HashMap<String, Comparable>();

		cond.put("unique_id", assy_uid);//unique_id
		cond.put("pl_no", pl_no);		//PL No
		cond.put("quan", quan);			//
		cond.put("bm_quan", quan);		//BOM
		cond.put("pr_quan", quan);		//BOM
		cond.put("sales_price", sales_price);		//ǰ
		
		assymapDao.update("assy_uid-assymap", cond);

	}
	

	public void addCart(String creator, List item_uid_list) {
		// TODO Auto-generated method stub
		
	}

	public AssyMap getAssyMap(int unique_id){
		return (AssyMap)assymapDao.select_uid("assymap",unique_id);
	}

	public boolean copyAssyMap(int assy_uid, int parent, String creator, int pj_uid, int pr_user_uid) {
		AssyMap new_map = getAssyMap(assy_uid);
		if(new_map==null)
			return false;
		
		Random ran = new Random();
		int iRand = ran.nextInt();
		
		if(iRand < 0) {
			iRand = (-1)* iRand;
		}
		
		new_map.setCopyDefault();
		
		
		new_map.setUnique_id(iRand);
		new_map.setPo_sec(iRand);
		new_map.setParent(parent);
		new_map.setOrigin("C");
		new_map.setPr_user_uid(pr_user_uid);
		new_map.setPo_user_uid(pr_user_uid);
		new_map.setAc_uid(pj_uid);

		Object returned = assymapDao.insert(creator, new_map);
		
		if(returned==null)
			return false;
		
		addParentPlPl(parent);
		//  Refrence Count  Ų.
		addRefrencePlPl(new_map.getChild());
		
		return true;
		
	}
	public boolean is_inAssyMapParentChild(int parent, int child) {
		Map<String, Object> cond = new HashMap<String, Object>();
		cond.put("parent", new Integer(parent) );
		cond.put("child", new Integer(child) );

		//return assymapDao.select_cond("partline", cond);//PartLine Class ¹޴´.
		List list=  this.baseLineDao.select_cond("assymap", cond);

		if(list==null || list.size()==0)
			return false;
		else
			return true;
	}

	public Project getProject(int pj_uid) {
		return (Project)this.baseLineDao.select_uid("project", pj_uid);

	}

	public Integer addPartQuan(Integer assymap_uid, Double addQuan, String creator, Integer pr_user_uid) {
		Random ran = new Random();
		int new_unique_id = ran.nextInt();
		new_unique_id = Math.abs(new_unique_id);
		
		Date change_date = new Date();
		
		AssyMap assymap = assymapDao.getById(assymap_uid);
		
		if(assymap==null)
			return -1;
		
		assymap.setUnique_id(new_unique_id);
		assymap.setChange_date(change_date);// ٲٸ Ͻ ļٲ
		assymap.setQuan(addQuan);
		assymap.setBm_quan(addQuan);
		assymap.setPr_quan(addQuan);
		assymap.setGr_quan(0.0);
		assymap.setRc_quan(0.0);
		assymap.setStatus("BM");
		assymap.setIs_closed("N");
		assymap.setPr_uid(-1);
		assymap.setPo_uid(-1);
		assymap.setPr_user_uid(pr_user_uid);
		
		assymapDao.insert(creator, assymap, assymap.getCreate_date());//̷ ؾ create_date ȴ.
		
		//srcahd refrence count 
		addRefrencePlPl(assymap.getChild()	);
		
		return new_unique_id;

	}


	public Integer updateChildQaun(int child_quan, int srcahd_uid, int assymap_uid) {
		if(child_quan<0 || srcahd_uid<0 || assymap_uid<0)
		{
			return -1;
		}
		srcahdDao.setChildQaun(child_quan, srcahd_uid);
		return assymapDao.setChildQaun(child_quan, assymap_uid);
	}

	public void modifyName(int unique_id, String item_name) {
		Map<String, Comparable> cond = new HashMap<String, Comparable>();
		cond.put("unique_id", unique_id);
		cond.put("item_name", item_name);
		srcahdDao.update("mod-item_name-srcahd", cond);
	}

	public Integer updateAssyMap(AssyMap assymap) {
		return assymapDao.update(assymap);
	}

	public void restoreCartByAssyMapUniquId(Integer cur_user_uid, Integer[] assymap_uid_list, Integer item_quan, String rtg_type) {
		List<Integer> unique_id_list = new ArrayList<Integer>();
		
		for(int i=0; i< item_quan; i++ )
			unique_id_list.add(assymap_uid_list[i]);
		
		//assymap 
		Map<String, Object> cond = new HashMap<String, Object>();
		cond.put("user_uid", cur_user_uid);	//û
		
		if(rtg_type.compareToIgnoreCase("O")==0)
			cond.put("po_uid", -1);	//po  
		else if(rtg_type.compareToIgnoreCase("R")==0)
			cond.put("pr_uid", -1);	//pr  
		
		
		cond.put("unique_id_list", unique_id_list);
		assymapDao.update("bm2cr-assymap-iter", cond);

	}
	public void restoreCartToRequesterByAssyMapUniquId(Integer[] assymap_uid_list, Integer item_quan, String rtg_type) {
		List<Integer> unique_id_list = new ArrayList<Integer>();
		
		for(int i=0; i< item_quan; i++ )
			unique_id_list.add(assymap_uid_list[i]);
		
		//assymap 
		Map<String, Object> cond = new HashMap<String, Object>();
		cond.put("restore_user_uid", "ûڷιٲ۴");	//û
		
		if(rtg_type.compareToIgnoreCase("O")==0)
			cond.put("po_uid", -1);	//po  
		else if(rtg_type.compareToIgnoreCase("R")==0)
			cond.put("pr_uid", -1);	//pr  
		
		
		cond.put("unique_id_list", unique_id_list);
		assymapDao.update("bm2cr-assymap-iter", cond);
	}

	//-------------------------AssyLine-----------------------------
	//--------------------------------------------------------------
	public AssyLine getAssyLineByUid(Integer assymap_uid) {
		return (AssyLine) this.baseLineDao.select_uid("assyline", assymap_uid);
	}
	
	public List getAllAssyLine() {
		
		return this.baseLineDao.select_all("assyline");
	}

	public List getAssyLineByPjUid(Integer pj_uid) {
		Map<String, Integer> cond = new HashMap<String, Integer>();
		cond.put("parent", pj_uid);//-->ac_uid ˻.
		
		return this.baseLineDao.select_cond("assyline", cond);
	}
	
	public List getTopAssyLineByPjUid(Integer pj_uid) {
		Map<String, Integer> cond = new HashMap<String, Integer>();
		cond.put("parent", pj_uid);//-->ac_uid ˻.
		
		return this.baseLineDao.select_cond("assyline-top", cond);
	}

}
