package com.rfxsoft.justrfx.business.e_ptnr;

import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.BeanCreationException;
import org.springframework.beans.factory.InitializingBean;

import com.rfxsoft.justrfx.domain.ComAst;
import com.rfxsoft.justrfx.domain.ComBst;
import com.rfxsoft.justrfx.domain.SupAst;
import com.rfxsoft.justrfx.domain.SupHst;

public class DefaultPtnrManager extends AbstractDaoBasedPtnrManager implements
		InitializingBean {

	public void afterPropertiesSet() throws Exception {
		if (supastDao == null) {
			throw new BeanCreationException("Must set supastDao on DefaultPtnrManager");
		}
		if (suphstDao == null)	throw new BeanCreationException("Must set suphstDao on DefaultPtnrManager");
		if (combstDao == null)	throw new BeanCreationException("Must set combstDao on DefaultPtnrManager");
	}

	public List getAllPtnrAddress() {
		return suphstDao.getAll();
	}

	public List getPtnrAddressDynamic(Map condition) {
		
		return suphstDao.getDynamic(condition);
	}

	public void deletePtnrAddress(String id) {
		// TODO Auto-generated method stub

	}

	public void modifyPtnrAddress(SupHst suphst) {
		// TODO Auto-generated method stub

	}

	public void addPtnrAddress(SupHst suphst) {
		

	}

	public List getAllBuyer() {
		return combstDao.getAll();
	}

	public List getBuyerDynamic(Map condition) {
		return combstDao.getDynamic(condition);
	}

	public void deleteBuyer(String wa_code) 
	{
		combstDao.delete(wa_code);

	}
	public void deleteBuyer(Integer unique_id) {
		combstDao.delete(unique_id);
	}

	public void modifyBuyer(ComBst combst) {
		combstDao.update(combst);

	}

	public void addBuyer(String creator, ComBst combst) {
		combstDao.insert(creator, combst);

	}

	public List getAllSupplier() {
		return supastDao. select_all("supast");
	}

	public List getSupplierDynamic(Map condition) {
		
		return supastDao.select_cond("supast", condition);
	}

	public void deleteSupplier(String code) {
		supastDao.delete(code);

	}
	
	public void deleteSupplier(Integer unique_id) {
		supastDao.delete(unique_id);
	}

	public void modifySupplier(SupAst supast) {
		supastDao.update(supast);

	}

	public void addSupplier(String creator, SupAst supast) {
		supastDao.insert(creator, supast);

	}

	public ComBst getBuyerByCode(String wa_code) {
		return combstDao.getByCode(wa_code);

	}
	public ComBst getBuyerByUniqueId(Integer unique_id) {
		return combstDao.getById(unique_id);
	}

	public void addCompany(ComAst comast) {
		// TODO Auto-generated method stub
		
	}

	public SupAst getSupplierById(int unique_id) {
		return (SupAst)this.baseLineDao.select_uid("supast", unique_id);
	}

}
