/*
 * [F]:USER
 	UserManager
 */
package com.rfxsoft.justrfx.business.f_admn;

import java.util.Date;
import java.util.List;
import java.util.Map;

import com.rfxsoft.justrfx.business.InvalidCredentialsException;
import com.rfxsoft.justrfx.domain.Board;
import com.rfxsoft.justrfx.domain.ComAst;
import com.rfxsoft.justrfx.domain.ComBst;
import com.rfxsoft.justrfx.domain.ComCst;
import com.rfxsoft.justrfx.domain.ComDst;
import com.rfxsoft.justrfx.domain.ErrHwGr;
import com.rfxsoft.justrfx.domain.ErrHwPo;
import com.rfxsoft.justrfx.domain.UsrAst;

/**
 * @author k1park
 *
	f03:	 ˻/
	f04:	 
	f01:	μ ˻/
	f02:	μ 
	f12:    ȸ 
 */

public interface AdmnManager {
//	f03:	 ˻/
//	f04:	 
//	f01:	μ ˻/
//	f02:	μ 
//	f12:	ȸ 
//  f15:	 ˻/
//  f16:	 

	//α üũ
	public Integer checkLogin(Integer user_uid, String ip, Date login_date);
	//α׾ƿ üũ
	public Integer checkLogout(Integer user_uid, Date logout_date);

    public UsrAst login(String username, String password)
    	throws InvalidCredentialsException;
    
	public Object addUser(String creator, UsrAst usrast);
	public void deleteUser(String userid);
	public void modifyUser(UsrAst usrast);
	
	public List getAllUsers();
	public List getUsersDynamic(Map condition);
	public List getUsersDynamic(UsrAst condition);
	public List getDeptByName(String deptname);
	public List getAllUserList(String user_id);
	public UsrAst getById(int unique_id);
	public ComAst getByCode(String company_code);
	public ComDst getDeptById(int unique_id);
	public ComBst getBusinessByUniqueId(int unique_id);
	public ComBst getComBstByCode(String company_code);
	public ComBst getCondComBst(Map condition);
	public void setBusinessUpDate(ComBst combst);
	public ComAst getCompanyByUniqueId(int unique_id);
	public int getUniqueIdByCode(String code);
	public ComCst getDivisionByUniqueId(int unique_id);
	//public ComDst getDeptByUniqueId(int unique_id);
	public int getUniqueByCode(String dept_code);
	public int getUniqueByCode(Map condition);
	
	public Boolean checkTempUser(String deptId, String userGrade, String email);
	public Object addTempUser(String creator, String deptId, String userGrade, String email);

	public Boolean checkDept(String deptId, String deptName);
	public Object addDept(String creator, String deptId, String deptName, double budget);
	public void addBusiness(String creator, ComBst combst);
	public String checkReason();
// 	f12:	ȸ 
	public void addCompany(String creator, ComAst comast);
// 	f12:	ȸ ˻/
	public ComAst getComInfo();
	public void setComInfo(ComAst com);
	public void changeComInfo(ComAst com);
	public List getCompanyList();
	public void deleteBusiness(int unique_id);
	public void deleteCompany(int unique_id);
	public void deleteUser(int unique_id);
	public List getBusiness(Map condition);
	public List getSelectcond(String tableName, Map condition, int start, int record_quan, String order_by);
	public List getAllBusiness();
	public List getCompanyList(Map condition);
	public void addDivision(String creator, ComCst comcst);
// f15:		 ˻//
	public List getDivision(Map condition);
	public List getAllDivision();
	public void deleteDivision(int unique_id);
	public void changeDivision(ComCst com);
// f02:		μ 
	public void addDeptList(String creator, ComDst comdst);
// f01:		μ ˻//
	public List getDepts(Map condition);
	public List getAllDepts();
	public void deleteDept(int unique_id);
	public void changeDept(ComDst com);
//f25:		 Խù 
	public void addBoard(String creator, Board board);
	public void addReplyBoard(String creator, Board board);
	public void replyBoard(Board board);
	public List getAllBoard();
	public List getBoard(Map condition);
	public List getMainBoard();
	public List getBoard_depth(String gubun);

//f21-view:	 Խù 󼼺/
	public Board getBoardByUniqueId(int unique_id);
	public void deleteBoard(int unique_id);
	public void changeBoard(Board board);
	public void addBoardCount(int uniqueid);
	
//  ڵ ȿ ˻
	//public int getWa_CodeCnt(Map condition);
	public int getComAstCompanyCodeCnt(Map condition);
	public int getComBstUnionCkCnt(Map condition);
	public int getComCstUnionCkCnt(Map condition);
	public int getComDstUnionCkCnt(Map condition);
	public int getComBstTatalCnt(Map condition);
	
	/*
	public int getComCstDivisionCodeCnt(Map condition);
	*/
	public int getComDstDeptCodeCnt(Map condition);
	public int getSrcAhdItemCodeCnt(Map condition);
	public int getSrcMapDupCnt(Map condition);
	public int getUsrAstUserIdCnt(Map condition);

// Interface  Ÿ ˻ ( f23/f24)
	public List getIFPOList(Map cond);
    public ErrHwPo getErrHwPoByUniqueId(int unique_id);
    
    public List getIFGRList(Map cond);
    public ErrHwGr getErrHwGrByUniqueId(int unique_id);  
}
