package com.rfxsoft.justrfx.business.f_admn;

import java.util.Date;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.BeanCreationException;
import org.springframework.beans.factory.InitializingBean;

import com.rfxsoft.justrfx.business.InvalidCredentialsException;
import com.rfxsoft.justrfx.domain.Board;
import com.rfxsoft.justrfx.domain.ComAst;
import com.rfxsoft.justrfx.domain.ComBst;
import com.rfxsoft.justrfx.domain.ComCst;
import com.rfxsoft.justrfx.domain.ComDst;
import com.rfxsoft.justrfx.domain.ErrHwGr;
import com.rfxsoft.justrfx.domain.ErrHwPo;
import com.rfxsoft.justrfx.domain.UsrAst;


public class DefaultAdmnManager extends AbstractDaoBasedAdmnManager implements
		InitializingBean {
	
	ComAst comInfo;
	

	String strReason=null;
	
	public void afterPropertiesSet() throws Exception {

		if (tableInfoDao == null)
			throw new BeanCreationException("Must set tableinfoDao on DefaultAdmnManager");
		if (usrastDao == null)
			throw new BeanCreationException("Must set usrastDao on DefaultAdmnManager");
		if (comastDao == null)
			throw new BeanCreationException("Must set comastDao on DefaultAdmnManager");
		if (combstDao == null)
			throw new BeanCreationException("Must set combstDao on DefaultAdmnManager");
		if (comcstDao == null)
			throw new BeanCreationException("Must set comcstDao on DefaultAdmnManager");
		if (comdstDao == null)
			throw new BeanCreationException("Must set comdstDao on DefaultAdmnManager");
		
		//usrast login flag  Ѵ.
		usrastDao.clearLoginFlag();
	}
	
    public UsrAst login(String username, String password) throws InvalidCredentialsException 
    {
    	UsrAst user = usrastDao.getByUsernameAndPassword(username, password);
    
//        Integer combst_uid = null;
		if(user!=null) {
			//combst_uid = user.getUid_combst();
			user.setUid_comast(1);
		}
			
		return user;
    }

	//f02 μ
	public void addDeptList(String creator, ComDst comdst){
		comdstDao.insert(creator, comdst);
	}
	
	public void changeDept(ComDst comdst) {
		logger.debug("ComDst"+comdst.getUnique_id());
		comdstDao.update(comdst);
		logger.debug(" ComDst");
	}
    //ȸ
	public void addCompany(String creator, ComAst comast){
		comastDao.insert(creator, comast);
	}

	//ȸ  
	public ComAst getComInfo() {
		return comInfo;
	}
	
	public void deleteUser(int unique_id)
	{
		usrastDao.delete(unique_id);
	}
	
	public void setComInfo(ComAst com) {
		comInfo = com;
	}
	//ȸ/˻
	public void changeComInfo(ComAst comast) {
		comastDao.update(comast);
	}
	public List getCompanyList() {
		return comastDao.getAll();
	}
	public List getBoard_depth(String gubun){
		return boardDao.getBoard_depth(gubun);
	}
	public void addDivision(String creator, ComCst comcst) {
		comcstDao.insert(creator, comcst);
		
	}
	
	public Object addUser(String creator, UsrAst usrast) {
		return usrastDao.insert(creator, usrast);

	}
	public void deleteUser(String userid) {
		usrastDao.delete(userid);
	}

	public void modifyUser(UsrAst usrast) {
		usrastDao.update(usrast);

	}
	
	public void setBusinessUpDate(ComBst combst)
	{
		combstDao.update(combst);
	}
	
	public ComBst getBusinessByUniqueId(int unique_id) 
	{
		return combstDao.getById(unique_id);
	}
	
	public List getAllUserList(String user_id) 
	{
		return usrastDao.getByIdMail(user_id);
	}
	
	public ComAst getCompanyByUniqueId(int unique_id) 
	{
		return comastDao.getById(unique_id);
	}
	
	public Board getBoardByUniqueId(int unique_id) 
	{
		return boardDao.getById(unique_id);
	}

	public Boolean checkTempUser(String deptId, String userGrade, String email) {
		this.strReason = null;
		if(usrastDao.isRegisterdMail(email) == true ) {
			this.strReason = "Registered Email";
			return false;
		}
				
		return true;
	}

	public Object addTempUser(String creator, String userId, String userGrade, String email) {

		UsrAst temp = new UsrAst();
		temp.SetDefault();//ʱȭѴ.
		temp.setUser_id(userId);
		temp.setPassword(userId+"00");
		temp.setEmail(email);
		temp.setGrade_code(userGrade);
		
		return usrastDao.insert(creator, temp);
	}

	public Boolean checkDept(String deptCode, String deptName) {
		
		this.strReason = null;
		if(comdstDao.isRegisterd(deptCode) == true ) {
			this.strReason = "Registered Code";
			return false;
		}
		
		if(comdstDao.isRegisterdName(deptName) == true ) {
			this.strReason = "Registered Name";
			return false;
		}
				
		return true;
	}
																				//budget ....
	public Object addDept(String creator, String deptId, String deptName, double budget) {
		ComDst temp = new ComDst();
		temp.SetDefault(creator);//ʱȭѴ.
		temp.setDept_code(deptId);
		temp.setDept_name(deptName);
	
		return comdstDao.insert(creator, temp);

	}

	
	public String checkReason() {
		return this.strReason;
	}
	
	public void deleteBusiness(int unique_id) 
	{
		combstDao.delete(unique_id);
	}
	
	public void deleteCompany(int unique_id)
	{
		comastDao.delete(unique_id);
	}
	
	
	public List getAllUsers() {
		
		return usrastDao.getAll();
		
	}
	
	public List getUsersDynamic(Map condition) {
		
		return usrastDao.getDynamic(condition);
		
	}
	
	public List getUsersDynamic(UsrAst condition) {
		
		return usrastDao.getDynamic(condition);
		
	}
	
	public List getDeptByName(String deptname) {
		return comdstDao.getByName(deptname);
	}

	public UsrAst getById(int unique_id) {
		return usrastDao.getById(unique_id);
	}

	public ComDst getDeptById(int unique_id) {
		return comdstDao.getById(unique_id);
	} 
	
	public int getUniqueIdByCode(String code) {
		return comdstDao.getUniqueByCode(code);
	}

	public void addBusiness(String creator, ComBst combst) {
		combstDao.insert(creator, combst);
	}
	
	public ComBst getComBstByCode(String company_code){
		return combstDao.getByCode(company_code);
	}
	public ComBst getCondComBst(Map condition)
	{
		return combstDao.getCondComBst(condition);
	}
	
	public List getBusiness(Map condition)
	{
		return combstDao.getDynamic(condition);
	}
	public List getSelectcond(String tableName, Map condition, int start, int record_quan, String order_by)
	{
		return combstDao.getSelectcond(tableName, condition, start, record_quan, order_by);
	}
	public List getAllBusiness() {
		return combstDao.getAll();
	}
	//f01 μ ˻//
	public List getDepts(Map condition)
	{
		return comdstDao.getDynamic(condition);
	}
	public List getAllDepts() {
		
		return comdstDao.getAll();
	}
	public void deleteDept(int unique_id) 
	{
		comdstDao.delete(unique_id);
	}
	
	//f15  ˻//
	public List getDivision(Map condition)
	{
		return comcstDao.getDynamic(condition);
	}
	public List getAllDivision() {
		return comcstDao.getAll();
	}
	public void deleteDivision(int unique_id) 
	{
		comcstDao.delete(unique_id);
	}
	public ComCst getDivisionByUniqueId(int unique_id) 
	{
		return comcstDao.getById(unique_id);
	}
	public void changeDivision(ComCst comcst) {
		logger.debug("ComCst"+comcst.getUnique_id());
		comcstDao.update(comcst);
		logger.debug(" ComCst");
	}

	public List getCompanyList(Map condition) {
		return comastDao.getDynamic(condition);
	}
	//
	public void addBoard(String creator, Board board) {
		boardDao.insert(creator, board);

	}
	public void addReplyBoard(String creator, Board board) {
		boardDao.insertReply(creator, board);

	}
	public void replyBoard(Board board) {
		boardDao.updateDepth(board);

	}
	public List getBoard(Map condition)
	{
		return boardDao.getDynamic(condition);
	}

	public List getAllBoard() {
		return boardDao.getAll();
	}
	public List getMainBoard() {
		return boardDao.getMainBoard();
	}
	public void deleteBoard(int unique_id) 
	{
		boardDao.delete(unique_id);
	}
	public void changeBoard(Board board) {
		boardDao.update(board);
		logger.debug(" Board");
	}
	
	public void addBoardCount(int uniqueid){
		boardDao.updateCount(uniqueid);
	}
	
	public int getUniqueByCode(String dept_code)
	{
		return comdstDao.getUniqueByCode(dept_code);
	}
	
	public int getUniqueByCode(Map condition)
	{
		return comdstDao.getUniqueByCode(condition);
	}
	
	public int getComAstCompanyCodeCnt(Map condition)
	{
		return tableInfoDao.getComAstCompanyCodeCnt(condition);
	}
	public int getSrcMapDupCnt(Map condition)
	{
		return tableInfoDao.getSrcMapDupCnt(condition);
	}
	/*
	public int getComCstDivisionCodeCnt(Map condition)
	{
		return tableInfoDao.getComCstDivisionCodeCnt(condition);
	}
	*/
	public int getComDstDeptCodeCnt(Map condition)
	{
		return tableInfoDao.getComDstDeptCodeCnt(condition);
	}
	
	public int getUsrAstUserIdCnt(Map condition)
	{
		return tableInfoDao.getUsrAstUserIdCnt(condition);
	}
	
	public int getSrcAhdItemCodeCnt(Map condition)
	{
		return tableInfoDao.getSrcAhdItemCodeCnt(condition);
	}
	
	public int getComBstUnionCkCnt(Map condition)
	{
		return tableInfoDao.getComBstUnionCkCnt(condition);
	}
	
	public int getComDstUnionCkCnt(Map condition)
	{
		return tableInfoDao.getComDstUnionCkCnt(condition);
	}
	
	public int getComCstUnionCkCnt(Map condition)
	{
		return tableInfoDao.getComCstUnionCkCnt(condition);
	}
	/*
	public int getWa_CodeCnt(Map condition){
		return tableInfoDao.getComBstWa_CodeCnt(condition);
	}
	*/
	public int getComBstTatalCnt(Map condition){
		return tableInfoDao.getComBstTatalCnt(condition);
	}
	
	public ComAst getByCode(String company_code)
	{
		return comastDao.getByCode(company_code);
	}
	
	/**
     * ERRHWPO I/F ȸ
     * @param
     * @return
	 */
	public List getIFPOList(Map cond)
    {
        return this.baseLineDao.select_cond("errhwpo", cond);
	}

    /**
     * ERRHWPO 󼼳 ȸ
     * @param unique_id Errhwpo unique_id
     */
    public ErrHwPo getErrHwPoByUniqueId(int unique_id)
    {
        return (ErrHwPo)this.baseLineDao.select_uid("errhwpo", unique_id);
    }

    /**
     * ERRHWGR I/F ȸ
     * @param
     * @return
     */
    public List getIFGRList(Map cond)
    {
        return this.baseLineDao.select_cond("errhwgr", cond);
    }

    /**
     * ERRHWGR 󼼳 ȸ
     * @param unique_id Errhwgr unique_id
     */
    public ErrHwGr getErrHwGrByUniqueId(int unique_id)
    {
        return (ErrHwGr)this.baseLineDao.select_uid("errhwgr", unique_id);
    }

	public Integer checkLogin(Integer user_uid, String ip, Date login_date) {
		return this.usrastDao.checkLogin(user_uid, ip, login_date);
	}

	public Integer checkLogout(Integer user_uid, Date logout_date) {
		return this.usrastDao.checkLogout(user_uid, logout_date);
		
	}
}
