package com.rfxsoft.justrfx.business.g_mynf;



import org.springframework.beans.factory.BeanCreationException;

import com.rfxsoft.justrfx.PairList;
import com.rfxsoft.justrfx.PairListimpl;
import com.rfxsoft.justrfx.domain.Project;
import com.rfxsoft.justrfx.domain.RegisterdMasterCompany;
import com.rfxsoft.justrfx.domain.UsrAst;
import com.rfxsoft.justrfx.domain.ComDst;
import com.rfxsoft.justrfx.mail.AttachmentMessageSender;

public class DefaultMynfManager extends AbstractDaoBasedMynfManager {
	
	RegisterdMasterCompany myCompany;
	AttachmentMessageSender	messageSender;
	
	public PairList getEnvList(String user_id, String var_name){
		PairList pairList = new PairListimpl(myinfoDao.GetEnvRaw(user_id, var_name));
		return pairList;
	}
	
	public void setEnvList(String user_id, String var_name, PairList pairList){
		String var_value = pairList.toString();
		myinfoDao.SetEnvRaw(user_id, var_name, var_value);
	}

	public String getEnvRaw(String user_id, String var_name){
		return myinfoDao.GetEnvRaw(user_id, var_name);
	}
	
	public void setEnvRaw(String user_id, String var_name, String var_value) {
		myinfoDao.SetEnvRaw(user_id, var_name, var_value);
	}
	
	private void clearEnv( String var_name, String var_value) {
		myinfoDao.ClearEnv(var_name, var_value);
	}

	public AttachmentMessageSender getMessageSender() {
		return messageSender;
	}

	public void setMessageSender(AttachmentMessageSender messageSender) {
		this.messageSender = messageSender;
	}

	public DefaultMynfManager() {
		super();
	}


	public void setMyCompany(RegisterdMasterCompany myCompany) {
		this.myCompany = myCompany;
	}


	public void changeMyInfo(UsrAst to) {

		usrastDao.update(to); 

	}
	
	public void changeinfo(ComDst com) {
		
		comdstDao.update(com);
	}

	public Boolean changeMyPassword(UsrAst user, String oldPass, String newPass) {
		
		if(oldPass.compareTo(user.getPassword())==0) {
			usrastDao.updatePassword(user.getUnique_id(), newPass);

			return true;
		}
		else
			return false;
	}

	public RegisterdMasterCompany getMyCompany() {
		return myCompany;
	}
	
	public Project getCurrentProject(String user_id) {
		String StrUnique = getCurrentProjectId(user_id);
		
		if(StrUnique==null)
			return null;
		if(StrUnique.length()==0)
			return null;
		Integer unique_id = Integer.valueOf(StrUnique).intValue();
		return projectDao.getById(unique_id);
	}
	
	public void SetCurrentProject(String user_id, String project_id) {
		setEnvRaw(user_id, "CUR_PROJECT_ID", project_id);
	}
	public String getCurrentProjectId(String user_id) {
		String cur_project = getEnvRaw( user_id, "CUR_PROJECT_ID" );

		return cur_project;
	}
	
	public void SetCurrentAssy(String user_id, String assy_unique, String pj_unique) {
		setEnvRaw(user_id, "CUR_ASSY_ID", assy_unique);
		SetCurrentProject(user_id,  pj_unique);
	}
	
	public void SetCurrentAssy(String user_id, int assy_unique, int pj_unique) {
		setEnvRaw(user_id, "CUR_ASSY_ID", String.valueOf(assy_unique));
		setEnvRaw(user_id, "CUR_PROJECT_ID", String.valueOf(pj_unique));

	}
	
	public void clearProjectInfo(int pj_unique_id) {
		clearEnv("CUR_PROJECT_ID", String.valueOf(pj_unique_id));
	}
	public void SetCurrentAssy(String user_id, int unique_id) {
		setEnvRaw(user_id, "CUR_ASSY_ID", String.valueOf(unique_id));
	}
	
	public String getCurrentAssy(String user_id) {
		return getEnvRaw(user_id, "CUR_ASSY_ID" );
	}

	public UsrAst getMyInfo(int unique_id) {
		return usrastDao.getById(unique_id);
	}

	public void afterPropertiesSet() throws Exception {
		
		if (baseLineDao == null)	throw new BeanCreationException("Must set baseLineDao");
		if (tableInfoDao == null)	throw new BeanCreationException("Must set tableInfoDao");
		if (usrastDao == null)	throw new BeanCreationException("Must set usrastDao");
		if (myinfoDao == null)	throw new BeanCreationException("Must set myinfoDao");
		if (projectDao == null)	throw new BeanCreationException("Must set projectDao");
		if (comdstDao == null)	throw new BeanCreationException("Must set comdstDao");	
	}

	public void SetCurrentProject(String user_id, int project_uid) {
		
		setEnvRaw(user_id, "CUR_PROJECT_ID", String.valueOf(project_uid) );
	}
	
//Cur Assy  Project  
//	public void SetCurrentAssy(String assy_unique) {
//		setEnv("CUR_ASSY_ID", assy_unique);
//	}
//	public void setLoginTime(Date date) {
//	this.loginTime = date;
//}
//
//public Date getLoginTime() {
//	return loginTime;
//}
}









