package com.rfxsoft.justrfx.business.j_prch;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.Set;

import org.springframework.beans.factory.BeanCreationException;
import org.springframework.beans.factory.InitializingBean;

import com.rfxsoft.justrfx.domain.AssyMap;
import com.rfxsoft.justrfx.domain.PartLine;
import com.rfxsoft.justrfx.domain.RtgAst;
import com.rfxsoft.justrfx.domain.XpoAdt;
import com.rfxsoft.justrfx.domain.XpoAhd;
import com.rfxsoft.justrfx.domain.XpoAst;


public class DefaultPrchManager extends AbstractDaoBasedPrchManager implements
		InitializingBean {

	public void afterPropertiesSet() throws Exception {
		if (srcahdDao == null)	throw new BeanCreationException("Must set srcahdDao on DefaultPrchManager");
		if (assymapDao == null)	throw new BeanCreationException("Must set assymapDao on DefaultPrchManager");
		if (tableInfoDao == null)	throw new BeanCreationException("Must set tableInfoDao on DefaultPrchManager");
		if (xpoastDao == null)	throw new BeanCreationException("Must set xpoastDao on DefaultPrchManager");
		if (rtgastDao == null)	throw new BeanCreationException("Must set rtgastDao on DefaultPrchManager");
		if (projectDao == null)	throw new BeanCreationException("Must set projectDao on DefaultPrchManager");
		if (sysinfoDao == null) throw new BeanCreationException("Must set sysinfoDao on DefaultPrchManager");

	}
	
	enum QryType {PR, PO, GR, RF};
	

	@SuppressWarnings("unchecked")
	public List getPrListForPoUser(int po_user_uid)	{
		Map cond = new HashMap();
		cond.put("rtg_type", "R" );	//ſû
		cond.put("po_user_uid", po_user_uid);//PO  .
//		cond.put("state", "I");//ΰ-->ϷȰ͵ ַ
		
		return rtgastDao.select_cond("rtgast-not-I", cond);
	}
	//POڰ û: STATUS: CR :: ſû(PR)ΰ POڰ īƮ ־
	public void confirmPrReceive(List assymap_uid_list) {
		for(Iterator i=assymap_uid_list.iterator(); i.hasNext();) {
			int assymap_uid = (Integer)i.next();
			addPrReceive( assymap_uid );
		}
	}
	
	// Ѱ 
	@SuppressWarnings("unchecked")
	public void addPrReceive(int assymap_uid) {
		Map cond = new HashMap();
		cond.put("status", "CR" );	//û 
		cond.put("unique_id", assymap_uid);
		assymapDao.update("pr2cr-assymap", cond);
	}
	

//	POڰ û
	@SuppressWarnings("unchecked")
	public void confirmPrReceiveByGroup(int pr_uid) {
		//assymap 
		Map cond = new HashMap();
		cond.put("status", "CR" );	//û 
		cond.put("pr_uid", pr_uid);
		assymapDao.update("pr2cr-by_pr_uid-assymap", cond);
		
		//rtgast 
		Map cond1 = new HashMap();
		cond1.put("state", "R" );	//ϸ R ȴ.
		cond1.put("unique_id", pr_uid);
		rtgastDao.ChangeState(cond1);
		
	}

	public void confirmPrReceiveByGroup(List unique_id_list) {
		//assymap 
		Map<String, Object> cond = new HashMap<String, Object>();
		cond.put("status", "CR" );	//û 
		cond.put("unique_id_list", unique_id_list);
		assymapDao.update("pr2cr-by_pr_uid-assymap-iter", cond);
		
		//rtgast 
		Map<String, Object> cond1 = new HashMap<String, Object>();
		cond1.put("state", "R" );	//û 
		cond1.put("unique_id_list", unique_id_list);
		rtgastDao.ChangeStateIter(cond1);
		
	}
	
	//POڰ ݷ
	@SuppressWarnings("unchecked")
	public void doPrDenyByGroup(int pr_uid) {
		//assymap :
		// pr_user_uid po_user_uid ƾ
		// status CR ؾ.
		
		// -->  status DI  ϴ  
		Map cond = new HashMap();
		cond.put("status", "DE" );	//û 
		cond.put("pr_uid", pr_uid);
		assymapDao.update("pr2cr-by_pr_uid-assymap", cond);
		
		
		//rtgast 
		Map cond1 = new HashMap();
		cond1.put("state", "D" );	//û 
		cond1.put("unique_id", pr_uid);
		rtgastDao.ChangeState(cond1);
		
	}
	
	//	POڰ ݷ
	@SuppressWarnings("unchecked")
	public void doPrDeny(List assymap_uid_list) {

		Integer unique_id;
		for(Iterator i=assymap_uid_list.iterator(); i.hasNext();){
			unique_id = (Integer)i.next();
			logger.info(unique_id);
			
			Map cond = new HashMap();
			cond.put("status", "DE" ); //ݷ
			cond.put("pr_user_uid", -1);
			cond.put("unique_id", unique_id);
			assymapDao.update("de-assymap", cond);
		}
		
	}
	public void doPrDeny(int item_quan, Integer[] assymap_uids) {
		Integer unique_id;
		for(int i=0; i<item_quan;i++){
			unique_id = assymap_uids[i];
			
			Map<String, Object> cond = new HashMap<String, Object>();
			cond.put("status", "DE" ); //ݷ
			cond.put("pr_user_uid", -1);
			cond.put("unique_id", unique_id);
			assymapDao.update("de-assymap", cond);
		}
		
	}

	public List getPrDetail(int pr_uid) {
		return getPrPoGrDetail(pr_uid, QryType.PR);
	}

	public List getPoDetail(int po_uid) {
		return getPrPoGrDetail(po_uid, QryType.PO);
	}
	
	public List getGrDetail(int gr_uid) {
		return getPrPoGrDetail(gr_uid, QryType.GR);
	}
	
	public List getRfqDetail(int rf_uid) {
		return getPrPoGrDetail(rf_uid, QryType.RF);
	}	
	//	PR uid ׸ (partline) <- CommonInfo  
	@SuppressWarnings("unchecked")
	private List getPrPoGrDetail(int prpogr_uid, QryType qryType) {
		
    	List assymaps = new ArrayList();
		Map<String, Object> cond = new HashMap<String, Object>();
		
		switch(qryType) {
		case PR:
			cond.put("pr_uid", new Integer(prpogr_uid) );
			break;
		case PO:
			cond.put("po_uid", new Integer(prpogr_uid) );
			break;
		case GR:
			cond.put("gr_uid", new Integer(prpogr_uid) );
			break;
		case RF:	
			cond.put("rf_uid", new Integer(prpogr_uid) );
			break;
		default:
				return null;
		}

		assymaps =  assymapDao.select_cond("partline",cond);
    	
    	logger.info(assymaps.size());
    	List assys = new ArrayList();
    	
    	for(Iterator i=assymaps.iterator(); i.hasNext();)
    	{
    		PartLine part = (PartLine)i.next();
    		if(part != null)
    		{
    			assys.add(part);
    			logger.info(part.getItem_code());
    		}
    	}
    	
    	return assys;
	}
	
	
	///-------------PO-----------------------
	
	//po_uid Ͽ ٿ Status  CR-->POڰ ϱ ٷ 

	@SuppressWarnings("unchecked")
	public void addTemporaryPurchageOrder(String creator, int po_uid, String po_no,  List assymap_uid_list){
		
		Integer last_no = this.getSysinfoDao().GetLastUnChecked("O");
		
		RtgAst rtgast = new RtgAst("O", last_no);
		rtgast.setUnique_id(po_uid);
		rtgast.setPo_no(po_no);
		
		
		if( rtgast != null) {
			this.baseLineDao.insert(creator, "rtgast-deleted", rtgast);
			this.getSysinfoDao().SetLastValue("O", last_no);
		}
		
		Map cond = new HashMap();
		cond.put("status", "CR" );
		cond.put("po_uid", po_uid );
		cond.put("po_no", po_no );
		//cond.put("po_sec", 0);--> unique_id/10000
		cond.put("unique_id_list", assymap_uid_list);
		
		assymapDao.update("cr2p0-assymap-iter", cond);
		
		/*
		if(this.baseLineDao.getDbTypeEnum() == DatabaseType.ORACLE)
			assymapDao.update("cr2p0-assymap-iter", cond);
		else
			assymapDao.update("cr2p0-assymap-oracle-iter", cond);
		*/
	
	}		
   
    /* --------------------------------------------------------------------------	
	public void addTemporaryPurchageOrder(int po_uid, String po_no,  List assymap_uid_list){
		
		int j=0;
		for(Iterator i=assymap_uid_list.iterator(); i.hasNext();j++) {

			int assymap_uid = (Integer)i.next();
			Map cond = new HashMap();
			cond.put("status", "CR" );
			cond.put("po_uid", po_uid );
			cond.put("po_no", po_no );
			cond.put("unique_id", assymap_uid);
			cond.put("po_sec", j+1);
			assymapDao.update("cr2p0-assymap", cond);
		}	

	}	
     */
/*
	public void addTemporaryPurchageOrder(int po_uid, String po_no,  List assymap_uid){
		Map cond = new HashMap();
		cond.put("status", "CR" );
		cond.put("po_uid", po_uid );
		cond.put("po_no", po_no );
		
		for (int i=0; i<assymap_uid.size(); i++) {
			cond.put("unique_id", assymap_uid.get(i));
			cond.put("po_sec", i+1);


			assymapDao.update("cr2p0-assymap", cond);
		}	

	}
	*/
	//	ֹ: 
	@SuppressWarnings("unchecked")
	public void addPurchageOrder(int assymap_uid, int po_uid, String po_no, int po_sec) {
		
		Map cond = new HashMap();
		cond.put("status", "P0" );
		cond.put("po_uid", po_uid );
		cond.put("po_no", po_no );
		cond.put("unique_id", assymap_uid);
		cond.put("po_sec", po_sec);
		assymapDao.update("cr2p0-assymap", cond);

	}

//	public void addPurchageOrder(int po_uid, String po_no,  Integer[] arrAssymap_uid, int quanUid) {
//
//		for(int i=0; i<quanUid; i++)  {
//			addPurchageOrder( arrAssymap_uid[i], po_uid, po_no, i);
//		}		
//	}
	
	public void addPurchageOrder(int po_uid, String po_no,  Integer[] arrAssymap_uid, int quanUid) {

		List<Integer> list = new ArrayList<Integer>();
		
		for(int i=0; i < arrAssymap_uid.length; i++) {
			if(arrAssymap_uid[i] !=null && arrAssymap_uid[i] >0) {
				list.add(arrAssymap_uid[i]);
			}
		}

		Map<String, Object> cond = new HashMap<String, Object>();
		cond.put("status", "P0" );
		cond.put("po_uid", po_uid );
		cond.put("po_no", po_no );
//		cond.put("po_sec", 0);-->unique_id 
		cond.put("unique_id_list", list);
		assymapDao.update("cr2p0-assymap-iter", cond);
		
		for(int i=0; i < arrAssymap_uid.length; i++) {
			if(arrAssymap_uid[i] !=null && arrAssymap_uid[i] >0) {
				//SrcAhd 
				assymapDao.update("assymap2srcahd-sales_price", arrAssymap_uid[i]);

			}
		}
		
		
		
	}
	
	//	ֹ:  : STATUS: P0: po unique_id ѱ
	public void addPurchageOrder(int po_uid, String po_no,  List assymap_uid_list) {
		int j = 0;
		for(Iterator i=assymap_uid_list.iterator(); i.hasNext();) {
			j++;
			int assymap_uid = (Integer)i.next();
			addPurchageOrder( assymap_uid, po_uid, po_no, j);
		}		
	}
	
	public Object addPurchageOrderDetail(int po_uid, Double sales_amount, String pay_condition, 
			Date req_delivery_date,	String request_info, String delivery_address_1, Date po_date, String creator) {
		
		XpoAdt xpoadt = new XpoAdt();
		xpoadt.setUnique_id(po_uid);
		xpoadt.setCreate_date(new Date());
		
		xpoadt.setXpoast_uid(po_uid);
		xpoadt.setSales_amount(sales_amount);
		xpoadt.setPay_condition(pay_condition);
		xpoadt.setReq_delivery_date(req_delivery_date);
		xpoadt.setRequest_info(request_info);
		xpoadt.setDelivery_address_1(delivery_address_1);
		xpoadt.setPo_date(po_date);
	
		
		return this.baseLineDao.insert(creator, "xpoadt", xpoadt);
		
	}

	//	ſû (POڰ ϱ ٷ)
	public List getTemporaryPurchageOrderList(int po_uid) {
		Map<String, Object> cond = new HashMap<String, Object>();
		cond.put("po_uid", new Integer(po_uid) );
		cond.put("status", "CR");
		
		logger.info(po_uid);
		
		return assymapDao.select_cond("partline", cond);
	}
	
	//	ſû (  ȸ)
	public List getSendApprPurchageOrderList(int po_uid) {
		Map<String, Object> cond = new HashMap<String, Object>();
		cond.put("po_uid", new Integer(po_uid) );
		
		return assymapDao.select_cond("partline", cond);
	}
		
	//	ſû 
	public List getPurchageOrderList(int po_uid) {
		Map<String, Object> cond = new HashMap<String, Object>();
		cond.put("po_uid", new Integer(po_uid) );
		cond.put("status", "PO");
		
		return assymapDao.select_cond("partline", cond);
	}


	
	// Ż
	public void deleteOrderAll(String[] routing_id){
		
		Map<String, Comparable> cond = new HashMap<String, Comparable>();
		
		cond.put("po_uid_value", -1 );
		cond.put("po_no", "-1" );
		cond.put("po_sec", 0);		
		
		int li_po_uid = -1;
		
		for(int i=0; i<routing_id.length; i++){
			li_po_uid = Integer.parseInt(routing_id[i]);
			baseLineDao.delete("routing-id-all",li_po_uid);
			cond.put("po_uid", li_po_uid);	
			assymapDao.update("po_uid-assymap",cond);
		}		
	}
	
	//	ſû ()
	public void deletePurchageOrderList(int po_uid, String po_no, List assymap_uid_list, int sec) {
		Map<String, Object> cond = new HashMap<String, Object>();
		cond.put("status", "CR" );
		cond.put("po_uid", po_uid );
		cond.put("po_no", po_no );
		cond.put("po_sec", sec);
		
		for (int i=0; i<assymap_uid_list.size(); i++) {
			cond.put("unique_id", assymap_uid_list.get(i));			
			assymapDao.update("cr2p0-assymap", cond);
		}
	}
	
	//	ſû (-º)
	public void changePurchageOrderAssyMap(List assymap_uid_list) {
		Map<String, Object> cond = new HashMap<String, Object>();
		
		cond.put("status", "CR" );
		
		for (int i=0; i<assymap_uid_list.size(); i++) {
			cond.put("unique_id", assymap_uid_list.get(i));			
			assymapDao.update("pr2cr-assymap", cond);
		}
	}

	
	//	Ϸ : ֹȮ : PO
	public boolean confirmPurchageOrderList(int po_uid, String creator) {
		
		//Transaction Manager ʿ

				List list = getSendApprPurchageOrderList(po_uid);
				
				int item_quan= list.size();
				Integer[] unique_ids = new Integer[item_quan];
				int j=0;
				for(Iterator i=list.iterator(); i.hasNext();j++) {
					PartLine part = (PartLine)i.next();
					unique_ids[j] = part.getUnique_uid();
				}
				
				if (this.confirmPurchageOrderListInsert(po_uid, creator, unique_ids, j) == false)
					return false;
				
				Map<String, Object> cond = new HashMap<String, Object>();
				cond.put("po_uid", new Integer(po_uid) );
				cond.put("status", "PO");
				
				if (assymapDao.update("p02po-assymap", cond) != null){
					RefreshPrRtgastByPo(po_uid);
					return true;
				}else{
					RefreshPrRtgastByPo(po_uid);
					return false;
				}


		
	}
	
	public boolean confirmPurchageOrderListInsert(int po_uid, String creator, Integer[] assy_uids, int item_quan) {
		
		for(int i=0; i<item_quan; i++) {
			XpoAst xpoast = (XpoAst)xpoastDao.select_uid("xpoast-assymap",	assy_uids[i]);
			xpoast.setCreate_date(new Date());
			xpoast.setCreator(creator);
			xpoast.setMp_status("PO");
			
			if (xpoastDao.insert(creator, xpoast)== null){
				return false;
			}
		}
		
		return true;
	}
	
	
	// ʴ Լ
	public boolean confirmPurchageOrderListInsert(int po_uid, String creator, List list){
		for(Iterator i=list.iterator(); i.hasNext();) {
			PartLine part = (PartLine)i.next();
			//xpoast unique_id assymap unique_id ȴ.
			Object object = xpoastDao.select_uid("xpoast-assymap",
					part.getUnique_uid()/*srcahd unique_id:part.getUnique_id()*/);
			
			if(object==null)
				return false;
			
			XpoAst xpoast = (XpoAst)object;
			
			//Xpoast Ѵ.
			xpoast.setCreate_date(new Date());
			xpoast.setCreator(creator);
			xpoast.setMp_status("PO");

			if (xpoastDao.insert(creator, xpoast)== null){
				return false;
			}

		}
		return true;
	}
	
	//庰 ֹ
	@SuppressWarnings("unchecked")
	public List /*XpoAhd*/ getPoHeadList(String wa_code) {
		Map condition = new HashMap();
		//condition.put("wa_code", wa_code);
		return this.baseLineDao.select_cond("xpoahd", condition);
	}
	public List /*XpoAhd*/ getPoHeadListNotGr(String wa_code) {
		
		List all_pos = getPoHeadList( wa_code );
    	List<XpoAhd> xpoahds = new ArrayList<XpoAhd>();
    	
    	for(Iterator i=all_pos.iterator(); i.hasNext();)
    	{
    		XpoAhd xpoahd = (XpoAhd)i.next();
    		if(xpoahd.getPo_status().compareToIgnoreCase("A") == 0)
    		{
    			xpoahds.add(xpoahd);
    		}
    	}

    	return xpoahds;
	}

	public List /*XpoAhd*/ getPoHeadListGr(String wa_code) {
		List all_pos = getPoHeadList( wa_code );
 //   	List xpoahds = new ArrayList();
    	return all_pos;
	}
	//	-------------------- GR(GoodsReceipt) ------------------------	
	
	public boolean addGoodsReceiptBatch(int item_quan, Integer assymap_uid[], Double po_quan[], Double gr_quan[], String[] is_close, int gr_user_uid, String gr_userid, String gr_user_name, String wa_code, Integer gr_uid, String gr_no,
			String gr_comment, String item_abst)
	{
		Integer cur_gr_uid = gr_uid;
		String cur_gr_no =  gr_no;

		//RtgAst ؾ Ѵ.
		//if( gr_uid <0) {//׻ -1̴.
		Integer last_no = this.getSysinfoDao().GetLastUnChecked("W");
		
		RtgAst	rtgast = new RtgAst("W", last_no);
		cur_gr_uid = rtgast.getUnique_id();
		cur_gr_no =  rtgast.getPo_no();
			
		//ʿ  .
		rtgast.setChanger(gr_userid);
		rtgast.setWork_cursor(-1);
		rtgast.setState("A");
		rtgast.setItem_quan(item_quan);
		rtgast.setItem_abst(item_abst);
		rtgast.setContent(item_abst);
		rtgast.setName(gr_comment);
		rtgast.setUser_id(gr_userid);
		rtgast.setUser_name(gr_user_name);
		rtgast.setWa_code(wa_code);
		
		this.baseLineDao.insert(gr_userid, "rtgast", rtgast);
		this.getSysinfoDao().SetLastValue("W", last_no);
		
		for(int i=0; i<item_quan; i++) {
			
			//is_closed --------------------------
			String temp_is_closed;
			if(po_quan[i] > gr_quan[i])
				temp_is_closed = "N";
			else
				temp_is_closed = "Y";
			//-------------------------------------------
			
			if( addGoodsReceiptSingle(gr_comment, gr_userid, cur_gr_uid, cur_gr_no, gr_user_uid,i+1, 
					assymap_uid[i], po_quan[i], gr_quan[i], temp_is_closed, new Date()) == false)
				return false;
		}

		return true;
	}
	
	public Double getPurchaseCostByPjCode(String pj_code) {
		return this.xpoastDao.getTotalProjectPrchCost(pj_code);

	}

	/*
	public boolean addGoodsReceipt(int item_quan, Integer assymap_uid[], Double po_quan[], Double gr_quan[], String[] is_close, int gr_user_uid, String gr_userid)
	{
		//gr uid RanddomϰԻ/
		Random ran = new Random();
		int gr_uid = ran.nextInt();
		
		if(gr_uid < 0) {
			gr_uid = (-1)* gr_uid;
		}
		
		String gr_no = String.valueOf(gr_uid);
		
		return addGoodsReceipt( item_quan,  assymap_uid,  po_quan,  gr_quan, is_close, gr_user_uid, gr_userid, gr_uid, gr_no);

	}
	*/

	//κ԰  ڵ带 ߰ϰ .
	private int copyAssyMap4GRByUid(int new_unique_id,  Date new_create_date, int unique_id, Double po_quan, Double gr_quan, String creator) {
		
		Double new_gr_quan = po_quan - gr_quan;// ޾ƾ 
		
		AssyMap assymap = assymapDao.getById(unique_id);
		
		if(assymap==null)
			return -1;
		
		assymap.setUnique_id(new_unique_id);
//		assymap.setCreate_date(new_create_date);// ٲٸ Ͻ ļٲ
		assymap.setChange_date(new Date());// ٲٸ Ͻ ļٲ
		assymap.setQuan(new_gr_quan);
		assymap.setGr_quan(new_gr_quan);
		assymap.setIs_closed("N");
		
		assymapDao.insert(creator, assymap, assymap.getCreate_date());//̷ ؾ create_date ȴ.
		
		return new_unique_id;
	}
	
	//κ԰  ڵ带 ߰ϰ .
	private int copyXpoAst4GRByUid(int new_unique_id,  Date new_create_date, int unique_id, Double po_quan, Double gr_quan, String creator) {
		
		Double new_gr_quan = po_quan - gr_quan;// ޾ƾ 
		
		XpoAst xpoast = xpoastDao.getById(unique_id);
		
		if(xpoast==null)
			return -1;
		
		xpoast.setUnique_id(new_unique_id);
//		xpoast.setCreate_date(new_create_date);// ٲٸ Ͻ ļٲ
		xpoast.setPo_qty(new_gr_quan);
		xpoast.setGr_qty(0.0);	//ֹ̱  ԰  ʾǷ gr_qty 0.0
        xpoast.setIs_closed("N");        
		xpoast.setGr_user_id(creator);
        xpoast.setSales_amount(xpoast.getPo_qty() * xpoast.getSales_price());
        xpoast.setBuying_amount(xpoast.getPo_qty() * xpoast.getBuying_price());
		xpoastDao.insert(creator, xpoast);
		
		return new_unique_id;
	}
	
	//԰
	public boolean addGoodsReceiptSingle(String gr_comment, String creator, int gr_uid, String gr_no, int gr_user_uid, int gr_sec, int assymap_uid, Double po_quan, Double gr_quan, String is_closed, Date gr_date) {

//		if(addGoodsReceiptAssyMap(creator, gr_uid, gr_no, gr_user_uid, gr_sec, assymap_uid, po_quan, gr_quan, is_closed)== false)
//			return false;
//		
//		return 
		
		//gr uid RanddomϰԻ/
		Random ran = new Random();
		int new_unique_id = ran.nextInt();
		
		Date new_create_date = new Date();
		
		if(new_unique_id < 0) {
			new_unique_id = Math.abs(gr_uid);
		}
		
		
		addGoodsReceiptXpoAst(new_unique_id, new_create_date, creator, gr_uid, gr_no, gr_user_uid, gr_sec, assymap_uid, po_quan, gr_quan, is_closed, gr_date, gr_comment);
		addGoodsReceiptAssyMap(new_unique_id, new_create_date, creator, gr_uid, gr_no, gr_user_uid, gr_sec, assymap_uid, po_quan, gr_quan, is_closed);

		return true;
	}
	//Ayymap ԰üũ
	@SuppressWarnings("unchecked")
	public boolean addGoodsReceiptAssyMap(Integer new_unique_id, Date new_create_date, String creator, int gr_uid, String gr_no, int gr_user_uid, int gr_sec, int assymap_uid, Double po_quan, Double gr_quan, String is_closed) {
		
		Map cond = new HashMap();
		cond.put("status", 		"GR" );
		cond.put("gr_uid", 		gr_uid );
		cond.put("gr_no",  		gr_no );
		cond.put("gr_quan", 	gr_quan);
		cond.put("gr_user_uid", gr_user_uid );
		cond.put("gr_sec", gr_sec);

		cond.put("is_closed", "Y");//纻 Ƿ Y ȴ.
		
		//Ŭ ƴϸ ڵ ϳ ߰ Ѵ. --κ԰̴.
		if(is_closed.compareToIgnoreCase("N") == 0) {
			if( copyAssyMap4GRByUid(new_unique_id, new_create_date, assymap_uid, po_quan, gr_quan, creator) < 0)
				return false;
			cond.put("quan",  		gr_quan );// ԰Ǽ ֹǼ
		}
		else {// ֹǼ ״ ֹ Ǽ
			cond.put("quan",  		po_quan );// ֹǼ ״
		}
		
		cond.put("unique_id", assymap_uid);
		if( assymapDao.update("po2gr-assymap", cond) == null)
			return false;	
		
		return true;
	}
	
	//XpoAst ԰üũ
	@SuppressWarnings("unchecked")
	public boolean addGoodsReceiptXpoAst(Integer new_unique_id, Date new_create_date, String creator, int gr_uid, String gr_no, int gr_user_uid, int gr_sec, int assymap_uid, Double po_quan, Double gr_quan, String is_closed, Date gr_date,
						String gr_comment) {

		Map cond = new HashMap();
		cond.put("mp_status", 	"GR" );
		cond.put("gr_no",  		gr_no );
		cond.put("gr_seq", 		gr_sec);
		cond.put("gr_qty", 	gr_quan);
		cond.put("gr_user_id", creator );
		cond.put("is_closed", "Y");//纻 Ƿ Y ȴ.
		cond.put("gr_date",  gr_date);
		cond.put("gr_reason", gr_comment);
        
		//Ŭ ƴϸ ڵ ϳ ߰ Ѵ. --κ԰̴.
		if(is_closed.compareToIgnoreCase("N") == 0) {
			if( copyXpoAst4GRByUid(new_unique_id, new_create_date, assymap_uid, po_quan, gr_quan, creator) <0)
				return false;
			cond.put("po_qty", gr_quan );// ԰Ǽ ֹǼ
		}
		else {
			cond.put("po_qty", po_quan );// ֹǼ ״
		}
        
		cond.put("unique_id", assymap_uid);
		if( xpoastDao.update("xpoast-cond-unique_id", cond) == null)
			return false;
        
		return true;
	}
	
	

	//pr Ʈŷ
	public List getOrderTrakingList(String date_type, String s_date, String e_date, String no_type, String s_type_no, String e_type_no, String wa_name, String dept_code, String sel_item_code, String var_item_code, 
			String item_name, String rush_order_flag, String gr_complete_flag, String worker_type, String user_name, String status, String seller_code){
		Map<String, Object> cond = new HashMap<String, Object>();
		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");

		Date date = new Date();
		
		//޿ڵ˻
		cond.put("seller_code",seller_code);
		//޿ڵ˻
		
		//˻
		cond.put("wa_name",wa_name);
		//˻
		
		//μڵ˻
		cond.put("dept_code",dept_code);
		//μڵ˻
		
		//ǰڵ,纰ڵ˻
		cond.put(sel_item_code, var_item_code);
		cond.put("var_item_code",var_item_code);
		//ǰڵ,纰ڵ˻
		
		//̸˻
		cond.put("item_name",item_name);
		//̸˻		
	
		//޿ΰ˻
		cond.put("rush_order_flag",rush_order_flag);
		//޿ΰ˻		
		
		//°˻
		if(status != null){

			if(status.equals("PR")){ //ſû
				
				cond.put("status",status);
				cond.put("state","I");
				cond.put("rtg_type","R");
				
			}else if(status.equals("DE")){ //ſûݷ
				
				cond.put("status",status);
				cond.put("state","D");
				cond.put("rtg_type","R");
				
			}else if(status.equals("CR")){ //
				
				cond.put("status",status);
				cond.put("state","A");
				cond.put("rtg_type","R");
				
			}else if(status.equals("P0")){ //
				
				cond.put("status",status);
				cond.put("state","A");
				cond.put("rtg_type","R");
				
			}
		}else if(status == null){
	
				cond.put("status",null);
				cond.put("state",null);
				cond.put("rtg_type",null);
				
		}
		//°˻
		
		//pr ɶ change_date ٲ ݷ,,ҽÿ ٲ ʴ´.
		//change_date óassymap ǰų pr ɶ ٲ.
		//System.out.println(date_type);
		
		if(date_type == null){ //Ʈ.
			cond.put("create_date", "create_date"); 
			cond.put("s_date",dateFormat.format(date));
			cond.put("e_date",dateFormat.format(date));
		}else{
			//û¥, ˻. ¥ ԷµǾ߸ ˻.
			cond.put(date_type, s_date.replace("/","-")); 
			cond.put("s_date",s_date.replace("/","-"));
			cond.put("e_date",e_date.replace("/","-"));
			//û¥, ˻.
		}
		
		//û,μ,ûװ˻
		cond.put(worker_type, user_name); 
		cond.put("user_name", user_name); 
		//û,μ,ûװ˻
		
		return this.rtgastDao.select_cond("pr-ordertrack",cond);
	}
	
	//poƮŷ
	public List getPoOrderTrakingList(String date_type, String s_date, String e_date, String no_type, String s_type_no, String e_type_no, String wa_name, String dept_code, String sel_item_code, String var_item_code, 
			String item_name, String rush_order_flag, String gr_complete_flag, String worker_type, String user_name, String status, String seller_code){
		Map<String, String> cond = new HashMap<String, String>();
		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
		Date date = new Date();
		
		//޿ڵ˻ : ʵ尡 .
		cond.put("seller_code",seller_code);
		//޿ڵ˻
		
		//˻
		cond.put("wa_name",wa_name);
		//˻
		
		//μڵ˻
		cond.put("dept_code",dept_code);
		//μڵ˻
		
		//ǰڵ,纰ڵ˻
		cond.put(sel_item_code, var_item_code);
		cond.put("var_item_code",var_item_code);
		//ǰڵ,纰ڵ˻
		
		//̸˻
		cond.put("item_name",item_name);
		//̸˻		
	
		//޿ΰ˻
		cond.put("rush_order_flag",rush_order_flag);
		//޿ΰ˻		
		
	
		//°˻
		if(status != null){
			cond.put("status",status);
			/*
			if(status.equals("PO")){ //ſû	
				cond.put("status",status);	
			}else if(status.equals("DE")){ //ſûݷ				
				cond.put("status",status);	
			}else if(status.equals("SN1")){ //				
				cond.put("status",status);
			}else if(status.equals("SN2")){ //			
				cond.put("status",status);				
			}
			*/
		}else if(status == null){
				cond.put("status",null);				
		}
		//°˻
	
		
		//pr ɶ change_date ٲ ݷ,,ҽÿ ٲ ʴ´.
		//change_date óassymap ǰų pr ɶ ٲ.
		
		if(date_type == null){ //Ʈ.

			cond.put("po_date", "po_date"); 
			cond.put("s_date",dateFormat.format(date));
			cond.put("e_date",dateFormat.format(date));
			
		}else{
			
			//ֹ¥, û¥, ˻. ¥ ԷµǾ߸ ˻.
			cond.put(date_type, s_date.replace("/","-")); 
			cond.put("s_date",s_date.replace("/","-"));
			cond.put("e_date",e_date.replace("/","-"));
			//ֹ¥, û¥, ˻.
		}
		
		//ֹ, û,μ,ûװ˻
		cond.put(worker_type, user_name); 
		cond.put("user_name", user_name); 
		//ֹ, û,μ,ûװ˻
		
		//ֹȣ,POȣ˻ : s_type_no(POȣ˻) ?
		cond.put(no_type, s_type_no); 
		cond.put("s_type_no", s_type_no); 
		cond.put("e_type_no", e_type_no); 
		//ֹȣ,POȣ˻
		
		//԰˻ : ԰ xpoast ִ?
		cond.put("gr_complete_flag", gr_complete_flag); 
		//԰˻	
		
		
		return this.xpoastDao.select_cond("po-ordertrack",cond);
	}
	

	//԰Ȳ
	public List getGoodsReceiptCancel(
			String date_type, 
			String s_date, 
			String e_date, 
			String no_type, 
			String s_type_no, 
			String e_type_no, 
			String gr_type, 
			String s_gr_type_no, 
			String e_gr_type_no, 
			String seller_code,
			String wa_name, 
			String dept_code, 
			String division_code,
			String gr_reason,
			String sel_item_code, 
			String var_item_code, 
			String item_name, 
			String po_type,
			String status, 
			String account_name,
			String arap_flag,
			String worker_type, 
			String var_user_name				
	) {
		Map<String, String> cond = new HashMap<String, String>();

		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
		Date date = new Date();
		
		if(date_type == null){ //Ʈ.

			cond.put("cn_date", "cn_date"); 
			cond.put("s_date",dateFormat.format(date));
			cond.put("e_date",dateFormat.format(date));
			
		}else{
			
			cond.put(date_type, "cn_date"); 
			cond.put("s_date",s_date.replace("/","-"));
			cond.put("e_date",e_date.replace("/","-"));
		}

		//ֹȣ,POȣ˻
		cond.put(no_type, s_type_no); 
		cond.put("s_type_no", s_type_no); 
		cond.put("e_type_no", e_type_no); 

		//԰ȣ,grȣ˻
		cond.put(gr_type, s_gr_type_no); 
		cond.put("s_gr_type_no", s_gr_type_no); 
		cond.put("e_gr_type_no", e_gr_type_no); 	
		
		//޿ڵ˻ : ʵ尡 .
		cond.put("seller_code",seller_code);

		//˻
		cond.put("wa_name",wa_name);

		//μڵ˻
		cond.put("dept_code",dept_code);

		//ڵ˻
		cond.put("division_code",division_code);

		//ڵ˻
		if(gr_reason != null)
			cond.put("gr_reason","%"+gr_reason+"%");

		//ǰڵ,纰ڵ˻
		cond.put(sel_item_code, var_item_code);
		cond.put("var_item_code",var_item_code);

		//̸˻
		cond.put("item_name",item_name);
	
		//
		cond.put("po_type",po_type);		
		
		//óа˻
		cond.put("status",status);				

		//̸
		cond.put("account_name",account_name);	
		
		//꿩
		//cond.put("arap_flag",arap_flag);	
		
		//԰
		cond.put(worker_type, var_user_name); 
		cond.put("user_name", var_user_name); 
		
		return this.xpoastDao.select_cond("xpoast-gr-cancel",cond);
	}
	
	//԰Ȳ
	public List getGoodsReceiptGr(
			String mp_status,
			String is_final,
			String date_type, 
			String s_date, 
			String e_date, 
			String no_type, 
			String s_type_no, 
			String e_type_no, 
			String gr_type, 
			String s_gr_type_no, 
			String e_gr_type_no,
			String seller_code,
			String seller_name,
			String wa_name, 
			String dept_code, 
			String division_code,
			String gr_reason,
			String sel_item_code, 
			String var_item_code, 
			String item_name, 
			String po_type,
			String status,
			String account_code,
			String account_name,
			String arap_flag,
			String worker_type, 
			String po_user_name,
			String gr_user_name,
			String wa_code
	) {

		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
		Map<String, String> cond = new HashMap<String, String>();

		
		//̹ 1ϰ  Ʈ 
		Calendar rightNow = Calendar.getInstance();
		Date today 	= rightNow.getTime();
		int  date	= rightNow.get(Calendar.DATE);
		
		rightNow.add(Calendar.DATE, (-1)*date+1);
//		Date firstDay = rightNow.getTime();
		
		if(s_date == null || e_date==null){ //Ʈ.

			//cond.put("s_date",dateFormat.format(firstDay));
			cond.put("s_date",dateFormat.format(today));
			cond.put("e_date",dateFormat.format(today));
			
		}else{
			
			cond.put("s_date",s_date.replace("/","-"));
			cond.put("e_date",e_date.replace("/","-"));
		}
		
		if(mp_status.compareToIgnoreCase("GR_PO")==0) {
			cond.put("po_or_gr", mp_status);//ҵ Ѵ.
		}
		else {
			cond.put("mp_status", mp_status);
			cond.put(date_type, date_type);
		}
		
		if(is_final.compareToIgnoreCase("ALL")!=0)//All̸ whereʿ.
			cond.put("is_final", is_final);

		//ֹȣ,POȣ˻
		cond.put("s_type_no", s_type_no); 
		//԰ȣ,grȣ˻
		cond.put("s_gr_type_no", s_gr_type_no); 
		//޿ڵ˻ : ʵ尡 .
		cond.put("seller_code",seller_code);
		if(seller_name != null)
			cond.put("seller_name","%"+seller_name+"%");
		//˻
		cond.put("wa_name",wa_name);
		//μڵ˻
		cond.put("dept_code",dept_code);
		//ڵ˻
		cond.put("division_code",division_code);
		//ڵ˻
		if(gr_reason != null)
			cond.put("gr_reason","%"+gr_reason+"%");

		//ǰڵ,纰ڵ˻
		cond.put("var_item_code",var_item_code);

		//̸˻
		cond.put("item_name",item_name);
	
		//
		cond.put("po_type",po_type);		
		
		//óа˻
		cond.put("status",status);				

		//̸
		cond.put("account_code", account_code);	
		cond.put("account_name", account_name);	
		
		//꿩
		//cond.put("arap_flag",arap_flag);	
		
		//ֹ, ԰
		cond.put("po_user_name", po_user_name); 
		cond.put("gr_user_name", gr_user_name); 
		
		cond.put("wa_code", wa_code); //ڽ 常 ˻.
	
		return this.xpoastDao.select_cond("xpoast-gr-row",cond);

	}
	
	//԰Ȳ
	public List getGoodsReceipt(
			String date_type, 
			String s_date, 
			String e_date, 
			String no_type, 
			String s_type_no, 
			String e_type_no, 
			String gr_type, 
			String s_gr_type_no, 
			String e_gr_type_no, 
			String seller_code,
			String wa_name, 
			String dept_code, 
			String division_code,
			String gr_reason,
			String sel_item_code, 
			String var_item_code, 
			String item_name, 
			String po_type,
			String status, 
			String account_name,
			String arap_flag,
			String worker_type, 
			String var_user_name				
	) {

		
		Map<String, String> cond = new HashMap<String, String>();
		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
		Date date = new Date();
		
		if(date_type == null){ //Ʈ.

			cond.put("gr_date", "gr_date"); 
			cond.put("s_date",dateFormat.format(date));
			cond.put("e_date",dateFormat.format(date));
			
		}else{
			
			cond.put(date_type, "gr_date"); 
			cond.put("s_date",s_date.replace("/","-"));
			cond.put("e_date",e_date.replace("/","-"));
		}

		//ֹȣ,POȣ˻
		cond.put(no_type, s_type_no); 
		cond.put("s_type_no", s_type_no); 
		cond.put("e_type_no", e_type_no); 

		//԰ȣ,grȣ˻
		cond.put(gr_type, s_gr_type_no); 
		cond.put("s_gr_type_no", s_gr_type_no); 
		cond.put("e_gr_type_no", e_gr_type_no); 	
		
		//޿ڵ˻ : ʵ尡 .
		cond.put("seller_code",seller_code);

		//˻
		cond.put("wa_name",wa_name);

		//μڵ˻
		cond.put("dept_code",dept_code);

		//ڵ˻
		cond.put("division_code",division_code);

		//ڵ˻
		if(gr_reason != null)
			cond.put("gr_reason","%"+gr_reason+"%");

		//ǰڵ,纰ڵ˻
		cond.put(sel_item_code, var_item_code);
		cond.put("var_item_code",var_item_code);

		//̸˻
		cond.put("item_name",item_name);
	
		//
		cond.put("po_type",po_type);		
		
		//óа˻
		cond.put("status",status);				

		//̸
		cond.put("account_name",account_name);	
		
		//꿩
		//cond.put("arap_flag",arap_flag);	
		
		//ֹ, ԰
		cond.put(worker_type, var_user_name); 
		cond.put("user_name", var_user_name); 
	
		return this.xpoastDao.select_cond("xpoast-gr",cond);

	}
	
	/*
	 *  (non-Javadoc)
	 *  : 1. ex) ԰:10 -> ԰:5 AND Ŭ:Y -> ԰ ʰڴٴ°ɷ .
	 * 				 xpoast gr_qty -5 . po_qty 0 .
	 * 				 = po_qty : 10+0 = 10
	 * 				 = gr_qty : 10+(-5) = 5
	 */
	public void deleteGoodsReceipt(Integer[] rtg_uid, String[] lo_is_closed, Double[] li_gr_quan, int item_qty,  String content) {
		
		for(int i=0; i<item_qty; i++){
			//Ŭ 'Y'? 'N'?
			if(rtg_uid[i] != null){
				
				if(lo_is_closed[i].equalsIgnoreCase("Y")){
					this.grCancelY(rtg_uid[i], li_gr_quan[i], content);
					//Ŭ'Y'϶ 
					this.XpoHeadUpdate(rtg_uid[i], li_gr_quan[i]);
				}else{
					this.grCancelN(rtg_uid[i], li_gr_quan[i], content);
				}
			
				
			}
		}
	}	
	
	//Ŭ Ʈ
	private void XpoHeadUpdate(Integer rtg_uid, Double li_gr_quan){
		
		XpoAst xpoAst = null;
		xpoAst = (XpoAst)this.baseLineDao.select_uid("xpoast",rtg_uid);	
		
		
		Map<String, String> cond = new HashMap<String, String>();
	
		cond.put("po_no", xpoAst.getPo_no());
		cond.put("po_seq", xpoAst.getPo_seq());
		cond.put("is_final", "Y");
		
		this.baseLineDao.update("xpoast-cond-rc", cond);
	}
	
	
	//ο xpoast
	/*
	 * Ķ  : ũ̵, +&-Ÿ, Ÿ.
	 *     	 : ԰Ұ ɶ xpoast  ޼.
	 */
	private void grXpoInsert(Integer rtg_uid, int type,  Double gr_qty, Double po_qty, String state, String closed, String content, String is_final){
		Double gr_quan 	= 0.0;
		Double po_quan 	= 0.0;
		int	num			= type;
		
		Random ran 		= new Random();
		int iRand		= ran.nextInt();
		if(iRand < 0) {
			iRand = (-1)* iRand;
		}
		
		XpoAst xpoAst = null;
		xpoAst = (XpoAst)this.baseLineDao.select_uid("xpoast",rtg_uid);
		
		gr_quan = gr_qty * (num);
		po_quan = po_qty * (num);
		
		xpoAst.setUnique_id(iRand);
		xpoAst.setPo_qty(po_quan);
		xpoAst.setGr_qty(gr_quan);
		xpoAst.setMp_status(state);
		xpoAst.setIs_closed(closed);
		xpoAst.setCreate_date(new Date());
		xpoAst.setChange_date(new Date());
		xpoAst.setGr_reason(content);
		xpoAst.setIs_final(is_final);
		
		this.baseLineDao.insert(xpoAst.getCreator(),"xpoast",xpoAst);	
	}
	
	
	private void grCancelY(Integer rtg_uid, Double li_gr_quan, String content){
		this.grXpoInsert(rtg_uid, -1, li_gr_quan, 0.0, "RC", "Y", content, "Y");
	}
	
	
	private void grCancelN(Integer rtg_uid, Double li_gr_quan, String content){
		this.grXpoInsert(rtg_uid, -1, li_gr_quan, li_gr_quan, "RC", "Y", content, "N");
		this.grXpoInsert(rtg_uid, 1, 0.0, li_gr_quan, "PO", "N", content, "Y");
	}
	
	
	@SuppressWarnings("unused")
	private void editRc(List unique_id_list, String status){
		Map<String, Object> cond = new HashMap<String, Object>();
		cond.put("unique_id_list",unique_id_list);
		cond.put("mp_status",status);
		cond.put("change_date",new Date());
		this.baseLineDao.update("xpoast-gr",cond);
	}
	
	//	-------------------- Ϸ(PaymentComplete) ------------------

	public void addPaymentComplete(Integer item_quan, Integer[] xpoast_uids,
			String txt_name, String txt_content, String item_abst, 
			String ac_userid, String ac_user_name, String wa_code, /*Double ac_sum,ȮѰ   */
			Integer coord_key
			) {
		
		List<Integer> unique_id_list = new ArrayList<Integer>();
		
		for(int i=0; i < item_quan; i++) {
			unique_id_list.add(xpoast_uids[i]);
		}
		Map<String, Object> cond = new HashMap<String, Object>();
		cond.put("unique_id_list",unique_id_list);
		
		Double ac_sum = this.tableInfoDao.getTotalPriceXpoAst(cond);
		
		Integer last_no = this.getSysinfoDao().GetLastUnChecked("A");
		RtgAst rtgast = new RtgAst("A", last_no);
		String cur_ac_no =  rtgast.getPo_no();
			
		//ʿ  .
		rtgast.setChanger(ac_userid);
		rtgast.setWork_cursor(-1);
		rtgast.setState("A");
		rtgast.setItem_quan(item_quan);
		rtgast.setItem_abst(item_abst);
		rtgast.setContent(txt_content);
		rtgast.setName(txt_name);
		rtgast.setUser_id(ac_userid);
		rtgast.setUser_name(ac_user_name);
		rtgast.setWa_code(wa_code);
		rtgast.setTotal_price(ac_sum); //<---
		rtgast.setCoord_key(coord_key);
		
		this.baseLineDao.insert(ac_userid, "rtgast", rtgast);
		this.getSysinfoDao().SetLastValue("A", last_no);
		
		//cond.put("mp_status","AC");
		cond.put("change_date",new Date());
		cond.put("is_final", "Y");
		cond.put("doc_type", cur_ac_no);
		
		this.baseLineDao.update("xpoast-gr",cond);
		
		
	}
	public List getPaymentComplete(int py_uid) {
		// TODO Auto-generated method stub
		return null;
	}

	public void deletePaymentComplete(int py_uid, List item_uid_list) {
		// TODO Auto-generated method stub
		
	}
	public List getXpoAstList(String po_no) {
		Map<String, Comparable> cond = new HashMap<String, Comparable>();
		cond.put("po_no", po_no);
		return this.baseLineDao.select_cond("xpoast", cond);
	}
	
	public void RefreshGrQuan(Integer rtgast_uid) {
		//ֹ rtgast Refresh
		RefreshPoRtgastByGr(rtgast_uid);
		//ſû rtgast Refresh
		RefreshPrRtgastByGr(rtgast_uid);
	}
	public void RefreshPoRtgastByGr(Integer rtgast_uid) {
		
		Integer gr_quan = this.tableInfoDao.getGrQuanByRtgAst(rtgast_uid);
		Integer not_gr_auan = this.tableInfoDao.getNotGrQuanByRtgAst(rtgast_uid);
		Integer item_quan = this.tableInfoDao.getItemQuanByRtgAst(rtgast_uid);
		
		Map<String, Comparable> cond = new HashMap<String, Comparable>();
		cond.put("item_quan",item_quan);
		cond.put("coord_key1",gr_quan);
		cond.put("coord_key2",not_gr_auan);
		cond.put("unique_id",rtgast_uid);
		if( not_gr_auan < 1)
			cond.put("state","G");
		
		rtgastDao.update("general-routing",cond);
		
	}
	
	/*ſû ֹͰ ȳ  
	 * 
	 */
	public void RefreshPrRtgastByPr(Integer /*PR uid*/pr_uid) {
		Integer po_quan = this.tableInfoDao.getNotGrQuanByRtgAstPr(pr_uid);
		Integer item_quan = this.tableInfoDao.getItemQuanByRtgAstPr(pr_uid);
		Integer not_po_quan = item_quan - po_quan;
		
		Map<String, Comparable> cond1 = new HashMap<String, Comparable>();
		cond1.put("item_quan",item_quan);
		cond1.put("coord_key1",po_quan);
		cond1.put("coord_key2",not_po_quan);
		cond1.put("unique_id",pr_uid);
		if( not_po_quan < 1)
			cond1.put("state","S");
		
		rtgastDao.update("general-routing",cond1);
	}
	
	//ֹ شϴ û ľ û ֹ  Ͱ ȳ  
	public void RefreshPrRtgastByPo(Integer /*PO uid*/po_uid) {
		
		Map<String, Object> cond = new HashMap<String, Object>();
		cond.put("po_uid",po_uid);

		List po_list = this.getBaseLineDao().select_cond("assymap", cond);
		
		Set<Integer> pr_uid_set = new HashSet<Integer>();
		
    	for(Iterator i=po_list.iterator(); i.hasNext();)
    	{
    		AssyMap assymap = (AssyMap)i.next();
    		pr_uid_set.add(assymap.getPr_uid());
    	}
    	
    	for(Iterator i=pr_uid_set.iterator(); i.hasNext();)
    	{
    		Integer pr_uid = (Integer)i.next();
    		RefreshPrRtgastByPr(pr_uid);
    	}
		
	}
	
	
	//	ſû rtgast Refresh
	public void RefreshPrRtgastByGr(Integer rtgast_uid) {
		
		Map<String, Integer> cond = new HashMap<String, Integer>();
		cond.put("po_uid",rtgast_uid);

		List po_list = this.getBaseLineDao().select_cond("assymap", cond);
		
		Set<Integer> pr_uid_set = new HashSet<Integer>();
		
    	for(Iterator i=po_list.iterator(); i.hasNext();)
    	{
    		AssyMap assymap = (AssyMap)i.next();
    		pr_uid_set.add(assymap.getPr_uid());
    	}
    	
    	for(Iterator i=pr_uid_set.iterator(); i.hasNext();)
    	{
    		Integer pr_uid = (Integer)i.next();
    		
    		if( this.tableInfoDao.getNotGrQuanByRtgAstPr(pr_uid) < 1) {
    			Map<String, Comparable> cond1 = new HashMap<String, Comparable>();
    			cond1.put("state","G");
    			cond1.put("unique_id", pr_uid);
    			rtgastDao.update("general-routing",cond1);
    		}
  
    	}
    	
	}
	public List getAcList(String wa_code, String s_date, String e_date, String supplier_code, String supplier_name) {

//		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
//		Date date = new Date();
		
		Map<String, String> condition = new HashMap<String, String>();
		
		if(s_date != null && e_date!=null){ //Ʈ.
			condition.put("s_date",s_date.replace("/","-"));
			condition.put("e_date",e_date.replace("/","-"));
		}
		
		if(supplier_code != null)
			condition.put("supplier_code", supplier_code);
		
		if(supplier_name != null)
			condition.put("supplier_name", supplier_name);
		
		condition.put("rtg_type", "A");
		
		
		return rtgastDao.getDynamic(condition);

	}
	public List getAcDetail(String doc_type) {
		Map<String, String> cond = new HashMap<String, String>();
		cond.put("doc_type", doc_type);
		return this.baseLineDao.select_cond("xpoast", cond);
	}
	public XpoAst getLineItemByUid(Integer xpoast_uid) {
		return (XpoAst)xpoastDao.select_uid("xpoast", xpoast_uid);
	}

	//ֹ
	public void editPoCancel(Integer[] rtg_uid, Double[] cn_quan, Double[] po_quan, String dr_id, String dr_info){
		Map<String, Object> assyCond 	= new HashMap<String, Object>();
		Map<String, Object> xpoastCond 	= new HashMap<String, Object>();
		
		Double real_quan = 0.0;					//											
		
		for(int i = 0; i < rtg_uid.length; i++){
			real_quan = po_quan[i] - cn_quan[i];
			
			assyCond.put("unique_id",rtg_uid[i]);
			assyCond.put("quan"		,real_quan);
			assyCond.put("mquan"	,cn_quan[i]);
			this.baseLineDao.update("de-assymap",assyCond);
			
			xpoastCond.put("unique_id"		,rtg_uid[i]);
			xpoastCond.put("po_qty"			,real_quan);
			xpoastCond.put("po_blocking_qty",cn_quan[i]);
			xpoastCond.put("dr_id"			,dr_id);
			xpoastCond.put("dr_info"		,dr_info);
			xpoastCond.put("dr_info_flag"	,"Y");
			xpoastCond.put("dr_cnt"			,"true");
			xpoastCond.put("plus_quan"		,real_quan);
			xpoastCond.put("dr_date"		,new Date());
			this.baseLineDao.update("xpoast-cond",xpoastCond);
		}
	}
	public void cancelPourchaseOrderLine(Integer cur_user_uid, String changer, Integer[] assymap_uid_list, Integer item_quan) {
		
		List<Integer> unique_id_list = new ArrayList<Integer>();
		
		for(int i=0; i< item_quan; i++ )
			unique_id_list.add(assymap_uid_list[i]);
		
		//AssyMap Restore
		Map<String, Object> cond = new HashMap<String, Object>();
		cond.put("user_uid", cur_user_uid);	//û
		cond.put("po_uid", -1);	//po  
		cond.put("unique_id_list", unique_id_list);
		assymapDao.update("bm2cr-assymap-iter", cond);
		
		//XpoAst 
		Map<String, Object> cond1 = new HashMap<String, Object>();
		cond1.put("unique_id_list", unique_id_list);
		cond1.put("change_date", new Date());
		cond1.put("changer", changer);
		this.baseLineDao.update("purge-xpoast-iter", cond1);
	}
	public void RefreshPoQuan(Integer rtgast_uid) {
		Integer item_quan = this.tableInfoDao.getItemQuanByRtgAst(rtgast_uid);

		Map<String, Comparable> cond = new HashMap<String, Comparable>();
		cond.put("item_quan",item_quan);
		cond.put("unique_id",rtgast_uid);
		if( item_quan < 1)
			cond.put("state","S");
		
		rtgastDao.update("general-routing",cond);
		
	}
	
	public void RefreshTotalPrice(String po_no, Double total_price) {
		Map<String, Comparable> cond = new HashMap<String, Comparable>();
		cond.put("po_no", po_no);
		cond.put("total_price", total_price);
		
		rtgastDao.update("total_price",cond);
		
	}
	
	public void RefreshAcTotalPrice(String[] doc_type, int quan) {
		
		for(int i=0; i<quan; i++) {
			String po_no = doc_type[i];
			Double total_price = this.tableInfoDao.getTotalPriceXpoAstByDocType(po_no);
			RefreshTotalPrice(po_no, total_price);
		}
		
	}

}



