package com.rfxsoft.justrfx.business.k_gate;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.BeanCreationException;
import org.springframework.beans.factory.InitializingBean;

import com.rfxsoft.justrfx.domain.AssyMap;
import com.rfxsoft.justrfx.domain.ComBst;
import com.rfxsoft.justrfx.domain.ErrHwGr;
import com.rfxsoft.justrfx.domain.ErrHwPo;
import com.rfxsoft.justrfx.domain.IhwGr;
import com.rfxsoft.justrfx.domain.IhwPo;
import com.rfxsoft.justrfx.domain.ImkOdt;
import com.rfxsoft.justrfx.domain.OdtAst;
import com.rfxsoft.justrfx.domain.SrcList;
import com.rfxsoft.justrfx.domain.UsrAst;

public class DefaultGateManager extends AbstractDaoBasedGateManager implements InitializingBean 
{
	public void afterPropertiesSet() throws Exception {
		if (ihwpoDao == null)  throw new BeanCreationException("Must set ihwpodao on DefaultGateManager");
		if (ihwgrDao == null)  throw new BeanCreationException("Must set ihwgrdao on DefaultGateManager");
		if (imkodtDao == null) throw new BeanCreationException("Must set imkodtdao on DefaultGateManager");
		if (imkrfqDao == null) throw new BeanCreationException("Must set imkrfqdao on DefaultGateManager");
		if (errhwpoDao == null) throw new BeanCreationException("Must set errhwpoDao on DefaultGateManager");
		if (errhwgrDao == null) throw new BeanCreationException("Must set errhwgrDao on DefaultGateManager");
		if (odtastDao == null) throw new BeanCreationException("Must set odtastDao on DefaultGateManager");		
	}
	
	private SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd");
	private SimpleDateFormat dateFormat1 = new SimpleDateFormat("yyyyMMddHHmmss");
	
	// PO : IHWPO ̺ ̽÷(interface_flag='N') 'N'ΰ͸ 븦 Ѵ.
	public List getIhwpoList(String table_name){
		return ihwpoDao.select_all(table_name);
	}
	
	public ErrHwPo getIhwpoList(String table_name, int unique_id) {
		return (ErrHwPo)errhwpoDao.select_uid(table_name,unique_id);
	}
	
	// IHWPO ̺ ̽ ÷׸ 'Y' 
	public boolean setIhwpoIfFlag(Date interface_date, String po_no, String po_seq, String wa_code, String status){
		Map<String, Comparable> cond = new HashMap<String, Comparable>();
		
		cond.put("status", status);
		cond.put("po_no", po_no);
		cond.put("po_seq", po_seq);
		cond.put("wa_code", wa_code);
		cond.put("interface_date", interface_date);
		
		if (ihwpoDao.update("ihwpo-all", cond) != null) {
			return true;
		}else{
			return false;
		}
	}
	
	// (ihwpo)status, po_no, po_seq, wa_code ߺǴ Ÿ  'Y' ϰ ߺٰ Ѵ.
	public int editValidateDup(String status, String po_no, String po_seq, String wa_code){
		Map<String, Comparable> cond = new HashMap<String, Comparable>();
		
		cond.put("status", status);
		cond.put("po_no", po_no);
		cond.put("po_seq", po_seq);
		cond.put("wa_code", wa_code);		
		
		List tmp = this.baseLineDao.select_cond("ihwpo", cond);
		IhwPo ihwpo = new IhwPo();
		ihwpo = null;
		int return_value = 0;
		IhwGr ihwgr = new IhwGr();
		
		for (Iterator i=tmp.iterator(); i.hasNext();) {
			ihwpo = (IhwPo)i.next();
			
			if (ihwpo != null) {
				String err = "[ֹȣ : "+po_no+"], [ֹ׹ : "+po_seq+"] ش DATA ̹ ֹ  DATAԴϴ.(ߺǾϴ)";
				if (this.ValidateInsert("PO", ihwpo, ihwgr, err) == true){
					if (this.setIhwpoIfErr(po_no, po_seq, wa_code, status, err) == true) {
						// ߺ Ÿ
						return_value = 1;
					}else{
						// update ߻
						return_value = -1;
					}
				}else{
					return_value = -1;
				}
			}
		}
		//  = 0, ߺŸ = 1, update ߻ = 2
		return return_value;
	}
	
	// IHWPO ̺ α׸ ´.
	public boolean setIhwpoIfErr(String po_no, String po_seq, String wa_code, String status, String err){
		Map<String, Comparable> cond = new HashMap<String, Comparable>();
		
		cond.put("po_no", po_no);
		cond.put("po_seq", po_seq);
		cond.put("wa_code", wa_code);
		cond.put("status", status);
		cond.put("error_reason", err);
		cond.put("error_reason_date", new Date());
		
		if (ihwpoDao.update("ihwpo", cond) != null) {
			return true;
		}else{
			return false;
		}
	}
	
	// ⺻ üũ
	public boolean ValidateDefault(String type, IhwPo ihwpo, IhwGr ihwgr){
		if ("PO".equals(type)) {
			// PO
			if (ihwpo.getStatus() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "°   ʽϴ.");
				return false;
			}else if (!ihwpo.getStatus().equalsIgnoreCase("C")) {//°  ƴϰ C ƴϾ .
				this.ValidateInsert("PO", ihwpo, ihwgr, "  Ҵ   ʽϴ.");
				return false;
			}else if (ihwpo.getPo_no() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "ֹȣ  ʽϴ.");
				return false;
			}else if (ihwpo.getPo_seq() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "ֹ׹  ʽϴ.");
				return false;
			}else if (ihwpo.getDivision_code() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "Division_code  ʽϴ.");
				return false;
			}else if (ihwpo.getItem_code() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "ǰڵ尡  ʽϴ.");
				return false;
			}else if (ihwpo.getReq_delivery_date() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "  ʽϴ.");
				return false;
			}else if (ihwpo.getPo_creator_id() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "ֹ ID  ʽϴ.");
				return false;
			}else if (ihwpo.getPo_creator_name() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "ֹ ̸  ʽϴ.");
				return false;
			}/*else if (ihwpo.getPo_creator_tel_no() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "ֹ ȭȣ  ʽϴ.");
				return false;
			}*/else if (ihwpo.getReceiver_name() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "μ ̸  ʽϴ.");
				return false;
			}/*else if (ihwpo.getReceiver_tel_no() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "μ ȭȣ  ʽϴ.");
				return false;
			}else if (ihwpo.getDelivery_zip_code() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "ǰó ȣ  ʽϴ.");
				return false;
			}*/else if (ihwpo.getDelivery_address_1() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "ǰó ּ1  ʽϴ.");
				return false;
			}else if (ihwpo.getCompany_code() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "ȸڵ尡  ʽϴ.");
				return false;			
			}else if (ihwpo.getPo_qty() <= 0) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "ֹ '0'̰ų ׺ ۽ϴ.");
				return false;
			}else if (ihwpo.getUnit_code() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "  ʽϴ.");
				return false;
			}else if (ihwpo.getSales_price() <= 0) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "ܰ '0'̰ų ׺ ۽ϴ.");
				return false;
			}else if (ihwpo.getSales_amount() <= 0) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "ݾ '0'̰ų ׺ ۽ϴ.");
				return false;
			}			
		}else{
			// GR
			if (ihwgr.getStatus() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "°   ʽϴ.");
				return false;
			}else if (!ihwgr.getStatus().equalsIgnoreCase("C")) {//°  ƴϰ C ƴϾ .
				this.ValidateInsert("GR", ihwpo, ihwgr, "  Ҵ   ʽϴ.");
				return false;
			}else if (ihwgr.getCompany_code() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "ȸڵ尡  ʽϴ.");
				return false;
			}else if (ihwgr.getYear() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "ȸ⵵  ʽϴ.");
				return false;
			}else if (ihwgr.getGr_no() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "GR_NO  ʽϴ.");
				return false;
			}else if (ihwgr.getGr_seq() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "GR_SEQ  ʽϴ.");
				return false;
			}else if (ihwgr.getPo_no() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "PO_NO  ʽϴ.");
				return false;
			}else if (ihwgr.getPo_seq() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "PO_SEQ  ʽϴ.");
				return false;
			}else if (ihwgr.getItem_code() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "ǰڵ尡  ʽϴ.");
				return false;
			}else if (ihwgr.getGr_qty() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "԰  ʽϴ.");
				return false;
			}else if (ihwgr.getUnit_price() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "ܰ  ʽϴ.");
				return false;
			}else if (ihwgr.getReceiving_amount() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "԰ݾ  ʽϴ.");
				return false;
			}else if ((Double.parseDouble(ihwgr.getGr_qty().toString()) * Double.parseDouble(ihwgr.getUnit_price().toString())) != ihwgr.getReceiving_amount()) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "(ܰ*) ԰ݾװ ٸϴ.");
				return false;
			}else if (ihwgr.getGr_date() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "԰ڰ  ʽϴ.");
				return false;
			}else if (ihwgr.getWa_code() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "ڵ尡  ʽϴ.");
				return false;
			}else if (ihwgr.getCreator() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "԰ڰ  ʽϴ.");
				return false;
			}			
		}
		return true;
	}
	
	//	ߺ ޼
	public boolean ValidateDefault(String type, ErrHwPo ihwpo, ErrHwGr ihwgr){
		if ("ERR_PO".equals(type)) {
			// PO
			if (ihwpo.getStatus() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "°   ʽϴ.");
				return false;
			}else if (!ihwpo.getStatus().equalsIgnoreCase("C")) {//°  ƴϰ C ƴϾ .
				this.ValidateInsert("PO", ihwpo, ihwgr, "  Ҵ   ʽϴ.");
				return false;
			}else if (ihwpo.getPo_no() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "ֹȣ  ʽϴ.");
				return false;
			}else if (ihwpo.getPo_seq() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "ֹ׹  ʽϴ.");
				return false;
			}else if (ihwpo.getDivision_code() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "Division_code  ʽϴ.");
				return false;
			}else if (ihwpo.getItem_code() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "ǰڵ尡  ʽϴ.");
				return false;
			}else if (ihwpo.getReq_delivery_date() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "  ʽϴ.");
				return false;
			}else if (ihwpo.getPo_creator_id() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "ֹ ID  ʽϴ.");
				return false;
			}else if (ihwpo.getPo_creator_name() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "ֹ ̸  ʽϴ.");
				return false;
			}/*else if (ihwpo.getPo_creator_tel_no() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "ֹ ȭȣ  ʽϴ.");
				return false;
			}*/else if (ihwpo.getReceiver_name() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "μ ̸  ʽϴ.");
				return false;
			}/*else if (ihwpo.getReceiver_tel_no() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "μ ȭȣ  ʽϴ.");
				return false;
			}*/else if (ihwpo.getDelivery_zip_code() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "ǰó ȣ  ʽϴ.");
				return false;
			}else if (ihwpo.getDelivery_address_1() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "ǰó ּ1  ʽϴ.");
				return false;
			}else if (ihwpo.getCompany_code() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "ȸڵ尡  ʽϴ.");
				return false;			
			}else if (ihwpo.getPo_qty() <= 0) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "ֹ '0'̰ų ׺ ۽ϴ.");
				return false;
			}else if (ihwpo.getUnit_code() == null) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "  ʽϴ.");
				return false;
			}else if (ihwpo.getSales_price() <= 0) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "ܰ '0'̰ų ׺ ۽ϴ.");
				return false;
			}else if (ihwpo.getSales_amount() <= 0) {
				this.ValidateInsert("PO", ihwpo, ihwgr, "ݾ '0'̰ų ׺ ۽ϴ.");
				return false;
			}			
		}else{
			// GR
			if (ihwgr.getStatus() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "°   ʽϴ.");
				return false;
			}else if (!ihwpo.getStatus().equalsIgnoreCase("C")) {//°  ƴϰ C ƴϾ .
				this.ValidateInsert("GR", ihwpo, ihwgr, "  Ҵ   ʽϴ.");
				return false;
			}else if (ihwgr.getCompany_code() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "ȸڵ尡  ʽϴ.");
				return false;
			}else if (ihwgr.getYear() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "ȸ⵵  ʽϴ.");
				return false;
			}else if (ihwgr.getGr_no() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "GR_NO  ʽϴ.");
				return false;
			}else if (ihwgr.getGr_seq() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "GR_SEQ  ʽϴ.");
				return false;
			}else if (ihwgr.getPo_no() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "PO_NO  ʽϴ.");
				return false;
			}else if (ihwgr.getPo_seq() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "PO_SEQ  ʽϴ.");
				return false;
			}else if (ihwgr.getItem_code() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "ǰڵ尡  ʽϴ.");
				return false;
			}else if (ihwgr.getGr_qty() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "԰  ʽϴ.");
				return false;
			}else if (ihwgr.getUnit_price() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "ܰ  ʽϴ.");
				return false;
			}else if (ihwgr.getReceiving_amount() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "԰ݾ  ʽϴ.");
				return false;
			}else if ((Double.parseDouble(ihwgr.getGr_qty().toString()) * Double.parseDouble(ihwgr.getUnit_price().toString())) != ihwgr.getReceiving_amount()) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "(ܰ*) ԰ݾװ ٸϴ.");
				return false;
			}else if (ihwgr.getGr_date() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "԰ڰ  ʽϴ.");
				return false;
			}else if (ihwgr.getWa_code() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "ڵ尡  ʽϴ.");
				return false;
			}else if (ihwgr.getCreator() == null) {
				this.ValidateInsert("GR", ihwpo, ihwgr, "԰ڰ  ʽϴ.");
				return false;
			}			
		}
		return true;		
	}
	
    /**
     * ȸ, ,  ˻
     */
	public int ValidateUser(String type, IhwPo ihwpo, IhwGr ihwgr) {
		int usrast_unique_id = -1;

		if ("PO".equals(type)) {
			// PO
            Map<String, Comparable> cond = new HashMap<String, Comparable>();            
			cond.put("company_code", ihwpo.getCompany_code());
			cond.put("wa_code", ihwpo.getWa_code());
			cond.put("user_id", ihwpo.getPo_creator_id());
            
            List List_usrast = this.baseLineDao.select_cond("if-usrast", cond);
            
            if (List_usrast != null && List_usrast.size() > 0){
                for(Iterator i=List_usrast.iterator(); i.hasNext();) {
                    UsrAst usrast = (UsrAst)i.next();
                    usrast_unique_id = usrast.getUnique_id();
                }
                return usrast_unique_id;
            }else{
                this.ValidateInsert(type, ihwpo, ihwgr, "ϵ user ƴմϴ.");
                return usrast_unique_id;
            }
            
		}else{
            // GR  ȸ  ȸϰ ڴ ýۿ ϴ  ˻Ѵ.
            Map<String, Comparable> cond = new HashMap<String, Comparable>();
			cond.put("company_code", ihwgr.getCompany_code());
			cond.put("wa_code", ihwgr.getWa_code());
            
            List lstCombst = this.baseLineDao.select_cond("combst", cond);
            
            if (lstCombst == null || lstCombst.size() == 0){
                this.ValidateInsert(type, ihwpo, ihwgr, "ϵ ȸ   ʰų 谡 Ʋϴ.");
                return usrast_unique_id;
            }
            
            Map<String, Comparable> usrCond = new HashMap<String, Comparable>();
            usrCond.put("user_id", ihwgr.getCreator());
            
            List lstUser = this.baseLineDao.select_cond("if-usrast", usrCond);
            if (lstUser != null && lstUser.size() > 0){
                for(Iterator i=lstUser.iterator(); i.hasNext();) {
                    UsrAst usrast = (UsrAst)i.next();
                    usrast_unique_id = usrast.getUnique_id();
                }
                return usrast_unique_id;
            }else{
                this.ValidateInsert(type, ihwpo, ihwgr, "ϵ user ƴմϴ.");
                return usrast_unique_id;
            }            
		}

	}
	
	//	ߺ ޼	
	public int ValidateUser(String type, ErrHwPo ihwpo, ErrHwGr ihwgr){
		Map<String, Comparable> cond = new HashMap<String, Comparable>();
		int usrast_unique_id = -1;

		if ("PO".equals(type)) {
			// PO
			cond.put("company_code", ihwpo.getCompany_code());
			cond.put("wa_code", ihwpo.getWa_code());
			cond.put("user_id", ihwpo.getPo_creator_id());
		}else{
			// GR
			cond.put("company_code", ihwgr.getCompany_code());
			cond.put("wa_code", ihwgr.getWa_code());
			cond.put("user_id", ihwgr.getCreator());
		}
		
		List List_usrast = this.baseLineDao.select_cond("if-usrast", cond);
		
		if (List_usrast != null && List_usrast.size() > 0){
			for(Iterator i=List_usrast.iterator(); i.hasNext();) {
				UsrAst usrast = (UsrAst)i.next();
				usrast_unique_id = usrast.getUnique_id();
			}
			return usrast_unique_id;
		}else{
			this.ValidateInsert(type, ihwpo, ihwgr, "ϵ user ƴմϴ.");
			return usrast_unique_id;
		}
	}
	
	// combst о´.
	public ComBst getComBst(String wa_code){
		Map<String, Comparable> cond = new HashMap<String, Comparable>();
		
		cond.put("wa_code", wa_code);
		
		List tmp = this.baseLineDao.select_cond("combst-if", cond);
		
		ComBst combst = new ComBst();
		
		for (Iterator i=tmp.iterator(); i.hasNext();) {
			combst = (ComBst)i.next();
		}
		
		return combst;
	}
	
	// Srclist о´.
	public List getSrclist(String buyer_item_code, int combst_uid){
		Map<String, Comparable> cond = new HashMap<String, Comparable>();
		
		cond.put("combst_uid", combst_uid);
		cond.put("buyer_item_code", buyer_item_code);
		
		return this.baseLineDao.select_cond("srclist", cond);
	}
	
	//  ǰ(srcmap ǰ != 0 && ġؾ ), ԰(srcahd source_price != 0) ˻
	public Map ValidateSrclist(IhwPo ihwpo, int combst_uid){
		Map<String, Comparable> cond = new HashMap<String, Comparable>();		
		IhwGr ihwgr = new IhwGr();
		int    item_uid  = -1;
		String item_code = "";
		
		List List_srclist = this.getSrclist(ihwpo.getItem_code(), combst_uid);

		if (List_srclist != null && List_srclist.size() > 0){
			for(Iterator i=List_srclist.iterator(); i.hasNext();) {
				SrcList srclist = (SrcList)i.next();
				
				item_uid  = srclist.getSrcahd_uid();
				item_code = srclist.getItem_code();
				
				cond.put("item_uid", item_uid);
				cond.put("item_code", item_code);
				
				if (srclist.getSales_price() <= 0) {
					this.ValidateInsert("PO", ihwpo, ihwgr, "ǰ '0'̰ų ׺ ۽ϴ.");
					
					cond.put("return_value", -1);
					return cond;
				}else if (!srclist.getSales_price().equals(ihwpo.getSales_price())) {
					this.ValidateInsert("PO", ihwpo, ihwgr, "ǰ ġ ʽϴ.");
					
					cond.put("return_value", -1);
					return cond;
				}else if (srclist.getSource_price() <= 0) {
					this.ValidateInsert("PO", ihwpo, ihwgr, "԰ '0'̰ų ׺ ۽ϴ.");
					
					cond.put("return_value", -1);
					return cond;
				}
			}
			cond.put("return_value", item_uid);
			return cond;
		}else{
			this.ValidateInsert("PO", ihwpo, ihwgr, "ϵ 簡 ƴմϴ.");
			
			cond.put("return_value", -1);
			return cond;
		}
	}
	
	//ߺ ޼
	public Map ValidateSrclist(ErrHwPo ihwpo, int combst_uid){
		Map<String, Comparable> cond = new HashMap<String, Comparable>();		
		ErrHwGr ihwgr = new ErrHwGr();
		int    item_uid  = -1;
		String item_code = "";
		
		List List_srclist = this.getSrclist(ihwpo.getItem_code(), combst_uid);

		if (List_srclist != null && List_srclist.size() > 0){
			for(Iterator i=List_srclist.iterator(); i.hasNext();) {
				SrcList srclist = (SrcList)i.next();
				
				item_uid  = srclist.getSrcahd_uid();
				item_code = srclist.getItem_code();
				
				cond.put("item_uid", item_uid);
				cond.put("item_code", item_code);
				
				if (srclist.getSales_price() <= 0) {
					this.ValidateInsert("PO", ihwpo, ihwgr, "ǰ '0'̰ų ׺ ۽ϴ.");
					
					cond.put("return_value", -1);
					return cond;
				}else if (!srclist.getSales_price().equals(ihwpo.getSales_price())) {
					this.ValidateInsert("PO", ihwpo, ihwgr, "ǰ ġ ʽϴ.");
					
					cond.put("return_value", -1);
					return cond;
				}else if (srclist.getSource_price() <= 0) {
					this.ValidateInsert("PO", ihwpo, ihwgr, "԰ '0'̰ų ׺ ۽ϴ.");
					
					cond.put("return_value", -1);
					return cond;
				}
			}
			cond.put("return_value", item_uid);
			return cond;
		}else{
			this.ValidateInsert("PO", ihwpo, ihwgr, "ϵ 簡 ƴմϴ.");
			
			cond.put("return_value", -1);
			return cond;
		}
	}
	
	// RtgAst item_quan, item_abst 
	public boolean editRtgastItem(int unique_id, int item_quan, String item_abst){
		Map<String, Comparable> cond = new HashMap<String, Comparable>();
		
		cond.put("unique_id", unique_id);
		cond.put("item_quan", item_quan);
		cond.put("item_abst", item_abst);
		cond.put("state", "A");		
		
		if (this.baseLineDao.update("general-routing", cond) != null) {
			return true;
		}else{
			return false;
		}
	}
	
	// assymap 
	public Object addAssyMap(String creator, AssyMap assymap){
		return this.baseLineDao.insert(creator, "assymap", assymap);
	}
	
	// assymap PO̺  row  
	public List getAssyMap(int po_uid, int po_sec){
		Map<String, Comparable> condition = new HashMap<String, Comparable>();
		
		condition.put("po_uid", po_uid);
		condition.put("po_sec", po_sec);
		
		return this.baseLineDao.select_cond("partline", condition);
	}

	
	// AssyMap update
	public boolean editAssyMapPo(String po_no, int po_sec){
		Map<String, Object> cond = new HashMap<String, Object>();
		cond.put("po_no", po_no);
		cond.put("po_sec", po_sec);
		cond.put("status", "PO");
		
		if (this.baseLineDao.update("if-assymap", cond) != null) {
			return true;
		}else{
			return false;
		}
	}
	
	// xpoast update
	public boolean editXpoAstPo(String po_no, String po_seq, String by_po_no, String by_po_seq, String po_creator_name, 
							    String po_creator_tel_no, String receiver_name, String receiver_tel_no, String receiver_hp_no, 
							    String delivery_zip_code, String delivery_address_1, String delivery_address_2, String by_item_code, String division_code,
                                Date po_date, String account_code, String budget_wa_code, String budget_division_code, String budget_dept_code) {
		Map<String, Comparable> cond = new HashMap<String, Comparable>();

		cond.put("po_no", po_no);
		cond.put("po_seq", po_seq);
		cond.put("by_po_no", by_po_no);
		cond.put("by_po_seq", by_po_seq);
		cond.put("by_item_code", by_item_code);
		cond.put("by_po_date", po_date);
		cond.put("po_creator_name", po_creator_name);
		cond.put("po_creator_tel_no", po_creator_tel_no);
		cond.put("receiver_name", receiver_name);
		cond.put("receiver_tel_no", receiver_tel_no);
		cond.put("receiver_hp_no", receiver_hp_no);
		cond.put("delivery_zip_code", delivery_zip_code);
		cond.put("delivery_address_1", delivery_address_1);
		cond.put("delivery_address_2", delivery_address_2);
		cond.put("division_code", division_code);
		cond.put("account_code", account_code);
		cond.put("budget_wa_code", budget_wa_code);
		cond.put("budget_division_code", budget_division_code);
		cond.put("budget_dept_code", budget_dept_code);
		
		if (this.baseLineDao.update("xpoast-cond", cond) != null) {
			return true;
		}else{
			return false;
		}
	}
	
	/******************** GR **********************/
	// GR : IHWGR ̺ ̽÷(interface_flag='N') 'N'ΰ͸ 븦 Ѵ.
	public List getIhwgrList(String table_name){
		return ihwgrDao.select_all(table_name);
	}
	
	public ErrHwGr getIhwgrList(String table_name, int unique_id){
		return (ErrHwGr)errhwgrDao.select_uid(table_name,unique_id);
	}
	
	// IHWGR ̺ ̽ ÷׸ 'Y' 
	public boolean setIhwgrIfFlag(Date interface_date, String gr_no, String gr_seq, String wa_code, String status){
		Map<String, Comparable> cond = new HashMap<String, Comparable>();
		
		cond.put("status", status);
		cond.put("gr_no", gr_no);
		cond.put("gr_seq", gr_seq);
		cond.put("wa_code", wa_code);
		cond.put("interface_date", interface_date);
		
		if (ihwgrDao.update("ihwgr-all", cond) != null) {
			return true;
		}else{
			return false;
		}
	}
	
	// IHWGR ̺ α׸ ´.
	public boolean setIhwgrIfErr(String gr_no, String gr_seq, String wa_code, String status, String err){
		Map<String, Comparable> cond = new HashMap<String, Comparable>();
		
		cond.put("gr_no", gr_no);
		cond.put("gr_seq", gr_seq);
		cond.put("wa_code", wa_code);
		cond.put("status", status);
		cond.put("error_reason", err);
		cond.put("error_reason_date", new Date());
		
		if (ihwgrDao.update("ihwgr", cond) != null) {
			return true;
		}else{
			return false;
		}
	}

	// xpoast po_no, po_seq ִ ˻
	public List ValidateGr(String po_no, String po_seq){
		Map<String, Comparable> cond = new HashMap<String, Comparable>();
		
		cond.put("po_no", po_no);
		cond.put("po_seq", po_seq);
		
		return this.baseLineDao.select_cond("xpoast", cond);
	}
	
	// xpoast po_no, po_seq ˻ Ѵ.
	public List getXpoAstGr(String by_po_no, String by_po_seq){
		Map<String, Comparable> cond = new HashMap<String, Comparable>();
		
		cond.put("by_po_no", by_po_no);
		cond.put("by_po_seq", by_po_seq);
		
		return this.baseLineDao.select_cond("if-xpoast", cond);
	}
	
	// gr_no, gr_seq ãƼ xpoast ׷ updateѴ.(by_gr_no, by_gr_seq, by_gr_year)
	public boolean editXpoAstGr(String gr_no, String gr_seq, String wa_code, String by_gr_no, String by_gr_seq, String by_gr_year){
		Map<String, Comparable> cond = new HashMap<String, Comparable>();
		
		cond.put("gr_no", gr_no);
		cond.put("gr_seq", gr_seq);
		cond.put("wa_code", wa_code);
		cond.put("by_gr_no", by_gr_no);
		cond.put("by_gr_seq", by_gr_seq);
		cond.put("by_gr_year", by_gr_year);
		
		if (this.baseLineDao.update("xpoast-cond", cond) != null){
			return true;
		}else{
			return false;
		}
	}
	

	/******************** űǰ **********************/
	// űǰ
	//public List getIhwgrList(String table_name){
		
	//}
	
	/******************** ǰ **********************/
	// ǰ : imkodt ̺ ̽÷(if_flag = 'N') 'N'ΰ͸ 븦 Ѵ.
	public List getImkodtList(String table_name){
		return imkodtDao.select_all(table_name);
	}
	
	// odtast domain  
	public boolean OdtastDomainSet(ImkOdt imkodt, OdtAst odtast){
		odtast.setStatus(imkodt.getStatus());
		odtast.setSn_no(imkodt.getSn_no());
		odtast.setSn_status(imkodt.getSn_status());
		odtast.setPo_no(imkodt.getPo_no());
		odtast.setPo_seq(imkodt.getPo_seq());
		odtast.setBy_po_no(imkodt.getBy_po_no());
		odtast.setBy_po_seq(imkodt.getBy_po_seq());
		odtast.setItem_code(imkodt.getItem_code());
		odtast.setBy_item_code(imkodt.getBy_item_code());
		odtast.setItem_name(imkodt.getItem_name());
		odtast.setDescription(imkodt.getDescription());
		odtast.setMaker_name(imkodt.getMaker_name());
		odtast.setModel_no(imkodt.getModel_no());
		odtast.setUnit_code(imkodt.getUnit_code());
		odtast.setSp_code(imkodt.getSp_code());
		odtast.setSp_name(imkodt.getSp_name());
		odtast.setPo_date(imkodt.getPo_date());
		odtast.setPo_time(imkodt.getPo_time());
		odtast.setReq_delivery_date(imkodt.getReq_delivery_date());
		odtast.setRush_order_flag(imkodt.getRush_order_flag());
		odtast.setPo_creator_emp_no(imkodt.getPo_creator_emp_no());
		odtast.setPo_creator_name(imkodt.getPo_creator_name());
		odtast.setPo_creator_tel_no(imkodt.getPo_creator_tel_no());
		odtast.setReceiver_emp_no(imkodt.getReceiver_emp_no());
		odtast.setReceiver_name(imkodt.getReceiver_name());
		odtast.setReceiver_tel_no(imkodt.getReceiver_tel_no());
		odtast.setDelivery_zip_code(imkodt.getDelivery_zip_code());
		odtast.setDelivery_address_1(imkodt.getDelivery_address_1());
		odtast.setDelivery_address_2(imkodt.getDelivery_address_2());
		odtast.setPo_qty(imkodt.getPo_qty());
		odtast.setSn_qty(imkodt.getSn_qty());
		odtast.setSales_price(imkodt.getSales_price());
		odtast.setSales_amount(imkodt.getSales_amount());
		odtast.setSales_currency(imkodt.getSales_currency());
		odtast.setSn_create_date(imkodt.getSn_create_date());
		odtast.setSn_create_time(imkodt.getSn_create_time());
		odtast.setSn_date(imkodt.getSn_date());
		odtast.setDc_date(imkodt.getDc_date());
		odtast.setDc_time(imkodt.getDc_time());
		odtast.setInterface_date(imkodt.getInterface_date());
		odtast.setInterface_time(imkodt.getInterface_time());
		odtast.setInvest_no(imkodt.getInvest_no());
		odtast.setCompany_code(imkodt.getCompany_code());
		odtast.setSn_wa_code(imkodt.getSn_wa_code());
		odtast.setSn_division_code(imkodt.getSn_division_code());
		odtast.setSn_dept_code(imkodt.getSn_dept_code());
		odtast.setBudget_wa_code(imkodt.getBudget_wa_code());
		odtast.setBudget_division_code(imkodt.getBudget_division_code());
		odtast.setBudget_dept_code(imkodt.getBudget_dept_code());
		odtast.setAccount_code(imkodt.getAccount_code());
		odtast.setRemark1(imkodt.getRemark1());
		odtast.setImk_unique_key(imkodt.getUnique_key());
		odtast.setCreate_datetime(imkodt.getCreate_datetime());
		odtast.setCreator(imkodt.getCreator());
		odtast.setChange_datetime(dateFormat1.format(new Date()).toString());
		odtast.setChanger("System");
		
		return this.addOdtast("System", odtast);
	}
	
	// ѰǾ odtast Ѵ.
	public boolean addOdtast(String creator, OdtAst odtast){
		if (odtastDao.insert(creator, "odtast", odtast) != null){
			return true;
		}else{
			return false;
		}
	}
	
	// ѰǾ assymap status tr_uid updateѴ.
	public boolean editAssymapTruid(String po_no, int po_sec, String status, int tr_uid){
        Map<String, Object> cond = new HashMap<String, Object>();        
		
		cond.put("tr_uid", tr_uid);
		cond.put("status", status);
		cond.put("po_no", po_no);
		cond.put("po_sec", po_sec);
        
        System.out.println("AssyMap --------------> " + cond.toString());
		
		if (this.baseLineDao.update("if-assymap", cond) != null){
			return true;
		}else{
			return false;
		}
	}
	
	// ѰǾ xpoast mp_status updateѴ.
	public boolean editXpoAstMpStatus(String po_no, String po_seq, String mp_status){
		Map<String, Comparable> cond = new HashMap<String, Comparable>();
		
		cond.put("po_no", po_no);
		cond.put("po_seq", po_seq);
		cond.put("mp_status", mp_status);
		
		if (this.baseLineDao.update("xpoast-cond", cond) != null){
			return true;
		}else{
			return false;
		}
	}
	
	// ѰǾ imkodt if_flag = 'Y', ,ڸ updateѴ.
	public boolean editImkodt(String po_no, String po_sec){
		Map<String, Comparable> cond = new HashMap<String, Comparable>();
		
		cond.put("changer", "System");
		cond.put("change_datetime", dateFormat1.format(new Date()).toString());
		cond.put("if_flag", "Y");
		cond.put("po_no", po_no);
		cond.put("po_seq", po_sec);
	   
		if (this.baseLineDao.update("imkodt", cond) != null){
			return true;
		}else{
			return false;
		}
	}
	
	/******************** űǰ **********************/
	// űǰ
	//public List getIhwgrList(String table_name){
		
	//}
	
	// ȿ ˻翡 հ óǸ PO Errer̺ ϰ IHWPO̺   Ѵ.
	// ȿ ˻翡 հ óǸ GR Errer̺ ϰ IHWGR̺   Ѵ.
	public boolean ValidateInsert(String type, IhwPo ihwpo, IhwGr ihwgr, String err){
	
		if ("PO".equals(type)) {
			// PO Err Table insert
			ErrHwPo errhwpo = new ErrHwPo();
			
			errhwpo.setAccount_code(ihwpo.getAccount_code());
			errhwpo.setBudget_dept_code(ihwpo.getBudget_dept_code());
			errhwpo.setBudget_division_code(ihwpo.getBudget_division_code());
			errhwpo.setBudget_wa_code(ihwpo.getBudget_wa_code());
			errhwpo.setCreator(ihwpo.getCreator());
			errhwpo.setChange_date(new Date());
			errhwpo.setChanger(ihwpo.getChanger());
			errhwpo.setCompany_code(ihwpo.getCompany_code());
			errhwpo.setDelivery_address_1(ihwpo.getDelivery_address_1());
			errhwpo.setDelivery_address_2(ihwpo.getDelivery_address_2());
			errhwpo.setDelivery_zip_code(ihwpo.getDelivery_zip_code());
			errhwpo.setDept_code(ihwpo.getDept_code());
			errhwpo.setDivision_code(ihwpo.getDivision_code());
			errhwpo.setError_reason(err);
			errhwpo.setError_reason_date(new Date());
			errhwpo.setInterface_date(String2Date("2001/01/01"));
			errhwpo.setInterface_flag("N");
			errhwpo.setInvest_no(ihwpo.getInvest_no());
			errhwpo.setItem_code(ihwpo.getItem_code());
			errhwpo.setItem_name(ihwpo.getItem_name());			
			errhwpo.setMaker_name(ihwpo.getMaker_name());
			errhwpo.setModel_no(ihwpo.getModel_no());
			errhwpo.setPo_creator_id(ihwpo.getPo_creator_id());
			errhwpo.setPo_creator_name(ihwpo.getPo_creator_name());
			errhwpo.setPo_creator_tel_no(ihwpo.getPo_creator_tel_no());
			errhwpo.setPo_date(ihwpo.getPo_date());
			errhwpo.setPo_no(ihwpo.getPo_no());
			errhwpo.setPo_qty(ihwpo.getPo_qty());
			errhwpo.setPo_seq(ihwpo.getPo_seq().toString());
			errhwpo.setReceiver_hp_no(ihwpo.getReceiver_hp_no());
			errhwpo.setReceiver_id(ihwpo.getReceiver_id());
			errhwpo.setReceiver_name(ihwpo.getReceiver_name());
			errhwpo.setReceiver_tel_no(ihwpo.getReceiver_tel_no());
			errhwpo.setReq_delivery_date(ihwpo.getReq_delivery_date());
			errhwpo.setReq_info(ihwpo.getReq_info());
			errhwpo.setRush_order_flag(ihwpo.getRush_order_flag());
			errhwpo.setSales_amount(ihwpo.getSales_amount());
			errhwpo.setSales_currency(ihwpo.getSales_currency());
			errhwpo.setSales_exchange_rate(ihwpo.getSales_exchange_rate());
			errhwpo.setSales_price(ihwpo.getSales_price());
			errhwpo.setSp_code(ihwpo.getSp_code());
			errhwpo.setSp_name(ihwpo.getSp_name());
			errhwpo.setSpecification(ihwpo.getSpecification());
			errhwpo.setStatus(ihwpo.getStatus());
			errhwpo.setUnit_code(ihwpo.getUnit_code());
			errhwpo.setWa_code(ihwpo.getWa_code());

			if (errhwpoDao.insert(errhwpo.getCreator(), errhwpo) != null) {
				// IHWPO ̺ ̽ ÷׸ 'Y' 			
				return this.setIhwpoIfErr(ihwpo.getPo_no(), ihwpo.getPo_seq(), ihwpo.getWa_code(), ihwpo.getStatus(), err);
			}else{
				return false;
			}
		}else{
			// GR Err Table insert
			ErrHwGr errhwgr = new ErrHwGr();
			
			errhwgr.setCreator(ihwgr.getCreator());
			errhwgr.setChange_date(new Date());
			errhwgr.setChanger(ihwgr.getChanger());
			errhwgr.setCompany_code(ihwgr.getCompany_code());
			errhwgr.setCurrency(ihwgr.getCurrency());
			errhwgr.setDept_code(ihwgr.getDept_code());
			errhwgr.setDivision_code(ihwgr.getDivision_code());
			errhwgr.setError_reason(err);
			errhwgr.setError_reason_date(new Date());
			errhwgr.setGr_date(ihwgr.getGr_date());
			errhwgr.setGr_no(ihwgr.getGr_no());
			errhwgr.setGr_qty(ihwgr.getGr_qty());
			errhwgr.setGr_seq(ihwgr.getGr_seq());
			errhwgr.setInterface_date(String2Date("2001/01/01"));
			errhwgr.setInterface_flag("N");
			errhwgr.setItem_code(ihwgr.getItem_code());
			errhwgr.setItem_name(ihwgr.getItem_name());
			errhwgr.setPo_no(ihwgr.getPo_no());
			errhwgr.setPo_seq(ihwgr.getPo_seq().toString());
			errhwgr.setPo_status(ihwgr.getPo_status());
			errhwgr.setReceiving_amount(ihwgr.getReceiving_amount());
			errhwgr.setSpecification(ihwgr.getSpecification());
			errhwgr.setStatus(ihwgr.getStatus());
			errhwgr.setUnit_code(ihwgr.getUnit_code());
			errhwgr.setUnit_price(ihwgr.getUnit_price());
			errhwgr.setWa_code(ihwgr.getWa_code());
			errhwgr.setYear(ihwgr.getYear());
			
			if (errhwgrDao.insert(errhwgr.getCreator(), errhwgr) != null) {
				// IHWGR ̺ ̽ ÷׸ 'Y' 
				return this.setIhwgrIfErr(ihwgr.getGr_no(), ihwgr.getGr_seq(), ihwgr.getWa_code(), ihwgr.getStatus(), err);
			}else{
				return false;
			}
		}
	}
		
	/**
     * I/F Error  
	 */
	public boolean ValidateInsert(String type, ErrHwPo ihwpo, ErrHwGr ihwgr, String err){
		
		if ("ERR_PO".equals(type)) {
			// PO Err Table insert
			ErrHwPo errhwpo = new ErrHwPo();
			
			errhwpo.setAccount_code(ihwpo.getAccount_code());
			errhwpo.setBudget_dept_code(ihwpo.getBudget_dept_code());
			errhwpo.setBudget_division_code(ihwpo.getBudget_division_code());
			errhwpo.setBudget_wa_code(ihwpo.getBudget_wa_code());
			errhwpo.setCreator(ihwpo.getCreator());
			errhwpo.setChange_date(new Date());
			errhwpo.setChanger(ihwpo.getChanger());
			errhwpo.setCompany_code(ihwpo.getCompany_code());
			errhwpo.setDelivery_address_1(ihwpo.getDelivery_address_1());
			errhwpo.setDelivery_address_2(ihwpo.getDelivery_address_2());
			errhwpo.setDelivery_zip_code(ihwpo.getDelivery_zip_code());
			errhwpo.setDept_code(ihwpo.getDept_code());
			errhwpo.setDivision_code(ihwpo.getDivision_code());
			errhwpo.setError_reason(err);
			errhwpo.setError_reason_date(new Date());
			errhwpo.setInterface_date(String2Date("2001/01/01"));
			errhwpo.setInterface_flag("N");
			errhwpo.setInvest_no(ihwpo.getInvest_no());
			errhwpo.setItem_code(ihwpo.getItem_code());
			errhwpo.setItem_name(ihwpo.getItem_name());			
			errhwpo.setMaker_name(ihwpo.getMaker_name());
			errhwpo.setModel_no(ihwpo.getModel_no());
			errhwpo.setPo_creator_id(ihwpo.getPo_creator_id());
			errhwpo.setPo_creator_name(ihwpo.getPo_creator_name());
			errhwpo.setPo_creator_tel_no(ihwpo.getPo_creator_tel_no());
			errhwpo.setPo_date(ihwpo.getPo_date());
			errhwpo.setPo_no(ihwpo.getPo_no());
			errhwpo.setPo_qty(ihwpo.getPo_qty());
			errhwpo.setPo_seq(ihwpo.getPo_seq().toString());
			errhwpo.setReceiver_hp_no(ihwpo.getReceiver_hp_no());
			errhwpo.setReceiver_id(ihwpo.getReceiver_id());
			errhwpo.setReceiver_name(ihwpo.getReceiver_name());
			errhwpo.setReceiver_tel_no(ihwpo.getReceiver_tel_no());
			errhwpo.setReq_delivery_date(ihwpo.getReq_delivery_date());
			errhwpo.setReq_info(ihwpo.getReq_info());
			errhwpo.setRush_order_flag(ihwpo.getRush_order_flag());
			errhwpo.setSales_amount(ihwpo.getSales_amount());
			errhwpo.setSales_currency(ihwpo.getSales_currency());
			errhwpo.setSales_exchange_rate(ihwpo.getSales_exchange_rate());
			errhwpo.setSales_price(ihwpo.getSales_price());
			errhwpo.setSp_code(ihwpo.getSp_code());
			errhwpo.setSp_name(ihwpo.getSp_name());
			errhwpo.setSpecification(ihwpo.getSpecification());
			errhwpo.setStatus(ihwpo.getStatus());
			errhwpo.setUnit_code(ihwpo.getUnit_code());
			errhwpo.setWa_code(ihwpo.getWa_code());
			
			if (errhwpoDao.insert(errhwpo.getCreator(), errhwpo) != null) {
				// ̺ .			
				errhwpoDao.delete("errhwpo", ihwpo.getUnique_id());
				return true;
			}else{
				return false;
			}
		}else{
			// GR Err Table insert
			ErrHwGr errhwgr = new ErrHwGr();
			
			errhwgr.setCreator(ihwgr.getCreator());
			errhwgr.setChange_date(new Date());
			errhwgr.setChanger(ihwgr.getChanger());
			errhwgr.setCompany_code(ihwgr.getCompany_code());
			errhwgr.setCurrency(ihwgr.getCurrency());
			errhwgr.setDept_code(ihwgr.getDept_code());
			errhwgr.setDivision_code(ihwgr.getDivision_code());
			errhwgr.setError_reason(err);
			errhwgr.setError_reason_date(new Date());
			errhwgr.setGr_date(ihwgr.getGr_date());
			errhwgr.setGr_no(ihwgr.getGr_no());
			errhwgr.setGr_qty(ihwgr.getGr_qty());
			errhwgr.setGr_seq(ihwgr.getGr_seq());
			errhwgr.setInterface_date(String2Date("2001/01/01"));
			errhwgr.setInterface_flag("N");
			errhwgr.setItem_code(ihwgr.getItem_code());
			errhwgr.setItem_name(ihwgr.getItem_name());
			errhwgr.setPo_no(ihwgr.getPo_no());
			errhwgr.setPo_seq(ihwgr.getPo_seq().toString());
			errhwgr.setPo_status(ihwgr.getPo_status());
			errhwgr.setReceiving_amount(ihwgr.getReceiving_amount());
			errhwgr.setSpecification(ihwgr.getSpecification());
			errhwgr.setStatus(ihwgr.getStatus());
			errhwgr.setUnit_code(ihwgr.getUnit_code());
			errhwgr.setUnit_price(ihwgr.getUnit_price());
			errhwgr.setWa_code(ihwgr.getWa_code());
			errhwgr.setYear(ihwgr.getYear());
			
			if (errhwgrDao.insert(errhwgr.getCreator(), errhwgr) != null) {
				errhwgrDao.delete("errhwgr", ihwgr.getUnique_id());
				return true;
			}else{
				return false;
			}
		}
	}
	
	public Date String2Date(String value) {
		
		Date date = null;
		if(value==null) {
			return date;
		}
		try {
			date = dateFormat.parse(value);
		} catch (ParseException e) {
			e.printStackTrace();
		}
		
		return date;
	}

    /**
     * ERRHWPO õ  ȸ
     */
    public List getErrhwpoList()
    {
        return errhwpoDao.select_all("errhwpo");
    }

    /**
     * ERRHWGR õ  ȸ
     */
    public List getErrhwgrList()
    {   
        return errhwgrDao.select_all("errhwgr");
    }
}
