package com.rfxsoft.justrfx.business.k_gate.file_write;


import java.io.DataOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.BeanCreationException;
import org.springframework.beans.factory.InitializingBean;

import com.rfxsoft.justrfx.domain.AssyMap;
import com.rfxsoft.justrfx.domain.ComAst;
import com.rfxsoft.justrfx.domain.UsrAst;
import com.rfxsoft.justrfx.domain.XpoAst;

public class DefaultFileWriteManager extends AbstractDaoBasedFileWriteManager
		implements InitializingBean {

    // private static final String FILE_PATH = "c:/if_imk/if_imk/isnd/";
    private static final String FILE_PATH = "/mroweb/if_imk/if_imk/isnd/"; 
    
	public void afterPropertiesSet() throws Exception {
		if (xpoastDao == null)  throw new BeanCreationException("Must set xpoastDao on DefaultFileWriteManager");
	}

	private SimpleDateFormat dateFormat = new SimpleDateFormat("yyyyMMdd");
	private SimpleDateFormat dateFormat1 = new SimpleDateFormat("HHmmss");
	
	/********************* PO ********************/
	// PO ڷḦ ˻Ѵ.(assymap status='PO'), GR ڷḦ ˻Ѵ. (xpoast is_close='Y', gr_sended='N')
	public List getPoGrList(String status) {
		if ("PO".equals(status)) {
			// PO
			Map<String, String> cond = new HashMap<String, String>();
			cond.put("status", status);
			
			return this.baseLineDao.select_cond("assymap", cond);
		}else{
			// GR
			return this.baseLineDao.select_all("if-xpoast");
		}
	}
	
	// PO ڷḦ ˻Ͽ(xpoast po_no, po_seq) file writeѴ.
	public boolean setPoFileWrite(List po_list) {
		String cur_date = dateFormat.format(new Date());
		String cur_time = dateFormat1.format(new Date());
		String req_info = "";
		
		String file_name = FILE_PATH + "1N080000POMT" + cur_date + cur_time + ".txt";
		//String file_name = path + "TEST" + cur_date + cur_time + ".txt";		
		
		UsrAst usrastFile 	= null;
		
		/*
        File dest = new File(file_name);

        // dest  ̹ ϸ .
        if ( dest.exists() )
       	   dest.delete();
       	*/
		
	    String []la_chkPath = FILE_PATH.split("/");
	    String ls_tmpPath = "";
	    
	    //  ϴ   
	    for (int i=0; i<la_chkPath.length; i++){
	       ls_tmpPath += "/" + la_chkPath[i];
	       replace(ls_tmpPath, "//", "/");
	       
	       if (ls_tmpPath.trim().length() < 2) continue;
	       
	       File lf_tmp = new File(ls_tmpPath);
	       if(lf_tmp.isDirectory()) continue;
	       
	       lf_tmp.mkdir();
        }

		Map<String, Comparable> cond = new HashMap<String, Comparable>();
		String ls_file_tmp = "";
		String ls_rate     = "";
		FileOutputStream fo_po = null;
//		FileInputStream fi_po = null;
		
		DataOutputStream dos = null;
//		DataInputStream dis = null;
		
//		InputStreamReader isr = null;
		
		
		try{
			try {
				fo_po = new FileOutputStream(file_name, true);
//				fi_po = new FileInputStream(file_name);
				
				dos   = new DataOutputStream(fo_po);
				
				/*
				try {
					isr = new InputStreamReader(fi_po, "UTF8");
				} catch (UnsupportedEncodingException e) {
					e.printStackTrace();
				}
				*/
				
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			for(Iterator i=po_list.iterator(); i.hasNext();) {
				AssyMap assymap = (AssyMap)i.next();

				cond.clear();
				cond.put("po_no", assymap.getPo_no());
				cond.put("po_seq", assymap.getPo_sec());
				
				// file write (xpoast)  ã´.
				List tmp = this.baseLineDao.select_cond("xpoast", cond);
				
				if (tmp.size() <= 0) continue; 

				XpoAst xpoast = new XpoAst();
				xpoast = null;
				req_info = "";

				for(Iterator j=tmp.iterator(); j.hasNext();) {
					xpoast = (XpoAst)j.next();
				}

				if (xpoast != null) {
					if (xpoast.getReq_info() != null) {
						req_info = replace(xpoast.getReq_info(), "\r", " ");
						req_info = replace(req_info, "\n", " ");
					}
					
					if (xpoast.getSales_currency() != null) {
						if (xpoast.getSales_currency().trim() == "KRW") {
							ls_rate = "";
						}else{
							if (xpoast.getSales_exchange_rate() != null) {
								ls_rate = xpoast.getSales_exchange_rate().toString();
							}else{
								ls_rate = "";
							}					
						}
					}else{
						ls_rate = "";
					}
				}
				//xpoast.getPo_creator_id() comast sourcing_group(=ھ̵) ͼ
				//usrast ȸ ̵,̸,ȭȣ Ͽ .                
				usrastFile 		= this.getPoInfo(xpoast.getCompany_code());
                				
				//ڵ.
				Map codeMap = this.getPoCode(usrastFile.getUser_id()); //sourcing_group
				
				//μ(=μڵ)̵ ȸ
				Map rcvrMap = this.getRcvrInfo(xpoast.getReceiver_id(), xpoast.getReceiver_tel_no(), xpoast.getReceiver_hp_no());
				

				try {
					ls_file_tmp =	  this.fixLenString("C", 1)
									+ this.fixLenString(this.setHanString(xpoast.getPo_no()), 20) 
									+ this.fixLenString(this.setHanString(xpoast.getPo_seq().toString()), 10)
									/********** Division **********/
									+ this.fixLenString(this.nullCk(xpoast.getCompany_code(), ""), 15)
									/********** Division  ********/
								    + this.fixLenString("OGN", 10)
								    + this.fixLenString(this.setHanString(xpoast.getItem_code()), 30)
								    + this.fixLenString(this.setHanString(this.nullCk(xpoast.getItem_name())), 100)
								    + this.fixLenString(this.setHanString(this.nullCk(xpoast.getSpecification())), 255)
								    + this.fixLenString(this.nullCk(""), 50)
								    + this.fixLenString(this.setHanString(this.nullCk(xpoast.getModel_no())), 100)
								    + this.fixLenString(this.setHanString(this.nullCk(xpoast.getSp_code())), 6)
								    + this.fixLenString(this.nullCk(""), 50)
								    + this.fixLenString(dateFormat.format(xpoast.getPo_date()), 8)
								    + this.fixLenString(dateFormat1.format(xpoast.getPo_date()), 6)
								    + this.fixLenString(dateFormat.format(xpoast.getReq_delivery_date()), 8)
								    + this.fixLenString(this.nullCk(xpoast.getRush_order_flag(), "N"), 1)
							        + this.fixLenString(this.setHanString(this.nullCk(usrastFile.getUser_id())), 20) 							//ھ̵
							        + this.fixLenString(this.setHanString(this.nullCk(usrastFile.getUser_name())), 40)				//̸
							        + this.fixLenString(this.setHanString(this.nullCk(usrastFile.getTel_no())), 20)  				//ȭȣ
							        //+ this.fixLenString(this.setHanString(xpoast.getReceiver_id()), 20)
							        + this.fixLenString(this.nullCk(""), 20)														//μ ̵ imk  ش.
								    + this.fixLenString(this.setHanString(this.nullCk(xpoast.getReceiver_name())), 40)
								    + this.fixLenString(this.setHanString(this.nullCk((String)rcvrMap.get("tel_no"))), 20)
								    + this.fixLenString(this.setHanString(this.nullCk((String)rcvrMap.get("hp_no"))), 20)
								    + this.fixLenString(this.setHanString(this.nullCk(xpoast.getDelivery_zip_code())), 7)
								    + this.fixLenString(this.setHanString(this.nullCk(xpoast.getDelivery_address_1())), 100)
								    + this.fixLenString(this.setHanString(this.nullCk(xpoast.getDelivery_address_2())), 100)
								    + this.fixLenString(this.setHanString(this.nullCk(req_info)), 255)
								    + this.fixLenString(this.setHanString(this.nullCk(xpoast.getInvest_no(), "")), 20)
								    + this.fixLenString(this.setHanString(this.nullCk((String)codeMap.get("company_code"))), 10)   	//ȸڵ  : ϵڵ ־ش.
								    + this.fixLenString(this.setHanString(this.nullCk((String)codeMap.get("wa_code"))), 10)        	//ڻڵ
								    /*********** Division ********/
								    //+ this.fixLenString(this.nullCk("", "TEST"), 10)												//ڻڵ
								    + this.fixLenString(this.setHanString(this.nullCk((String)codeMap.get("division_code"))), 10)
								    /**********Division  *********/
								    + this.fixLenString(this.setHanString(this.nullCk((String)codeMap.get("dept_code"))), 20)		//ںμڵ
								    /*************  ***************/
								    + this.fixLenString(this.nullCk(""), 10)
								    + this.fixLenString(this.nullCk(""), 10)
								    + this.fixLenString(this.nullCk(""), 10)
								    /*************   ***************/
								    /*************  ***************/
								    + this.fixLenString(this.setHanString(this.nullCk(xpoast.getAccount_code(), "")), 12)
								    /************   ***************/
								    + this.fixLenString(xpoast.getPo_qty().toString(), 15)
								    + this.fixLenString(this.setHanString(this.nullCk(xpoast.getUnit_code())), 10)
                                    
								    + this.fixLenString(xpoast.getBuying_price().toString(), 17)
								    + this.fixLenString(xpoast.getBuying_amount().toString(), 17)
                                    
								    + this.fixLenString(this.setHanString(this.nullCk(xpoast.getSales_currency())), 3)
								    + this.fixLenString(this.nullCk(ls_rate), 17)
								    + this.fixLenString(this.setHanString(this.nullCk(xpoast.getBy_po_no())), 20)
								    + this.fixLenString(this.setHanString(this.nullCk(xpoast.getBy_item_code())), 30)
							        + this.fixLenString(this.setHanString(this.nullCk(xpoast.getPo_creator_name())), 40)			//̸ֹ
							        + this.fixLenString(this.setHanString(this.nullCk(xpoast.getPo_creator_tel_no())), 20)  		//ֹȭȣ								    
								    + "\n";

					// file write
					fo_po.write(ls_file_tmp.getBytes());

					// assymap  ('PI')
					/*boolean return_value = */this.setAssyStatusChange(assymap.getUnique_id());
					
				} catch (IOException e1) {}
			}
		}finally{
			try {
				fo_po.close();
				dos.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		return true;
	}

	// file writeѰſ  assymap ¸ 'PI'
	public boolean setAssyStatusChange(int unique_id) {
		Map<String, Comparable> cond = new HashMap<String, Comparable>();
		
		cond.clear();
		cond.put("status", "PI");
		cond.put("unique_id", unique_id);
		
		if (this.baseLineDao.update("de-assymap", cond) != null){
			return true;
		}else{
			return false;
		}
	}

	/********************* GR ********************/
	// GR ڷḦ Ϸ .
	public boolean setGrFileWrite(List gr_list){
		String cur_date = dateFormat.format(new Date());
		String cur_time = dateFormat1.format(new Date());
	
		String file_name = FILE_PATH + "1N080000GRDT" + cur_date + cur_time + ".txt";
		//String file_name = path + "TEST" + cur_date + cur_time + ".txt";		
		
	    String []la_chkPath = FILE_PATH.split("/");
	    String ls_tmpPath = "";
	    
	    //  ϴ   
	    for (int i=0; i<la_chkPath.length; i++){
	       ls_tmpPath += "/" + la_chkPath[i];
	       replace(ls_tmpPath, "//", "/");
	       
	       if (ls_tmpPath.trim().length() < 2) continue;
	       
	       File lf_tmp = new File(ls_tmpPath);
	       if(lf_tmp.isDirectory()) continue;
	       
	       lf_tmp.mkdir();
        }

		FileOutputStream fo_gr = null;
		String ls_file_tmp = "";
		String ls_amount   = "";
		XpoAst xpoast = new XpoAst();
		
		try{
			try {
				fo_gr = new FileOutputStream(file_name, true);
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			for(Iterator i=gr_list.iterator(); i.hasNext();) {
				xpoast = (XpoAst)i.next();
				ls_file_tmp = "";
				ls_amount = (xpoast.getGr_qty() * xpoast.getSales_price())+"";
                
                UsrAst usrastFile = this.getPoInfo(xpoast.getCompany_code());
                Map codeMap = this.getPoCode(usrastFile.getUser_id());
				
				try {					
					ls_file_tmp =	  this.fixLenString("C", 1)
									/*********** ȸڵ ***********/
									+ this.fixLenString(this.nullCk((String)codeMap.get("company_code"), ""), 10)
									/*********** Division  *********/
								    + this.fixLenString(this.nullCk(xpoast.getBy_gr_year(), dateFormat.format(xpoast.getGr_date()).substring(4)), 4)
								    + this.fixLenString(this.setHanString(xpoast.getGr_no()), 20)
								    + this.fixLenString(this.setHanString(xpoast.getGr_seq()), 10)
								    
								    + this.fixLenString(this.setHanString(xpoast.getPo_no()), 20)
								    + this.fixLenString(this.setHanString(xpoast.getPo_seq()), 10)
								    + this.fixLenString(this.setHanString(xpoast.getItem_code()), 18)
								    + this.fixLenString(this.setHanString(this.nullCk(xpoast.getItem_name())), 50)
								    + this.fixLenString(this.setHanString(this.nullCk(xpoast.getSpecification())), 50)
								    + this.fixLenString(xpoast.getGr_qty().toString(), 15)
								    + this.fixLenString(this.setHanString(this.nullCk(xpoast.getUnit_code())), 3)
								    + this.fixLenString(xpoast.getSales_price().toString(), 17)
								    + this.fixLenString(this.setHanString(this.nullCk(xpoast.getSales_currency())), 3)
								    + this.fixLenString(this.nullCk(ls_amount), 17)
								    + this.fixLenString(dateFormat.format(xpoast.getGr_date()), 8)
								    + this.fixLenString(this.setHanString(this.nullCk((String)codeMap.get("wa_code"))), 10)
								    + this.fixLenString(this.setHanString(this.nullCk((String)codeMap.get("division_code"))), 10)
								    + this.fixLenString(this.setHanString(this.nullCk((String)codeMap.get("dept_code"))), 20)
								    + this.fixLenString("", 20)
								    + "\n";
					// file write
					fo_gr.write(ls_file_tmp.getBytes());
					
					// file writeѰſ  xpoast gr_sended = 'Y'
					/*boolean return_value = */this.setXpoastGrSendedChange(xpoast.getUnique_id());
					
				} catch (IOException e1) { 
				    logger.error("setGrFileWrite()", e1);
                }
			}
		}finally{
			try {
				fo_gr.close();				
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		return true;
	}
	
	// file writeѰſ  xpoast gr_sended = 'Y'
	public boolean setXpoastGrSendedChange(int unique_id){
		Map<String, Comparable> cond = new HashMap<String, Comparable>();
		
		cond.clear();
		cond.put("gr_sended", "Y");
		cond.put("unique_id", unique_id);
		
		if (this.baseLineDao.update("xpoast-cond", cond) != null){
			return true;
		}else{
			return false;
		}
	}	
	
	/********************* űǰ ********************/
	
	
    /**
	 * ѱ  ο   Byte   äִ ޼ҵ<br>
	 * Էµ Byte Size  ū 쿡 Է String ڸ.<br>
	 */
    public String fixLenString(String asStr, int aiByteSize) {
		final String STR_APPEND = " ";			// ߰ 1 Byte String

		if (asStr == null) asStr	= "";

		// Էµ String  ̰, ȯϷ ̺  쿡.. ڸ.
		if ( asStr.getBytes().length == aiByteSize ){
			return asStr;
		}else if ( asStr.getBytes().length > aiByteSize ){
			int iSize = 0;
			int iLen = 0;

			for ( iSize = 0 ; iSize < asStr.length(); iSize++ ){
				if ( asStr.charAt(iSize) > 0x007F )
					iLen += 2;
				else
					iLen++;
				if ( iLen > aiByteSize )
					break;
			}
			
			asStr	= asStr.substring( 0, iSize );
			if (aiByteSize == asStr.getBytes().length)
				return asStr;
		}

		StringBuffer sbRtn = new StringBuffer();
		sbRtn.append(asStr);

		for (int iCnt = 0; iCnt < (aiByteSize - asStr.getBytes().length); iCnt++){
			sbRtn.append(STR_APPEND);
		}

		return sbRtn.toString();
	}
    
	/**
	 * ڿ ٸ ڿ ٲ۴.
	 */
	public static String replace(String src, String oldstr, String newstr) {
         if( src == null ) return null;
         StringBuffer dest = new StringBuffer("");
         
	     int len = oldstr.length();
	     int srclen = src.length();
	     int pos = 0;
	     int oldpos = 0;
	     
	     while( ( pos = src.indexOf( oldstr, oldpos ) ) >= 0 ) {
	         dest.append( src.substring( oldpos, pos ) );
	         dest.append( newstr );
	         oldpos = pos + len;
	     }
	     if( oldpos < srclen ) {
	         dest.append( src.substring( oldpos, srclen ) );
	     }
	     return dest.toString();
	}
	
	// null check
	public String nullCk(String args, String rtn){
		if(args == null){
			args = rtn + "";
		}else if(args.trim() .length() == 0){
			args = rtn + "";
		}
		
		return args;	
	}
	
	// null check
	public String nullCk(String args){
		if(args == null){
			args = "";
		}
		
		return args;	
	}
	
	//  ȯѴ.
	public String setHanString(String str) {
		try {
		    str = new String( str.getBytes("KSC5601" ), "8859_1" );
		}catch( Exception _e ){
			
		}
		return str;
	}
	
	// po ̵   .
	private UsrAst getPoInfo(String company_code) {
        UsrAst usrast = null;        
		Map<String, String> com_cond = new HashMap<String, String>();
		com_cond.put("company_code",company_code);
		List comast_list = this.baseLineDao.select_cond("comast", com_cond);

        if (comast_list.size() > 0) {
            String sourcing = null;
    		for(Iterator i=comast_list.iterator(); i.hasNext();) {
    			ComAst comast = (ComAst)i.next();
    			sourcing = comast.getSourcing_group();
    		}
            
            Map<String, String> usr_cond = new HashMap<String, String>();
            usr_cond.put("user_id",sourcing);
            List List_usrast = this.baseLineDao.select_cond("if-usrast", usr_cond);
            
            for(Iterator i=List_usrast.iterator(); i.hasNext();) {
                usrast = (UsrAst)i.next();
            }
            
            return usrast;
        }
        else
            return new UsrAst();
	}
	
	
	//ȸڵ  ڵ带 ϵڵ Ѵ.
	private Map getPoCode(String sourcing_group){
		Map<String, String> codeMap 			= new HashMap<String, String>();
		String company_code 	= null;
		String wa_code 			= null;
		String division_code 	= null;
		String dept_code 		= null;
		
		if(sourcing_group.equalsIgnoreCase("1N080A")){ //ȭ
			
			company_code 	= "1N080"; //ȸڵ  1N080 ´?
			wa_code 		= "1N080A";
			division_code 	= "1000";
			dept_code 		= "001";			
			
		}else if(sourcing_group.equalsIgnoreCase("1N080B")){ //ȭȭ
			
			company_code 	= "1N080";
			wa_code 		= "1N080B";
			division_code 	= "2000";
			dept_code 		= "002";				
			
		}else if(sourcing_group.equalsIgnoreCase("1N080C")){ //ȭȭ
			
			company_code 	= "1N080"; //ȸڵ  1N080 ´?
			wa_code 		= "1N080C";
			division_code 	= "3000";
			dept_code 		= "003";				
			
		}else if(sourcing_group.equalsIgnoreCase("1N080D")){ //ȭ䰳
			
			company_code 	= "1N080"; //ȸڵ  1N080 ´?
			wa_code 		= "1N080D";
			division_code 	= "4000";
			dept_code 		= "004";	
			
		}else if(sourcing_group.equalsIgnoreCase("1N080E")){ //ѻ
			
			company_code 	= "1N080"; //ȸڵ  1N080 ´?
			wa_code 		= "1N080E";
			division_code 	= "5000";
			dept_code 		= "005";	
			
		}
		codeMap.put("company_code", company_code); //ȸڵ(ȸڵ ҽ̱׷ڵ尡 ?)
		codeMap.put("wa_code", wa_code); //ڵ
		codeMap.put("division_code", division_code); //ڵ
		codeMap.put("dept_code", dept_code); //μڵ
		
		return codeMap;
	}
	
	// μ(=μڵ)̵  .
	private Map getRcvrInfo(String rcvr_id, String tel_no, String hp_no){
		
		Map<String, String> numberMap		= new HashMap<String, String>();
		Map<String, String> usr_cond 		= new HashMap<String, String>();
		usr_cond.put("user_id",rcvr_id);
		
		String rcvr_telNo 	= null;
		String rcvr_hpNo  	= null;
		
		UsrAst usrast = null;
		List List_usrast = this.baseLineDao.select_cond("if-usrast", usr_cond);
		
		for(Iterator i=List_usrast.iterator(); i.hasNext();) {
			usrast = (UsrAst)i.next();

		}

		
		if(tel_no != null){rcvr_telNo = tel_no;}else{rcvr_telNo = usrast.getTel_no();}
		if(hp_no != null){rcvr_hpNo = hp_no;}else{rcvr_hpNo = usrast.getHp_no();}
		
		numberMap.put("tel_no",rcvr_telNo);
		numberMap.put("hp_no",rcvr_hpNo);
		
		return numberMap;
	}	
}
