package com.rfxsoft.justrfx.business.y_audt;


import java.util.Date;
import java.util.List;

import com.rfxsoft.justrfx.data.AuditDao;
import com.rfxsoft.justrfx.domain.Audit;
import com.rfxsoft.justrfx.domain.UsrAst;


/**
 * @author robh
 */
public class DefaultAuditService implements AuditService {

    private AuditDao auditDao;

    public void setAuditDao(AuditDao auditDao) {
        this.auditDao = auditDao;
    }

    public void writeAuditMessage(String data, UsrAst user) {
        Audit audit = new Audit();
        audit.setAuditDate(new Date());
        audit.setData(data);
        if (user != null) {
            audit.setUser(new Integer(user.getUnique_id()));
        } else {
            audit.setUser(null);
        }

        auditDao.insert(user.getUser_id(), audit);
    }
    
    public void purgeAudit(Date oldestDate) {
        auditDao.purge(oldestDate);
    }
    
    public List getAllAuditEntries() {
        return auditDao.getAll();
    }

}