package com.rfxsoft.justrfx.data.ibatis;

import java.util.Date;
import java.util.List;
import java.util.Map;


import org.springframework.orm.ibatis.support.SqlMapClientDaoSupport;
import com.rfxsoft.justrfx.DatabaseType;
import com.rfxsoft.justrfx.data.JrfxBaselineDao;
import com.rfxsoft.justrfx.domain.JrfxSuperDomain;
import com.rfxsoft.justrfx.domain.SystemInfo;


/**
 * @author k1park
 *	 ibatis Dao ...
 *	creator   õȴ.
 */
public class BaseLineSqlMapClientDao extends SqlMapClientDaoSupport implements JrfxBaselineDao
{
	String tableName;
	
	SystemInfo systemInfo;
	
	public SystemInfo getSystemInfo() {
		return systemInfo;
	}
	public void setSystemInfo(SystemInfo systemInfo) {
		this.systemInfo = systemInfo;
	}
	public BaseLineSqlMapClientDao() {
		super();
		tableName = "UN-DEFINED";


	}
	public BaseLineSqlMapClientDao(String tableName) {
		super();
		this.tableName = tableName;
	}
	
	public List select_all() {
		
		if(tableName.compareToIgnoreCase("UN-DEFINED") == 0)
			return null;
		return select_all(this.tableName );
	}
	
	public List select_cond(Map condition) {
		if(tableName.compareToIgnoreCase("UN-DEFINED") == 0)
			return null;
		return select_cond( this.tableName, condition);

	}

	public Object select_uid(int unique_id) {
		if(tableName.compareToIgnoreCase("UN-DEFINED") == 0)
			return null;
		return select_uid( this.tableName,	unique_id );
	}
	
	
	public Integer delete_uid(int unique_id) {
		if(tableName.compareToIgnoreCase("UN-DEFINED") == 0)
			return null;
		return delete( this.tableName, unique_id);
	}
	
	public Object insert_object(String creator, Object object) {
		if(tableName.compareToIgnoreCase("UN-DEFINED") == 0)
			return null;
		return insert(creator, this.tableName, object);

	}

	public Integer update_object(Object object) {
		if(tableName.compareToIgnoreCase("UN-DEFINED") == 0)
			return null;
		return update( this.tableName, object);
	}
	
	
	///---------Table Name ---------------//
	public List select_all(String tableName) {
		//Map condition = new HashMap();
		//return select_cond( tableName, condition);
		return getSqlMapClientTemplate().queryForList("selectall-" + tableName, null);

	}
	
	public List select_cond(String tableName, Map condition) {
		
		//return select_cond( tableName,  condition,
		//		this.getSystemInfo().getDbQryStartPt(), this.getSystemInfo().getDbQryQuan(), this.getSystemInfo().getDbQryOrderby());
		
		return getSqlMapClientTemplate().queryForList("selectcond-" + tableName, condition);

	}

	public Object select_uid(String tableName, int unique_id) {
		//logger.debug("tableName"+tableName); 
		return getSqlMapClientTemplate().queryForObject(
				"selectuid-" + tableName,	unique_id);
	}
	
	
	public Integer delete(String tableName, int unique_id) {
		return getSqlMapClientTemplate().update("delete-" + tableName, unique_id);

	}
	
	public Object insert(String creator, String tableName, Object object) {
		
		JrfxSuperDomain sdomain = (JrfxSuperDomain)object;
		//System.out.println(creator+"    "+tableName+"      "+object);
		//  object session user creator 
		//SessionSecurityManage Controller   ִ.
		//String creator = SessionSecurityManager.getThis_userid();
		
		if(creator==null)
			return false;
		
		sdomain.setCreator(creator);
		sdomain.setCreate_date(new Date());
		logger.debug(tableName);

		getSqlMapClientTemplate().insert("insert-" + tableName, object);

		return true;
	}

	public Integer update(String tableName, Object object) {

		return getSqlMapClientTemplate().update("update-" + tableName, object);
	}
	public List select_all(String tableName, int start, int record_quan, String order_by, boolean is_asc) {
	
		
		//PaginatedList pagedList = getSqlMapClientTemplate().queryForPaginatedList("selectall-" + tableName, null, record_quan);
		
		return null;

	}
	
	public DatabaseType getDbTypeEnum() {
		return systemInfo.getDbTypeEnum();
	}
	
	@SuppressWarnings("unchecked")
	public List select_cond(String tableName, Map condition, int start, int record_quan, String order_by) {
		
		int start_point = start+1;
		int end_point = start + record_quan;
		
		condition.put("order_by", order_by );
		
		String table_name ="";
		
		condition.put("start_point", start_point );
		
		if(getDbTypeEnum()== DatabaseType.ORACLE){
			table_name = "selectcond-ora-" + tableName;
			condition.put("end_point", end_point );
		}
		else {
			table_name = "selectcond-" + tableName;
			condition.put("end_point", record_quan );
		}
	
		return getSqlMapClientTemplate().queryForList(table_name, condition);
	}
	
}

// .
//	-----------
/*

protected	String		orderby;		//Query Temparatyϰ .
protected	boolean		is_desc;		//true:DESC, false:ASC


public BaseLineSqlMapClientDao() {
	this.orderby		= "create_date";
	this.is_desc		= true;
}

public String getOrderby() {
	if(is_desc)
		return (orderby + " DESC");
	else
		return (orderby + " ASC");
}
public void setOrderby(String orderby, boolean is_desc) {
	this.orderby = orderby;
	this.is_desc = is_desc;
}

public void setOrderby(String orderby) {
	this.orderby = orderby;
	this.is_desc = true;
}

*/