package com.rfxsoft.justrfx.data.ibatis;

import com.rfxsoft.justrfx.RtgType;
import com.rfxsoft.justrfx.data.SysInfoDao;
import com.rfxsoft.justrfx.domain.SysInfo;

public class SqlMapClientSysInfoDao extends BaseLineSqlMapClientDao implements
		SysInfoDao {

	public void ClearEnv(String var_name, String var_value) {
		SysInfo new_val = new SysInfo();
		
		new_val.setVar_name(var_name);
		new_val.setVar_value(var_value);
		
		getSqlMapClientTemplate().update("clearSysValue", new_val);
		
	}

	public String GetEnv(String name) {
		
		return (String)getSqlMapClientTemplate().queryForObject("getSysinfoByName",	name);
	}

	public void SetEnv(String name, String value) {
		SysInfo new_val = new SysInfo();
		
		new_val.setVar_name(name);
		new_val.setVar_value(value);
		
		String info = GetEnv(name);
		if(info==null) { //insert
			getSqlMapClientTemplate().insert("insert-sysinfo", new_val);
		}
		else {//update
			getSqlMapClientTemplate().update("updateSysinfo", new_val);
		}
		
	}
	
	private RtgType checkRtgType(String strRtgType) {
		
		if(strRtgType==null) {
			return RtgType.UKN;

		}
		if(strRtgType.compareToIgnoreCase("G")==0 ||
				strRtgType.compareToIgnoreCase("GE")==0)
			return RtgType.GE;
		
		else if (strRtgType.compareToIgnoreCase("R")==0 ||
				strRtgType.compareToIgnoreCase("PR")==0)
			return RtgType.PR;
		
		else if (strRtgType.compareToIgnoreCase("O")==0 ||
				strRtgType.compareToIgnoreCase("OR")==0 ||
				strRtgType.compareToIgnoreCase("ERR_PO")==0 ||
				strRtgType.compareToIgnoreCase("PO")==0)
			return RtgType.OR;
		
		else if (strRtgType.compareToIgnoreCase("W")==0 ||
				strRtgType.compareToIgnoreCase("GR")==0 ||
				strRtgType.compareToIgnoreCase("ERR_GR")==0  )
			return RtgType.GR;
		
		else if (strRtgType.compareToIgnoreCase("A")==0 ||
				strRtgType.compareToIgnoreCase("AC")==0 )
			return RtgType.AC;
		
		else if (strRtgType.compareToIgnoreCase("Q")==0 ||
				strRtgType.compareToIgnoreCase("FQ")==0 )
			return RtgType.FQ;
		
		else if (strRtgType.compareToIgnoreCase("C")==0 ||
				strRtgType.compareToIgnoreCase("CT")==0 )
			return RtgType.CT;		
		else
			return RtgType.UKN;	
	}

	public Integer GetLastUnChecked(RtgType rtg_type) {
		
		String var_name = rtg_type.toString() + "_NO";
		String var_value = GetEnv(var_name);
		
		if(var_value==null)
			return 0;
		
		return Integer.parseInt(var_value);
	}

	public Integer GetLastUnChecked(String strRtgType) {
		return GetLastUnChecked(checkRtgType(strRtgType));
	}

	public void SetLastValue(RtgType rtg_type, Integer var_val) {
		String var_name = rtg_type.toString() + "_NO";
		SetEnv(var_name, String.valueOf(var_val+1));
	}

	public void SetLastValue(String strRtgType, Integer var_val) {
		SetLastValue(checkRtgType(strRtgType), var_val);
	}

	public void SetLastValue(RtgType rtg_type) {
		
		Integer var_val = GetLastUnChecked(rtg_type);
		
		String var_name = rtg_type.toString() + "_NO";
		SetEnv(var_name, String.valueOf(var_val+1));
		
	}

	public void SetLastValue(String strRtg_type) {
		SetLastValue(checkRtgType(strRtg_type));
		
	}

	
//	public Integer GetLastChecked(String strRtgType) {
//		return GetLastChecked(checkRtgType(strRtgType) );
//	}
//	
//	public Integer GetLastChecked(RtgType rtg_type) {
//
//		String var_name = rtg_type.toString() + "_NO";
//		Integer last_no = GetLastUnChecked(rtg_type);
//		
//		Integer new_val = last_no + 1;
//		
//		SetEnv(var_name, String.valueOf(new_val));
//		
//		return last_no;
//	}


	

}
