package com.rfxsoft.justrfx.data.ibatis;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.rfxsoft.justrfx.data.UsrAstDao;
import com.rfxsoft.justrfx.domain.UsrAst;

public class SqlMapClientUsrAstDao extends BaseLineSqlMapClientDao implements
		UsrAstDao {
	
	/**
	 *  ԼBaseLineSqlMapClientDao ǵǾ ִµ ȣȯ  
	 * k1park 060318
	 */
	public SqlMapClientUsrAstDao() {		super("usrast");	}
	public List getAll() {		return this.select_all();	}
	public UsrAst getById(int unique_id) {		return (UsrAst)this.select_uid(unique_id);	}
//	public Object insert( String creator, UsrAst object) {		return this.insert_object(creator, object);	}
	public Integer update(UsrAst object) {	return	this.update_object(object);	}
	public Integer delete(int unique_id) {	return	this.delete_uid(unique_id);	}

	public List getDynamic(Map condition) {		return this.select_cond(condition);	}
	// end of baseline--------------------------------
	
	public UsrAst getByUsernameAndPassword(String username, String password) {
		Map<String, String> params = new HashMap<String, String>();
		params.put("user_id", username);
		params.put("password", password);

		return (UsrAst)getSqlMapClientTemplate().queryForObject("getUserByUseridAndPassword", params);
	}
	
	public boolean isRegisterdMail(String mail) {
	
		UsrAst usrast = null;
		usrast = (UsrAst)getSqlMapClientTemplate().queryForObject("getUsrAstByMail",	mail);
		if(usrast==null) {
			return false;
		}
		else {
			return true;
		}
	}
	
	public boolean isRegisterdUserId(String user_id) {
		
		UsrAst usrast = null;
		usrast = (UsrAst)getSqlMapClientTemplate().queryForObject("getUsrAstByUserId",	user_id);
		if(usrast==null) {
			return false;
		}
		else {
			return true;
		}
			
	}

	public List getByIdMail(String user_id)
	{
		return getSqlMapClientTemplate().queryForList("getUsrAstByCode", user_id);
	}
	
	public boolean isRegisteredUserId(String user_id) {
		
		return false;
	}
	

	public List getDynamic(UsrAst condition) {
		
		return getSqlMapClientTemplate().queryForList("getUsersDynamicClass", condition);
	}
	
//	Delete Flag Setting
	public Integer delete(String user_id) {
		return getSqlMapClientTemplate().update("deleteUsrAstByUserid", user_id);

	}

//	<!--	 ̰ ¥ ϱ ϸ ȵ -->
	public Integer deleteConfirm(int unique_id) {
		return getSqlMapClientTemplate().delete("deleteConfirmUsrAst", unique_id);
	}


	public Object insert( String creator, UsrAst usrast) {
		// TODO Auto-generated method stub
		
		//if(isRegisterdMail(usrast.getEmail()) )	{
		//	logger.debug("Registerd Mail");
		//	return false;
		//}
		if(isRegisterdUserId(usrast.getUser_id() ) )	{
			logger.debug("Registerd User");
			return false;
		}		
		
		getSqlMapClientTemplate().insert("insert-usrast", usrast);
		
		return true;

	}

	public Integer updatePassword(int unique_id, String new_password) {
		// TODO Auto-generated method stub

		Map<String, Comparable> params = new HashMap<String, Comparable>();
		params.put("unique_id", new Integer(unique_id));
		params.put("password", new_password);
		return getSqlMapClientTemplate().update("updateUsrAstPassword", params);

	}
	
	public Integer updateEMail(int unique_id, String new_email) {
		Map<String, Comparable> params = new HashMap<String, Comparable>();
		params.put("unique_id", new Integer(unique_id));
		params.put("email", new_email);
		return getSqlMapClientTemplate().update("updateUsrAstEMail", params);

	}
	
	public Integer restore(int unique_id) {
		return getSqlMapClientTemplate().update("restoreUsrAst", unique_id);
	}

	public Integer checkLogin(Integer user_uid, String ip, Date login_date) {
		
		Map<String, Comparable> map = new HashMap<String, Comparable>();
	
		map.put("login_ip",ip);
		map.put("login_date", login_date);
		map.put("unique_id", user_uid);

		return getSqlMapClientTemplate().update("checkLogIn", map);
	}
	public Integer checkLogout(Integer user_uid, Date logout_date) {
		Map<String, Comparable> map = new HashMap<String, Comparable>();
		
		map.put("logout_date", logout_date);
		map.put("unique_id", user_uid);

		return getSqlMapClientTemplate().update("checkLogOut", map);
	}
	public void clearLoginFlag() {
		getSqlMapClientTemplate().update("clearLoginFlag", null);
	}
}
