package com.rfxsoft.justrfx.document;

import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import org.springframework.beans.factory.BeanCreationException;

import com.lowagie.text.BadElementException;
import com.lowagie.text.Chunk;
import com.lowagie.text.Document;
import com.lowagie.text.DocumentException;
import com.lowagie.text.Element;
import com.lowagie.text.Image;
import com.lowagie.text.Paragraph;
import com.lowagie.text.Phrase;
import com.lowagie.text.Rectangle;
import com.lowagie.text.pdf.Barcode;
import com.lowagie.text.pdf.BarcodeEAN;
import com.lowagie.text.pdf.BarcodePDF417;
import com.lowagie.text.pdf.PdfContentByte;
import com.lowagie.text.pdf.PdfPCell;
import com.lowagie.text.pdf.PdfPTable;
import com.lowagie.text.pdf.PdfWriter;
import com.rfxsoft.justrfx.domain.RegisterdMasterCompany;
import com.rfxsoft.justrfx.domain.SystemInfo;
import com.rfxsoft.justrfx.domain.XpoAst;
import com.rfxsoft.justrfx.domain.XpoBhd;

//---------------------------- Contents Layour ----------------------------------------
// 	[ ΰ ]							[    ] 
//									ֹȣpo_no			ڹȣbiz_no
//														ȣcom_name
//														ּcom_addr
//	attWho												ǥpresident
//-------------------------------------------------------------------------------------
//ֹósupplier_name (޻ȣ:supplier_code   ) 	Ŵpo_name po_email
//sales_person_name						μreceiver_name, dept_name, receiver_tel
//ǰreceive_loc								ýbarcode_content
//-------------------------------------------------------------------------------------
//									--- ֹ  ---
//ûrequest_info	ĺȣrtgast_uid			ֹabst_info	 հݾ()total_price
//ֹpo_date			ͻ ǰ......contract_desc
//condition		
//ǰdelivery

public class PdfDocuPo extends AbstractPdfDocuLayout {

	private RegisterdMasterCompany masterCompany;
	private SystemInfo	systemInfo;
	
	private XpoBhd	xpobhd;
	private List	listXpoast;
	
	private SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd");
	private DecimalFormat 	decimalFormat = new DecimalFormat("#,##0");
	
	//--------------------- PDF Contents -------------------
	final static String strTitle = "  ";;
	final static String contract_desc1 = "ͻ ǰް Ϲ  ؼϸ, ⿡ Ʋ ϰ.";
	final static String contract_desc2 = " ǰ :";
	final static String contract_desc3 = "()";
	
	private String  biz_no, com_name, com_addr, president;
	
	private String po_no ;
	private String supplier_name, supplier_code, sales_name, req_delivery_date,
	delivery_address_1,	po_user_name, po_user_email;
	//, receiver_name, receiver_dept,
	//receiver_tel,	barcode_content;
	String barcode2d_content;
	
	private String  sales_telephone_no, sales_email;

	private String request_info, xpobhd_uid, total_price, po_date;
	//,	pay_condition;

	private String po_user_tel;
	private String abst_info;
	
	protected PdfPTable hTable;
	protected PdfPTable gTable;
	protected PdfPCell cell;
	
	public PdfDocuPo(PdfWriter writer, Document doc, int progress, String strCode, String logo_img_path, String sign_img_path, 
			RegisterdMasterCompany masterCompany,
			SystemInfo	systemInfo,
			XpoBhd	xpobhd,
			List listXpoast
		) {
		super(writer, doc, progress, strCode, logo_img_path, sign_img_path);
		
		this.setMasterCompany(masterCompany);
		this.setSystemInfo(systemInfo);
		this.setXpobhd(xpobhd);
		this.setListXpoast(listXpoast);
	}

	private String getAbstInfo() {
		
		String ret = "";
		Integer len = listXpoast.size()-1;
		
		for(Iterator i=listXpoast.iterator(); i.hasNext();) {
			XpoAst xpoast = (XpoAst)i.next();
			String item_name = xpoast.getItem_name();
			
			ret = item_name + " " + len.toString() + "" ;
			return ret;
		}
		
		return ret;
	}
	
	
	@Override
	protected void GetFileContent() {
		biz_no 			= masterCompany.getBizNo();		
		com_name 		= masterCompany.getCompanyName();
		com_addr 		= masterCompany.getCompanyAddress();
		president 		= masterCompany.getCeoName();
		
		po_no 				= xpobhd.getPo_no();
		
		supplier_name 		= xpobhd.getSupplier_name();
		supplier_code		= xpobhd.getSupplier_code();
		sales_name			= xpobhd.getSales_name();
		req_delivery_date 	= dateFormat.format(xpobhd.getReq_date());
		delivery_address_1	= xpobhd.getDelivery_address_1();
		po_user_name		= xpobhd.getPo_user_name();
		po_user_email		= xpobhd.getPo_user_email();
		po_user_tel			= xpobhd.getPo_user_tel();
		
	//	receiver_name		= xpobhd.getRequester();
	//	receiver_dept		= xpobhd.getDept_name();
	//	receiver_tel		= xpobhd.getReceiver_tel();
	//	barcode_content		= xpobhd.getBarcode_content();
		
		barcode2d_content	= xpobhd.getBarcode2d_content();
		
		request_info		= xpobhd.getRequest_info();
		xpobhd_uid			= xpobhd.getUnique_id().toString();
		total_price			= Double2String(xpobhd.getSales_amount() );
		po_date				= dateFormat.format(xpobhd.getPo_date() );
	//	pay_condition		= xpobhd.getPay_condition();
		
		sales_telephone_no	= xpobhd.getSales_telephone_no();
		sales_email			= xpobhd.getSales_email();
		
		abst_info			= getAbstInfo();
		
		//ѱ ڵ
		strBarCode = "880";//1 ū 

		String strCodeFormatted= xpobhd_uid;
		while(strCodeFormatted.length()<10)
			strCodeFormatted = "0" + strCodeFormatted;
		
		if(strCodeFormatted.length() > 10 )
			strCodeFormatted = strCodeFormatted.substring(0,10);
		
		//880 ڵ
		strBarCode = strBarCode + strCodeFormatted;
		

	}

	protected void CreateHeaderTable() {
		
		String attWho = ": " + sales_name + " ";
		//2 ڵ ִũ 1,800 byte.
        BarcodePDF417 pdf417 = new BarcodePDF417();
        pdf417.setText(barcode2d_content);
        try {
			bar2Dimg = pdf417.getImage();
		} catch (BadElementException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        bar2Dimg.scalePercent(50, 50 * pdf417.getYHeight());
        bar2Dimg.setAlignment(Image.LEFT);
        bar2Dimg.setAbsolutePosition(0, 0);

		float[] widths = 			{0.40f, 0.20f, 0.40f};
		float[] inh_widths = 		{1.0f};
		float[] inh3_widths = 	{0.25f, 0.75f};
		
		hTable = new PdfPTable(widths);
		hTable.getDefaultCell().setBorder(Rectangle.NO_BORDER);
		
		PdfPTable inh1 = new PdfPTable(inh_widths);
		inh1.getDefaultCell().setBorder(Rectangle.NO_BORDER);
		inh1.addCell(new Phrase(new Chunk(logo, 0, 0)));
		inh1.addCell(new Phrase(new Chunk(attWho, FontKorea12)));
		
		PdfPTable inh2 = new PdfPTable(inh_widths);
		inh2.getDefaultCell().setBorder(Rectangle.NO_BORDER);
		Chunk chTitle = new Chunk(strTitle, FontKorea28);
		chTitle.setBackground(clrDisp);
		chTitle.setUnderline(clrPurple, 2.0f, 0.0f, 13.0f, 0.0f, PdfContentByte.LINE_CAP_BUTT);
		chTitle.setTextRenderMode(PdfContentByte.TEXT_RENDER_MODE_FILL_STROKE, 0.4f, clrBlack);
		
		Chunk chRfxno = new Chunk("ֹȣ:"+this.po_no, FontKorea10);
		
		inh2.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);
		inh2.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		inh2.addCell(new Phrase(chTitle) );
		inh2.getDefaultCell().setVerticalAlignment(Element.ALIGN_TOP);
		inh2.addCell(new Phrase(chRfxno) );

		
		PdfPTable inh3 = new PdfPTable(inh3_widths);
		inh3.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);
		inh3.getDefaultCell().setBackgroundColor(clrCBack);
		inh3.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		inh3.addCell(new Phrase("Ϲȣ", FontKorea10b) );
		inh3.getDefaultCell().setBackgroundColor(clrWhite);
		inh3.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
		inh3.addCell(new Phrase(biz_no, FontKorea10) );

		inh3.getDefaultCell().setBackgroundColor(clrCBack);
		inh3.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		inh3.addCell(new Phrase("    ȣ", FontKorea10b) );
		inh3.getDefaultCell().setBackgroundColor(clrWhite);
		inh3.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
		inh3.addCell(new Phrase(com_name, FontKorea10) );
		
		inh3.getDefaultCell().setBackgroundColor(clrCBack);
		inh3.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		inh3.addCell(new Phrase("    ", FontKorea10b) );
		inh3.getDefaultCell().setBackgroundColor(clrWhite);
		inh3.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
		inh3.addCell(new Phrase(com_addr, FontKorea10) );
		
		inh3.getDefaultCell().setBackgroundColor(clrCBack);
		inh3.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		inh3.addCell(new Phrase("    ǥ", FontKorea10b) );
		inh3.getDefaultCell().setBackgroundColor(clrWhite);
		inh3.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
		inh3.addCell(new Phrase(president, FontKorea10) );
		

		hTable.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);
		hTable.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
		hTable.addCell( inh1 );
		hTable.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		hTable.addCell( inh2 );
		hTable.getDefaultCell().setHorizontalAlignment(Element.ALIGN_RIGHT);
		hTable.addCell( inh3 );
	
		float global_width[] = {1.0f};

		gTable = new PdfPTable(global_width);
		gTable.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);
		gTable.setHorizontalAlignment(Element.ALIGN_CENTER);
   
		cb = writer.getDirectContent();
		BarcodeEAN codeEAN = new BarcodeEAN();
		codeEAN.setCodeType(Barcode.EAN13);
		codeEAN.setCode(strBarCode);
		Image imageEAN = codeEAN.createImageWithBarcode(cb, null, null);

		AddHeaderTable(gTable, imageEAN);
	}

	
	@SuppressWarnings("unused")
	private void ResizeImage(Image attach) {
		float  height = attach.plainHeight();
		float  width = attach.plainWidth();
		
		if( height/width > 0.5f)
			attach.scalePercent(100*60/height);
		else
			attach.scalePercent(100*120/width);
		
	}
	
	
	private void AddHeaderTable(PdfPTable gTable, Image imageEAN) {
			
		float cus_ad_width[] = {0.1f, 0.4f, 0.1f, 0.4f};
		

		PdfPTable table = new PdfPTable(cus_ad_width);
		
		table.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);

		table.getDefaultCell().setBackgroundColor(clrCBack);
		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		table.addCell(new Phrase("  ó", FontKorea10b) );
		table.getDefaultCell().setBackgroundColor(clrWhite);
		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
		
		table.addCell(new Phrase(supplier_name + "\n(޻ڵ: " + supplier_code + ")", FontKorea10) );
		
		table.getDefaultCell().setBackgroundColor(clrCBack);
		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		table.addCell(new Phrase("Ŵ", FontKorea10b) );
		table.getDefaultCell().setBackgroundColor(clrWhite);
		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
		String fromWho = po_user_name + " (T: " + po_user_tel + ")\n" + po_user_email;
		table.addCell(new Phrase(fromWho, FontKorea10) );

		table.getDefaultCell().setBackgroundColor(clrCBack);
		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		table.addCell(new Phrase("", FontKorea10b) );
		table.getDefaultCell().setBackgroundColor(clrWhite);
		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
		String toWho = sales_name + " (T: " + sales_telephone_no + ")\n" + sales_email;
		table.addCell(new Phrase(toWho, FontKorea10) );
		table.getDefaultCell().setBackgroundColor(clrCBack);
		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		table.addCell(new Phrase("û", FontKorea10b) );
		table.getDefaultCell().setBackgroundColor(clrWhite);
		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);

		table.addCell(new Phrase(getRequesterName(), FontKorea10) );//μ ǥþ-->ûڷ ǥ
		
		table.getDefaultCell().setBackgroundColor(clrCBack);
		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		table.addCell(new Phrase("ǰ", FontKorea10b) );
		table.getDefaultCell().setBackgroundColor(clrWhite);
		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
		cell = new PdfPCell(new Phrase(delivery_address_1, FontKorea10) );
		cell.setMinimumHeight(18f);
		table.addCell(cell );

		table.getDefaultCell().setBackgroundColor(clrCBack);
		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		table.addCell(new Phrase("s.y.s.t.e.m\ni.n.f.o", FontKorea8) );
		table.getDefaultCell().setBackgroundColor(clrWhite);
		
        table.addCell(new Phrase(new Chunk(imageEAN, 0, 0)));
		gTable.addCell( table );
	}
	
	//÷° û
	private String getRequesterName() {
		for(Iterator i=listXpoast.iterator(); i.hasNext();) {
   			
			XpoAst xpoast = (XpoAst)i.next();
			if(xpoast !=null)
				return xpoast.getPr_name();
			
		}
		return "";
	}
	
    public  void DoWork() {
        try {
            
        	this.writer.setPageEvent(this);

    		table = new PdfPTable(global_width);

    		cell = new PdfPCell(new Phrase("- - - ֹ  - - -", FontKorea12b) );
    		cell.setHorizontalAlignment(Element.ALIGN_CENTER);
    		cell.setVerticalAlignment(Element.ALIGN_MIDDLE);
    		cell.setBackgroundColor(clrCBack);
    		table.addCell(cell );
    		
    		cell = new PdfPCell(new Paragraph(request_info, FontKorea10));
    		cell.setHorizontalAlignment(Element.ALIGN_LEFT);
    		cell.setVerticalAlignment(Element.ALIGN_MIDDLE);
    		cell.setBackgroundColor(clrWhite);
    		table.addCell(cell );
    		
    		table.setTotalWidth(594-20);
    		table.setLockedWidth(true);
    		doc.add(table);
    		
    		float wide_width[] = {0.2f, 0.8f};
    		table = new PdfPTable(wide_width);
    		//table.getDefaultCell().setBorder(Rectangle.UNDEFINED);
    		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    		table.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);
    		table.getDefaultCell().setBackgroundColor(clrWhite);

    		float in_table_width[] = {0.42f, 0.58f};
    		float cell_height = 22f;
    		PdfPTable in_table = new PdfPTable(in_table_width);
    		in_table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    		in_table.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);
    		in_table.getDefaultCell().setBackgroundColor(clrCBack);

    		cell = new PdfPCell(new Paragraph("ֹ", FontKorea10));
    		cell.setMinimumHeight(cell_height);
    		cell.setHorizontalAlignment(Element.ALIGN_CENTER);
    		cell.setVerticalAlignment(Element.ALIGN_MIDDLE);
    		cell.setBackgroundColor(clrCBack);
    		in_table.addCell(cell );
    		in_table.getDefaultCell().setBackgroundColor(clrWhite);
    		in_table.getDefaultCell().setBorder(Rectangle.NO_BORDER);
    		in_table.addCell(new Phrase(po_date, FontKorea10) );
    		in_table.getDefaultCell().setBorder(Rectangle.BOX);

    		cell = new PdfPCell(new Paragraph("ǰ", FontKorea10));
    		cell.setMinimumHeight(cell_height);
    		cell.setHorizontalAlignment(Element.ALIGN_CENTER);
    		cell.setVerticalAlignment(Element.ALIGN_MIDDLE);
    		cell.setBackgroundColor(clrCBack);
    		in_table.addCell(cell );
    		in_table.getDefaultCell().setBackgroundColor(clrWhite);
    		in_table.getDefaultCell().setBorder(Rectangle.BOTTOM|Rectangle.TOP);
    		in_table.addCell(new Phrase(req_delivery_date, FontKorea10) );

    		/* 
    		cell = new PdfPCell(new Paragraph("", FontKorea10));
    		cell.setMinimumHeight(cell_height);
    		cell.setHorizontalAlignment(Element.ALIGN_CENTER);
    		cell.setVerticalAlignment(Element.ALIGN_MIDDLE);
    		cell.setBackgroundColor(clrCBack);
    		in_table.addCell(cell );
    		in_table.getDefaultCell().setBackgroundColor(clrWhite);
    		in_table.getDefaultCell().setBorder(Rectangle.BOTTOM);
    		in_table.addCell(new Phrase(pay_condition, FontKorea10) );
    		*/
    		cell = new PdfPCell(new Paragraph("ܻ", FontKorea10));
    		cell.setMinimumHeight(cell_height);
    		cell.setHorizontalAlignment(Element.ALIGN_CENTER);
    		cell.setVerticalAlignment(Element.ALIGN_MIDDLE);
    		cell.setBackgroundColor(clrCBack);
    		in_table.addCell(cell );
    		in_table.getDefaultCell().setBackgroundColor(clrWhite);
    		in_table.getDefaultCell().setBorder(Rectangle.NO_BORDER);
    		in_table.addCell(new Phrase("ǥ", FontKorea10) );

    		table.addCell( in_table );

    		float content_width[] = {				0.12f,
    												0.48f,
    												0.30f,
    												0.10f		};
    		
    		in_table = new PdfPTable(content_width);
    		in_table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    		in_table.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);
    		in_table.getDefaultCell().setBackgroundColor(clrDisp);
    		
    		in_table.addCell(new Phrase("ĺȣ", FontKorea10) );
    		in_table.addCell(new Phrase("ֹ", FontKorea10) );
    		in_table.addCell(new Phrase("ֹհݾ", FontKorea10) );
    		in_table.addCell(new Phrase("ȭ", FontKorea10) );
    
    		in_table.getDefaultCell().setBackgroundColor(clrWhite);
    		
    		cell = new PdfPCell(new Paragraph(xpobhd_uid, FontKorea8));
    		cell.setMinimumHeight(20f);
    		cell.setHorizontalAlignment(Element.ALIGN_CENTER);
    		cell.setVerticalAlignment(Element.ALIGN_MIDDLE);
    		
    		in_table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    		in_table.addCell(cell );
    		in_table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
    		in_table.addCell(new Phrase(abst_info, FontKorea8) );
    		in_table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_RIGHT);
    		in_table.addCell(new Phrase(total_price, FontKorea8) );
    		in_table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    		in_table.addCell(new Phrase("", FontKorea8) );
    		
    		cell = new PdfPCell(new Phrase("ǰ  ֹȣ  ٶϴ.", FontKorea12b) );
    		cell.setHorizontalAlignment(Element.ALIGN_RIGHT);
    		cell.setBackgroundColor(clrWhite);
    		cell.setMinimumHeight(30f);
    		cell.setColspan(4);
    		in_table.addCell(cell );
    		
    		table.addCell( in_table );
    		
    		table.setTotalWidth(594-20);
    		table.setLockedWidth(true);
    		doc.add(table);

    		float detail_width[] = {			0.04f,
    											0.05f,
    											0.13f,
    											0.13f,
    											0.32f,
    											0.06f,
    											0.09f,
    											0.09f,
    											0.09f};

    		table = new PdfPTable(detail_width);
    		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    		table.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);
    		table.getDefaultCell().setBackgroundColor(clrCBack);
    		cell = new PdfPCell(new Phrase("- - -   - - -", FontKorea12b) );
    		cell.setHorizontalAlignment(Element.ALIGN_CENTER);
    		cell.setBackgroundColor(clrCBack);
    		cell.setColspan(10);
    		table.addCell(cell );
    		
    		table.getDefaultCell().setBackgroundColor(clrDisp);
    		
    		table.addCell(new Phrase("No", FontKorea8) );
    		table.addCell(new Phrase("", FontKorea10) );
    		table.addCell(new Phrase("ǰڵ", FontKorea10) );
    		table.addCell(new Phrase("ǰ", FontKorea10) );
    		table.addCell(new Phrase("԰ / ", FontKorea10) );
    		table.addCell(new Phrase("ַ", FontKorea10) );
    		table.addCell(new Phrase("ܰ", FontKorea10) );
    		table.addCell(new Phrase("ݾ", FontKorea10) );
    		table.addCell(new Phrase("", FontKorea10) );
    		
    		
    		
//    		for(int i=0; i<100; i++) {
//    			Random ran = new Random();
//    			Integer iRand = ran.nextInt();
//    			String strCode =Integer.toHexString(iRand.intValue()).toUpperCase();
//    			while(strCode.length()<8)
//    				strCode = strZero.concat(strCode);
//    			
//    			String strNo = Integer.toString(i+1);
//    			while(strNo.length()<3)
//    				strNo = strZero.concat(strNo);
    		
    		Double quan_sum = 0.0;
    		Double price_sum = 0.0;
    		int serial_no = 1;
    		for(Iterator i=listXpoast.iterator(); i.hasNext(); serial_no++) {
   			
    			XpoAst xpoast = (XpoAst)i.next();
    			
    			String strNo = Integer.toString(serial_no);
    			String project_code = xpoast.getAccount_code();
    			String item_code = xpoast.getItem_code_dash();
    			String item_name = xpoast.getItem_name();
    			
    			String description = xpoast.getFull_spec();
    			/*
    			String model_no = xpoast.getModel_no();
    			String maker = xpoast.getDescription();
    			if(model_no != null && model_no.length()>0)
    				description = description + " / " + model_no;
    			if(maker != null && maker.length()>0)
    				description = description + " (" + maker + ")";
    			*/
    			
//    			String pr_qty = Double2String(xpoast.getPr_qty() );
    			String po_qty = Double2String(xpoast.getPo_qty() );
    			String unit_price = Double2String(xpoast.getSales_price() );
    			String total_price = Double2String(xpoast.getSales_price()* xpoast.getPo_qty());
    			String delevery = xpoast.getDelivery_terms();
    			
    			quan_sum = quan_sum + xpoast.getPo_qty();
    			price_sum = price_sum + xpoast.getSales_price()* xpoast.getPo_qty();
    			
    			table.getDefaultCell().setBackgroundColor(clrWhite);
    			table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    			table.addCell(new Phrase( strNo, FixedEng8) );
    			table.addCell(new Phrase( project_code, FixedEng8) );
    			table.addCell(new Phrase( item_code, FixedEng8) );
    			table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
    			table.addCell(new Phrase( item_name, FontKorea8) );
    			table.addCell(new Phrase(description, FontKorea8) );
       			table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_RIGHT);
//    			table.addCell(new Phrase(pr_qty, FontKorea8) );
     			table.addCell(new Phrase( po_qty, FontKorea8) );
    			table.addCell(new Phrase(unit_price, FontKorea8) );
    			table.addCell(new Phrase(total_price, FontKorea8) );
    			table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
    			table.addCell(new Phrase(delevery, FontKorea8) );
    		}
    		
    		cell = new PdfPCell(new Phrase("   ", FontKorea10) );
    		cell.setHorizontalAlignment(Element.ALIGN_RIGHT);
    		cell.setVerticalAlignment(Element.ALIGN_MIDDLE);
    		cell.setBackgroundColor(clrDisp);
    		cell.setColspan(5);
    		table.addCell(cell );
    		
    		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_RIGHT);
    		table.addCell(new Phrase(Double2String(quan_sum), FontKorea8) );
    		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    		table.addCell(new Phrase("-", FontKorea8) );
    		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_RIGHT);
    		table.addCell(new Phrase(Double2String(price_sum), FontKorea8) );
    		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    		table.addCell(new Phrase("-", FontKorea8) );

    		
    		table.setTotalWidth(594-20);
    		table.setLockedWidth(true);
    		doc.add(table);
    		
//    		
//    		
//    		float image_width[] = {		0.25f,
//    											0.25f,
//    											0.25f,
//    											0.25f};
//
//    		table = new PdfPTable(image_width);
//    		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
//    		table.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);
//    		table.getDefaultCell().setBackgroundColor(clrCBack);
//    		cell = new PdfPCell(new Phrase("- - - ǰ ̹ - - -", FontKorea12b) );
//    		cell.setHorizontalAlignment(Element.ALIGN_CENTER);
//    		cell.setBackgroundColor(clrCBack);
//    		cell.setColspan(4);
//    		table.addCell(cell );
//    		
//    		
//    		table.getDefaultCell().setBackgroundColor(clrDisp);
//    		
//    		table.addCell(new Phrase("001:", FontKorea8) );
//    		table.addCell(new Phrase("002:Ź", FontKorea8) );
//    		table.addCell(new Phrase("003:", FontKorea8) );
//    		table.addCell(new Phrase("004:ûұ", FontKorea8) );
//
//            Image attatch = Image.getInstance("C:/REPOSIT/IMAGE/att1.bmp");
//            ResizeImage(attatch);
//            table.addCell(new Phrase(new Chunk(attatch, 0, 0)));
//            attatch = Image.getInstance("C:/REPOSIT/IMAGE/att2.bmp");
//            ResizeImage(attatch); 
//            table.addCell(new Phrase(new Chunk(attatch, 0, 0)));
//            attatch = Image.getInstance("C:/REPOSIT/IMAGE/att3.bmp");
//            ResizeImage(attatch);
//            table.addCell(new Phrase(new Chunk(attatch, 0, 0)));
//            attatch = Image.getInstance("C:/REPOSIT/IMAGE/att4.bmp");
//            ResizeImage(attatch);
//            table.addCell(new Phrase(new Chunk(attatch, 0, 0)));
//            attatch = Image.getInstance("C:/REPOSIT/IMAGE/att5.bmp");
//
//    		
//    		table.addCell(new Phrase("005:ڷ", FontKorea8) );
//    		table.addCell(new Phrase("006:", FontKorea8) );
//    		table.addCell(new Phrase("007:", FontKorea8) );
//    		table.addCell(new Phrase("s.y.s.t.e.m  i.n.f.o", FontKorea8) );
//    		
//            attatch = Image.getInstance("C:/REPOSIT/IMAGE/att5.bmp");
//            ResizeImage(attatch);
//            table.addCell(new Phrase(new Chunk(attatch, 0, 0)));
//            attatch = Image.getInstance("C:/REPOSIT/IMAGE/att6.bmp");
//            ResizeImage(attatch);
//            table.addCell(new Phrase(new Chunk(attatch, 0, 0)));
//            attatch = Image.getInstance("C:/REPOSIT/IMAGE/att7.bmp");
//            ResizeImage(attatch);
//            table.addCell(new Phrase(new Chunk(attatch, 0, 0)));
//            attatch = Image.getInstance("C:/REPOSIT/IMAGE/att8.bmp");
//            ResizeImage(attatch);
//            
//            table.addCell(new Phrase(new Chunk(bar2Dimg, 0, 0)));
//            
//    		table.setTotalWidth(594-20);
//    		table.setLockedWidth(true);
//    		doc.add(table);
//    		
//    		table.setSpacingAfter(15f);
//    		
    		Chunk chEnd = new Chunk("-----   -----", FontKorea12);
    		chEnd.setBackground(clrDisp);
           Paragraph end = new Paragraph();
            end.setAlignment(PdfContentByte.ALIGN_CENTER);
            end.add(chEnd);
    		doc.add(end);

    		cb.beginText();
    		cb.setFontAndSize(bfKorea, 8);

    		String text = "This is End:";
     		cb.showTextAligned(PdfContentByte.ALIGN_RIGHT, text, 594-10-30, 5, 0);
    		cb.endText();
    		
    		intProgress = writer.getPageNumber();

        }
        catch ( Exception e ) {
            e.printStackTrace();
        }
    }

    public void onEndPage(PdfWriter writer, Document document) {
        PdfContentByte cb = writer.getDirectContent();
        cb.saveState();
        
		hTable.setTotalWidth(document.right() - document.left());
		hTable.setLockedWidth(true);
		hTable.writeSelectedRows(0, -1, 5, 831, cb);
		hTable.setHeaderRows(4);
        
		//		ܺ 輱
		cb.moveTo(10, 841-85);
		cb.lineTo(594-10, 841-85);
		cb.stroke();
		cb.saveState();
		
		gTable.setTotalWidth(document.right() - document.left() -10);
		gTable.setLockedWidth(true);
		gTable.writeSelectedRows(0, -1, 10, 831-90+9, cb);


		//
		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd, H:mm:ss");
		Date today = new Date();
		cb.beginText();
		cb.setFontAndSize(bfKorea, 8);
		//cb.setRGBColorFill(0x80, 0x00, 0x80);
		String text = "μϽ:";
		text = text + dateFormat.format(today); // + ", Powered by justRFX(tm) / www.justrfx.com";
	  
		cb.showTextAligned(PdfContentByte.ALIGN_LEFT, text, 10, 5, 0);
		text = "Page " + writer.getPageNumber();
 		cb.showTextAligned(PdfContentByte.ALIGN_RIGHT, text, 594-10, 5, 0);
		cb.endText();
		
		//ϴܺ 輱
		cb.setLineDash(3, 3, 0);
		//cb.setColorStroke(clrDisp);
		
		cb.setLineWidth(0.8f);
		cb.moveTo(10, 20);
		cb.lineTo(594-10, 20);
		cb.stroke();


//        cb.beginText();
//        cb.setFontAndSize(bfKorea, 12);
//        //cb.setRGBColorFill(0x80, 0x00, 0x80);
//        cb.showTextAligned(PdfContentByte.ALIGN_CENTER, strRfxNo.toUpperCase(), 594/2, 841-65, 0);
//        cb.endText();
        
//		Image sign=null;
//		try {
//			sign = Image.getInstance("C:/REPOSIT/IMAGE/com_sign.gif");
//		} catch (BadElementException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		} catch (MalformedURLException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		} catch (IOException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}

		try {
			cb.addImage(sign);
		} catch (DocumentException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

        cb.saveState();
        cb.restoreState();
        intProgress++;
    }    
    
    
	public RegisterdMasterCompany getMasterCompany() {
		return masterCompany;
	}

	public void setMasterCompany(RegisterdMasterCompany masterCompany) {
		this.masterCompany = masterCompany;
	}

	public SystemInfo getSystemInfo() {
		return systemInfo;
	}

	public void setSystemInfo(SystemInfo systemInfo) {
		this.systemInfo = systemInfo;
	}

	public void setListXpoast(List listXpoast) {
		this.listXpoast = listXpoast;
	}

	
		
	public String Double2String(Double value) {
		if(value==null) {
			return "0.0";
		}
		
		return decimalFormat.format(value);
	}

	public XpoBhd getXpobhd() {
		return xpobhd;
	}

	public void setXpobhd(XpoBhd xpobhd) {
		this.xpobhd = xpobhd;
	}

	public void afterPropertiesSet() throws Exception {
		if (masterCompany == null) throw new BeanCreationException("Must set masterCompany on PdfDocuPo");
		if (systemInfo == null) throw new BeanCreationException("Must set systemInfo on PdfDocuPo");
		if (xpobhd == null) throw new BeanCreationException("Must set xpobhd on PdfDocuPo");
		if (listXpoast == null) throw new BeanCreationException("Must set listXpoast on PdfDocuPo");

		
	}
}
