package com.rfxsoft.justrfx.document;

import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Iterator;
import java.util.List;


import com.lowagie.text.Chunk;
import com.lowagie.text.Document;
import com.lowagie.text.Element;
import com.lowagie.text.Image;
import com.lowagie.text.Paragraph;
import com.lowagie.text.Phrase;
import com.lowagie.text.Rectangle;
import com.lowagie.text.pdf.Barcode;
import com.lowagie.text.pdf.BarcodeEAN;
import com.lowagie.text.pdf.PdfContentByte;
import com.lowagie.text.pdf.PdfPCell;
import com.lowagie.text.pdf.PdfPTable;
import com.lowagie.text.pdf.PdfWriter;
import com.rfxsoft.justrfx.domain.RegisterdMasterCompany;
import com.rfxsoft.justrfx.domain.RtgAst;
import com.rfxsoft.justrfx.domain.SystemInfo;
import com.rfxsoft.justrfx.domain.PartLine;

//---------------------------- Contents Layour ----------------------------------------
//	[ ΰ ]							[ ſû ] 
//								        ûȣpo_no			
//-------------------------------------------------------------------------------------
//Ʈ pj_code: pj_name 						Ŵpo_name po_email
//û : requester(requester_id)(T: )		ýbarcode_content
//     : aprver(aprv_id)(T: )				
//-------------------------------------------------------------------------------------
//								--- û  ---
//ûpr_date			ĺȣrtgast_uid			ֹabst_info	 հݾ()total_price
//ǰdelivery	
//ܻ:ǥ		
//

public class PdfDocuPr extends AbstractPdfDocuLayout {

	private RegisterdMasterCompany masterCompany;
	private SystemInfo	systemInfo;
	
	private	RtgAst		prHeader;
	private	List		listPL;
	
	private SimpleDateFormat dateFormat 		= new SimpleDateFormat("yyyy/MM/dd");
	private SimpleDateFormat dateFormatDetail 	= new SimpleDateFormat("yyyy/MM/dd, H:mm:ss");
	private SimpleDateFormat dateFormatMedium 	= new SimpleDateFormat("MM/dd,H:mm:ss");

	private DecimalFormat 	decimalFormat = new DecimalFormat("#,##0");

	
	//--------------------- PDF Contents -------------------
	final static String strTitle = "ſû";
	
	private String pr_no ;
	private String requestWho;//, req_delivery_date;
	
	private String abst_info;
//	private String	barcode_content;
	
	private String	rtgast_uid;

	private String request_info,/* rtgast,*/ total_price, pr_date;

	private String project_info;
	
	protected PdfPTable hTable;
	protected PdfPTable gTable;
	protected PdfPCell cell;

	public PdfDocuPr(PdfWriter writer, Document doc, int progress, String strCode, String logo_img_path, String sign_img_path, 
			RegisterdMasterCompany masterCompany,
			SystemInfo	systemInfo,
			RtgAst		rtgast,
			List	listPL
	) {
		super(writer, doc, progress, strCode, logo_img_path, sign_img_path);
		this.setMasterCompany(masterCompany);
		this.setSystemInfo(systemInfo);
		this.setPrHeader(rtgast);
		this.setListPL(listPL);
	}

	@Override
	protected void GetFileContent() {
		pr_no = prHeader.getPo_no();
		project_info = prHeader.getName();
		
		abst_info			= getAbstInfo();

		//ѱ ڵ
		strBarCode = "880";//1 ū 
		
		rtgast_uid			= prHeader.getUnique_id().toString();
		pr_date				= dateFormat.format(prHeader.getAprv_date());
//		req_delivery_date	= dateFormat.format(prHeader.getReq_date());

		String strCodeFormatted= rtgast_uid;
		while(strCodeFormatted.length()<10)
			strCodeFormatted = "0" + strCodeFormatted;
		
		if(strCodeFormatted.length() > 10 )
			strCodeFormatted = strCodeFormatted.substring(0,10);
		
		//880 ڵ
		strBarCode = strBarCode + strCodeFormatted;
	}

	protected void CreateHeaderTable() {
		
		String pr_user_name 	= prHeader.getUser_name();
		String pr_user_id		= prHeader.getUser_id();
		String ap_user_name		= prHeader.getAprv_name();
		String ap_user_id		= prHeader.getAprv_user_id();
		Date request_date		= prHeader.getCreate_date();
		Date aprv_date			= prHeader.getAprv_date();
		
		String request_date_str = "'" + dateFormatMedium.format(request_date);
		String aprv_date_str 	= "'" + dateFormatMedium.format(aprv_date);
		
		requestWho				= 		":" + pr_user_name + "(" + pr_user_id + ")" + "  -  " + request_date_str   + "\n";

		if(ap_user_name!=null && ap_user_id!=null)
			requestWho = requestWho + 	":" + ap_user_name + "(" + ap_user_id + ")" + "  -  "  +  aprv_date_str 	 ;
		else
			requestWho = requestWho + 	"̰ ſû " ;

		float[] widths = 			{0.20f, 0.60f, 0.20f};
		float[] inh_widths = 		{1.0f};
		//float[] inh3_widths = 	{0.25f, 0.75f};
		
		hTable = new PdfPTable(widths);
		hTable.getDefaultCell().setBorder(Rectangle.NO_BORDER);
		
		PdfPTable inh1 = new PdfPTable(inh_widths);
		inh1.getDefaultCell().setBorder(Rectangle.NO_BORDER);
		inh1.addCell(new Phrase(new Chunk(logo, 0, 0)));
		
		PdfPTable inh2 = new PdfPTable(inh_widths);
		inh2.getDefaultCell().setBorder(Rectangle.NO_BORDER);
		Chunk chTitle = new Chunk(strTitle, FontKorea28);
		chTitle.setBackground(clrDisp);
		chTitle.setUnderline(clrPurple, 2.0f, 0.0f, 13.0f, 0.0f, PdfContentByte.LINE_CAP_BUTT);
		chTitle.setTextRenderMode(PdfContentByte.TEXT_RENDER_MODE_FILL_STROKE, 0.4f, clrBlack);
				
		inh2.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);
		inh2.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		inh2.addCell(new Phrase(chTitle) );
		
		Chunk chRfxno = new Chunk("ûȣ:"+this.pr_no, FontKorea10);
		inh2.getDefaultCell().setVerticalAlignment(Element.ALIGN_TOP);
		inh2.addCell(new Phrase(chRfxno) );

		
		cb = writer.getDirectContent();
		BarcodeEAN codeEAN = new BarcodeEAN();
		codeEAN.setCodeType(Barcode.EAN13);
		codeEAN.setCode(strBarCode);
		Image imageEAN = codeEAN.createImageWithBarcode(cb, null, null);


		PdfPTable inh3 = new PdfPTable(inh_widths);
		inh3.getDefaultCell().setBorder(Rectangle.NO_BORDER);
		inh3.addCell(new Phrase(new Chunk(imageEAN, 0, 0)));

		hTable.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);
		hTable.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
		hTable.addCell( inh1 );
		hTable.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		hTable.addCell( inh2 );
		hTable.getDefaultCell().setHorizontalAlignment(Element.ALIGN_RIGHT);
		hTable.addCell( inh3 );
	
		float global_width[] = {1.0f};

		gTable = new PdfPTable(global_width);
		gTable.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);
		gTable.setHorizontalAlignment(Element.ALIGN_CENTER);
   
		AddHeaderTable(gTable);
	}
	
	
	private void AddHeaderTable(PdfPTable gTable ) {
		
		float cus_ad_width[] = {0.1f, 0.4f, 0.1f, 0.4f};
		
		PdfPTable table = new PdfPTable(cus_ad_width);
		
		table.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);

		table.getDefaultCell().setBackgroundColor(clrCBack);
		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		table.addCell(new Phrase("Ʈ", FontKorea10b) );
		table.getDefaultCell().setBackgroundColor(clrWhite);
		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
		
		table.addCell(new Phrase(project_info, FontKorea10) );
		
		table.getDefaultCell().setBackgroundColor(clrCBack);
		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		table.addCell(new Phrase("û", FontKorea10b) );
		table.getDefaultCell().setBackgroundColor(clrWhite);
		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
		table.addCell(new Phrase(requestWho, FontKorea10) );

		gTable.addCell( table );
	}
	
	
    public  void DoWork() {
        try {
            
        	this.writer.setPageEvent(this);

    		table = new PdfPTable(global_width);

    		cell = new PdfPCell(new Phrase("- - - û  - - -", FontKorea12b) );
    		cell.setHorizontalAlignment(Element.ALIGN_CENTER);
    		cell.setVerticalAlignment(Element.ALIGN_MIDDLE);
    		cell.setBackgroundColor(clrCBack);
    		table.addCell(cell );
    		
    		cell = new PdfPCell(new Paragraph(request_info, FontKorea10));
    		cell.setHorizontalAlignment(Element.ALIGN_LEFT);
    		cell.setVerticalAlignment(Element.ALIGN_MIDDLE);
    		cell.setBackgroundColor(clrWhite);
    		table.addCell(cell );
    		
    		table.setTotalWidth(594-20);
    		table.setLockedWidth(true);
    		doc.add(table);
    		
    		float wide_width[] = {0.2f, 0.8f};
    		table = new PdfPTable(wide_width);
    		//table.getDefaultCell().setBorder(Rectangle.UNDEFINED);
    		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    		table.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);
    		table.getDefaultCell().setBackgroundColor(clrWhite);

    		float in_table_width[] = {0.42f, 0.58f};
    		float cell_height = 22f;
    		PdfPTable in_table = new PdfPTable(in_table_width);
    		in_table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    		in_table.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);
    		in_table.getDefaultCell().setBackgroundColor(clrCBack);

    		cell = new PdfPCell(new Paragraph("û", FontKorea10));
    		cell.setMinimumHeight(cell_height);
    		cell.setHorizontalAlignment(Element.ALIGN_CENTER);
    		cell.setVerticalAlignment(Element.ALIGN_MIDDLE);
    		cell.setMinimumHeight(25f);
    		cell.setBackgroundColor(clrCBack);
    		in_table.addCell(cell );
    		in_table.getDefaultCell().setBackgroundColor(clrWhite);
    		//in_table.getDefaultCell().setBorder(Rectangle.NO_BORDER);
    		in_table.addCell(new Phrase(pr_date, FontKorea10) );
    		in_table.getDefaultCell().setBorder(Rectangle.BOX);
/*
    		cell = new PdfPCell(new Paragraph("", FontKorea10));
    		cell.setMinimumHeight(cell_height);
    		cell.setHorizontalAlignment(Element.ALIGN_CENTER);
    		cell.setVerticalAlignment(Element.ALIGN_MIDDLE);
    		cell.setBackgroundColor(clrCBack);
    		in_table.addCell(cell );
    		in_table.getDefaultCell().setBackgroundColor(clrWhite);
    		in_table.getDefaultCell().setBorder(Rectangle.BOTTOM|Rectangle.TOP);
    		in_table.addCell(new Phrase("ǥ", FontKorea10) );
*/
    		cell = new PdfPCell(new Paragraph("", FontKorea10));
    		cell.setMinimumHeight(cell_height);
    		cell.setHorizontalAlignment(Element.ALIGN_CENTER);
    		cell.setVerticalAlignment(Element.ALIGN_MIDDLE);
    		cell.setBackgroundColor(clrCBack);
    		cell.setMinimumHeight(25f);
    		in_table.addCell(cell );
    		in_table.getDefaultCell().setBackgroundColor(clrWhite);
    		//in_table.getDefaultCell().setBorder(Rectangle.NO_BORDER);
    		in_table.addCell(new Phrase("ǥ", FontKorea10) );

    		table.addCell( in_table );

    		float content_width[] = {				0.12f,
    												0.76f,
    												0.06f,
    												0.06f		};
    		
    		in_table = new PdfPTable(content_width);
    		in_table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    		in_table.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);
    		in_table.getDefaultCell().setBackgroundColor(clrDisp);
    		
    		in_table.addCell(new Phrase("ĺȣ", FontKorea10) );
    		in_table.addCell(new Phrase("û ", FontKorea10) );
    		in_table.addCell(new Phrase("", FontKorea10) );
    		in_table.addCell(new Phrase("", FontKorea10) );
    
    		in_table.getDefaultCell().setBackgroundColor(clrWhite);
    		
    		cell = new PdfPCell(new Paragraph(rtgast_uid, FontKorea8));
    		cell.setMinimumHeight(15f);
    		cell.setHorizontalAlignment(Element.ALIGN_CENTER);
    		cell.setVerticalAlignment(Element.ALIGN_MIDDLE);
    		
    		in_table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    		in_table.addCell(cell );
    		in_table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
    		in_table.addCell(new Phrase(abst_info, FontKorea8) );
    		in_table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_RIGHT);
    		in_table.addCell(new Phrase(total_price, FontKorea8) );
    		in_table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    		in_table.addCell(new Phrase("", FontKorea8) );
    		
    		cell = new PdfPCell(new Phrase("  ſûմϴ.", FontKorea10) );
    		cell.setHorizontalAlignment(Element.ALIGN_CENTER);
    		cell.setVerticalAlignment(Element.ALIGN_MIDDLE);
    		cell.setBackgroundColor(clrWhite);
    		cell.setMinimumHeight(20f);
    		cell.setColspan(4);
    		in_table.addCell(cell );
    		
    		table.addCell( in_table );
    		
    		table.setTotalWidth(594-20);
    		table.setLockedWidth(true);
    		doc.add(table);

    		float detail_width[] = {			0.04f,
    											0.05f,
    											0.13f,
    											0.17f,
    											0.39f,
    											0.06f,
    											0.07f,
    											0.09f};

    		table = new PdfPTable(detail_width);
    		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    		table.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);
    		table.getDefaultCell().setBackgroundColor(clrCBack);
    		cell = new PdfPCell(new Phrase("- - -   - - -", FontKorea12b) );
    		cell.setHorizontalAlignment(Element.ALIGN_CENTER);
    		cell.setBackgroundColor(clrCBack);
    		cell.setColspan(10);
    		table.addCell(cell );
    		
    		table.getDefaultCell().setBackgroundColor(clrDisp);
    		
    		table.addCell(new Phrase("No", FontKorea8) );
    		table.addCell(new Phrase("", FontKorea10) );
    		table.addCell(new Phrase("ǰڵ", FontKorea10) );
    		table.addCell(new Phrase("ǰ", FontKorea10) );
    		table.addCell(new Phrase("԰ / ", FontKorea10) );
    		table.addCell(new Phrase("", FontKorea10) );
    		table.addCell(new Phrase("û", FontKorea8) );
    		table.addCell(new Phrase("", FontKorea10) );
    		
    		Double bm_quan_sum = 0.0;
    		Double pr_quan_sum = 0.0;
    		int serial_no = 1;
    		for(Iterator i=listPL.iterator(); i.hasNext(); serial_no++) {
   			
    			PartLine partline = (PartLine)i.next();
    			
    			String strNo = Integer.toString(serial_no);
    			
				String class_code = partline.getClass_code();
				String mat_type = "";
				if(class_code != null && class_code.length()>4) {
					mat_type = class_code.substring(0,4);
					if(mat_type.compareToIgnoreCase("O000")==0)
						mat_type = "";
					else if(mat_type.compareToIgnoreCase("S000")==0)
						mat_type = "ǥ";
					else if(mat_type.compareToIgnoreCase("M000")==0)
						mat_type = "Ŀ";
					else
						mat_type = "ǥ";
				}
    			String item_code = partline.getItem_code_dash();
    			String item_name = partline.getItem_name();
    			
    			String description = partline.getFull_spec();
    			
    			String pr_qty = Double2String(partline.getPr_quan() );
    			String bm_qty = Double2String(partline.getBm_quan() );
    			String delevery = partline.getReq_date_str();
    			
    			bm_quan_sum = bm_quan_sum + partline.getBm_quan();
    			pr_quan_sum = pr_quan_sum + partline.getPr_quan();
    			
    			table.getDefaultCell().setBackgroundColor(clrWhite);
    			table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    			table.addCell(new Phrase( strNo, FixedEng8) );
    			table.addCell(new Phrase( mat_type, FontKorea8) );
    			table.addCell(new Phrase( item_code, FixedEng8) );
    			table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
    			table.addCell(new Phrase( item_name, FontKorea8) );
    			table.addCell(new Phrase(description, FontKorea8) );
       			table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_RIGHT);
    			table.addCell(new Phrase( bm_qty, FontKorea8) );
    			table.addCell(new Phrase( pr_qty, FontKorea8) );
    			table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    			table.addCell(new Phrase(delevery, FontKorea8) );
    		}
    		
    		cell = new PdfPCell(new Phrase("   ", FontKorea10) );
    		cell.setHorizontalAlignment(Element.ALIGN_RIGHT);
    		cell.setVerticalAlignment(Element.ALIGN_MIDDLE);
    		cell.setBackgroundColor(clrDisp);
    		cell.setColspan(5);
    		table.addCell(cell );
    		
    		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_RIGHT);
    		table.addCell(new Phrase(Double2String(bm_quan_sum), FontKorea8) );
    		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_RIGHT);
    		table.addCell(new Phrase(Double2String(pr_quan_sum), FontKorea8) );
    		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    		table.addCell(new Phrase("-", FontKorea8) );

    		
    		table.setTotalWidth(594-20);
    		table.setLockedWidth(true);
    		doc.add(table);
 	
    		Chunk chEnd = new Chunk("-----   -----", FontKorea12);
    		chEnd.setBackground(clrDisp);
           Paragraph end = new Paragraph();
            end.setAlignment(PdfContentByte.ALIGN_CENTER);
            end.add(chEnd);
    		doc.add(end);

    		cb.beginText();
    		cb.setFontAndSize(bfKorea, 8);

    		String text = "This is End:";
     		cb.showTextAligned(PdfContentByte.ALIGN_RIGHT, text, 594-10-30, 5, 0);
    		cb.endText();
    		
    		intProgress = writer.getPageNumber();

        }
        catch ( Exception e ) {
            e.printStackTrace();
        }
    }
	
    public void onEndPage(PdfWriter writer, Document document) {
        PdfContentByte cb = writer.getDirectContent();
        cb.saveState();
        
		hTable.setTotalWidth(document.right() - document.left());
		hTable.setLockedWidth(true);
		hTable.writeSelectedRows(0, -1, 5, 831, cb);
		hTable.setHeaderRows(2);
        
		//		ܺ 輱
		cb.moveTo(10, 841-85+25);
		cb.lineTo(594-10, 841-85+25);
		cb.stroke();
		cb.saveState();
		
		gTable.setTotalWidth(document.right() - document.left() -10);
		gTable.setLockedWidth(true);
		gTable.writeSelectedRows(0, -1, 10, 831-90+9+25, cb);


		//
		Date today = new Date();
		cb.beginText();
		cb.setFontAndSize(bfKorea, 8);
		//cb.setRGBColorFill(0x80, 0x00, 0x80);
		String text = "μϽ:";
		text = text + dateFormatDetail.format(today); // + ", Powered by justRFX(tm) / www.justrfx.com";
	  
		cb.showTextAligned(PdfContentByte.ALIGN_LEFT, text, 10, 5, 0);
		text = "Page " + writer.getPageNumber();
 		cb.showTextAligned(PdfContentByte.ALIGN_RIGHT, text, 594-10, 5, 0);
		cb.endText();
		
		//ϴܺ 輱
		cb.setLineDash(3, 3, 0);
		//cb.setColorStroke(clrDisp);
		
		cb.setLineWidth(0.8f);
		cb.moveTo(10, 20);
		cb.lineTo(594-10, 20);
		cb.stroke();

        cb.saveState();
        cb.restoreState();
        intProgress++;
    }
    
	private String getAbstInfo() {
		
		String ret = "";
		Integer len = listPL.size()-1;
		
		for(Iterator i=listPL.iterator(); i.hasNext();) {
			PartLine partline = (PartLine)i.next();
			String item_name = partline.getItem_name();
			
			ret = item_name + " " + len.toString() + "" ;
			return ret;
		}
		
		return ret;
	}

	public void afterPropertiesSet() throws Exception {
		// TODO Auto-generated method stub

	}
	
	public String Double2String(Double value) {
		if(value==null) {
			return "0.0";
		}
		
		return decimalFormat.format(value);
	}
	
	public List getListPL() {
		return listPL;
	}

	public void setListPL(List listPL) {
		this.listPL = listPL;
	}

	public RegisterdMasterCompany getMasterCompany() {
		return masterCompany;
	}

	public void setMasterCompany(RegisterdMasterCompany masterCompany) {
		this.masterCompany = masterCompany;
	}

	public RtgAst getPrHeader() {
		return prHeader;
	}

	public void setPrHeader(RtgAst prHeader) {
		this.prHeader = prHeader;
	}

	public SystemInfo getSystemInfo() {
		return systemInfo;
	}

	public void setSystemInfo(SystemInfo systemInfo) {
		this.systemInfo = systemInfo;
	}
}
