package com.rfxsoft.justrfx.domain.menu;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import com.rfxsoft.justrfx.UserType;
import com.rfxsoft.justrfx.domain.command.JrServiceName;
import com.rfxsoft.justrfx.domain.command.MenuId;

public class MenuGroup extends MenuObject {

	List listMenu;

	public MenuGroup() {}
	
	
	
	public MenuGroup(String menuPerm) {
		super(menuPerm);
	}



	public int GetLength() {
		return listMenu.size();
	}
	
	public String GetHtmlDisply(String menuType) {
		String strDist ="";
		
		int size = listMenu.size();
		for(int i=0; i< size; i++)
		{
			MenuObject menu_obj = (MenuObject)listMenu.get(i);
			
			String label = menu_obj.getDisplayName();
			String key = menu_obj.getKey();
			String path = menu_obj.getLinkPath();
			
			if(i > 0 && label.length() > 0) {
				strDist = strDist + "<span>&nbsp;&nbsp;|&nbsp;&nbsp;</span>";
			}
			strDist = strDist + "<span style='text-align:center'></span>";
			
			 if(key.compareToIgnoreCase(menuType)==0)
			 {
				 strDist = strDist + "<b>";
			 }
			strDist = strDist + "<span id=";
			strDist = strDist + key;
			strDist = strDist + " align=center><a href=";
			strDist = strDist + "\\\"javascript:commandLocation(" + "'";
			strDist = strDist + path;
			strDist = strDist + "'" + ");\\\">";
			strDist = strDist + label;
			strDist = strDist + "</a></span>" ;
			 if(key.compareToIgnoreCase(menuType)==0)
			 {
				 strDist = strDist + "</b>";
			 }
		}
	
		return this.getKey() + "_ = " + "\"" + strDist+ "\";";
	}
	
	
	MenuGroup CopyedGroup() {
		MenuGroup copied = new  MenuGroup();
		this.copy_process(copied);
		
		return copied;
	}
	
	
	public MenuGroup(String name, String path) {
		super(name, path  );
	}


	boolean isExist (MenuId menuId, JrServiceName service) {
		
		if( matchService(menuId, service) == true )
			return true;
		
		for(Iterator i=listMenu.iterator(); i.hasNext();) {
			MenuObject object = (MenuObject)i.next();
			if(object.matchService(menuId, service) == true)
				return true;
		}
		
		return false;
	}
	public MenuObject GetMenuObjectByName(String name) {
		
		for(Iterator i=listMenu.iterator(); i.hasNext();) {
			MenuObject object = (MenuObject)i.next();
			if(object.getKey().compareToIgnoreCase(name) == 0)
				return object;
			
		}
		return null;
	}
	
	public List getListMenu() {
		return listMenu;
	}
	
	
	private void imYourStructure(MenuObject son) {
		son.setMenuStructure(this.getMenuStructure());
	}

	private void imYourParant(MenuObject son) {
		son.setParentName(this.getKey());
	}
	public void setListMenu(List listMenu) {
		this.listMenu = listMenu;
		
		//MenuGroupٰ ƹ .

		for(Iterator i=this.listMenu .iterator(); i.hasNext();) {
			MenuObject son = (MenuObject)i.next();
			imYourStructure( son);
			imYourParant(son);
		}
		
	}
	
	String HasKey(String key) {
		if( listMenu == null)
			return null;
		for(Iterator i=listMenu.iterator(); i.hasNext();) {
			MenuObject obj = (MenuObject)i.next();
		
			if(obj.FindKey(key))
				return this.getDisplayName();
		}
		
		return null;
	}
	
	public List getPowerdMenu(UserType callerType) {
		List<MenuObject> newList = new ArrayList<MenuObject>();
		
		for(Iterator i=this.listMenu .iterator(); i.hasNext();) {
			MenuObject son = (MenuObject)i.next();
			if(son.isPowerd(callerType)) {
				MenuObject newSon = son.copy();
				newList.add(newSon);	
			}
		}
		
		return newList;
	}
	
	
	public MenuObject getMenuFirst( UserType callerType ) {

		for(Iterator i= listMenu.iterator(); i.hasNext();) {
			MenuObject menu = (MenuObject)i.next();
			
			if( menu.isPowerd(callerType) )
			{
				return menu;
			}
		}
		return null;
	}

	
	String GetDisplay(String key) {
		
		String my_name = this.DisplayName(key);
		if(my_name != null)
			return my_name;
		
		if( listMenu == null)
			return null;
		
		for(Iterator i=listMenu.iterator(); i.hasNext();) {
			MenuObject obj = (MenuObject)i.next();
		
			my_name = obj.DisplayName(key);
			if(my_name!=null)
				return my_name;
		}
		
		return null;
		
	}
	
			
}
