package com.rfxsoft.justrfx.domain.menu;

import java.util.Random;

import com.rfxsoft.justrfx.UserType;
import com.rfxsoft.justrfx.domain.command.JrServiceName;
import com.rfxsoft.justrfx.domain.command.MenuId;

public class MenuObject {
	private MenuStructure menuStructure;
	private String key;
	private JrServiceName service;
	private MenuId		  menuId;
	private String displayName;
	private String linkPath;
	private MenuPerm mnuPerm;
	private String parentName;
	private String menuPerm;
	
	
	
	public MenuObject(String menuPerm) {
		super();
		setMnuPerm(menuPerm);
	}

	boolean matchService (MenuId menuId, JrServiceName service) {
		if(menuId == this.menuId && service==this.service)
			return true;
		else
			return false;
	}
	
	public void copy_process(MenuObject copied) {
		copied.setMenuStructure( this.getMenuStructure() );
		copied.setKey(this.getKey());
		copied.setService(this.getService());
		copied.setMenuId(this.getMenuId());
		copied.setDisplayName(this.getDisplayName());
		copied.setLinkPath(this.getLinkPath());
		copied.setMenuPerm(this.getMenuPerm());
		copied.setMnuPerm(this.getMnuPerm());
		copied.setParentName(this.getParentName());
	}

	MenuObject copy() {
		MenuObject copied = new  MenuObject();
		copy_process(copied);
		return copied;
	}
	
	public boolean isPowerd(UserType userType) {
		//return true;//  Ҷ
		
		if(mnuPerm==null)
			return false;
		
		return mnuPerm.hasPower(userType);

	}
	
	public boolean isWritePower(UserType userType) {
		//return true;//  Ҷ
		
		if(mnuPerm==null)
			return false;
		
		return mnuPerm.hasWritePower(userType);

	}


	public String getMenuPerm() {
		return menuPerm;
	}

	//̰ ɼ .
	public void setMenuPerm(String menuPerm) {
		this.menuPerm = menuPerm;
	}

	public MenuId getMenuId() {
		return menuId;
	}

	public JrServiceName getService() {
		return service;
	}

	public void setMnuPerm(MenuPerm mnuPerm) {
		this.mnuPerm = mnuPerm;
	}
	
	//Strig MenuPermƮ ȯ
	public void setMnuPerm(String menuPerm) {
		
		if(menuPerm==null)
			return;
		this.menuPerm = menuPerm;
		this.mnuPerm = new MenuPerm(menuPerm);
		
		mnuPerm = new MenuPerm(menuPerm);
		
	}
	
	public String getMnuPerm() {
		
		return this.menuPerm;
	}

	
	//public MenuPerm getMnuPerm() {
	//	return mnuPerm;
	//}
	
	//public void setMnuPerm(MenuPerm mnuPerm) {
	//	this.mnuPerm = mnuPerm;
	//}
	
	
	public MenuObject() {}
	
	
	public MenuObject(String name, String path) {
		super();
		
		Random ran = new Random();
		int iRand = ran.nextInt();
		
		key = "k" + Integer.toHexString(iRand);
		displayName = name;
		linkPath = path;
		mnuPerm = null;
	}
	public String getDisplayName() {
		return displayName;
	}
	public void setDisplayName(String displayName) {
		this.displayName = displayName;
	}
	public String getLinkPath() {
		return linkPath;
	}
	public void setLinkPath(String linkPath) {
		this.linkPath = linkPath;
	}
	public String getKey() {
		return key;
	}
	public void setKey(String key) {
		this.key = key;
		createService();
		
	}
	private boolean createService() {
		
		if(key==null)
			return false;
		if(key.length() < 3 )//ּ3
			return false;
	
		if( makeServiceName(key.charAt(0))==false)
			return false;
		
		if( makeMenuId(key.substring(1, 3))==false)
			return false;
		
		return true;
	}
	
	private boolean makeMenuId(String mn_key) {
		if(mn_key.compareToIgnoreCase("01")==0)
			this.setMenuId(MenuId.MN01);
		else if(mn_key.compareToIgnoreCase("02")==0)
			this.setMenuId(MenuId.MN02);
		else if(mn_key.compareToIgnoreCase("03")==0)
			this.setMenuId(MenuId.MN03);
		else if(mn_key.compareToIgnoreCase("04")==0)
			this.setMenuId(MenuId.MN04);
		else if(mn_key.compareToIgnoreCase("05")==0)
			this.setMenuId(MenuId.MN05);
		else if(mn_key.compareToIgnoreCase("06")==0)
			this.setMenuId(MenuId.MN06);
		else if(mn_key.compareToIgnoreCase("07")==0)
			this.setMenuId(MenuId.MN07);
		else if(mn_key.compareToIgnoreCase("08")==0)
			this.setMenuId(MenuId.MN08);
		else if(mn_key.compareToIgnoreCase("09")==0)
			this.setMenuId(MenuId.MN09);
		else if(mn_key.compareToIgnoreCase("10")==0)
			this.setMenuId(MenuId.MN10);
		else if(mn_key.compareToIgnoreCase("11")==0)
			this.setMenuId(MenuId.MN11);
		else if(mn_key.compareToIgnoreCase("12")==0)
			this.setMenuId(MenuId.MN12);
		else if(mn_key.compareToIgnoreCase("13")==0)
			this.setMenuId(MenuId.MN13);
		else if(mn_key.compareToIgnoreCase("14")==0)
			this.setMenuId(MenuId.MN14);
		else if(mn_key.compareToIgnoreCase("15")==0)
			this.setMenuId(MenuId.MN15);
		else if(mn_key.compareToIgnoreCase("16")==0)
			this.setMenuId(MenuId.MN16);
		else if(mn_key.compareToIgnoreCase("17")==0)
			this.setMenuId(MenuId.MN17);
		else if(mn_key.compareToIgnoreCase("18")==0)
			this.setMenuId(MenuId.MN18);
		else if(mn_key.compareToIgnoreCase("19")==0)
			this.setMenuId(MenuId.MN19);
		else if(mn_key.compareToIgnoreCase("20")==0)
			this.setMenuId(MenuId.MN20);
		else if(mn_key.compareToIgnoreCase("21")==0)
			this.setMenuId(MenuId.MN21);
		else if(mn_key.compareToIgnoreCase("22")==0)
			this.setMenuId(MenuId.MN22);
		else if(mn_key.compareToIgnoreCase("23")==0)
			this.setMenuId(MenuId.MN23);
		else if(mn_key.compareToIgnoreCase("24")==0)
			this.setMenuId(MenuId.MN24);
		else if(mn_key.compareToIgnoreCase("25")==0)
			this.setMenuId(MenuId.MN25);
		else if(mn_key.compareToIgnoreCase("26")==0)
			this.setMenuId(MenuId.MN26);
		else if(mn_key.compareToIgnoreCase("27")==0)
			this.setMenuId(MenuId.MN27);
		else if(mn_key.compareToIgnoreCase("28")==0)
			this.setMenuId(MenuId.MN28);
		else if(mn_key.compareToIgnoreCase("29")==0)
			this.setMenuId(MenuId.MN29);
		else if(mn_key.compareToIgnoreCase("30")==0)
			this.setMenuId(MenuId.MN30);
		else if(mn_key.compareToIgnoreCase("31")==0)
			this.setMenuId(MenuId.MN31);
		else if(mn_key.compareToIgnoreCase("32")==0)
			this.setMenuId(MenuId.MN32);
		else if(mn_key.compareToIgnoreCase("33")==0)
			this.setMenuId(MenuId.MN33);
		else if(mn_key.compareToIgnoreCase("34")==0)
			this.setMenuId(MenuId.MN34);
		else if(mn_key.compareToIgnoreCase("35")==0)
			this.setMenuId(MenuId.MN35);
		else if(mn_key.compareToIgnoreCase("36")==0)
			this.setMenuId(MenuId.MN36);
		else if(mn_key.compareToIgnoreCase("37")==0)
			this.setMenuId(MenuId.MN37);
		else if(mn_key.compareToIgnoreCase("38")==0)
			this.setMenuId(MenuId.MN38);
		else if(mn_key.compareToIgnoreCase("39")==0)
			this.setMenuId(MenuId.MN39);
		else if(mn_key.compareToIgnoreCase("40")==0)
			this.setMenuId(MenuId.MN40);
		else if(mn_key.compareToIgnoreCase("41")==0)
			this.setMenuId(MenuId.MN41);
		else if(mn_key.compareToIgnoreCase("42")==0)
			this.setMenuId(MenuId.MN42);
		else if(mn_key.compareToIgnoreCase("43")==0)
			this.setMenuId(MenuId.MN43);
		else if(mn_key.compareToIgnoreCase("44")==0)
			this.setMenuId(MenuId.MN44);
		else if(mn_key.compareToIgnoreCase("45")==0)
			this.setMenuId(MenuId.MN45);
		else if(mn_key.compareToIgnoreCase("46")==0)
			this.setMenuId(MenuId.MN46);
		else if(mn_key.compareToIgnoreCase("47")==0)
			this.setMenuId(MenuId.MN47);
		else if(mn_key.compareToIgnoreCase("48")==0)
			this.setMenuId(MenuId.MN48);
		else if(mn_key.compareToIgnoreCase("49")==0)
			this.setMenuId(MenuId.MN49);
		
		else
			return false;
		

		return true;
	}
	private boolean makeServiceName(char charHead) {
		
		if(charHead == 'a' || charHead == 'A')
			this.setService(JrServiceName.A_RFML);
		else if(charHead == 'b' || charHead == 'B')
			this.setService(JrServiceName.B_RTNG);
		else if(charHead == 'c' || charHead == 'C')
			this.setService(JrServiceName.C_PRJT);
		else if(charHead == 'd' || charHead == 'D')
			this.setService(JrServiceName.D_MTRL);
		else if(charHead == 'e' || charHead == 'E')
			this.setService(JrServiceName.E_PTNR);
		else if(charHead == 'f' || charHead == 'F')
			this.setService(JrServiceName.F_ADMN);
		else if(charHead == 'g' || charHead == 'G')
			this.setService(JrServiceName.G_MYNF);
		else if(charHead == 'h' || charHead == 'H')
			this.setService(JrServiceName.H_MYNV);
		else if(charHead == 'j' || charHead == 'J')
			this.setService(JrServiceName.J_PRCH);
		else if(charHead == 'y' || charHead == 'Y')
			this.setService(JrServiceName.Y_AUDT);
		else if(charHead == 'z' || charHead == 'Z')
			this.setService(JrServiceName.Z_RELO);
		else
			return false;
		
		return true;
	}
	
	boolean FindKey(String key) {
		if( this.key.compareToIgnoreCase(key)==0)
			return true;
		else
			return false;
	}
	
	String DisplayName(String key) {
		if( this.key.compareToIgnoreCase(key)==0)
			return displayName;

			return null;
	}
	public MenuStructure getMenuStructure() {
		return menuStructure;
	}
	public void setMenuStructure(MenuStructure menuStructure) {
		this.menuStructure = menuStructure;
	}
	public String getParentName() {
		return parentName;
	}
	public void setParentName(String parentName) {
		this.parentName = parentName;
	}

	public void setMenuId(MenuId menuId) {
		this.menuId = menuId;
	}

	public void setService(JrServiceName service) {
		this.service = service;
	}

}
