package com.rfxsoft.justrfx.domain.menu;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.springframework.beans.factory.BeanCreationException;
import org.springframework.beans.factory.InitializingBean;

import com.rfxsoft.justrfx.UserType;
import com.rfxsoft.justrfx.domain.command.JrServiceName;
import com.rfxsoft.justrfx.domain.command.MenuId;

public class MenuStructure implements InitializingBean{

	int	   menuPosition;
	String key;
	String menuTitle;
	List menuGroups; // . ִڴ 
	List<MenuGroup> menuPowerds;//̰ 
	
	
	public void afterPropertiesSet() throws Exception {
		if (key == null) throw new BeanCreationException("MenuStructure Ű  ʾҽϴ.(key==null)");
		
	}
	
	
	public List getMenuGroups(String option_name) {
		
		if(key.compareToIgnoreCase("optionUserType")==0)
			return menuGroups;
		return null;
	}

	public MenuStructure() {
		super();
		menuPowerds = new ArrayList<MenuGroup>();
	}

	public String getGroupName(String name) {
		if(this.getKey().compareToIgnoreCase(name) == 0)
			return key;
		
		MenuObject menuWhoami = this.GetMenuObjectByName(name);
		
		if(menuWhoami!=null)
			return menuWhoami.getParentName();
		
		return null;
	}

	
	public boolean IsRightObjectByName(String name) {
		//System.out.println(name +"        "+ this.getKey());
		if(this.getKey().compareToIgnoreCase(name) == 0)
			return true;
		
		for(Iterator i=menuGroups.iterator(); i.hasNext();) {
				MenuGroup group = (MenuGroup)i.next();
				MenuObject object =  group.GetMenuObjectByName(name);
				if(object!=null) {
					return true;
				}
			}
			return false;
	}
	public MenuObject GetMenuObjectByName(String name) {

		for(Iterator i=menuGroups.iterator(); i.hasNext();) {
			MenuGroup group = (MenuGroup)i.next();
			MenuObject object =  group.GetMenuObjectByName(name);
			if(object!=null) {
				return object;
			}
			
		}
		return null;
	}

	public String getMenuGroupTitle( String key ) {
		//System.out.println("key    "+key);
		if( menuGroups == null)
			return null;
		
		for(Iterator i=menuGroups.iterator(); i.hasNext();) {
			MenuGroup group = (MenuGroup)i.next();
			
			String display_name = group.HasKey(key);
			//System.out.println("display_name    "+display_name);
			if(display_name != null)
				return display_name;
			
		}
		
		return null;
	}
	
	public String getMenuDisplayTitle( String key ) {
		
		if( menuGroups == null)
			return menuTitle;
		
		for(Iterator i=menuGroups.iterator(); i.hasNext();) {
			MenuGroup group = (MenuGroup)i.next();
			
			String display_name = group.GetDisplay(key);
			
			if(display_name != null)
				return display_name;
			
		}
		
		return null;
	}

	public String getMenuTitle() {
		return menuTitle;
	}

	public void setMenuTitle(String menuTitle) {
		this.menuTitle = menuTitle;
	}

	public void destroyMenuGroups() {
		menuPowerds = null;
	}
		// ִ ޴ return
	public void createMenuGroups(UserType callerType) {
		
		menuPowerds.clear();
		
		for(Iterator i=menuGroups.iterator(); i.hasNext();) {
			MenuGroup group = (MenuGroup)i.next();
			
			if( group.isPowerd(callerType) )
			{
				List powerd = group.getPowerdMenu(callerType);
				
				MenuGroup cloneGroup = group.CopyedGroup();
				cloneGroup.setListMenu(powerd);
				
				menuPowerds.add(cloneGroup);	
			}
		}

	}
	
	public List getPoweredGroups() {
		return menuPowerds;
	}
	
	public String getPoweredGroupsHtml(String groupName, String menuType) {
		String strLine="";
		String strLineSub ="";
		List powerGroups = this.getPoweredGroups();
		int cnt=0;
		for(Iterator i= powerGroups.iterator(); i.hasNext();cnt++) {
			MenuGroup group = (MenuGroup)i.next();
			String groupKey = group.getKey();

			 if(cnt > 0) {
				 	strLine = strLine + "<span class=mid_menu_class >&nbsp;&nbsp;|&nbsp;&nbsp;</span>";					 
			 }
			 if(groupKey!=null && groupKey.compareToIgnoreCase(groupName)==0)
			 {
				 strLine = strLine + "<b>";
			 }
			 strLine = strLine + "<span id=" + group.getKey();
			 strLine = strLine + ">";
			 strLine = strLine + "<a style=\\\"cursor:pointer;\\\" onmouseover=\\\"getSubMenu('" + group.getKey() + "', this);\\\" ";
			 strLine = strLine + ">" + group.getDisplayName() + "</a></span>";
			 
			 if(groupKey!=null && groupKey.compareToIgnoreCase(groupName)==0)
			 {
				 strLine = strLine + "</b>";
			 }
			 strLineSub = strLineSub + group.GetHtmlDisply(menuType) + "\n";
		}
		
		return key + "_ = " + "\"" + strLine + "\";\n" + strLineSub;
	}
	
	public String getGroupMenuPosition() {
		String strLine="";
		
		List powerGroups = this.getPoweredGroups();
		int cnt=0;
		for(Iterator i= powerGroups.iterator(); i.hasNext();cnt++) {
			MenuGroup group = (MenuGroup)i.next();
			strLine = strLine + group.getKey() + "_pos = " + String.valueOf(cnt) + ";\n";
			cnt = cnt + group.getDisplayName().length();
		}
		
		return strLine;
	}


	public MenuGroup getPowerdGroupFirst( UserType callerType ) {

		for(Iterator i= menuGroups.iterator(); i.hasNext();) {
			MenuGroup group = (MenuGroup)i.next();
			
			if( group.isPowerd(callerType) )
			{
				return group;
			}
		}
		return null;
	}
	
	public MenuObject getMenuFirst( UserType callerType ) {
		
		MenuGroup firstMenuGroup = this.getPowerdGroupFirst(callerType);
		if(firstMenuGroup!=null) {
			return firstMenuGroup.getMenuFirst(callerType);
		}

		return null;
	}
	
	public boolean checkAuthority(MenuId menuId, JrServiceName service) {
		
		List powerGroups = this.getPoweredGroups();
		for(Iterator i= powerGroups.iterator(); i.hasNext();) {
			MenuGroup group = (MenuGroup)i.next();
			if(group.isExist(menuId, service)) 
				return true;
		}
		return false;
	}
	
	
	private void imYourStructure(MenuGroup son) {
		son.setMenuStructure(this);

	}

	private void imYourParant(MenuGroup son) {
		son.setParentName(this.getKey());
	}
	
	public void setMenuGroups(List menuGroups) {
		this.menuGroups = menuGroups;
		
		//MenuGroupٰ ƹ .

		for(Iterator i=this.menuGroups .iterator(); i.hasNext();) {
			MenuGroup son = (MenuGroup)i.next();
			imYourStructure( son);
			imYourParant(son);
		}

	}

	public int getMenuPosition() {
		return menuPosition;
	}
	
	public String getMenuPositionStr() {
		return Integer.toString(menuPosition);
	}

	public void setMenuPosition(int menuPosition) {
		this.menuPosition = menuPosition;
	}

	public String getKey() {
		return key;
	}

	public void setKey(String key) {
		this.key = key;
	}


}
