package com.rfxsoft.justrfx.dwr;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;

/**
 * If you want to avoid that your Servlet times out, you should use this ProgressServlet.
 * 
 * @author blowagie
 */
public class ProgressUploadServlet extends HttpServlet {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -8861617972077660871L;

	public class ProgressCopier implements Runnable {
		
		FileOutputStream 	out_stream;
		InputStream 		in_stream;
		long				file_Size;
		
		int percent = 0;

		public void run() {

			int n = 0;
			byte data[];
			data = new byte[2048];
			
			try {
				
				while ((n = in_stream.read(data)) != -1) {
					
					percent = (int) ((int)n * 100 / file_Size);
					out_stream.write(data, 0, n);  // file 
				}
				in_stream.close();
				out_stream.close();
				
				
			} catch (IOException e) {
				percent = -1;
				e.printStackTrace();
			} // while 
			
			percent = 100;

		}

		public void setIn_stream(InputStream in_stream) {
			this.in_stream = in_stream;
		}

		public void setOut_stream(FileOutputStream out_stream) {
			this.out_stream = out_stream;
		}

		public void setFile_Size(long file_Size) {
			this.file_Size = file_Size;
		}

		public int getPercent() {
			return percent;
		}
		
	}
	
    /**
     * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
     * @param request
     * @param response
     * @throws IOException
     * @throws ServletException
     */
    public void doGet (HttpServletRequest request, HttpServletResponse response)
    throws IOException, ServletException {
    	// We get a Session object
        HttpSession session = request.getSession(true);
        Object o = session.getAttribute("myFile");
        ProgressCopier copier;
        
		//ſܼ File Upload.

		String name = 		 request.getParameter("name");
//		String description = request.getParameter("description");
		MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
		MultipartFile multipartFile = multipartRequest.getFile("image");
		long fsize = multipartFile.getSize();
		
		File file = new File("/tmp/" + name);
		FileOutputStream os = new FileOutputStream( file );
		InputStream in = multipartFile.getInputStream();

        
        if (o == null) {
        	copier = new ProgressCopier();
        	copier.setIn_stream(in);
        	copier.setOut_stream(os);
        	copier.setFile_Size(fsize);
        	
        	session.setAttribute("myFile", copier);
        	Thread t = new Thread(copier);
        	t.start();
        }
        else {
        	copier = (ProgressCopier)o;
        }
        response.setContentType("text/html");
        switch (copier.getPercent()) {
        	case -1:
        		isError(response.getOutputStream());
        		return;
        	case 100:
        		isFinished(response.getOutputStream());
        		return;
        	default:
        		isBusy(copier, response.getOutputStream());
        		return;
        }
    }
	/**
     * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
     * @param request
     * @param response
     * @throws IOException
     * @throws ServletException
     */
    public void doPost (HttpServletRequest request, HttpServletResponse response)
    throws IOException, ServletException {
    	
    	doGet (request, response);
    	/*
    	// We get a Session object
        HttpSession session = request.getSession(false);
        try {
        	ProgressCopier copier = (ProgressCopier) session.getAttribute("myFile");
        	session.removeAttribute("myFile");
			//setting some response headers
			response.setHeader("Expires", "0");
			response.setHeader("Cache-Control", "must-revalidate, post-check=0, pre-check=0");
			response.setHeader("Pragma", "public");
			//setting the content type
			response.setContentType("text/html");
			isFinishedAgain(response.getOutputStream());
        }
        catch(Exception e) {
        	isError(response.getOutputStream());
        }
        */
    }

	/**
	 * Sends an HTML page to the browser saying how many percent of the document is finished.
	 * @param pdf 		the class that holds the PDF
	 * @param stream	the outputstream of the servlet
	 * @throws IOException
	 */
	private void isBusy(ProgressCopier pdf, ServletOutputStream stream) throws IOException {
		stream.print("<html>\n\t<head>\n\t\t<title>Please wait...</title>\n\t\t<meta http-equiv=\"Refresh\" content=\"5\">\n\t</head>\n\t<body>");
		stream.print(String.valueOf(pdf.getPercent()));
		stream.print("% of the document is done.<br>\nPlease Wait while this page refreshes automatically (every 5 seconds)\n\t</body>\n</html>");
	}

	/**
	 * Sends an HTML form to the browser to get the PDF
	 * @param stream	the outputstream of the servlet
	 * @throws IOException
	 */
	private void isFinished(ServletOutputStream stream) throws IOException {
		stream.print("<html>\n\t<head>\n\t\t<title>Finished!</title>\n\t</head>\n\t<body>");
		stream.print("The document is finished:<form method=\"POST\"><input type=\"Submit\" value=\"Get PDF\"></form>\n\t</body>\n</html>");
	}

	/**
	 * Sends an error message in HTML to the browser
	 * @param stream	the outputstream of the servlet
	 * @throws IOException
	 */
	private void isError(ServletOutputStream stream) throws IOException {
		stream.print("<html>\n\t<head>\n\t\t<title>Error</title>\n\t</head>\n\t<body>");
		stream.print("An error occured.\n\t</body>\n</html>");
	}
	
	@SuppressWarnings("unused")
	private void isFinishedAgain(ServletOutputStream stream) throws IOException {
		stream.print("<html>\n\t<head>\n\t\t<title>Finished OK!</title>\n\t</head>\n\t<body>");
		stream.print("The document is finished OK:<form method=\"POST\"><input type=\"Submit\" value=\"Get PDF\"></form>\n\t</body>\n</html>");
	}
}
