package com.rfxsoft.justrfx.gate.hwg2hmro;

import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.BeanCreationException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.FileSystemXmlApplicationContext;

import com.rfxsoft.justrfx.business.b_rtng.DefaultRtngManager;
import com.rfxsoft.justrfx.business.d_mtrl.DefaultMtrlManager;
import com.rfxsoft.justrfx.business.f_admn.DefaultAdmnManager;
import com.rfxsoft.justrfx.business.j_prch.DefaultPrchManager;
import com.rfxsoft.justrfx.business.k_gate.DefaultGateManager;
import com.rfxsoft.justrfx.domain.AssyMap;
import com.rfxsoft.justrfx.domain.ComBst;
import com.rfxsoft.justrfx.domain.IhwGr;
import com.rfxsoft.justrfx.domain.IhwPo;
import com.rfxsoft.justrfx.domain.RtgAst;
import com.rfxsoft.justrfx.domain.SrcAhd;
import com.rfxsoft.justrfx.domain.UsrAst;
import com.rfxsoft.justrfx.domain.XpoAst;

public class GateManagerHwgController {
	/* 1. Time Looping type 
	 *    Arguments : type('PO','GR','NW')
	 * 2. PO
	 *    - IHWPO ̺ ̽÷(interface_flag='N') 'N'ΰ͸ 븦 Ѵ.
	 *    - ȿ ˻ 
	 *       ȸ, ,  ˻
	 *       
	 *       ǰ(srcmap ǰ != 0 && ġؾ )
	 *       ԰(srcahd source_price != 0)
	 *       assymap ش ° 'GV'   Ҽ .
	 *        (. ϰ imk Ѿ ǰ  ֹ   )
	 *         assymap 
	 *          (PI : ̽   ɶ...
	 *           GV : imk Ѿ ǰ 'غ' ϶..
	 *           GH : imk Ѿ ǰ '' ϶..
	 *           GO : imk Ѿ ǰ 'ۿϷ' ϶..)
	 *    - ȿ ˻翡 հ óǸ PO Errer̺ ϰ
	 *      IHWPO̺   Ѵ.
	 *    - PO ̺(rtgast) 
	 *    - Part Line(assymap) 
	 *    - PO Detail(xpoast) 
	 * 3. GR
	 *    - IHWGR ̺ ̽÷(interface_flag='N') 'N'ΰ͸ 븦 Ѵ.
	 *    - ȿ ˻ 
	 *       
	 *    - ȿ ˻翡 հ óǸ GR Errer̺ ϰ
	 *      IHWGR̺   Ѵ.
	 *    - GR ԰̺(wgrast) 
	 * 4. űǰû(1 ȭ鿡 Ѿ´.)
	 *    - ȿ ˻ 
	 *       validate	 */
	
	ApplicationContext context = 
		new FileSystemXmlApplicationContext(new String[] {"company-information.xml", "envContext.xml", "applicationContext.xml"});

	DefaultRtngManager routingManager  = (DefaultRtngManager)context.getBean("routingManager");
	DefaultPrchManager purchaseManager = (DefaultPrchManager)context.getBean("purchaseManager");
	DefaultGateManager gateManager     = (DefaultGateManager)context.getBean("gateManager");
	DefaultAdmnManager adminManager    = (DefaultAdmnManager)context.getBean("adminManager");
    DefaultMtrlManager mtrlManager     = (DefaultMtrlManager)context.getBean("materialManager");
	
	/******************** PO **********************/
	public void CreateInterfacePORecord(String type){
		// ȿ ˻
		this.validate(type);
	}
	
	/******************** GR **********************/
	public void CreateInterfaceGRRecord(String type){
		// ȿ ˻
		this.validate(type);
	}
	
	/******************** űǰû **********************/
	// űǰû(1 ȭ鿡 Ѿ´.)
	public void CreateInterfaceNWRecord(String type){
		this.validate(type);
	}
	
    public void validate(String type)
    {
        if ("PO".equals(type)) 
        {
            validatePO(type);      
        }
        else if ("GR".equals(type)) 
        {
            validateGR(type);
        }
        else if ("NW".equals(type)) 
        {
            // ׷ -> ȭ (űǰû)
        }
        else
        {
            // ˼  ȣ         
        }
    }
    
    /**
     * ֹ I/F (׷ -> HWMRO)
     */
    public void validatePO(String type)
    {
        Integer po_uid = new Integer(-1);                
        String org_item_abst    = "";
        int item_quan = 0; 
        String po_no = "";     
        String by_po_no = "";
        
        // PO ȸ
        List ihwpoList = gateManager.getIhwpoList("ihwpo");
        if (ihwpoList != null) 
        {
            for(Iterator i=ihwpoList.iterator(); i.hasNext();) 
            {
                IhwPo ihwpo = (IhwPo)i.next();
                
                // (ihwpo)status, po_no, po_seq, wa_code ߺǴ Ÿ  'Y' ϰ ߺٰ Ѵ.
                // return value -1̸ DB
                if (gateManager.editValidateDup(ihwpo.getStatus(), ihwpo.getPo_no(), ihwpo.getPo_seq(), ihwpo.getWa_code()) != 0) 
                    continue;
                                    
                // ⺻ üũ
                if (gateManager.ValidateDefault(type, ihwpo, null) == false) 
                    continue;
                
                // ȸ, ,  ˻
                int usrast_unique_id = gateManager.ValidateUser(type, ihwpo, null);
                if (usrast_unique_id == -1) 
                    continue;
                
                ComBst combst = gateManager.getComBst(ihwpo.getWa_code());
                
                // , ǰ(srcmap ǰ != 0 && ġؾ ), ԰(srcahd source_price != 0) ˻
                Map return_value_tmp = gateManager.ValidateSrclist(ihwpo, combst.getUnique_id());
                if ((Integer)return_value_tmp.get("return_value") == -1) 
                    continue;
                
                int item_uid = (Integer)return_value_tmp.get("item_uid");
                String item_code = (String)return_value_tmp.get("item_code");
                
                /*
                 * assymap ش ° 'GV'   Ҽ .
                 *        (. ϰ imk Ѿ ǰ  ֹ   )
                 *         assymap 
                 *          (PI : ̽   ɶ...
                 *           GV : imk Ѿ ǰ 'غ' ϶..
                 *           GH : imk Ѿ ǰ '' ϶..
                 *           GO : imk Ѿ ǰ 'ۿϷ' ϶..)
                 */
                String item_abst = "";                
                if (!by_po_no.equals(ihwpo.getPo_no())) 
                {
                    item_abst = ihwpo.getItem_name();
                    org_item_abst = item_abst;
                    item_quan = 1;
                    
                    // PO ̺(rtgast) (׷翡 Ѿ ֹȣ Ѵ.)
                    Map return_value = this.addRouting(type, ihwpo, null, usrast_unique_id, item_quan, item_abst);

                    po_no = (String)return_value.get("po_no");                      
                    po_uid = (Integer)return_value.get("po_uid");
                }
                else
                {
                    item_abst = org_item_abst + " " + item_quan + "";
                    ++item_quan;
                    
                    // PO ̺(rtgast) update
                    gateManager.editRtgastItem(po_uid, item_quan, item_abst);
                }
                
                by_po_no = ihwpo.getPo_no();
                
                // Part Line(assymap) 
                if (this.addOrderAssyMap(ihwpo, usrast_unique_id, po_no, po_uid, item_uid, item_quan, item_code) != null) 
                {
                    // PO Detail(xpoast) 
                    int return_tmp = this.addXpoast(po_uid, ihwpo.getPo_creator_id(), po_no, item_quan, ihwpo);
                    
                    if (return_tmp == -3)           // xpoast update ߻
                        gateManager.ValidateInsert(type, ihwpo, null, "PO Detail̺(xpoast) UPDATE ߻!");
                    else if (return_tmp == -2)      // assymap update err
                        gateManager.ValidateInsert(type, ihwpo, null, "AssyMap̺ UPDATE ߻!");
                    else if (return_tmp == -1)      // xpoast insert err
                        gateManager.ValidateInsert(type, ihwpo, null, "PO Detail̺(xpoast)  ߻!");
                }
                else
                {
                    gateManager.ValidateInsert(type, ihwpo, null, "Part Line(assymap)  ߻!");
                }
                
                // IHWPO ̺ ̽ ÷׸ 'Y' 
                gateManager.setIhwpoIfFlag(new Date(), ihwpo.getPo_no(), ihwpo.getPo_seq(), ihwpo.getWa_code(), ihwpo.getStatus());
            }
        }
            
    }
    
    /**
     * ԰ I/F (׷ -> HWMRO)
     */
    public void validateGR(String type)
    {
        Integer gr_uid = -1;
        String gr_no = "";
        String by_gr_no = "";
        String org_item_abst = "";
        int item_quan = 0;
            
        // GR : IHWGR ̺ ̽÷(interface_flag='N') 'N'ΰ͸ 븦 Ѵ.
        List ihwgrList = gateManager.getIhwgrList("ihwgr");
        
        if (ihwgrList != null) 
        {
            for(Iterator i=ihwgrList.iterator(); i.hasNext();) 
            {
                IhwGr ihwgr = (IhwGr)i.next();
                                
                // ⺻ üũ
                if (gateManager.ValidateDefault(type, null, ihwgr) == false) 
                    continue;
                
                // xpoast po_no, po_seq Ȱ ִ Ȯ(־ )
                List tmp_list = gateManager.getXpoAstGr(ihwgr.getPo_no(), ihwgr.getPo_seq());
                if (tmp_list == null || tmp_list.size() <= 0) 
                {
                    gateManager.ValidateInsert(type, null, ihwgr, "ش ԰(GR_NO:"+ihwgr.getGr_no()+", GR_SEQ:"+ihwgr.getGr_seq()+")  ֹͰ  ʽϴ.");
                    continue;
                }
                
                // ȸ, ,  ˻
                int usrast_unique_id = gateManager.ValidateUser(type, null, ihwgr);
                if (usrast_unique_id == -1) 
                    continue;

                String item_abst = "";
                if (!by_gr_no.equals(ihwgr.getGr_no())) 
                {
                    item_abst = ihwgr.getItem_name();
                    org_item_abst = item_abst;
                    item_quan = 1;
                    
                    // GR ̺(rtgast) (׷翡 Ѿ ԰ȣ Ѵ.)
                    Map return_value = this.addRouting(type, null, ihwgr, usrast_unique_id, item_quan, item_abst);

                    gr_no = (String)return_value.get("gr_no");
                    gr_uid = (Integer)return_value.get("gr_uid");
                }
                else
                {
                    item_abst = org_item_abst + " "+item_quan+"";
                    ++item_quan;
                    
                    // GR ̺(rtgast) update
                    gateManager.editRtgastItem(gr_uid, item_quan, item_abst);
                }
                
                by_gr_no = ihwgr.getGr_no();

                // assymap po_no, po_sec ˻ Ѵ.
                List grassymap_tmp = gateManager.getXpoAstGr(ihwgr.getPo_no(), ihwgr.getPo_seq());

                XpoAst xpoast = new XpoAst();
                for(Iterator k=grassymap_tmp.iterator(); k.hasNext();) 
                {
                    xpoast = (XpoAst)k.next();
                }

                // assymap, xpoast    Ѵ.
                // is_closed O̸ ֹ Ÿ ɰ ƴϸ ױ⼭ .
                String temp = "";
                if ("O".equals(ihwgr.getPo_status())) 
                    temp = "N";

                if (purchaseManager.addGoodsReceiptSingle("԰ǰ:IF", ihwgr.getCreator(), gr_uid, gr_no, usrast_unique_id, item_quan, xpoast.getUnique_id(), xpoast.getPo_qty(), ihwgr.getGr_qty(), temp, ihwgr.getGr_date()) == true)
                {
                    //   gr_no, gr_seq ãƼ xpoast ׷ updateѴ.(by_gr_no, by_gr_seq, by_gr_year)
                    if (gateManager.editXpoAstGr(gr_no, item_quan+"", ihwgr.getWa_code(), ihwgr.getGr_no(), ihwgr.getGr_seq(), ihwgr.getYear()) == false) 
                        gateManager.ValidateInsert(type, null, ihwgr, "GR ̺(xpoast) ׷  UPDATE ߻!");
                }
                else
                {
                    gateManager.ValidateInsert(type, null, ihwgr, "GR ̺(assymap, xpoast)  ߻!");
                }

                // IHWPO ̺ ̽ ÷׸ 'Y' 
                gateManager.setIhwgrIfFlag(new Date(), ihwgr.getGr_no(), ihwgr.getGr_seq(), ihwgr.getWa_code(), ihwgr.getStatus());
            }
        }
            
    }
    
	// PO ̺(rtgast) 
	public Map addRouting(String type, IhwPo ihwpo, IhwGr ihwgr, int usrast_unique_id, int item_quan, String item_abst)
    {
		Map<String, Comparable> return_value = new HashMap<String, Comparable>();
		
		String user_id = "";
		
		Integer last_no = routingManager.getSysinfoDao().GetLastUnChecked(type);
		RtgAst rtgast = new RtgAst(type, last_no);
		
		switch(rtgast.getRtg_type_enum()) 
        {
    		case OR://PO 
    			user_id = ihwpo.getPo_creator_id();
    			rtgast.setName("[I/F] PO:"+ihwpo.getPo_no()+", SEQ:"+ihwpo.getPo_seq());
    			rtgast.setContent(ihwpo.getPo_creator_name()+" "+ihwpo.getItem_name()+"() "+ihwpo.getPo_qty()+ihwpo.getUnit_code()+" ֹ Ͽϴ.");
    			rtgast.setRtg_type("O");
    			return_value.put("po_no", rtgast.getPo_no());
    			return_value.put("po_uid", rtgast.getUnique_id());
    			break;
    			
    		case GR://GR 
    			user_id = ihwgr.getCreator();
    			rtgast.setName("[I/F] GR:"+ihwgr.getGr_no()+", SEQ:"+ihwgr.getGr_seq());
    			rtgast.setContent(ihwgr.getCreator()+" "+ihwgr.getItem_name()+"() "+ihwgr.getGr_qty()+ihwgr.getUnit_code()+" ԰ Ͽϴ.");
    			rtgast.setRtg_type("W");
    			return_value.put("gr_no", rtgast.getPo_no());
    			return_value.put("gr_uid", rtgast.getUnique_id());
    			break;
                
    		default:
    				return null;
		}

		rtgast.setCreator(user_id);
		rtgast.setChange_date(rtgast.getCreate_date());
		rtgast.setChanger(rtgast.getCreator());
		rtgast.setState("A");
		rtgast.setWork_cursor(-1);		
		rtgast.setItem_quan(item_quan);
		rtgast.setItem_abst(item_abst);		
		rtgast.setUser_id(user_id);
		rtgast.setAccp_quan(0);
		rtgast.setDeni_quan(0);		
		rtgast.setPo_type("IF");
		rtgast.setWork_quan(0);
		
		routingManager.addRouting(user_id, rtgast, usrast_unique_id, -1);
		routingManager.getSysinfoDao().SetLastValue(type, last_no);
		
		return return_value;
	}
	
	// Part Line(assymap) 

	public Object addOrderAssyMap(IhwPo ihwpo, int usrast_unique_id, String po_no, Integer po_uid, int item_uid, int po_sec, String item_code)
    {
        SrcAhd scrahd = mtrlManager.getDetail(ihwpo.getItem_code(), ihwpo.getCompany_code(), ihwpo.getWa_code());
        
		//   Ǿ Ѵ.
  		AssyMap assymap = new AssyMap();
  		
  		assymap.setChild(item_uid);
  		assymap.setStatus("PO");
  		assymap.setQuan(ihwpo.getPo_qty());
  		assymap.setPr_quan(assymap.getQuan());
  		assymap.setMquan(0.0);
  		assymap.setAc_uid(0);
  		assymap.setPr_user_uid(usrast_unique_id);
  		assymap.setPo_uid(po_uid);
  		assymap.setPo_user_uid(usrast_unique_id);
  		assymap.setRush_order_flag(ihwpo.getRush_order_flag());
  		assymap.setDelivery_info(""); // ǰ imk Ѿ´.
  		assymap.setDel_info_flag("N");
  		// û
  		if (ihwpo.getReq_info() != null) 
        {
  			assymap.setReq_flag("Y");
  			assymap.setReq_info(ihwpo.getReq_info());
  		}
        else
        {
  			assymap.setReq_flag("N");
  			assymap.setReq_info("");
  		}
  		
  		// μ uid˻
  		List tmp = adminManager.getAllUserList(ihwpo.getReceiver_id());
  		for(Iterator i=tmp.iterator(); i.hasNext();) 
        {
  			UsrAst usrast = (UsrAst)i.next();
  			assymap.setRcvr_uid(usrast.getUnique_id());
  		}
  		
  		assymap.setRcvr_name(ihwpo.getReceiver_name());
  		assymap.setPo_no(po_no);
  		assymap.setPo_sec(po_sec);
  		assymap.setGr_sec(0);
  		assymap.setItem_code(item_code);
  		assymap.setBuyer_item_code(ihwpo.getItem_code());
  		assymap.setSp_code(ihwpo.getSp_code());
  		assymap.setCreator(ihwpo.getPo_creator_id());
  		assymap.setCreate_date(new Date());
  		assymap.setChanger(assymap.getCreator());
  		assymap.setReq_date(ihwpo.getReq_delivery_date());
  		assymap.setChange_date(assymap.getCreate_date());
        
        assymap.setSales_price(ihwpo.getSales_price());
        assymap.setSource_price(scrahd.getSource_price());
  		
  		return gateManager.addAssyMap(assymap.getCreator(), assymap);
	}
	
	// PO Detail(xpoast) 
	public int addXpoast(int po_uid, String creator, String po_no, int item_quan, IhwPo ihwpo)
    {	
		// assymap PO̺  row  
		List list = gateManager.getAssyMap(po_uid, item_quan);
		
		// xpoast 
		if (purchaseManager.confirmPurchageOrderListInsert(po_uid, creator, list)) 
        {
			// AssyMap  
			if (gateManager.editAssyMapPo(po_no, item_quan) == true) 
            {
				String po_seq = item_quan+"";
				
				if (gateManager.editXpoAstPo(po_no, po_seq, ihwpo.getPo_no(), ihwpo.getPo_seq(), ihwpo.getPo_creator_name(), 
										     ihwpo.getPo_creator_tel_no(), ihwpo.getReceiver_name(), ihwpo.getReceiver_tel_no(), ihwpo.getReceiver_hp_no(), 
										     ihwpo.getDelivery_zip_code(), ihwpo.getDelivery_address_1(), ihwpo.getDelivery_address_2(), ihwpo.getItem_code(), 
                                             ihwpo.getDivision_code(), ihwpo.getPo_date(), ihwpo.getAccount_code(), ihwpo.getBudget_wa_code(), 
                                             ihwpo.getBudget_division_code(), ihwpo.getBudget_dept_code()) == true) {
					return 0;
				}
                else
					return -3;
			}
            else
            {
				return -2;
			}
		}
        else
			return -1;
	}
	
	public final void afterPropertiesSet() throws Exception {
		if (routingManager == null) throw new BeanCreationException("Must be set routingManager on GateManagerHwgController");
		if (purchaseManager == null) throw new BeanCreationException("Must be set purchaseManager on GateManagerHwgController");
		if (adminManager == null) throw new BeanCreationException("Must be set adminManager on GateManagerHwgController");
		if (gateManager == null) throw new BeanCreationException("Must be set gateManager on GateManagerHwgController");
	}
	
	public DefaultAdmnManager getAdminManager() {
		return adminManager;
	}

	public void setAdminManager(DefaultAdmnManager adminManager) {
		this.adminManager = adminManager;
	}

	public ApplicationContext getContext() {
		return context;
	}

	public void setContext(ApplicationContext context) {
		this.context = context;
	}

	public DefaultGateManager getGateManager() {
		return gateManager;
	}

	public void setGateManager(DefaultGateManager gateManager) {
		this.gateManager = gateManager;
	}

	public DefaultPrchManager getPurchaseManager() {
		return purchaseManager;
	}

	public void setPurchaseManager(DefaultPrchManager purchaseManager) {
		this.purchaseManager = purchaseManager;
	}

	public DefaultRtngManager getRoutingManager() {
		return routingManager;
	}

	public void setRoutingManager(DefaultRtngManager routingManager) {
		this.routingManager = routingManager;
	}
}
