package com.rfxsoft.justrfx.mail;

import java.io.File;

import javax.mail.MessagingException;
import javax.mail.internet.MimeMessage;

import org.springframework.context.ApplicationContext;
import org.springframework.context.support.FileSystemXmlApplicationContext;
import org.springframework.core.io.FileSystemResource;
import org.springframework.mail.javamail.MimeMessageHelper;

/**
 * @author robh
 *  
 */
public class AttachmentMessageSender extends AbstractMessageSender {

	public void sendMessage() throws MessagingException {
		MimeMessage msg = sender.createMimeMessage();
		MimeMessageHelper helper = new MimeMessageHelper(msg, true);

		helper.setTo(to);
		helper.setFrom(from);
		helper.setSubject(subject);

		helper.setText(
				"<html><head></head><body><h1>Hello World!</h1></body></html>",
				true);

		// add the image
		FileSystemResource file = new FileSystemResource(new File(
				"C:/wlic3pack.log"));
		helper.addAttachment("wlic3pack.log", file);

		sender.send(msg);
	}

	public static void main(String[] args) throws Exception {
//		logger.debug("User's current working directory : "+System.getProperty("user.dir")); 
		
		ApplicationContext ctx = new FileSystemXmlApplicationContext(
				new String[] { "WebContent/WEB-INF/attachmentMessageSender.xml",
						"WebContent/WEB-INF/javaMailSender.xml"
						});

		AttachmentMessageSender sender = (AttachmentMessageSender) ctx
				.getBean("messageSender");
		
		sender.setTo("keionepark@paran.com");
		sender.setFrom("k1park@microsoft.com");
		sender.setSubject("ƿ迡 ÷η .");
		sender.sendMessage();
	}
}