package com.rfxsoft.justrfx.view;

import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import org.apache.poi.hssf.usermodel.HSSFDataFormat;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.springframework.web.servlet.view.document.AbstractExcelView;

import com.rfxsoft.justrfx.domain.XpoAst;

public class ExcelView_j05 extends AbstractExcelView {

	private static final int ITEM_CODE		= 0;	//ǰڵ
	private static final int PO_NO			= 1;	//ֹȣ
	private static final int GR_NO			= 2;	//԰ȣ
	private static final int ITEM_NAME		= 3;	//ǰ
	private static final int SPECIFICATION	= 4;	//԰
	private static final int MODEL_NO		= 5;	///
	private static final int DESCRIPTION	= 6;	//ó
	private static final int MAKER_NAME		= 7;	//
	private static final int DEPT_NAME		= 8;	//μ
	private static final int SELLER_NAME	= 9;	//޿
	private static final int PR_DATE		= 10;	//û
	private static final int PR_QTY			= 11;	//û
	private static final int PO_DATE		= 12;	//
	private static final int PO_QTY			= 13;	//ּ
	private static final int REQ_DELIVERY	= 14;	//
	private static final int GR_DATE		= 15;	//԰
	private static final int PR_NAME		= 16;	//û
	private static final int RECEIVER_NAME	= 17;	//μ
	private static final int MP_STATUS		= 18;	//
	private static final int SALES_PRICE	= 19;	//ܰ
	private static final int PO_PRICE		= 20;	//ֱݾ
	private static final int GR_QTY			= 21;	//԰
	private static final int GR_PRICE		= 22;	//԰ݾ


	void SetCellValue(HSSFSheet sheet, HSSFCellStyle style, int row, int col, Object value) {
		
		getCell(sheet, row, col).setEncoding(HSSFCell.ENCODING_UTF_16);
		if(row == 0)
		{
			getCell(sheet, row, col).setCellValue((String)value);
		}
		else {
			switch(col) {
			case PR_DATE:
			case PO_DATE:
			case REQ_DELIVERY:
			case GR_DATE:
				getCell(sheet, row, col).setCellValue((Date)value);
				getCell(sheet, row, col).setCellStyle(style);
				break;
			case PR_QTY:
			case PO_QTY:
			case SALES_PRICE:
			case PO_PRICE:
			case GR_QTY:
			case GR_PRICE:
				getCell(sheet, row, col).setCellValue((Double)value);
				break;
			default:
				getCell(sheet, row, col).setCellValue((String)value);
			}
		}
	}
	
	@Override
	protected void buildExcelDocument(Map model, HSSFWorkbook wb,
			HttpServletRequest request, HttpServletResponse response) throws Exception {


		List xpoastList = (List) model.get("xpoast");
		
		if(xpoastList==null)
			return;
		
		HSSFSheet sheet = wb.createSheet();
		//ŸϽƮ
	    HSSFCellStyle style = wb.createCellStyle();
	    style.setDataFormat(HSSFDataFormat.getBuiltinFormat("m/d/yy"));
		
	    wb.setSheetName(0, "԰Ȳ", HSSFCell.ENCODING_UTF_16);
	    
		int row = 0;
		SetCellValue( sheet, style, row, ITEM_CODE, "ǰڵ");
		SetCellValue( sheet, style, row, PO_NO, "ֹȣ");
		SetCellValue( sheet, style, row, GR_NO, "԰ȣ");
		SetCellValue( sheet, style, row, ITEM_NAME, "ǰ");
		SetCellValue( sheet, style, row, SPECIFICATION, "԰");
		SetCellValue( sheet, style, row, MODEL_NO, "/");
		SetCellValue( sheet, style, row, DESCRIPTION, "ó");
		SetCellValue( sheet, style, row, MAKER_NAME, "");
		SetCellValue( sheet, style, row, DEPT_NAME, "μ");
		SetCellValue( sheet, style, row, SELLER_NAME, "޿");
		SetCellValue( sheet, style, row, PR_DATE, "û");
		SetCellValue( sheet, style, row, PR_QTY, "û");
		SetCellValue( sheet, style, row, PO_DATE, "");
		SetCellValue( sheet, style, row, PO_QTY, "ּ");
		SetCellValue( sheet, style, row, REQ_DELIVERY, "");
		SetCellValue( sheet, style, row, GR_DATE, "԰");
		SetCellValue( sheet, style, row, PR_NAME, "û");
		SetCellValue( sheet, style, row, RECEIVER_NAME, "μ");
		SetCellValue( sheet, style, row, MP_STATUS, "");
		SetCellValue( sheet, style, row, SALES_PRICE, "ܰ");
		SetCellValue( sheet, style, row, PO_PRICE, "ֱݾ");
		SetCellValue( sheet, style, row, GR_QTY, "԰");
		SetCellValue( sheet, style, row, GR_PRICE, "԰ݾ");
		
		row++;
		
	    for(Iterator i=xpoastList.iterator(); i.hasNext();){
	    	
	    	XpoAst xpoast 			= (XpoAst)i.next();
	    	
			SetCellValue( sheet, style, row, ITEM_CODE, 	xpoast.getItem_code());
			SetCellValue( sheet, style, row, PO_NO, 		xpoast.getPo_no());
			SetCellValue( sheet, style, row, GR_NO, 		xpoast.getGr_no());
			SetCellValue( sheet, style, row, ITEM_NAME, 	xpoast.getItem_name());
			SetCellValue( sheet, style, row, SPECIFICATION, xpoast.getSpecification());
			SetCellValue( sheet, style, row, MODEL_NO, 		xpoast.getModel_no());
			SetCellValue( sheet, style, row, DESCRIPTION, 	xpoast.getDescription());
			SetCellValue( sheet, style, row, MAKER_NAME, 	xpoast.getMaker_name());
			SetCellValue( sheet, style, row, DEPT_NAME, 	xpoast.getDept_name());
			SetCellValue( sheet, style, row, SELLER_NAME, 	xpoast.getSeller_name());
			SetCellValue( sheet, style, row, PR_DATE, 		xpoast.getPr_date());
			SetCellValue( sheet, style, row, PR_QTY, 		xpoast.getPr_qty());
			SetCellValue( sheet, style, row, PO_DATE, 		xpoast.getPo_date());
			SetCellValue( sheet, style, row, PO_QTY, 		xpoast.getPo_qty());
			SetCellValue( sheet, style, row, REQ_DELIVERY, 	xpoast.getReq_delivery_date());
			SetCellValue( sheet, style, row, GR_DATE, 		xpoast.getGr_date());
			SetCellValue( sheet, style, row, PR_NAME, 		xpoast.getPr_name());
			SetCellValue( sheet, style, row, RECEIVER_NAME, xpoast.getReceiver_name());
			SetCellValue( sheet, style, row, MP_STATUS, 	xpoast.getMp_status());
			SetCellValue( sheet, style, row, SALES_PRICE, 	xpoast.getSales_price());
			SetCellValue( sheet, style, row, PO_PRICE, 		xpoast.getPo_qty()*xpoast.getSales_price());
			SetCellValue( sheet, style, row, GR_QTY, 		xpoast.getGr_qty());
			SetCellValue( sheet, style, row, GR_PRICE, 		xpoast.getGr_qty()*xpoast.getSales_price());
			
			row++;
		}
		
	}

}
