package com.rfxsoft.justrfx.web;


import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;
import java.util.Map;
import java.util.Random;
import java.util.Vector;


import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.web.bind.ServletRequestBindingException;
import org.springframework.web.bind.ServletRequestUtils;
import org.springframework.web.servlet.ModelAndView;

import com.rfxsoft.justrfx.CmdType;
import com.rfxsoft.justrfx.DwrPageType;
import com.rfxsoft.justrfx.domain.ComAst;
import com.rfxsoft.justrfx.domain.ComBst;
import com.rfxsoft.justrfx.domain.ComCst;
import com.rfxsoft.justrfx.domain.ComDst;
import com.rfxsoft.justrfx.domain.PartLine;
import com.rfxsoft.justrfx.domain.Project;
import com.rfxsoft.justrfx.domain.SrcAhd;
import com.rfxsoft.justrfx.domain.SupAst;
import com.rfxsoft.justrfx.domain.UsrAst;
import com.rfxsoft.justrfx.domain.ZipCode;
import com.rfxsoft.justrfx.dwr.CommonInfo;
import com.rfxsoft.justrfx.web.controller.AbstractSecurityController;
import com.rfxsoft.justrfx.web.security.SessionSecurityManager; //ǰ. 



public class DwrPageController extends AbstractSecurityController {
	
	CommonInfo commonInfo;
	protected final Log logger = LogFactory.getLog( getClass() );

	public CommonInfo getCommonInfo() {
		return commonInfo;
	}


	public void setCommonInfo(CommonInfo commonInfo) {
		this.commonInfo = commonInfo;
	}

	private String StripDash(String key) {
		return key.replace('-', '_').toUpperCase();
	}
	
	private DwrPageType getPageType(String key) {
		return DwrPageType.valueOf(StripDash(key));
	}

	void getOutputResult(Integer uid_combst, String page_header, String searchType, String searchKey, Map<String, Object> menu_info,
			String this_user_id, String company_code, String wa_code,Integer this_user_uid) {
		
		String page_name = ""; //page_header;
		List plList =null;
		
		switch( getPageType(searchType)) {
			case TASKCOMMAND:
				menu_info.put("TaskList", DoCommandGetTaskList(searchKey, this_user_id ));
				page_name =  page_name + "tasklist-view";
				break;
			case TASKLIST:
				menu_info.put("TaskList", GetTaskList(searchKey, this_user_id ));
				page_name =  page_name + "tasklist-view";
				break;
			case ZIPCODE:
				menu_info.put("ziplist", GetZipList(searchKey ));
				page_name =  page_name + "dong-view";
				break;
			case BUYER:
				menu_info.put("buyerlist", GetBuyerList(searchKey ));
				page_name =  page_name + "buyer-view";
				break;
			case USER:
				menu_info.put("userlist", GetUserList(searchKey ));
				page_name =  page_name + "user-view";
				break;
			case PROJECT:
				menu_info.put("projectlist", GetProjectList(searchKey ));
				page_name =  page_name + "project-view";
				break;
			case PROJECT_DETAIL:
				menu_info.put("project_detail", commonInfo.getProjectDetailList(searchKey));
				page_name =  page_name + "project-detail-view";
				break;
			case ASSEMBLY:
				menu_info.put("partlist", GetAssemblyList(searchKey, this_user_id ));
				page_name =  page_name + "part-view";
				break;
			case PARTLINE:
			{
				Double[] sales_price = 	new Double[1];
				sales_price[0] = 0.0;
				plList = GetPartList(searchKey, this_user_id, sales_price );
				menu_info.put("assy_uid",  searchKey);
				menu_info.put("record_quan", plList.size());
				menu_info.put("assy_sales_price", sales_price[0]);
				menu_info.put("partlinelist", plList);
				page_name =  page_name + "partline-view";
				break;
			}
			case PARTLINE_ASSY:
			{
				Double[] sales_price = 	new Double[1];
				sales_price[0] = 0.0;
				plList = GetPartList(searchKey, this_user_id, sales_price );
				menu_info.put("assy_uid",  searchKey);
				menu_info.put("record_quan", plList.size());
				menu_info.put("partlinelist", plList);
				page_name =  page_name + "partline-view-assy";
				break;
			}
			case PR_PARTLINE:
				menu_info.put("partlinelist", GetPartListPR(searchKey ));
				page_name =  page_name + "partline-pr-view";
				break;
			case PO_PARTLINE:
				menu_info.put("partlinelist", GetPartListPO(searchKey ));
				menu_info.put("rtgast_uid", searchKey);
				page_name =  page_name + "partline-po-view";
				break;
			case PO_PARTLINE_ONLY:
				menu_info.put("partlinelist", GetPartListPO(searchKey ));
				menu_info.put("rtgast_uid", searchKey);
				page_name =  page_name + "partline-po-only";
				break;
			case GR_PARTLINE:
				menu_info.put("partlinelist", GetPartListGR(searchKey ));
				page_name =  page_name + "partline-pr-view";
				break;
			case PARTLINE_SIMPLE:
				menu_info.put("partlinelist", getPartListByParentOrderbyCreateDateDesc(searchKey, this_user_id ));
				page_name =  page_name + "partline-view-simple";
				break;
			case PARTLINE_MYNEED:
				menu_info.put("partlinelist", getPartListMyNeed( this_user_uid ));
				page_name =  page_name + "partline-view-myneed";
				break;
			case COMPANY_NAME:
				menu_info.put("companylist", GetCompanyList(searchKey ));
				page_name =  page_name + "company-view";
				break;
			case SITE_MANAGER_ID:
				menu_info.put("managerlist", GetUserList(searchKey ));
				page_name =  page_name + "manager-view";
				break;
			case COMPANY_DETAIL:
				menu_info.put("companydetaillist", GetCompanyById(searchKey));
				page_name =  page_name + "company-detail-view";
				break;
			case USER_DETAIL:
				menu_info.put("user_detail", GetUserByUniqueId(searchKey));
				page_name =  page_name + "user-detail-view";
				break;
			case BUSINESS_DETAIL:
				menu_info.put("businessdetaillist", GetBusinessById(searchKey));
				page_name =  page_name + "business-detail-view";
				break;
			case BUDGET_DEPT_NAME:
				menu_info.put("deptlist", GetBudgetDeptList(searchKey ));
				page_name =  page_name + "dept_name-view";
				break;
			case DEPT_NAME:
				menu_info.put("deptlist", GetDeptList(company_code, wa_code));
				page_name =  page_name + "dept_name-view";	
				break;
			case BIZ_GROUP:
				menu_info.put("bizgrouplist", GetComAstList(searchKey));
				page_name =  page_name + "bizgroup-view";
				break;
			case MULTI:
				menu_info.put("multilist", GetComAstList(searchKey));
				page_name =  page_name + "multi-view";
				break;
			case GROUPWARE:
				menu_info.put("groupwarelist", GetComAstList(searchKey));
				page_name =  page_name + "groupware-view";
				break;
			case SOURCING_GROUP:
				menu_info.put("sourcing_grouplist",  GetComAstList(searchKey));
				page_name =  page_name + "sourcing_group-view";
				break;
			case COMP_NAME:
				menu_info.put("comp_namelist", GetComp_nameList(searchKey ));
				page_name =  page_name + "comp-view";
				break;
			case WA_NAME:
				menu_info.put("wa_namelist", GetWa_nameList(searchKey ));
				page_name =  page_name + "wa-view";
				break;
			case COM_NAME:
				menu_info.put("companylist", GetCompanynameList(searchKey ));
				page_name =  page_name + "com-view";
				break;
			case WANAME:
				menu_info.put("wanamelist", GetWanameList(searchKey ));
				page_name =  page_name + "waname-view";
				break;
			case DIVISION_NAME:
				menu_info.put("divisionlist", GetDivision_nameList(company_code, wa_code ));
				page_name =  page_name + "division-view";
				break;
			case PART_DETAIL:
				//SrcAhd srcAhd = commonInfo.getDetail(searchKey, uid_combst);
				menu_info.put("partDetail",commonInfo.getDetail(searchKey, uid_combst));
				page_name =  page_name + "part-detail-view";
				break;
			case PART_DETAIL2:
				menu_info.put("partDetail",commonInfo.getDetail2(searchKey));
				page_name =  page_name + "part-detail-view2";
				break;
			case WA_NAME2:
				menu_info.put("wa_namelist", getWaList2(searchKey ));
				page_name =  page_name + "wa-view";
				break;
			case DEPT_NAME2:
				menu_info.put("deptlist", getDeptList2(searchKey));
				page_name =  page_name + "dept_name-view";
				break;
			case DIVISION_NAME2:
				menu_info.put("divisionlist", getDivisionList2(searchKey));
				page_name =  page_name + "division-view";
				break;				
			case SELLER:
				menu_info.put("sellerlist", getSeller(searchKey));
				page_name =  page_name + "seller-view";
				break;
			case SUPPLIER:
				menu_info.put("supplierlist", GetSupplierList(searchKey));
				page_name =  page_name + "supplier-view";
				break;
			case CART_DETAIL:
				menu_info.put("cartDetail",commonInfo.getPrDetail(searchKey));
				menu_info.put("pr_uid",searchKey);
				page_name =  page_name + "cart-detail-view";
				break;
            case PO_ERROR_DETAIL:
                menu_info.put("poErrDetail", commonInfo.getErrHwPoByUniqueId(searchKey));
                page_name =  page_name + "po-error-detail-view";
                break;  
            case GR_ERROR_DETAIL:
                menu_info.put("grErrDetail", commonInfo.getErrHwGrByUniqueId(searchKey));
                page_name =  page_name + "gr-error-detail-view";                
                break;
            case PART_REGIST:
            {
            	String assy_code = searchKey;
            	
            	if(assy_code.length() > 7) {
            		assy_code = assy_code.substring(0, 4) + "-" + assy_code.substring(4) + "-";
            	}
            	menu_info.put("assy_code",searchKey);
            	menu_info.put("assy_code_span",assy_code);
            	
            	page_name =  page_name + "part-regist-view";
            }
            	break;
            case PART_COPY://
            	break;
            case ASSY_REGIST:
            {
            	menu_info.put("pj_code",searchKey);
            	page_name =  page_name + "assy-regist-view";
            }
            	break;
            case RFQ_PARTLINE:
				menu_info.put("partlinelist", GetPartListRFQ(searchKey ));
				page_name =  page_name + "partline-rfq-view";
            	break;
            case ERQ_SUPLINE:
            	break;
		}
		
		menu_info.put("page_view", page_name /*+".jsp"*/);
	}
	
	
	public ModelAndView DoMenuTileProcess(HttpServletRequest request,
			HttpServletResponse response) throws Exception {
		  
		String searchKey = null;
		String searchType = null;
		String searchHandler = null;
//		String cartItemData = null;		//īƮ Ѿ ũ̵.
		String this_user_id= null;
		Integer this_user_uid=-1;
		String company_code=null;
		String wa_code=null;
		Integer uid_combst = null;

		try {
			searchKey = ServletRequestUtils.getStringParameter(request, "searchKey");
			searchType= ServletRequestUtils.getStringParameter(request, "searchType");
			searchHandler= ServletRequestUtils.getStringParameter(request, "searchHandler");
//			cartItemData = RequestUtils.getStringParameter(request, "cartItemData");	//īƮ Ѿ ũ̵.
			this_user_id = this.getThis_userid(request);
			this_user_uid = this.getThis_useruid(request);
			company_code = request.getParameter("company_code");
			wa_code		= request.getParameter("wa_code");
			uid_combst	= SessionSecurityManager.getThis_combst_uid(request);

		} catch (ServletRequestBindingException e) {
			e.printStackTrace();
		}
		
		if(searchType==null)
			return null;
		
		if(searchHandler==null)
			searchHandler = "null";
		
		if(searchKey==null)
			searchKey = "";
		
		logger.info(searchKey);
		logger.info(searchType);
		
		if(searchType.compareToIgnoreCase("*")== 0 ) {
			searchType = "";
		}

		Map<String, Object> menu_info = new HashMap<String, Object>();
		
		//Ʒ  Ѱ ? ǹ..
		menu_info.put("searchHandler",	searchHandler);
		
		// Էµ  JSP Ȱ  ֵ ϱ .
		Vector<Map<String, String>> key_list = new Vector<Map<String, String>>();
		Map<String, String> data = new HashMap<String, String>();
		data.put("searchKey", searchKey);
		key_list.add(data);
		menu_info.put("key_list",	key_list);
		
		String page_header = "dwr/";
		
		switch( getPageType(searchType)) {
		/*
			case CART_ADD:
				commonInfo.addCart(cartItemData, this_user_id, this_user_uid, uid_combst);
				menu_info.put("cartAdd",null);
				return new ModelAndView("index", menu_info);
		*/	
			case NONE:
				commonInfo.deleteUserAll( this_user_id);
				return null;
				
			case APPRV_ADD:
				commonInfo.addRtgApp(searchKey, this_user_id);
				return null;

			case APPRV_DEL:
				commonInfo.delRtgApp(searchKey, this_user_id);
				return null;
				
			case UPDATE_CHILD_QUAN:
				commonInfo.updateChildQuan(searchKey, this_user_id);
				return null;

			default:
				getOutputResult(uid_combst, page_header, searchType, searchKey, menu_info, this_user_id,
						company_code, wa_code, this_user_uid);
				break;
		}
		
		String page_vaiew = (String)menu_info.get("page_view");
		return new ModelAndView(page_vaiew, menu_info);
		//return new ModelAndView("dwr-view", menu_info);
	}
/*		
		if(searchType.compareToIgnoreCase("zipcode")== 0 ) {
			map_list = GetZipList(searchKey );
			menu_info.put("ziplist", map_list);
			return new ModelAndView("dong-view", menu_info);	
		}
		
		if(searchType.compareToIgnoreCase("buyer")== 0 ) {
			map_list = GetBuyerList(searchKey );
			menu_info.put("buyerlist", map_list);
			return new ModelAndView("buyer-view", menu_info);	
		}
		if(searchType.compareToIgnoreCase("user")== 0 ) {
			map_list = GetUserList(searchKey );
			menu_info.put("userlist", map_list);
			return new ModelAndView("user-view", menu_info);	
		}

		if(searchType.compareToIgnoreCase("project")== 0 ) {
			map_list = GetProjectList(searchKey );
			menu_info.put("projectlist", map_list);
			return new ModelAndView("project-view", menu_info);	
		}
		if(searchType.compareToIgnoreCase("project-detail")== 0 ) {
			Project project = commonInfo.getProjectByUniqueId(searchKey );
			ArrayList lists = new ArrayList();
			lists.add(project);
			menu_info.put("project_detail", lists);
			return new ModelAndView("project-detail-view", menu_info);	
		}
		if(searchType.compareToIgnoreCase("assembly")== 0 ) {
			map_list = GetAssemblyList(searchKey, request );
			menu_info.put("partlist", map_list);
			return new ModelAndView("part-view", menu_info);	
		}
		if(searchType.compareToIgnoreCase("partline")== 0 ) {
			menu_info.put("partlinelist", GetPartList(searchKey, request ));
			return new ModelAndView("partline-view", menu_info);	
		}
		if(searchType.compareToIgnoreCase("pr-partline")== 0 ) {
			menu_info.put("partlinelist", GetPartListPR(searchKey ));
			return new ModelAndView("partline-pr-view", menu_info);	
		}
		if(searchType.compareToIgnoreCase("po-partline")== 0 ) {
			menu_info.put("partlinelist", GetPartListPO(searchKey ));
			menu_info.put("rtgast_uid", searchKey);
			return new ModelAndView("partline-po-view", menu_info);	
		}
		if(searchType.compareToIgnoreCase("gr-partline")== 0 ) {
			menu_info.put("partlinelist", GetPartListGR(searchKey ));
			return new ModelAndView("partline-pr-view", menu_info);	
		}
		if(searchType.compareToIgnoreCase("partline-simple")== 0 ) {
			menu_info.put("partlinelist", GetPartList(searchKey, request ));
			return new ModelAndView("partline-view-simple", menu_info);	
		}

		if(searchType.compareToIgnoreCase("company_name")== 0 ) {
			map_list = GetCompanyList(searchKey );
			menu_info.put("companylist", map_list);
			return new ModelAndView("company-view", menu_info);	
		}

		if(searchType.compareToIgnoreCase("site_manager_id")== 0 ) {
			map_list = GetUserList(searchKey );
			menu_info.put("managerlist", map_list);
			return new ModelAndView("manager-view", menu_info);	
		}
		
		//̾ƶ ȸ 󼼺
		if(searchType.compareToIgnoreCase("company-detail")== 0 ) {
			map_list = GetCompanyById(searchKey);
			menu_info.put("companydetaillist", map_list);
			return new ModelAndView("company-detail-view", menu_info);	
		}
		if(searchType.compareToIgnoreCase("user-detail")== 0 ) {
			map_list = GetUserByUniqueId(searchKey);
			menu_info.put("user_detail", map_list);
			return new ModelAndView("user-detail-view", menu_info);		
		}
		
//		 2006.03.27  
		if(searchType.compareToIgnoreCase("business-detail")== 0 ) {
			map_list = GetBusinessById(searchKey);
			menu_info.put("businessdetaillist", map_list);
			return new ModelAndView("business-detail-view", menu_info);	
		}
		// 2006.05.01 ⺻ μ HwanKyu.Kang
		if(searchType.compareToIgnoreCase("budget_dept_name")== 0 ) {
			map_list = GetBudgetDeptList(searchKey );
			menu_info.put("deptlist", map_list);
			return new ModelAndView("dept_name-view", menu_info);	
		}
		
		//̾ƶ  ȸ : μ˻
		if(searchType.compareToIgnoreCase("dept_name")== 0 ) {
			map_list = GetDeptList(request);
			menu_info.put("deptlist", map_list);
			return new ModelAndView("dept_name-view", menu_info);	
		}
		//̾ƶ
		//ȸԷ
		if(searchType.compareToIgnoreCase("biz_group")== 0 ) {
			map_list = GetComAstList(searchKey);
			menu_info.put("bizgrouplist", map_list);
			return new ModelAndView("bizgroup-view", menu_info);	
		}
		//ȸԷ
		if(searchType.compareToIgnoreCase("multi")== 0 ) {
			map_list = GetComAstList(searchKey);
			menu_info.put("multilist", map_list);
			return new ModelAndView("multi-view", menu_info);	
		}
		//ȸԷ
		if(searchType.compareToIgnoreCase("groupware")== 0 ) {
			map_list = GetComAstList(searchKey);
			menu_info.put("groupwarelist", map_list);
			return new ModelAndView("groupware-view", menu_info);	
		}
		//ȸԷ
		if(searchType.compareToIgnoreCase("sourcing_group")== 0 ) {
			map_list = GetComAstList(searchKey);
			menu_info.put("sourcing_grouplist", map_list);
			return new ModelAndView("sourcing_group-view", menu_info);	
		}
		//Է(ȸ˻)
		if(searchType.compareToIgnoreCase("comp_name")== 0 ) {
			map_list = GetComp_nameList(searchKey );
			menu_info.put("comp_namelist", map_list);
			return new ModelAndView("comp-view", menu_info);	
		}
		//Է(˻)
		if(searchType.compareToIgnoreCase("wa_name")== 0 ) {
			map_list = GetWa_nameList(searchKey );
			
			menu_info.put("wa_namelist", map_list);
			return new ModelAndView("wa-view", menu_info);	
		}
		//μԷ(ȸ˻)
		if(searchType.compareToIgnoreCase("com_name")== 0 ) {
			map_list = GetCompanynameList(searchKey );
			menu_info.put("companylist", map_list);
			return new ModelAndView("com-view", menu_info);	
		}
		//μԷ(˻)
		if(searchType.compareToIgnoreCase("waname")== 0 ) {
			map_list = GetWanameList(searchKey );
			menu_info.put("wanamelist", map_list);
			return new ModelAndView("waname-view", menu_info);	
		}
		//μԷ(ΰ˻)
		if(searchType.compareToIgnoreCase("division_name")== 0 ) {
			map_list = GetDivision_nameList(request );
			menu_info.put("divisionlist", map_list);
			return new ModelAndView("division-view", menu_info);	
		}
		
		
	    // 2006.3.13  [˻/κ 󼼺 .]
		if(searchType.compareToIgnoreCase("part-detail")== 0)
		{
			logger.info("part-detail-view ---> move");
			SrcAhd srcAhd = commonInfo.getById(searchKey);
			menu_info.put("partDetail",srcAhd);
			
			return new ModelAndView("part-detail-view",menu_info);
			
		}
		
		
		//˻
		if(searchType.compareToIgnoreCase("wa_name2")== 0 ) {
			map_list = getWaList2(searchKey );
			
			menu_info.put("wa_namelist", map_list);
			return new ModelAndView("wa-view", menu_info);	
		}

		//μ˻
		if(searchType.compareToIgnoreCase("dept_name2")== 0 ) {
			map_list = getDeptList2(searchKey);

			menu_info.put("deptlist", map_list);
			return new ModelAndView("dept_name-view", menu_info);	
		}
		
		//޻˻
		if(searchType.compareToIgnoreCase("seller")== 0 ) {
			map_list = getSeller(searchKey);

			menu_info.put("sellerlist", map_list);
			return new ModelAndView("seller-view", menu_info);	
		}		
		
		//޼
		if(searchType.compareToIgnoreCase("supplier")== 0 ) {
			map_list = GetSupplierList(searchKey);
			menu_info.put("supplierlist", map_list);
			return new ModelAndView("supplier-view", menu_info);	
		}
		
        // 2006.3.17  [īƮ.]
		if(searchType.compareToIgnoreCase("cart-add")== 0)
		{
			logger.info("cart-add ---> move");
			commonInfo.addCart(cartItemData, this.getThis_userid(request), this.getThis_useruid(request));
			menu_info.put("cartAdd",null);
			return new ModelAndView("index",menu_info);
			
		}	
		
	    // 2006.3.17  [īƮ.]
		if(searchType.compareToIgnoreCase("cart-detail")== 0)
		{
			logger.info("cart-detail ---> move");

			menu_info.put("cartDetail",commonInfo.getPrDetail(searchKey));
			menu_info.put("pr_uid",searchKey);
			logger.info(searchKey);
			return new ModelAndView("cart-detail-view",menu_info);
			
		}	
		
        // 2006.3.21 app λ
		if(searchType.compareToIgnoreCase("none")== 0)
		{
			//ü Կ Ѿö : none
			commonInfo.deleteUserAll( this.getThis_userid(request));
			return null;
		}		
		
        // 2006.3.21 ȣ [缱 ()]
		if(searchType.compareToIgnoreCase("apprv-add")== 0)
		{
			logger.info("apprv-add");	
			commonInfo.addRtgApp(searchKey, this.getThis_userid(request));
			return null;
		}
		
	    // 2006.3.21 ȣ [缱 ()]
		if(searchType.compareToIgnoreCase("apprv-del")== 0)
		{
			logger.info("apprv-del");
			commonInfo.delRtgApp(searchKey, this.getThis_userid(request));
			return null;
			
		}
		*/
	
	private Vector GetZipList(String searchKey ) {
		
		List zips = commonInfo.GetZipByDong(searchKey);
		Vector<Map<String, String>> map_list = new Vector<Map<String, String>>();
		if( zips.size() > 0) {
			for(Iterator i=zips.iterator(); i.hasNext();) {
				Map<String, String> map = new HashMap<String, String>();
				ZipCode zip = (ZipCode)i.next();
				String address = zip.getSido() + " " +
									zip.getGubun()+ " " +
									zip.getDong()+ " " +
									((zip.getBunji() != null)? zip.getBunji() : "");
				map.put("code", zip.getZipcode());
				map.put("address", address);
				
				logger.info(address);
				map_list.add(map);
			}
		}
		else {
			Map<String, String> map = new HashMap<String, String>();
			map.put("code", "000-000");
			map.put("address", "  Է  ˻(:ﵿ)");
			
			map_list.add(map);
		}
		
		return map_list;
	}
	
	private Vector GetUserList(String searchKey ) {
		
		logger.info(" DwrPageController.GetUserList");
		
		List users = commonInfo.getUserList(searchKey);
		Vector<Map<String, Comparable>> map_list = new Vector<Map<String, Comparable>>();
		
		if( users.size() > 0) {
			for(Iterator i=users.iterator(); i.hasNext();) {
				Map<String, Comparable> map = new HashMap<String, Comparable>();
				UsrAst user = (UsrAst)i.next();

				map.put("user_id", user.getUser_id() );
				map.put("user_name", user.getUser_name() );
				map.put("unique_id", user.getUnique_id() );
				map.put("company_code", user.getCompany_code());
				map.put("position", user.getPosition());
				map.put("tel_no", user.getTel_no());
				map.put("hp_no", user.getHp_no());
				map.put("email", user.getEmail());
				map.put("address_1", user.getAddress_1());
				map.put("address_2", user.getAddress_2());
				map.put("company_name", user.getCompany_name());
				map.put("dept_name", user.getDept_name());
				logger.info(user.getUser_name());
				
				map_list.add(map);
			}
		}
		else {
			Map<String, Comparable> map = new HashMap<String, Comparable>();
			map.put("code", "????");
			map.put("address", "˻ ϴ.");
			
			map_list.add(map);
		}
		
		return map_list;
	}
	
//	̾ƶ     ȸ󼼺
	private Vector GetCompanyById(String searchKey) {
		logger.info(" DwrPageController.GetDeptList");
		Map<String, Comparable> map = new HashMap<String, Comparable>();	
		Vector<Map<String, Comparable>> map_list = new Vector<Map<String, Comparable>>();
		ComAst comast = commonInfo.getCompanyById(searchKey);
		logger.debug("̵"+comast.getUnique_id()+"    "+comast.getCompany_group_name());
		map.put("unique_id",comast.getUnique_id());
		map.put("company_code", comast.getCompany_code());
		map.put("company_name", comast.getCompany_name());
		map.put("multi_price_group", comast.getMulti_price_group());
		map.put("groupware_type", comast.getGroupware_type());
		map.put("sourcing_group", comast.getSourcing_group());
		map.put("agreement_type", comast.getAgreement_type());
		map.put("employee", comast.getEmployee_str());
		map.put("sales_amount", comast.getSales_amount_str());
		map.put("mro_amount", comast.getMro_amount_str());
		map.put("deal_amount", comast.getDeal_amount_str());
		map.put("deal_date", comast.getDeal_date_str());
		map.put("remark", comast.getRemark());
		
		
		map_list.add(map);
		logger.debug(""+map_list.size());
		return map_list;
		
	}
	
	private Vector GetUserByUniqueId(String searchKey) {
		logger.info(" DwrPageController.GetUserByUniqueId");
		Map<String, Comparable> map = new HashMap<String, Comparable>();	
		Vector<Map<String, Comparable>> map_list = new Vector<Map<String, Comparable>>();
		UsrAst usrast = commonInfo.getUserByUniqueId(searchKey);
		logger.debug("̵"+usrast.getUnique_id()+"    "+usrast.getCompany_code());
		
		map.put("unique_id",usrast.getUnique_id());
		map.put("company_code", usrast.getCompany_code());
		map.put("company_name", usrast.getCompany_name());
		map.put("wa_code", usrast.getWa_code());
		map.put("wa_name", usrast.getWa_name());
		map.put("dept_code", usrast.getDept_code());
		map.put("dept_name", usrast.getDept_name());
		map.put("user_id", usrast.getUser_id());
		map.put("emp_no", usrast.getEmp_no());
		map.put("user_name", usrast.getUser_name());
		map.put("position", usrast.getPosition());
		map.put("tel_no", usrast.getTel_no());
		map.put("fax_no", usrast.getFax_no());
		map.put("email", usrast.getEmail());
		map.put("hp_no", usrast.getHp_no());
		map.put("budget_flag", usrast.getBudget_flag());
		map.put("approval_flag", usrast.getApproval_flag());
		map.put("approver_flag", usrast.getApprover_flag());
		map.put("gr_approval_flag", usrast.getGr_approval_flag());
		
		map_list.add(map);
		logger.debug(""+map_list.size());
		return map_list;
		
	}

	//2006.03.27 ȯ  
	private Vector GetBusinessById(String searchKey) {
		logger.info(" DwrPageController.GetBusinessById");
		Map<String, Comparable> map = new HashMap<String, Comparable>();	
		Vector<Map<String, Comparable>> map_list = new Vector<Map<String, Comparable>>();
		ComBst combst = commonInfo.getBusnessById(searchKey);
		map.put("unique_id",combst.getUnique_id());
		map.put("company_name",combst.getCompany_name());
		map.put("wa_code",combst.getWa_code());
		map.put("wa_name",combst.getWa_name());
		map.put("president_name",combst.getPresident_name());
		map.put("biz_no",combst.getBiz_no());
		map.put("biz_condition",combst.getBiz_condition());
		map.put("biz_category",combst.getBiz_category());
		map.put("budget_active_flag",combst.getBudget_active_flag());
		map.put("account_need_flag",combst.getAccount_need_flag());
		map.put("add_budget_flag",combst.getAdd_budget_flag());
		map.put("account_assign_type",combst.getAccount_assign_type());
		map.put("abudget_av_flag",combst.getAbudget_av_flag());
		map.put("site_manager_name",combst.getSite_manager_name());
		map.put("site_manager_email",combst.getSite_manager_email());
		map.put("site_manager_tel_no",combst.getSite_manager_tel_no());
		map.put("site_manager_mobile_no",combst.getSite_manager_mobile_no());
		
		map_list.add(map);
		return map_list;
		
	}
		
	private Vector getDivisionList2(String searchKey) {
		logger.info(" DwrPageController.GetDeptList");

		List divisiongroup = commonInfo.division_list(searchKey);
		Vector<Map<String, Comparable>> map_list = new Vector<Map<String, Comparable>>();
		
		if( divisiongroup.size() > 0) {
			for(Iterator i=divisiongroup.iterator(); i.hasNext();) {
				Map<String, Comparable> map = new HashMap<String, Comparable>();
				ComCst comcst = (ComCst)i.next();

				map.put("division_code1", comcst.getDivision_code());
				map.put("division_name", comcst.getDivision_name());
				map.put("unique_id", comcst.getUnique_id());
				
				map_list.add(map);
			}
		}
		else {
			Map<String, Comparable> map = new HashMap<String, Comparable>();
			map.put("code", "????");
			map.put("address", "˻ ϴ.");
			
			map_list.add(map);
		}
		
		return map_list;
		
	}
	
	
	private Vector getDeptList2(String searchKey) {
		logger.info(" DwrPageController.GetDeptList");

		List deptgroup = commonInfo.dept_list(searchKey);
		Vector<Map<String, Comparable>> map_list = new Vector<Map<String, Comparable>>();
		
		if( deptgroup.size() > 0) {
			for(Iterator i=deptgroup.iterator(); i.hasNext();) {
				Map<String, Comparable> map = new HashMap<String, Comparable>();
				ComDst comDst = (ComDst)i.next();

				map.put("dept_code", comDst.getDept_code());
				map.put("dept_name", comDst.getDept_name());
				map.put("unique_id", comDst.getUnique_id());
				
				
				logger.info("׽Ʈ׽Ʈ"+comDst.getDept_name());
				
				map_list.add(map);
			}
		}
		else {
			Map<String, Comparable> map = new HashMap<String, Comparable>();
			map.put("code", "????");
			map.put("address", "˻ ϴ.");
			
			map_list.add(map);
		}
		
		return map_list;
		
	}
	
	private Vector getWaList2(String searchKey ) {
		
		List wa = commonInfo.wa_list(searchKey);
		Vector<Map<String, Comparable>> map_list = new Vector<Map<String, Comparable>>();
		
		if( wa.size() > 0) {
			for(Iterator i=wa.iterator(); i.hasNext();) {
				Map<String, Comparable> map = new HashMap<String, Comparable>();
				ComBst combst = (ComBst)i.next();
				
				map.put("wa_name",combst.getWa_name());
				map.put("wa_code",combst.getWa_code());
				map.put("unique_id",combst.getUnique_id());
				logger.debug(":::::::::::"+combst.getWa_code());

				
				map_list.add(map);
			}
		}
		else {
			Map<String, Comparable> map = new HashMap<String, Comparable>();
			map.put("code", "????");
			map.put("address", "˻ ϴ.");
			
			map_list.add(map);
		}
		
		return map_list;
	}
	
	private Vector getSeller(String searchKey ) {
		
		List wa = commonInfo.seller_list(searchKey);
		Vector<Map<String, Comparable>> map_list = new Vector<Map<String, Comparable>>();
		
		if( wa.size() > 0) {
			for(Iterator i=wa.iterator(); i.hasNext();) {
				Map<String, Comparable> map = new HashMap<String, Comparable>();
				SrcAhd srcahd = (SrcAhd)i.next();
				
				map.put("seller_name",srcahd.getSeller_name());
				map.put("seller_code",srcahd.getSeller_code());
				map.put("unique_id",srcahd.getUnique_id());

				map_list.add(map);
			}
		}
		else {
			Map<String, Comparable> map = new HashMap<String, Comparable>();
			map.put("code", "????");
			map.put("address", "˻ ϴ.");
			
			map_list.add(map);
		}
		
		return map_list;
	}
	
	
	private Vector GetBudgetDeptList(String searchKey) {
		logger.info(" DwrPageController.GetBudgetDeptList");

		List deptgroup = commonInfo.getBudgetDeptList(searchKey);
		Vector<Map<String, Comparable>> map_list = new Vector<Map<String, Comparable>>();
		
		if( deptgroup.size() > 0) {
			for(Iterator i=deptgroup.iterator(); i.hasNext();) {
				Map<String, Comparable> map = new HashMap<String, Comparable>();
				ComDst comDst = (ComDst)i.next();

				map.put("dept_code", comDst.getDept_code());
				map.put("dept_name", comDst.getDept_name());
				map.put("unique_id", comDst.getUnique_id());
				
				
				logger.info("׽Ʈ׽Ʈ"+comDst.getDept_name());
				
				map_list.add(map);
			}
		}
		else {
			Map<String, Comparable> map = new HashMap<String, Comparable>();
			map.put("code", "????");
			map.put("address", "˻ ϴ.");
			
			map_list.add(map);
		}
		
		return map_list;
		
	}
	
	
	//̾ƶ     ȸ :μ˻
	private Vector GetDeptList(String company_code, String wa_code) {
		logger.info(" DwrPageController.GetDeptList");
		
		List deptgroup = commonInfo.getDeptList(company_code, wa_code);
		Vector<Map<String, Comparable>> map_list = new Vector<Map<String, Comparable>>();
		
		if( deptgroup.size() > 0) {
			for(Iterator i=deptgroup.iterator(); i.hasNext();) {
				Map<String, Comparable> map = new HashMap<String, Comparable>();
				ComDst comDst = (ComDst)i.next();

				map.put("dept_code", comDst.getDept_code());
				map.put("dept_name", comDst.getDept_name());
				map.put("unique_id", comDst.getUnique_id());
				
				
				logger.info("׽Ʈ׽Ʈ"+comDst.getDept_name());
				
				map_list.add(map);
			}
		}
		else {
			Map<String, Comparable> map = new HashMap<String, Comparable>();
			map.put("code", "????");
			map.put("address", "˻ ϴ.");
			
			map_list.add(map);
		}
		
		return map_list;
		
	}
	
	private Vector GetComAstList(String searchKey ) {
		
		List com = commonInfo.getComastList(searchKey);
		Vector<Map<String, Comparable>> map_list = new Vector<Map<String, Comparable>>();
		
		if( com .size() > 0) {
			for(Iterator i=com .iterator(); i.hasNext();) {
				Map<String, Comparable> map = new HashMap<String, Comparable>();
				ComAst comAst = (ComAst)i.next();
				
				map.put("biz_group_name", comAst.getBiz_group_name());
				map.put("unique_id", comAst.getUnique_id());
				map.put("multi_price_group", comAst.getMulti_price_group());
				map.put("groupware_type", comAst.getGroupware_type());
				map.put("sourcing_group", comAst.getSourcing_group());
				
				logger.debug(":::::::::::"+comAst.getBiz_group_name());
				logger.debug(":::::::::::"+comAst.getUnique_id());
				logger.debug(":::::::::::"+comAst.getMulti_price_group());
				logger.debug(":::::::::::"+comAst.getGroupware_type());
				logger.debug(":::::::::::"+comAst.getSourcing_group());

				
				map_list.add(map);
			}
		}
		else {
			Map<String, Comparable> map = new HashMap<String, Comparable>();
			map.put("code", "????");
			map.put("address", "˻ ϴ.");
			
			map_list.add(map);
		}
		
		return map_list;
	}
	
	
	//ε(ȸ˻)
	private Vector GetComp_nameList(String searchKey ) {
		
		logger.info(" DwrPageController.GetComp_nameList");
		
		List company = commonInfo.getComp_nameList(searchKey);
		Vector<Map<String, Comparable>> map_list = new Vector<Map<String, Comparable>>();
		
		if( company.size() > 0) {
			for(Iterator i=company.iterator(); i.hasNext();) {
				Map<String, Comparable> map = new HashMap<String, Comparable>();
				ComBst combst = (ComBst)i.next();
				
				map.put("company_name",combst.getCompany_name());
				map.put("company_code1",combst.getCompany_code());
				map.put("unique_id",combst.getUnique_id());
				logger.debug(":::::::::::"+combst.getCompany_code());
				
				map_list.add(map);
			}
		}
		else {
			Map<String, Comparable> map = new HashMap<String, Comparable>();
			map.put("code", "????");
			map.put("address", "˻ ϴ.");
			
			map_list.add(map);
		}
		
		return map_list;
	}
	
	//ε(˻)
	private Vector GetWa_nameList(String searchKey ) {
		
		List wa = commonInfo.getWa_nameList(searchKey);
		Vector<Map<String, Comparable>> map_list = new Vector<Map<String, Comparable>>();
		
		if( wa.size() > 0) {
			for(Iterator i=wa.iterator(); i.hasNext();) {
				Map<String, Comparable> map = new HashMap<String, Comparable>();
				ComBst combst = (ComBst)i.next();
				
				map.put("wa_name",combst.getWa_name());
				map.put("wa_code",combst.getWa_code());
				map.put("unique_id",combst.getUnique_id());
				logger.debug(":::::::::::"+combst.getWa_code());

				
				map_list.add(map);
			}
		}
		else {
			Map<String, Comparable> map = new HashMap<String, Comparable>();
			map.put("code", "????");
			map.put("address", "˻ ϴ.");
			
			map_list.add(map);
		}
		
		return map_list;
	}
	
	//μ(ȸ˻)
	private Vector GetCompanynameList(String searchKey ) {
		
		List com = commonInfo.getCompanynameList(searchKey);
		Vector<Map<String, Comparable>> map_list = new Vector<Map<String, Comparable>>();
		
		if( com.size() > 0) {
			for(Iterator i=com.iterator(); i.hasNext();) {
				Map<String, Comparable> map = new HashMap<String, Comparable>();
				ComCst comcst = (ComCst)i.next();
				
				map.put("company_name",comcst.getCompany_name());
				map.put("company_code1",comcst.getCompany_code());
				map.put("unique_id",comcst.getUnique_id());
				logger.debug(":::::::::::"+comcst.getCompany_code());

				map_list.add(map);
			}
		}
		else {
			Map<String, Comparable> map = new HashMap<String, Comparable>();
			map.put("code", "????");
			map.put("address", "˻ ϴ.");
			
			map_list.add(map);
		}
		
		return map_list;
	}
	
	//μ(˻)
	private Vector GetWanameList(String searchKey ) {
		
		List wa = commonInfo.getWanameList(searchKey);
		Vector<Map<String, Comparable>> map_list = new Vector<Map<String, Comparable>>();
		
		if( wa.size() > 0) {
			for(Iterator i=wa.iterator(); i.hasNext();) {
				Map<String, Comparable> map = new HashMap<String, Comparable>();
				ComCst comcst = (ComCst)i.next();
				
				map.put("wa_name",comcst.getWa_name());
				map.put("wa_code1",comcst.getWa_code());
				map.put("unique_id",comcst.getUnique_id());
				logger.debug(":::::::::::"+comcst.getWa_code());
			map_list.add(map);
			}
		}
				
		return map_list;
	}
	
	//μ(ΰ˻)
	private Vector GetDivision_nameList(String company_code, String wa_code ) {

		List division = commonInfo.getDivision_nameList(company_code, wa_code);
		Vector<Map<String, Comparable>> map_list = new Vector<Map<String, Comparable>>();
		
		if( division .size() > 0) {
			for(Iterator i=division .iterator(); i.hasNext();) {
				Map<String, Comparable> map = new HashMap<String, Comparable>();
				ComCst comcst = (ComCst)i.next();
				
				map.put("division_name",comcst.getDivision_name());
				map.put("division_code1",comcst.getDivision_code());
				map.put("unique_id",comcst.getUnique_id());
				logger.debug(":::::::::::"+comcst.getDivision_code());

				map_list.add(map);
			}
		}
		else {
			Map<String, Comparable> map = new HashMap<String, Comparable>();
			map.put("code", "????");
			map.put("address", "˻ ϴ.");
			
			map_list.add(map);
		}
		
		return map_list;
	}
	
	private Vector GetBuyerList(String searchKey ) {
		
		logger.info(" DwrPageController.GetBuyerList");
		
		List buyers = commonInfo.getBuyerList(searchKey);
		Vector<Map<String, Comparable>> map_list = new Vector<Map<String, Comparable>>();
		
		if( buyers.size() > 0) {
			for(Iterator i=buyers.iterator(); i.hasNext();) {
				Map<String, Comparable> map = new HashMap<String, Comparable>();
				ComBst combst = (ComBst)i.next();

				map.put("wa_code", combst.getWa_code());
				map.put("wa_name", combst.getWa_name());
				map.put("unique_id", combst.getUnique_id());
				
				
				logger.info(combst.getWa_name());
				
				map_list.add(map);
			}
		}
		else {
			Map<String, Comparable> map = new HashMap<String, Comparable>();
			map.put("code", "????");
			map.put("address", "˻ ϴ.");
			
			map_list.add(map);
		}
		
		return map_list;
	}
	
private Vector GetCompanyList(String searchKey ) {
		
		logger.info(" DwrPageController.GetCompanyList");

		List companys = commonInfo.getCompanyList(searchKey);
		Vector<Map<String, Comparable>> map_list = new Vector<Map<String, Comparable>>();
		
		if( companys.size() > 0) {
			for(Iterator i=companys.iterator(); i.hasNext();) {
				Map<String, Comparable> map = new HashMap<String, Comparable>();
				ComAst comast = (ComAst)i.next();
				
				map.put("company_name",comast.getCompany_name());
				map.put("company_code",comast.getCompany_code());
				logger.debug(":::::::::::"+comast.getCompany_name());
				//map.put("wa_code", combst.getWa_code());
				//map.put("wa_name", combst.getWa_name());
				//map.put("unique_id", combst.getUnique_id());
				
				
				//logger.info(combst.getWa_name());
				
				map_list.add(map);
			}
		}
		else {
			Map<String, Comparable> map = new HashMap<String, Comparable>();
			map.put("code", "????");
			map.put("address", "˻ ϴ.");
			
			map_list.add(map);
		}
		
		return map_list;
	}

	
	private Vector GetProjectList(String searchKey ) {
		
		logger.info(" DwrPageController.GetProjectList");
		
		List projects = commonInfo.getProjectList(searchKey);
		Vector<Map<String, Comparable>> map_list = new Vector<Map<String, Comparable>>();
		
		if( projects.size() > 0) {
			for(Iterator i=projects.iterator(); i.hasNext();) {
				Map<String, Comparable> map = new HashMap<String, Comparable>();
				Project project = (Project)i.next();

				map.put("pj_code", project.getPj_code());
				map.put("pj_name", project.getPj_name());
				map.put("unique_id", project.getUnique_id());
				
				
				logger.info(project.getWa_name());
				
				map_list.add(map);
			}
			return map_list;
		}
//		else {
//			Map map = new HashMap();
//			map.put("pj_code", "????");
//			map.put("pj_name", "˻ ϴ.");
//			
//			map_list.add(map);
//		}
		
		return null;
		
		
	}
	
	
	private List GetPartList(String searchKey, String this_user_id, Double[] sales_price) {
	
		return commonInfo.getPartListByAssy(this_user_id,searchKey,sales_price);

	}
	
	private List getPartListByParentOrderbyCreateDateDesc(String searchKey, String this_user_id) {
		
		return commonInfo.getPartListByParentOrderbyCreateDateDesc(this_user_id,searchKey);

	}
	private List getPartListMyNeed(Integer this_user_uid) {
		
		return commonInfo.getPartListMyNeed(this_user_uid);

	}
	
	
	
	@SuppressWarnings("unused")
	private List GetPartListReverse(String searchKey, String this_user_id) {
		Double[] sales_price = 	new Double[1];
		sales_price[0] = 0.0;
		List partList = commonInfo.getPartListByAssy(this_user_id,searchKey,sales_price);
		ListIterator iterator = partList.listIterator(partList.size());
		
		//ȯ
		List<PartLine> revPartList = new Vector<PartLine>(partList.size());
		while( iterator.hasPrevious())
			revPartList.add((PartLine) iterator.previous());
		
		return revPartList;

	}
	
	
	
	private List GetPartListPR(String searchKey) {
		return commonInfo.getPrDetail(searchKey);
	}
	private List GetPartListPO(String searchKey) {
		return commonInfo.getPoDetail(searchKey);
	}
	private List GetPartListGR(String searchKey) {
		return commonInfo.getGrDetail(searchKey);
	}
	private List GetPartListRFQ(String searchKey) {
		return commonInfo.getRfqDetail(searchKey);
	}	
	
	
	private Vector GetSupplierList(String searchKey ) {
		
		List suppliers = commonInfo.getSupplierList(searchKey);
		Vector<Map<String, Comparable>> map_list = new Vector<Map<String, Comparable>>();
		
		if( suppliers!=null && suppliers.size() > 0) {
			for(Iterator i=suppliers.iterator(); i.hasNext();) {
				Map<String, Comparable> map = new HashMap<String, Comparable>();
				SupAst supast = (SupAst)i.next();

				map.put("supplier_uid", supast.getUnique_id());
				map.put("supplier_code", supast.getSupplier_code());
				map.put("supplier_name", supast.getSupplier_name());
				map.put("address", supast.getAddress_1());
				map.put("president_name", supast.getPresident_name());
				
				map.put("sales_person1_name", supast.getSales_person1_name());
				map.put("sales_person1_telephone_no", supast.getSales_person1_telephone_no());
				map.put("sales_person1_mobilephone_no", supast.getSales_person1_mobilephone_no());
				map.put("sales_person1_fax_no", supast.getSales_person1_fax_no() );
				map.put("sales_person1_email_address", supast.getSales_person1_email_address() );
				
				map_list.add(map);
			}
		}
		else {
			Map<String, Comparable> map = new HashMap<String, Comparable>();
			map.put("supplier_code", "????");
			map.put("supplier_name", "˻ ϴ.");
			
			map_list.add(map);
		}
		
		return map_list;
	}
	

	private boolean ChangePositionDown(Vector<Integer> from, Vector<Integer> to, Integer task_uid) {

		int vec_len = from.size();
		to.ensureCapacity (vec_len);
		
		int pos = from.indexOf(task_uid);
		if(pos<0)
			return false;
		
		Integer target = (Integer) from.remove(pos);
		
		if(pos==vec_len-1) {//ϵڿ ִ 
			to.add(target);
			to.addAll(1, from);
			
		}
		else {
			to.addAll(from);
			to.add(pos+1, target);
		}

		return true;
	}
	
	private boolean ChangePositionUp(Vector<Integer> from, Vector<Integer> to, Integer task_uid) {

		int vec_len = from.size();
		to.ensureCapacity (vec_len);
		
		int pos = from.indexOf(task_uid);
		if(pos<0)
			return false;
		
		Integer target = (Integer) from.remove(pos);
		
		if(pos==0) {//Ͼտ ִ 
			to.addAll(from);
			to.add(target);
		}
		else {
			to.addAll(from);
			to.add(pos-1, target);
		}

		return true;
	}

	

	private List DoCommandGetTaskList(String searchKey, String this_user_id ) {
		logger.info(" DwrPageController.DoCommandGetTaskList: " +searchKey);
		
		//	cmd_type:pj_uid:task_uid:unique_id1:unique_id2:....

		String []searchKeyWords = searchKey.split(":");
		
		int cmd_len = searchKeyWords.length;
		if( cmd_len < 4) {
			return null;
		}

		int i=0;
		String cmd_type		= searchKeyWords[i];i++;
		String pj_uid		= searchKeyWords[i];i++;
		Integer task_uid	= Integer.valueOf(searchKeyWords[i] );i++;
		
		Vector<Integer> vecUid = new Vector<Integer>();
		for( ; i < cmd_len; i++) {
			vecUid.add(Integer.valueOf(searchKeyWords[i]));
		}
		
		
		switch(CmdType.valueOf(StripDash(cmd_type)) ) {
		case 	UP:
		{
			Vector<Integer> new_vec = new Vector<Integer>();
			ChangePositionUp(vecUid, new_vec, task_uid);
			commonInfo.ChangeTaskListPosition(new_vec);
		}
		break;
		case	DOWN:
		{
			Vector<Integer> new_vec = new Vector<Integer>();
			ChangePositionDown(vecUid, new_vec, task_uid);
			commonInfo.ChangeTaskListPosition(new_vec);
		}
		break;
		case	ADD:
			Random ran = new Random();
			int iRand = ran.nextInt();
			
			if(iRand < 0) {
				iRand = (-1)* iRand;
			}
			commonInfo.addTask(this_user_id, iRand, task_uid);
			
			Vector<Integer> new_vec = new Vector<Integer>();
			int pos = vecUid.indexOf(task_uid);
			new_vec.addAll(vecUid);
			new_vec.add(pos+1, iRand);
			commonInfo.ChangeTaskListPosition(new_vec);
			break;
		case	DELETE:
			commonInfo.deleteTask(task_uid);
			break;
		default:
				break;
		}
		
		return commonInfo.getTaskListByUid(this_user_id, pj_uid);

		
		
	}
	
	private List GetTaskList(String searchKey, String this_user_id ) {
		
		logger.info(" DwrPageController.GetTaskList: " +searchKey);
		
		return commonInfo.getTaskListByUid(this_user_id, searchKey);

	}

	
	private Vector GetAssemblyList(String searchKey, String this_user_id ) {
		
		logger.info(" DwrPageController.GetAssemblyList: " +searchKey);
		
//		List assys = commonInfo.getAssyList(searchKey);
		
		Double[] sales_price = 	new Double[1];
		sales_price[0] = 0.0;
		List assys =commonInfo.getPartListByAssy(this_user_id, searchKey, sales_price);
		if(assys==null)
			return null;
		
		Vector<Map<String, Comparable>> map_list = new Vector<Map<String, Comparable>>();
		
		if( assys.size() > 0) {
			for(Iterator i=assys.iterator(); i.hasNext();) {
				Map<String, Comparable> map = new HashMap<String, Comparable>();
				PartLine part = (PartLine)i.next();

				map.put("item_code", part.getItem_code());
				map.put("item_name", part.getItem_name());
				map.put("unique_id", part.getUnique_id());
				
				
				logger.info(part.getItem_name());
				
				map_list.add(map);
			}
		}
		else {
			Map<String, Comparable> map = new HashMap<String, Comparable>();
			map.put("item_code", "????");
			map.put("item_name", "˻ ϴ.");
			
			map_list.add(map);
		}
		
		return map_list;
	}

}


