package com.rfxsoft.justrfx.web;

import java.text.DecimalFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.BeanCreationException;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.AbstractController;

import com.rfxsoft.justrfx.ExcelPage;
import com.rfxsoft.justrfx.business.j_prch.PrchManager;
import com.rfxsoft.justrfx.domain.XpoAst;
import com.rfxsoft.justrfx.web.security.SessionSecurityManager;

public class ExcelViewController extends AbstractController implements /*Controller,*/ InitializingBean {
	
	private DecimalFormat 	decimalFormat = new DecimalFormat("#,##0");
	private SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd");
	
	public String getThis_wa_code(HttpServletRequest request) {
		
		return SessionSecurityManager.getThis_wa_code(request);
	}
	
	public Double String2Double(String value) {
		if(value==null) {
			return 0.0;
		}
		if(value.length()==0) {
			return 0.0;
		}
		
		Number number = null;
		try {
			number = decimalFormat.parse(value);
		} catch (ParseException e) {
			e.printStackTrace();
		}
		return number.doubleValue();
	}
	
	public Date String2Date(String value) {
		
		Date date = null;
		if(value==null || value.length()==0) {
			return new Date();
		}
		try {
			date = dateFormat.parse(value);
		} catch (ParseException e) {
			e.printStackTrace();
		}
		
		return date;
	}
	
	public String Date2String(Date date) {
		if(date==null) {
			return "0000/00/00";
		}
		
		return dateFormat.format(date);
	}
	/*
	 *  2006.3.8 
	 *  
	 *  ڸ ڷ ȯ޼.
	 */
	public Integer String2Integer(String str)
	{
		try
		{
			return Integer.parseInt(str);
		}
		catch(NumberFormatException e)
		{
			return 0;
		}
	}
	
	public String GetRequestString(HttpServletRequest request, String argment) {
		String ret = request.getParameter( argment );
		if(ret==null)
			return "";
		return ret;
	}
	public Integer GetRequestInteger(HttpServletRequest request, String argment) {
		String ret = request.getParameter( argment );
		if(ret==null)
			return -1;
		return String2Integer(ret);
	}
	public Double GetRequestDouble(HttpServletRequest request, String argment) {
		String ret = request.getParameter( argment );
		if(ret==null)
			return 0.0;
		return String2Double(ret);
	}
	public Date GetRequestDate(HttpServletRequest request, String argment) {
		String ret = request.getParameter( argment );
		if(ret==null)
			ret = "0000/00/00";
		return String2Date(ret);
	}
	
	private String nullCheck(String parameter){
		if(parameter != null && parameter .length() == 0){
			return null;
		}else{
			return parameter;
		}
	}
	
	//PrchaseManagerController ؿ.
	public List PrchProcess_05Listcond(HttpServletRequest request){
		
		String date_type 		= this.nullCheck(request.getParameter("date_type"));													
		String s_date 			= this.nullCheck(request.getParameter("s_date"));					
		String e_date 			= this.nullCheck(request.getParameter("e_date"));					
		String no_type 			= this.nullCheck(request.getParameter("no_type"));					
		String s_type_no 		= this.nullCheck(request.getParameter("s_type_no"));				
		String e_type_no 		= this.nullCheck(request.getParameter("e_type_no"));				
		String gr_type 			= this.nullCheck(request.getParameter("gr_type")); 
		String s_gr_type_no 	= this.nullCheck(request.getParameter("s_gr_type_no"));
		String e_gr_type_no 	= this.nullCheck(request.getParameter("e_gr_type_no")); 
		String seller_code 		= this.nullCheck(request.getParameter("seller_code"));
		String seller_name 		= this.nullCheck(request.getParameter("seller_name"));
		String wa_name 			= this.nullCheck(request.getParameter("wa_name")); 
		String dept_code 		= this.nullCheck(request.getParameter("dept_code")); 
		String division_code 	= this.nullCheck(request.getParameter("division_code"));
		String gr_reason 		= this.nullCheck(request.getParameter("gr_reason"));
		String sel_item_code 	= this.nullCheck(request.getParameter("sel_item_code")); 
		String var_item_code 	= this.nullCheck(request.getParameter("var_item_code"));
		String item_name 		= this.nullCheck(request.getParameter("item_name")); 
		String po_type 			= this.nullCheck(request.getParameter("po_type"));
		String status 			= this.nullCheck(request.getParameter("status")); 
		String account_code 	= this.nullCheck(request.getParameter("account_code"));
		String account_name 	= this.nullCheck(request.getParameter("account_name"));
		String arap_flag 		= this.nullCheck(request.getParameter("arap_flag"));
		String worker_type 		= this.nullCheck(request.getParameter("worker_type")); 
		String po_user_name 	= this.nullCheck(request.getParameter("po_user_name"));
		String gr_user_name 	= this.nullCheck(request.getParameter("gr_user_name"));
		String mp_status 		= this.nullCheck(request.getParameter("mp_status"));				//԰Ϸ
		String is_final 		= this.nullCheck(request.getParameter("is_final"));					//԰Ϸ

		if(date_type==null)
			date_type = "gr_date";
		
		if(mp_status==null)
			mp_status = "GR";
		
		if(is_final==null)
			is_final = "ALL";


		List list/*Map*/ = this.purchaseManager.getGoodsReceiptGr(
				mp_status,
				is_final,
				 date_type, 
				 s_date, 
				 e_date, 
				 no_type, 
				 s_type_no, 
				 e_type_no, 
				 gr_type, 
				 s_gr_type_no, 
				 e_gr_type_no,
				 seller_code,
				 seller_name,
				 wa_name,
				 dept_code, 
				 division_code,
				 gr_reason,
				 sel_item_code, 
				 var_item_code, 
				 item_name, 
				 po_type,
				 status,
				 account_code,
				 account_name,
				 arap_flag,
				 worker_type, 
				 po_user_name,
				 gr_user_name,
				 this.getThis_wa_code(request)
				
		);

		
		return list;
	} 
	
	private PrchManager purchaseManager;

	public PrchManager getPurchaseManager() {
		return purchaseManager;
	}

	public void setPurchaseManager(PrchManager purchaseManager) {
		this.purchaseManager = purchaseManager;
	}

	public final void afterPropertiesSet() throws Exception {
		if (purchaseManager == null) throw new BeanCreationException("Must be set purchaseManager on ExcelViewController");
	}


	public ModelAndView handleRequestInternal(HttpServletRequest request, HttpServletResponse response) throws Exception {

		String docuTypeStr = request.getParameter("excel_page");
		ExcelPage docu_type = ExcelPage.valueOf(docuTypeStr);
		
		String viewName = null;
		String modelName = null;
		List<XpoAst> modelList = null;
		
		switch(docu_type) {
		case EXCEL_J05:
		{
			String strUid_array = this.GetRequestString(request, "uid_array");
			String[] arrUid = strUid_array.split(";");
			modelList = new ArrayList<XpoAst>();
			
			for(int i=0; i<arrUid.length; i++) {
				XpoAst xpoast = purchaseManager.getLineItemByUid(Integer.parseInt(arrUid[i]) );
				modelList.add(xpoast);
			}
			modelName = "xpoast";
			viewName = "j05-excel-view";
		}
			break;
		case EXCEL_D20:
			modelName = "template";
			viewName = "d20-excel-view";
			break;
		}
		
		return new ModelAndView(viewName, modelName, modelList);
	}
}
