package com.rfxsoft.justrfx.web;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.Random;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.springframework.beans.factory.BeanCreationException;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.AbstractController;

import com.rfxsoft.justrfx.DocuType;
import com.rfxsoft.justrfx.business.b_rtng.RtngManager;
import com.rfxsoft.justrfx.business.d_mtrl.MtrlManager;
import com.rfxsoft.justrfx.business.j_prch.PrchManager;
import com.rfxsoft.justrfx.document.PdfRunnableFormatter;
import com.rfxsoft.justrfx.domain.RegisterdMasterCompany;
import com.rfxsoft.justrfx.domain.SystemInfo;

public class PdfFactoryController extends AbstractController implements /*Controller,*/ InitializingBean{
	
	
	private static String strCallOnLoad =
		"<script language=\"JavaScript\"> <!--" +
		"function init(){lo_form.submit();	}	function callOnLoad(load)	{if (window.addEventListener) { window.addEventListener('load', load, false); }" +
	    "else if (window.attachEvent) {window.attachEvent('onload', load); } else {window.onload = load;" +
	    "}	}	callOnLoad(init);" +
		"//	--></script>";
    /**
     * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
     * @param request
     * @param response
     * @throws IOException
     * @throws IOException
     * @throws ServletException
     */
    public void doMakePdf (HttpServletRequest request, HttpServletResponse response, String rtgast_uid,
    		DocuType docu_type, String po_no) throws IOException {

    	// We get a Session object
        HttpSession session = request.getSession(true);
        Object object = session.getAttribute(rtgast_uid);
        
		// ȣ
		Random ran = new Random();
		Integer iRand = ran.nextInt();
		int rand_int = iRand.intValue();
		if(rand_int < 0) {
			rand_int = rand_int*(-1);
		}
		String strZero="0";
		String strCode =Integer.toHexString(iRand.intValue()).toUpperCase();
		while(strCode.length()<8)
			strCode = strZero.concat(strCode);
        
        String file_name = systemInfo.getPdfPath() + "/" + rtgast_uid + "-" + strCode + ".pdf";
        
        PdfRunnableFormatter pdf;
        if (object == null) {
        	pdf = new PdfRunnableFormatter(file_name,
        			/*Docu No.*/rtgast_uid,
        			docu_type,
        			po_no,
        			this.getMasterCompany(),
        			this.getSystemInfo(),
        			this.getRoutingManager(),
        			this.getPurchaseManager(),
        			this.getMaterialManager()
        			
        	
        	);
        	session.setAttribute(rtgast_uid, pdf);
        	Thread t = new Thread(pdf);
        	t.start();
        }
        else {
        	pdf = (PdfRunnableFormatter)object;
        }
        response.setContentType("text/html");
        switch (pdf.getPercentage()) {
        	case -1:
        		isError(response.getOutputStream());
        		return;
        	case 100:
        		isFinished(response.getOutputStream(), rtgast_uid);
        		return;
        	default:
        		isBusy(pdf, response.getOutputStream());
        		return;
        }
    }
	/**
     * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
     * @param request
     * @param response
	 * @throws IOException 
     * @throws IOException
     * @throws ServletException
     */
    public void doSendPdf (HttpServletRequest request, HttpServletResponse response, String rtgast_uid) throws IOException{
    	
    	// We get a Session object
        HttpSession session = request.getSession(false);
        try {
        	PdfRunnableFormatter pdf = (PdfRunnableFormatter) session.getAttribute(rtgast_uid);
        	session.removeAttribute(rtgast_uid);
			ByteArrayOutputStream baos = pdf.getPdf();
			//setting some response headers
			response.setHeader("Expires", "0");
			response.setHeader("Cache-Control", "must-revalidate, post-check=0, pre-check=0");
			response.setHeader("Pragma", "public");
			//setting the content type
			response.setContentType("application/pdf");
			// the contentlength is needed for MSIE!!!
			response.setContentLength(baos.size());
			// write ByteArrayOutputStream to the ServletOutputStream
			ServletOutputStream out = response.getOutputStream();
			baos.writeTo(out);
			out.flush();
        }
        catch(Exception e) {
        	isError(response.getOutputStream());
        }
    }
    
	public ModelAndView handleRequestInternal(HttpServletRequest request, HttpServletResponse response) throws Exception {
		String rtgast_uid = request.getParameter("rtgast_uid");
		String po_no = request.getParameter("po_no");
		String is_post = request.getParameter("is_post");
		String docuTypeStr = request.getParameter("docutype");
		
		//Key ݵ ־ Ѵ...
		if(rtgast_uid==null)
			return null;
		
		//  ޴ ̴.
		if(is_post!=null && is_post.compareToIgnoreCase("true")==0) {
			doSendPdf(request, response, rtgast_uid);
			return null;
		}

		if(docuTypeStr==null)
			return null;
		
		DocuType docu_type = DocuType.valueOf(docuTypeStr);
		if(po_no==null)
			po_no = "";
		
		doMakePdf(request, response, rtgast_uid, docu_type, po_no);
		
		return null;
	}
    
	/**
	 * Sends an HTML page to the browser saying how many percent of the document is finished.
	 * @param pdf 		the class that holds the PDF
	 * @param stream	the outputstream of the servlet
	 * @throws IOException
	 */
	private void isBusy(PdfRunnableFormatter pdf, ServletOutputStream stream) throws IOException {
		stream.print("<html>\n\t<head>\n\t\t<title>Please wait...</title>\n\t\t<meta http-equiv=\"Refresh\" content=\"1\">\n\t</head>\n\t<body>");
		stream.print(String.valueOf(pdf.getPercentage()));
		stream.print("% of the document is done.<br>\nPlease Wait while this page refreshes automatically (every 1 seconds)\n\t</body>\n</html>");
	}

	/**
	 * Sends an HTML form to the browser to get the PDF
	 * @param stream	the outputstream of the servlet
	 * @throws IOException
	 */
	private void isFinished(ServletOutputStream stream, String rtgast_uid) throws IOException {
		stream.print("<html>\n\t<head>\n\t\t<title>Finished!</title>\n\t");
		stream.print(strCallOnLoad);
		stream.print("</head>\n\t<body>The document is finished:<form name=lo_form method=\"POST\">");
		stream.print("<input type=\"hidden\" name=\"is_post\" value=\"true\">");
		stream.print("<input type=\"hidden\" name=\"rtgast_uid\" value=\"");
		stream.print(rtgast_uid);
		stream.print("\">");
		stream.print("<input type=\"submit\" value=\"Get PDF\"></form>\n\t</body>\n</html>");
	}
	
	/**
	 * Sends an error message in HTML to the browser
	 * @param stream	the outputstream of the servlet
	 * @throws IOException
	 */
	private void isError(ServletOutputStream stream) throws IOException {
		stream.print("<html>\n\t<head>\n\t\t<title>Error</title>\n\t</head>\n\t<body>");
		stream.print("An error occured.\n\t</body>\n</html>");
	}

	private RegisterdMasterCompany masterCompany;
	private SystemInfo	systemInfo;
	private PrchManager purchaseManager;
	private RtngManager routingManager;
	private MtrlManager	materialManager;
	
	public SystemInfo getSystemInfo() {
		return systemInfo;
	}
	public void setSystemInfo(SystemInfo systemInfo) {
		this.systemInfo = systemInfo;
	}
	public RtngManager getRoutingManager() {
		return routingManager;
	}
	public void setRoutingManager(RtngManager routingManager) {
		this.routingManager = routingManager;
	}
	public RegisterdMasterCompany getMasterCompany() {
		return masterCompany;
	}
	public void setMasterCompany(RegisterdMasterCompany masterCompany) {
		this.masterCompany = masterCompany;
	}
	public PrchManager getPurchaseManager() {
		return purchaseManager;
	}
	public void setPurchaseManager(PrchManager purchaseManager) {
		this.purchaseManager = purchaseManager;
	}
	public final void afterPropertiesSet() throws Exception {
		if (purchaseManager == null) throw new BeanCreationException("Must be set PrchManagerController on RfxController");
		if (materialManager == null) throw new BeanCreationException("Must be set materialManager on RfxController");
		if (masterCompany == null) throw new BeanCreationException("Must be set masterCompany on RfxController");
		if (routingManager == null) throw new BeanCreationException("Must be set routingManager on RfxController");
		if (systemInfo == null) throw new BeanCreationException("Must be set systemInfo on RfxController");

	}
	public MtrlManager getMaterialManager() {
		return materialManager;
	}
	public void setMaterialManager(MtrlManager materialManager) {
		this.materialManager = materialManager;
	}
}
