package com.rfxsoft.justrfx.web;
//.-->PdfFactoryController...
import java.io.ByteArrayOutputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Random;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.springframework.beans.factory.BeanCreationException;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.AbstractController;

import com.lowagie.text.Document;
import com.lowagie.text.DocumentException;
import com.lowagie.text.PageSize;
import com.lowagie.text.pdf.PdfWriter;
import com.rfxsoft.justrfx.business.b_rtng.RtngManager;
import com.rfxsoft.justrfx.business.j_prch.PrchManager;
import com.rfxsoft.justrfx.domain.RegisterdMasterCompany;
import com.rfxsoft.justrfx.web.views.RfxPdfDocuLayout;

public class RfxController extends AbstractController implements /*Controller,*/ InitializingBean{ 
	
	private static final int OUTPUT_BYTE_ARRAY_INITIAL_SIZE = 512;
	
	String html_head = 
		"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\" \"http://www.w3.org/TR/html4/strict.dtd\">" +
		"<html><head>" +
			"<link rel=stylesheet type=\"text/css\" href=\"main.css\"/>" +
			"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">" ;
	
	
	public void CreateFile(ByteArrayOutputStream bo, String file_name) {

			FileOutputStream f_out=null;
			try {
				f_out = new FileOutputStream(file_name);
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			} 
			try {
				f_out.write(bo.toByteArray());
			} catch (IOException e) {
				e.printStackTrace();
			} //Ͽ   .
			try {
				f_out.close();
			} catch (IOException e) {
				e.printStackTrace();
			} //ä ݴ´. ̶ Ʈ .


	}
	/**
	 * This class will keep a Pdf file
	 * @author k1park
	 */
	public class MyPdf implements Runnable {

		/** the ByteArrayOutputStream that holds the PDF data. */
		ByteArrayOutputStream baos = new ByteArrayOutputStream(OUTPUT_BYTE_ARRAY_INITIAL_SIZE);
		/** the percentage of the PDF file that is finished */
		int p = 0;
		int createdPage=0;
		int redrawcount=0;
		
		/**
		 * @see java.lang.Runnable#run()
		 */
		public void run() {

			Document document = newDocument();
			PdfWriter writer=null;
			try {
				writer = PdfWriter.getInstance(document, baos);
			} catch (DocumentException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			// Apply preferences and build metadata.
			writer.setViewerPreferences(getViewerPreferences());
			document.setMargins(5, 5, 195, 20);
			document.addTitle("justRFX Document");
			document.addAuthor("RFX Soft");
			document.addSubject("justRFX ۹");
			document.addKeywords("RFX, justRFX, RFXSoft");
			document.addCreator("Programmed by k1park");

			// Build PDF document.
			document.open();
			
			//ȣ
			Random ran = new Random();
			Integer iRand = ran.nextInt();
			int rand_int = iRand.intValue();
			
			if(rand_int < 0) {
				rand_int = rand_int*(-1);
			}
			
			String strZero="0";
			String strCode =Integer.toHexString(iRand.intValue()).toUpperCase();
			
			while(strCode.length()<8)
				strCode = strZero.concat(strCode);
			
			RfxPdfDocuLayout pdf_layout = new RfxPdfDocuLayout(writer, document, createdPage, strCode);
			pdf_layout.DoWork();
			
			document.close();
			p = 100;
			
			String file_name = "C:/REPOSIT/PDF/" + strCode + ".pdf";
			CreateFile(baos, file_name);
			
		}
		/**
		 * Gets the complete PDF data
		 * @return the PDF as an array of bytes
		 * @throws DocumentException when the document isn't ready yet
		 */
		public ByteArrayOutputStream getPdf() throws DocumentException {
			if (p < 100) {
				throw new DocumentException("The document isn't finished yet!");
			}
			return baos;
		}
		/**
		 * Gets the current percentage of the file that is done.
		 * @return a percentage or -1 if something went wrong.
		 */
		public int getPercentage() {
			return p;
		}
		
		public int getCreatedPage() {
			return createdPage;
		}
		public int getRedrawCount() {
			redrawcount++;
			return redrawcount-1;
		}
		
		
	}
	
	
    /**
     * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
     * @param request
     * @param response
     * @throws IOException 
     * @throws IOException
     * @throws ServletException
     */
    public void doMakePdf (HttpServletRequest request, HttpServletResponse response, String rtgast_uid) throws IOException {
    	
    	// We get a Session object
        HttpSession session = request.getSession(true);
        Object o = session.getAttribute("myPdf");
        MyPdf pdf;
        if (o == null) {
        	pdf = new MyPdf();
        	session.setAttribute("myPdf", pdf);
        	Thread t = new Thread(pdf);
        	t.start();
        }
        else {
        	pdf = (MyPdf)o;
        }
        response.setContentType("text/html");
        switch (pdf.getPercentage()) {
        	case -1:
        		isError(response.getOutputStream());
        		return;
        	case 100:
        		isFinished(response.getOutputStream(), rtgast_uid);
        		return;
        	default:
        		isBusy(pdf, response.getOutputStream());
        		return;
        }
    }
	/**
     * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
     * @param request
     * @param response
	 * @throws IOException 
     * @throws IOException
     * @throws ServletException
     */
    public void doSendPdf (HttpServletRequest request, HttpServletResponse response, String rtgast_uid) throws IOException{
    	
    	// We get a Session object
        HttpSession session = request.getSession(false);
        try {
        	MyPdf pdf = (MyPdf) session.getAttribute("myPdf");
        	session.removeAttribute("myPdf");
			ByteArrayOutputStream baos = pdf.getPdf();
			//setting some response headers
			response.setHeader("Expires", "0");
			response.setHeader("Cache-Control", "must-revalidate, post-check=0, pre-check=0");
			response.setHeader("Pragma", "public");
			//setting the content type
			response.setContentType("application/pdf");
			// the contentlength is needed for MSIE!!!
			response.setContentLength(baos.size());
			// write ByteArrayOutputStream to the ServletOutputStream
			ServletOutputStream out = response.getOutputStream();
			baos.writeTo(out);
			out.flush();
        }
        catch(Exception e) {
        	isError(response.getOutputStream());
        }
    }

	public ModelAndView handleRequestInternal(HttpServletRequest request, HttpServletResponse response) throws Exception {
		String rtgast_uid = request.getParameter("rtgast_uid");
		
		if(rtgast_uid==null)
			return null;
		
		String is_post = request.getParameter("is_post");
		
		if(is_post!=null && is_post.compareToIgnoreCase("true")==0) {
			doSendPdf(request, response, rtgast_uid);
		}
		else
			doMakePdf(request, response, rtgast_uid);
		
		
		return null;
	}
		
	/**
	 * Sends an HTML page to the browser saying how many percent of the document is finished.
	 * @param pdf 		the class that holds the PDF
	 * @param stream	the outputstream of the servlet
	 * @throws IOException
	 */
	private void isBusy(MyPdf pdf, ServletOutputStream stream) throws IOException {
		stream.print("<html>\n\t<head>\n\t\t<title>Please wait...</title>\n\t\t<meta http-equiv=\"Refresh\" content=\"1\">\n\t</head>\n\t<body>");
		stream.print(String.valueOf(pdf.getPercentage()));
		stream.print("% of the document is done.<br>\nPlease Wait while this page refreshes automatically (every 1 seconds)\n\t</body>\n</html>");
	}

	/**
	 * Sends an HTML form to the browser to get the PDF
	 * @param stream	the outputstream of the servlet
	 * @throws IOException
	 */
	private void isFinished(ServletOutputStream stream, String rtgast_uid) throws IOException {
		stream.print("<html>\n\t<head>\n\t\t<title>Finished!</title>\n\t</head>\n\t<body>");
		stream.print("The document is finished:<form method=\"POST\">");
		stream.print("<input type=\"hidden\" name=\"is_post\" value=\"true\">");
		stream.print("<input type=\"hidden\" name=\"rtgast_uid\" value=\"");
		stream.print(rtgast_uid);
		stream.print("\">");
		stream.print("<input type=\"submit\" value=\"Get PDF\"></form>\n\t</body>\n</html>");
	}

	/**
	 * Sends an error message in HTML to the browser
	 * @param stream	the outputstream of the servlet
	 * @throws IOException
	 */
	private void isError(ServletOutputStream stream) throws IOException {
		stream.print("<html>\n\t<head>\n\t\t<title>Error</title>\n\t</head>\n\t<body>");
		stream.print("An error occured.\n\t</body>\n</html>");
	}

    
    
    
    
/*
	private void isBusy(ServletOutputStream stream) throws IOException {
		
		String elapseTime = "ð: " + String.valueOf(pdf.getRedrawCount()*3) + "";
		
		stream.print( html_head +"\n\t\t<title>   ֽϴ......</title>\n\t\t<meta http-equiv=\"Refresh\" content=\"3\">\n\t</head>\n\t<BODY bgcolor=\"#F5EBFF\">");		
		stream.print("<FONT SIZE=\"2\">  ֽϴ.<br> ٷ ּ...<br>ϷῩθ 3ʸ Ȯմϴ.\n\t<hr><b>");
		stream.print(elapseTime + "</FONT></body>\n</html>" );
	}

	private void isFinished(MyPdf pdf, ServletOutputStream stream) throws IOException {
		String html_msg = 
								"\n\t\t<title>Ϸ!!!!</title>\n\t</head>\n\t<BODY bgcolor=\"#F5EBFF\"><FONT SIZE=\"2\"><b>Ϸ!!!!</b><hr>" +
								" Ǿϴ.  ؼ" +
								"<a href=\"http://www.adobe.com\">Adobe Reader</a><br>ġǾմϴ." +
								"<form method=\"POST\"><input type=\"Submit\" value=\"\"></form>\n\t</FONT></body>\n</html>";
		
		stream.print(html_head);
		stream.print(html_msg);
	}

	private void isError(ServletOutputStream stream) throws IOException {
		stream.print("<html>\n\t<head>\n\t\t<title>Error</title>\n\t</head>\n\t<BODY bgcolor=\"#F5EBFF\">");
		stream.print("An error occured.\n\t</body>\n</html>");
	}
	*/
	/**
	 * Create a new document to hold the PDF contents.
	 * <p>By default returns an A4 document, but the subclass can specify any
	 * Document, possibly parameterized via bean properties defined on the View.
	 * @return the newly created iText Document
	 * @see com.lowagie.text.Document#Document(com.lowagie.text.Rectangle)
	 */
	protected Document newDocument() {
		return new Document(PageSize.A4);
	}

	/**
	 * Return the viewer preferences for the PDF file.
	 * <p>By default returns <code>AllowPrinting</code> and
	 * <code>PageLayoutSinglePage</code>, but can be subclassed.
	 * The subclass can either have fixed preferences or retrieve
	 * them from bean properties defined on the View.
	 * @return an int containing the bits information against PdfWriter definitions
	 * @see com.lowagie.text.pdf.PdfWriter#AllowPrinting
	 * @see com.lowagie.text.pdf.PdfWriter#PageLayoutSinglePage
	 */
	protected int getViewerPreferences() {
		return PdfWriter.AllowPrinting | PdfWriter.PageLayoutSinglePage;
	}
	
	protected RegisterdMasterCompany masterCompany;
	private PrchManager purchaseManager;
	private RtngManager routingManager;
	
	public RtngManager getRoutingManager() {
		return routingManager;
	}
	public void setRoutingManager(RtngManager routingManager) {
		this.routingManager = routingManager;
	}
	public RegisterdMasterCompany getMasterCompany() {
		return masterCompany;
	}
	public void setMasterCompany(RegisterdMasterCompany masterCompany) {
		this.masterCompany = masterCompany;
	}
	public PrchManager getPurchaseManager() {
		return purchaseManager;
	}
	public void setPurchaseManager(PrchManager purchaseManager) {
		this.purchaseManager = purchaseManager;
	}
	public final void afterPropertiesSet() throws Exception {
		if (purchaseManager == null) throw new BeanCreationException("Must be set RfxController on PrchManagerController");
		if (masterCompany == null) throw new BeanCreationException("Must be set RfxController on masterCompany");
		if (routingManager == null) throw new BeanCreationException("Must be set RfxController on routingManager");

	}
}

