package com.rfxsoft.justrfx.web.controller;

import java.text.DecimalFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.Vector;

import java.io.UnsupportedEncodingException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.springframework.beans.factory.InitializingBean;
import org.springframework.web.bind.ServletRequestUtils;
import org.springframework.web.servlet.ModelAndView;


import com.rfxsoft.justrfx.DownloadUtil;
import com.rfxsoft.justrfx.domain.JrfxSuperDomain;
import com.rfxsoft.justrfx.domain.RegisterdMasterCompany;
import com.rfxsoft.justrfx.domain.command.ActivityName;
import com.rfxsoft.justrfx.domain.command.CommandType;
import com.rfxsoft.justrfx.domain.command.JrServiceName;
import com.rfxsoft.justrfx.domain.command.MenuId;
import com.rfxsoft.justrfx.domain.menu.MenuObject;
import com.rfxsoft.justrfx.domain.menu.MenuStructure;
import com.rfxsoft.justrfx.web.tiles.MenuManager;


import com.rfxsoft.justrfx.MenuObjectType;
import com.rfxsoft.justrfx.UserType;





/**
 * @author k1park
 *޴ ϴ Ŭ
 */
public abstract class AbstractMenuTileController extends AbstractSecurityController implements InitializingBean, InitializingMenuSet{

	// ó  ִ ִ ƼRequest 
	final int MAX_RECORD_QUAN	=	512;
	
	private DecimalFormat 	decimalFormat = new DecimalFormat("#,##0");

	private SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd");
	
	protected Integer intRowCursor=0;// ȣ(0 )
	protected Integer intRowCount=-1;//üڵ īƮ
	protected Integer intRowPerPage=30;//  ǥ ڵ 
	
//	06.04.11 Aram
	private int totalRecord;      //ü ڵ 
	private int numPerPage;       // default ۼ 
	private int pagePerBlock=10;  // default 
	private int totalPage;        //
	private int totalBlock;       //Ѻ
	private int nowPage;          //
	private int nowBlock;         //
	String charEnc;
//	private Map<String, Object> map;
//	private String  pagePath;
	private String   fielddata = "";
	
	
	protected final Log logger = LogFactory.getLog( getClass() );
	
	CommandType cmdType;
	


	public MenuId getMenuId() {
		return cmdType.getMenuId();
	}
	
	public ActivityName getActivityName () {
		return cmdType.getActivity();
	}
	
	public JrServiceName getServiceName () {
		return cmdType.getService();
	}
	
	
	int copyArrStr2Str(String[] from, String[] to) {
		
		if(from==null)
			return -1;
		
		for(int i=0; i<from.length; i++) {
			//to[i] = new String(from[i]);
			to[i] = from[i] ;
		}
		
		return from.length;
	}
	
	int copyArrStr2Int(String[] from, Integer[] to) {
		
		if(from==null)
			return -1;
		
		for(int i=0; i<from.length; i++) {
			to[i] = Integer.parseInt(from[i] );
		}
		
		return from.length;
	}
	
	

	private void readPageFormat(HttpServletRequest request) {
		String offset = request.getParameter("offset");
		String row_count = request.getParameter("row_count");
		
		if(row_count == null || row_count.length()==0)
			intRowCount = -1;//ڵ  ˼ .
		else
			intRowCount = Integer.valueOf(row_count);
		
		if(offset == null || offset.length()==0)
			intRowCursor = 0;
		else
			intRowCursor = Integer.valueOf(offset);
	}
	
	private void writePageFormat(HttpServletRequest request, Map<String, Object> menu_info) {

		Vector<Map<String, Integer>> page_info = new Vector<Map<String, Integer>>();
		
		Map<String, Integer> data = new HashMap<String, Integer>();
		data.put("row_cursor", intRowCursor);
		data.put("row_count", intRowCount);
		data.put("row_count", intRowCount);
		
		page_info.add(data);

		menu_info.put("page-info", page_info);

	}
	/*
	 * HwanKyu.Kang ѱ Encoding
	 */
	public String charEncoding(String str)
	{
		charEnc = null;
		
		try{
			if(str != null)
			{
				charEnc = new String(str.getBytes("8859_1"),"euc-kr");
			}
			else
			{
				charEnc = str;
			}
		}
		catch(UnsupportedEncodingException e)
		{
			//System.out.println(e);
		}
		return charEnc;
	}
	
	/*
	 * 06.04.11 Aram
	 * toStringPage ȣָ ڵ  ī 
	 */
	
	@SuppressWarnings("unchecked")
	public Map toStringPage(int  numPerPage,int totalRecord, int nowpage, Map condition)
	{
		if(condition==null) {
			condition = new HashMap();
		}
		condition.put("topage", pageBar(numPerPage, totalRecord, nowpage, condition));
		return condition;
	}
	
	/*
	 * 06.04.11 Aram
	 * numPerPage        default ۼ
	 * totalRecord      ü ڵ 
	 * nowPage          
	 */
	public StringBuffer pageBar(int numPerPage,int totalRecord,int nowPage, Map<String, Object> map)
	{
		/* Get϶ 
		if(map == null) map = new java.util.HashMap();
		else this.map = map;
		*/
		this.numPerPage  = numPerPage;
		this.totalRecord = totalRecord;
		this.nowPage     = nowPage;
//		this.pagePath    = pagePath;
		totalPage    = (int)Math.ceil((double)this.totalRecord/this.numPerPage);
		totalBlock   = (int)Math.ceil((double)this.totalPage/this.pagePerBlock);
		nowBlock     = (int)((double)this.nowPage/this.pagePerBlock);
		return setPageBar();
	}
	
	//׺̼ 
	public StringBuffer setPageBar()
	{
		/* Get϶ 
		StringBuffer sb = new StringBuffer();
		
		java.util.Iterator e = map.keySet().iterator();
		
		while(e.hasNext()) {
			String name = e.next().toString();
			if(map.get(name) != null && !map.get(name).toString().equals("")){
				sb.append("&").append(name).append("=");
				sb.append(((map.get(name)).toString()).replaceAll("%",""));
				
			}
		}
		*/
		StringBuffer pageLink = new StringBuffer();
		if(totalRecord >0)
		{
			if(nowBlock > 0)
			{	
				pageLink.append("<a href=javascript:Block('"+(nowBlock-1)*pagePerBlock+"')>" );
				pageLink.append("");
				pageLink.append("</a>&nbsp;&nbsp;");
				
				/*   
				 * Get 
				 	pageLink.append("<a href='"+pagePath+"&page="+((nowBlock-1)*pagePerBlock)+sb+"'>"); 
				 	pageLink.append("");
				 	pageLink.append("</a>&nbsp;&nbsp;");
				*/
			}
			for(int i=0;i<pagePerBlock;i++)
			{
				
				if(nowBlock*pagePerBlock+i==nowPage){
		   		pageLink.append("<b>"+(nowBlock*pagePerBlock+i+1)+"</b>&nbsp;");
			  }
				else
				{
					//System.out.println((nowBlock*pagePerBlock)+i);
					pageLink.append("<a href=javascript:Block('"+((nowBlock*pagePerBlock)+i)+"')>"+((nowBlock*pagePerBlock)+i+1)+"</a>&nbsp;" );
									
				/* GET
				 * pageLink.append("<a href='"+pagePath+"&page="+((nowBlock*pagePerBlock)+i)+sb+"'>"+((nowBlock*pagePerBlock)+i+1)+"</a>&nbsp;");
				 */
			   		
			
				}
				if((nowBlock*pagePerBlock)+i+1 == totalPage) break;
			}
			if(totalBlock > nowBlock+1)
			{
				pageLink.append("<a href=javascript:Block('"+((nowBlock+1)*pagePerBlock)+"')>" );
				pageLink.append("");
				pageLink.append("</a>");
				/*
				 * Get 
				 		pageLink.append("&nbsp;&nbsp;<a href='"+pagePath+"&page="+((nowBlock+1)*pagePerBlock)+sb+"'>");
				 		pageLink.append("");
				 		//pageLink.append("<img border=0 src='../images/bu_b.gif'>");
					 	pageLink.append("</a>");
				*/
			}
		}
		return pageLink;

	}

	
	private JrServiceName getJrServiceName( String strName) {
		JrServiceName service=null;
		try {
			service = JrServiceName.valueOf(strName.toUpperCase());
		}
		catch (Exception e) {
		}
		return service;
	}
	

	
		
	public ModelAndView DoMenuTileProcess(HttpServletRequest request, HttpServletResponse response) throws Exception {
		
		String from_search 	= ServletRequestUtils.getStringParameter(request, "from_search");
		String fieldnames;
		String[] fields;
		String[] values;
				
		Map<String, Object> menu_info = new HashMap<String, Object>();
		
		if(from_search!=null  && from_search.compareToIgnoreCase("true") == 0) {
			fieldnames 	= ServletRequestUtils.getStringParameter(request, "fieldnames");
			fields = fieldnames.split(";");
			values = new String[fields.length];
			
			for(int i=0; i< fields.length; i++) 
			{
				values[i] = request.getParameter((String)fields[i]);
				//values[i] = RequestUtils.getStringParameter(request, (String)fields[i]);
				fielddata += fields[i]+"="+values[i]+";";
			}
			
			
			menu_info.put("from_values", fielddata);

			
		}
		fielddata = "";  //ʱȭ
		
		
		//ϴٿε .
		String filecode 	= ServletRequestUtils.getStringParameter(request, "filecode");
		String filename 	= ServletRequestUtils.getStringParameter(request, "filename");
		
	    //ϴٿε .
		if(filecode != null && filename != null){
		    String[] str_end 	= filename.split("[.]");
		    String end_type 	= "."+str_end[str_end.length-1];
		    
		    String fileName 	= filecode+end_type;
		    String filePath 	= this.downloadPath +filecode;
		    
		    DownloadUtil.download(request,response, fileName, filePath, null);
			return null;
		}

		String menuType = ServletRequestUtils.getStringParameter(request, "menuId");
		String isPopup = ServletRequestUtils.getStringParameter(request, "popup");

		
		
		if(menuType==null) {
			logger.info("   ޴Ÿ.");
			return new ModelAndView("index", null);
			
		}
		
		RegisterdMasterCompany m_com = this.getMasterCompany();
		String companyDisplay = "";
		String companyLogo	  = "";
		
		if(m_com!=null) {
			companyDisplay  = this.getMasterCompany().getCompanyDisplay();
			companyLogo		= this.getMasterCompany().getCompanyLogo();
		}

		UserType myUserType = this.getThis_user_type(request);
		String	 myUserId	= this.getThis_userid(request);
		String	 myUserName	= this.getThis_user_name(request);
	
		readPageFormat(request);
		
		
		//menuType ޴ ù° ޴Ʈ ġȯѴ.
		MenuManager menuManager = this.getMenuManager();
		JrServiceName service = null;

		service = getJrServiceName(menuType);
		if(service!=null) {
			MenuStructure selectedMenu = menuManager. GetSelectedParent(service);
			if(selectedMenu != null) {
				MenuObject target = selectedMenu.getMenuFirst(myUserType);
				if(target!=null)
					menuType = target.getKey();
				else {
					menuManager.GetMenuDisplay(menuType, menu_info, myUserType,
							companyDisplay, myUserId, myUserName, companyLogo, MenuObjectType.MN_SERVICE
							/*,	target*/);
					return new ModelAndView("index", menu_info);
				}
					
			}
		}
		
		
		this.cmdType = new CommandType(menuType);
		MenuId menuId = cmdType.getMenuId();
		service = cmdType.getService();
		
		if( !menuManager.checkAuthority(menuId, service, menuType) ) {
			// ϴ  .
			return new ModelAndView("index", menu_info);
		}
		
		if(isPopup !=null) {
			DoPopupMenuProcess(request, response, menuType, menu_info);
			DoMenuProcess(request, response, menuType, menu_info);
			return new ModelAndView(menuType+"-popup", menu_info);
		}
		
		
		try {
			
			DoMenuProcess(request, response, menuType, menu_info);
			
			if(isPopup !=null) {
				return new ModelAndView(menuType+"-popup", menu_info);
			}
			String forward = this.cmdType.getForward();
			MenuObjectType objectType = MenuObjectType.MN_OBJECT;
			if(forward.length()==8 && forward.substring(2).compareToIgnoreCase("result")  == 0) {//f-result
				objectType = MenuObjectType.MN_RESULT;
			}	
			this.getMenuManager().GetMenuDisplay(this.cmdType.getForward(), menu_info, myUserType,
					companyDisplay, myUserId, myUserName, companyLogo, objectType/*, target*/);
	
			writePageFormat( request, menu_info);
			
		}catch (Throwable t) {
			
			String[] err_arr = null;
			String err_msg = t.getLocalizedMessage();
			
			if(err_msg!=null){
				err_arr = err_msg.split("\n");
				
			}
			
			String full_message=": ";
			
			if(err_arr!=null) {
				for(int i=0; i<err_arr.length; i++)
					full_message = full_message + err_arr[i] + " / ";
			}
			
			menu_info.put("data", full_message);
			menu_info.put("URL", "BACK_WARD");
			//menu_info.put("URL",  service.toString().toLowerCase() + ".html?menuId=" + this.cmdType.getKey() );
			this.getMenuManager().GetMenuDisplay(this.cmdType.getKey().substring(0,1)+ "-result", menu_info, myUserType,
					companyDisplay, myUserId, myUserName, companyLogo, MenuObjectType.MN_RESULT/*, target*/);
		}
				
		return new ModelAndView("index", menu_info);
	}
	
	public String Double2String(Double value) {
		if(value==null) {
			return "0.0";
		}
		
		return decimalFormat.format(value);
	}
	public Double String2Double(String value) {
		if(value==null) {
			return 0.0;
		}
		if(value.length()==0) {
			return 0.0;
		}
		
		Number number = null;
		try {
			number = decimalFormat.parse(value);
		} catch (ParseException e) {
			e.printStackTrace();
		}
		return number.doubleValue();
	}
	
	public Date String2Date(String value) {
		
		Date date = null;
		if(value==null || value.length()==0) {
			return new Date();
		}
		try {
			date = dateFormat.parse(value);
		} catch (ParseException e) {
			e.printStackTrace();
		}
		
		return date;
	}
	
	public String Date2String(Date date) {
		if(date==null) {
			return "0000/00/00";
		}
		
		return dateFormat.format(date);
	}
	/*
	 *  2006.3.8 
	 *  
	 *  ڸ ڷ ȯ޼.
	 */
	public Integer String2Integer(String str)
	{
		try
		{
			return Integer.parseInt(str);
		}
		catch(NumberFormatException e)
		{
			return 0;
		}
	}
	
	public String GetRequestString(HttpServletRequest request, String argment) {
		String ret = request.getParameter( argment );
		if(ret==null)
			return "";
		return ret;
	}
	public Integer GetRequestInteger(HttpServletRequest request, String argment) {
		String ret = request.getParameter( argment );
		if(ret==null)
			return -1;
		return String2Integer(ret);
	}
	public Double GetRequestDouble(HttpServletRequest request, String argment) {
		String ret = request.getParameter( argment );
		if(ret==null)
			return 0.0;
		return String2Double(ret);
	}
	public Date GetRequestDate(HttpServletRequest request, String argment) {
		String ret = request.getParameter( argment );
		if(ret==null)
			ret = "0000/00/00";
		return String2Date(ret);
	}
	
	public int	GetRequestUniqueIds(HttpServletRequest request, String argment, Integer[] int_uid) {

		String[] str_uids		= request.getParameterValues(argment);
		
		if(str_uids==null)
			return -1;
		int quan = str_uids.length;
		
		if(quan==0) {
			return quan;
		}
		
		if(quan>MAX_RECORD_QUAN)
			quan=MAX_RECORD_QUAN;
		
		for(int i=0; i < quan; i++) {
			int_uid[i]		=	String2Integer(str_uids[i]);
		}
		return quan;
	}
	
	public int createRandNumber() {
		Random ran = new Random();
		int iRand = ran.nextInt();
		if(iRand < 0) {
			return (-1)* iRand;
		}
		return iRand;
	}
	
	protected int GetRequestValue_ChkBox(HttpServletRequest request, Integer[] unique_ids) {
		
		String[] chkBox     	= request.getParameterValues("chkBox");
		
		if(chkBox==null)
			return -1;//߻   ̴.item_quan  0 Ŭ  Լ Ҹ. 
		
		int item_quan   = chkBox.length;

		for(int i=0; i < item_quan; i++) {	
			unique_ids[i] = String2Integer(chkBox[i]);
		}
		
		return item_quan;
	}

	public String GetUidStringList(List list) {
	    
		String retStrValue = "";
		int quan=0;
		for(Iterator i=list.iterator(); i.hasNext(); quan++ ){
			if(quan!=0) {
				retStrValue = retStrValue + ",";
			}
	    	JrfxSuperDomain domain 		= (JrfxSuperDomain)i.next();
	    	
	    	retStrValue = retStrValue + domain.getUnique_id().toString();
	    }

		return retStrValue;
	}

	
//	public void DoPopupMenuProcess(HttpServletRequest request,HttpServletResponse response, String menuType, Map<String, Object> menu_info) {
//	// ʴµ.   	
//	}

}
