package com.rfxsoft.justrfx.web.controller;

import java.util.HashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.AbstractController;

import com.rfxsoft.justrfx.UserType;
import com.rfxsoft.justrfx.business.g_mynf.MynfManager;
import com.rfxsoft.justrfx.domain.RegisterdMasterCompany;
import com.rfxsoft.justrfx.domain.SystemInfo;
import com.rfxsoft.justrfx.web.security.SessionSecurityManager;
import com.rfxsoft.justrfx.web.tiles.MenuManager;

public abstract class AbstractSecurityController extends AbstractController implements /*Controller,*/ InitializingMenutileProcess {
	
	protected MenuManager menuManager;
	protected RegisterdMasterCompany masterCompany;
	protected SystemInfo systemInfo;
	protected String downloadPath;
	protected MynfManager myInfoManager;
	
	protected final Log logger = LogFactory.getLog( getClass() );

	public ModelAndView handleRequestInternal(HttpServletRequest request,
			HttpServletResponse response) throws Exception {
		
		//this.setRequireSession(true);
		this.setSynchronizeOnSession(true);
		//this.setCacheSeconds(5);
		
		
		//αε Ǿ 
		if (SessionSecurityManager.isUserLoggedIn(request)==false )	{
			return DoLogoutProcess();
		}
		else {
			systemInfo = SessionSecurityManager.getSystemInfo(request);
			if(systemInfo==null) {
				return DoLogoutProcess();
			}
			else {
				downloadPath = systemInfo.getUploadPath();
				if(downloadPath==null) {
					return DoLogoutProcess();
				}
			}
			return DoMenuTileProcess(request, response);
		}
	}
	
	private ModelAndView DoLogoutProcess() {
		logger.info("Logged-Off");
		
		Map<String, Object> menu_info = new HashMap<String, Object>();
		RegisterdMasterCompany m_com = this.getMasterCompany();
		//String companyDisplay = "";
		String companyLogo	  = "";

		if(m_com!=null) {
			//companyDisplay  = this.getMasterCompany().getCompanyDisplay();
			companyLogo		= this.getMasterCompany().getCompanyLogo();
			menu_info.put("com_logo",	companyLogo);
		}
		
		String login_route = "security-login";
		
		return new ModelAndView(login_route, menu_info);
	}
	
	public String getThis_userid(HttpServletRequest request) {

		return SessionSecurityManager.getThis_userid(request);
	}

	public Integer getThis_useruid(HttpServletRequest request) {

		return SessionSecurityManager.getThis_useruid(request);
	}
	
	public Integer getThis_combstuid(HttpServletRequest request) {

		return SessionSecurityManager.getThis_combst_uid(request);
	}
	
	public Integer getThis_po_useruid(HttpServletRequest request) {
		
		return SessionSecurityManager.getThis_po_useruid(request);
	}

	public UserType getThis_user_type(HttpServletRequest request) {
		
		return SessionSecurityManager.getThis_user_type(request);
	}
	
	public String getThis_user_name(HttpServletRequest request) {
		
		return SessionSecurityManager.getThis_user_name(request);
	}
	public String getThis_wa_code(HttpServletRequest request) {
		
		return SessionSecurityManager.getThis_wa_code(request);
	}
	public String getThis_company_code(HttpServletRequest request) {
		
		return SessionSecurityManager.getThis_company_code(request);
	}

	public RegisterdMasterCompany getMasterCompany() {
		return masterCompany;
	}

	public void setMasterCompany(RegisterdMasterCompany masterCompany) {
		this.masterCompany = masterCompany;
	}
	
	public MenuManager getMenuManager() {
		return menuManager;
	}

	public void setMenuManager(MenuManager menuManager) {
		this.menuManager = menuManager;
	}

	/**
	 * @return the myInfoManager
	 */
	public MynfManager getMyInfoManager() {
		return myInfoManager;
	}

	/**
	 * @param myInfoManager the myInfoManager to set
	 */
	public void setMyInfoManager(MynfManager myInfoManager) {
		this.myInfoManager = myInfoManager;
	}
	
	
	public Integer getCurrentProject(HttpServletRequest request) {
		return SessionSecurityManager.getCurrentProject(request);
	}
	
	public Integer getCurrentAssy(HttpServletRequest request) {
		return SessionSecurityManager.getCurrentAssy(request);
	}
	
	public boolean setCurrentProject(HttpServletRequest request, String cur_project) {
		
		String session_project = getCurrentProject(request).toString();
		
		if(session_project==cur_project) {
			return true;
		}
		
		SessionSecurityManager.setCurProjectId(request, cur_project);
		
		String user_id = this.getThis_userid(request);
		this.myInfoManager.setEnvRaw(user_id, "CUR_PROJECT_ID", cur_project);
		
		return false;
		
	}
	
	public boolean setCurrentAssy(HttpServletRequest request, String cur_assy) {
		String session_assy = getCurrentAssy(request).toString();
		if(session_assy==cur_assy) {
			return true;
		}
		
		SessionSecurityManager.setCurAssyId(request, cur_assy);
		
		String user_id = this.getThis_userid(request);
		this.myInfoManager.setEnvRaw(user_id, "CUR_ASSY_ID", cur_assy);
		
		return false;
	}

	
}


