package com.rfxsoft.justrfx.web.controller;

import java.io.*;

import org.apache.poi.poifs.filesystem.POIFSFileSystem;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.poi.hssf.usermodel.*;

import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import com.rfxsoft.justrfx.web.security.SessionSecurityManager;
import com.rfxsoft.justrfx.DownloadUtil;

public class ExcelFileController {
	
	protected final Log logger  = LogFactory.getLog( getClass() );	
	 String filepath			= null;		// ϰ
	 
	 
	
	public ExcelFileController(String filepath) {
		super();
		this.filepath = filepath;
	}



	private String ReadCell( HSSFCell cell ) {
		String retStr = "";
		if(cell==null) {
			return retStr;
		}
			
		switch (cell.getCellType()) 
		{
			case HSSFCell.CELL_TYPE_FORMULA :
				retStr =  cell.getCellFormula();
				break;
			case HSSFCell.CELL_TYPE_NUMERIC :
				/*
				 * CELL_TYPE_NUMERIC :
				 *  Ÿ϶ : getNumericCellValue()	ȯŸ : double
				 * ¥ Ÿ϶ : getDateCellValue()		ȯŸ : Date
				 */
				retStr =  Double.toString(cell.getNumericCellValue());
				break;
			case HSSFCell.CELL_TYPE_STRING :
				/*
				 * CELL_TYPE_STRING :
				 * getStringCellValue()					ȯŸ : String
				 */
				retStr =  cell.getStringCellValue(); 
				break;
			case HSSFCell.CELL_TYPE_BLANK :
				/*
				 * CELL_TYPE_BLANK :
				 * ȯŸ : null
				 */
				retStr = "";
				break;
			case HSSFCell.CELL_TYPE_BOOLEAN :
				/*
				 * CELL_TYPE_BOOLEAN :
				 * getBooleanCellValue()	ȯŸ : boolean
				 */
				retStr =  Boolean.toString(cell.getBooleanCellValue());
				break;
			case HSSFCell.CELL_TYPE_ERROR :
				/*
				 * CELL_TYPE_ERROR :
				 * getErrorCellValue()	ȯŸ : byte
				 */
				retStr =  Byte.toString(cell.getErrorCellValue()); 
				break;
				/*
				 * Ÿ
				 * ü ö : getCellFormula()			ȯŸ : String
				 *  ȯ ϶ : getNumericCellValue()		ȯŸ : double
				 *  ȯ ϶ : getStringCellValue()		ȯŸ : String
				 */
			default :
		}//endofswitch
		
		return retStr;
		
	}
	/*
	 * 	 HSSFWorkbook 	:  ũ
	 *	 HSSFSheet    	:  Ʈ
	 *	 HSSFRow 		:  Ư 
	 *	 HSSFCell 		:  Ư ࿡ Ư 
	 */
	//public void doExcelFile(HttpServletRequest request)throws Exception
	public Vector readExcelFile(boolean read_full)throws Exception	{
		Vector<String[]>		vt		= new Vector<String[]>();
		String[]	buffer	= null;
	
		File f = new File(filepath);
		File reNmF = new File(filepath+".xls");
	
		if(f.exists())
		{
			f.renameTo(reNmF);
			
			//System.out.println(reNmF.getPath());
			
			//POSFS ̿Ͽ  ũ 
			POIFSFileSystem fs = new POIFSFileSystem(new FileInputStream(reNmF.getPath()));
			HSSFWorkbook workbook = new HSSFWorkbook(fs);
			int sheetNum =1;//ù° Ʈ д´.
			if(read_full==true) {
				sheetNum = workbook.getNumberOfSheets();
			}
			
			// ũ ̿Ͽ Ʈ ŭ 鼭  Ʈ ϳ 
			for (int k = 0; k < sheetNum; k++) {
				HSSFSheet sheet = workbook.getSheetAt(k);
				int rows = sheet.getPhysicalNumberOfRows();
				// Ʈ ̿Ͽ   ŭ 鼭  ϳ 
				int cells = -1;
				for (int r = 0; r < rows; r++) {
					HSSFRow row = sheet.getRow(r);
					if (row != null) {
						if(cells==-1) {
							cells = row.getPhysicalNumberOfCells();
						}
						buffer = new String[cells];
						//  ̿Ͽ   ŭ 鼭  ϳ 
						for (short c = 0; c < cells; c++) {
							HSSFCell cell = row.getCell(c);
							buffer[c] = ReadCell(cell);
						}
						vt.add(buffer);
					}
				}
				
			}
		}
		else
		{
			logger.info(filepath+"  ã ϴ.");
		}
	
		reNmF.delete();
			
		return vt;
	}
	
	/*
	 * ۼ 	: 
	 * ۼ	: 06.4.25
	 * Ķ 	: ̸, Ʈ, 迭
	 * 		: ֹƮŷ  ٿε	
	*/
	public boolean doExcelFileDownload(String file_nm, int size, String[][] cell_value, HttpServletResponse response,  HttpServletRequest request)throws Exception{
		
		String dir 		= SessionSecurityManager.getSystemInfo(request).getExcelPath(); //丮
		String filename = file_nm+".xls";	//̸
		String filePath = dir+filename; 	//ü
		
		HSSFWorkbook workbook	= new HSSFWorkbook();
		HSSFSheet sheet 	  	= workbook.createSheet();
		workbook.setSheetName(0,file_nm);
		
		
		//ŸϽƮ
	    HSSFCellStyle style = workbook.createCellStyle();

//	    style.setBorderBottom(HSSFCellStyle.BORDER_THIN);
//	    style.setBottomBorderColor(HSSFColor.BLACK.index);
//	    style.setBorderLeft(HSSFCellStyle.BORDER_THIN);
//	    style.setLeftBorderColor(HSSFColor.GREEN.index);
//	    style.setBorderRight(HSSFCellStyle.BORDER_THIN);
//	    style.setRightBorderColor(HSSFColor.BLUE.index);
//	    style.setBorderTop(HSSFCellStyle.BORDER_MEDIUM_DASHED);
//	    style.setTopBorderColor(HSSFColor.BLACK.index); 
  
	      
	    for(int i=0; i < size+1; i++){
	    	
	    	HSSFRow row 			= sheet.createRow(i); //i° 
	    	for(int k=0; k<cell_value[i].length; k++){
	            HSSFCell cell = row.createCell((short)k); //i°ٿ k°ĭ
	            cell.setEncoding(HSSFCell.ENCODING_UTF_16); 
	            cell.setCellStyle(style);
	            cell.setCellValue(cell_value[i][k]);
	    	}
	    }
        
        FileOutputStream fs = null;
        try { 
            fs = new FileOutputStream(filePath);
            workbook.write(fs);
        } catch (Exception e) {
        } finally {
            if (fs != null) fs.close();
        }
		DownloadUtil.download(request, response, filename, filePath, null);
		return true;
	}
	

	
	
}
