package com.rfxsoft.justrfx.web.controller;

import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.Vector;
import java.util.ArrayList;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.BeanCreationException;


import com.rfxsoft.justrfx.Pair;
import com.rfxsoft.justrfx.PairList;
import com.rfxsoft.justrfx.Pairimpl;
import com.rfxsoft.justrfx.business.b_rtng.RtngManager;
import com.rfxsoft.justrfx.business.c_prjt.PrjtManager;
import com.rfxsoft.justrfx.business.d_mtrl.MtrlManager;
import com.rfxsoft.justrfx.business.g_mynf.MynfManager;
import com.rfxsoft.justrfx.domain.AssyLine;
import com.rfxsoft.justrfx.domain.Project;
import com.rfxsoft.justrfx.domain.SrcAhd;
import com.rfxsoft.justrfx.domain.AssyMap;
import com.rfxsoft.justrfx.domain.command.JrServiceName;

public class MtrlManagerController extends AbstractMenuTileController {
	
	
	private static final int GUBUN			= 0;	//ǰ
	private static final int ITEM_NAME		= 1;	//ǰ
	private static final int SPECIFICATION	= 2;	//԰
	private static final int MODEL_NO		= 3;	///
	private static final int DESCRIPTION	= 4;	//ó
	private static final int MAKER_NAME		= 5;	//
	private static final int SALES_PRICE	= 6;	//
	private static final int BM_QTY			= 7;	//()
	private static final int PL_NO			= 8;	//ȣ(4)
	private static final int MAX_STAN_NAME	= 128;	//ǥظĪ ִ밳

	
	
	int		start;
	int     totalCnt;
	Map<String, Comparable>		map;
	public String nullCk(String args)
	{
		if(args == null)
		{
			args = "";
		}
	  return args;
	}
		
	private void FillMaxSize(Vector<Pair> vecPair) {
		
		while(vecPair.size()<MAX_STAN_NAME) {
			Random ran = new Random();
			int iRand = ran.nextInt();
			
			if(iRand < 0) {
				iRand = (-1)* iRand;
			}
			String strRand = Integer.toHexString(iRand).toUpperCase();
			
			if(strRand.length() > 6)
				strRand = strRand.substring(0, 6);
			
			while(strRand.length()<6) {
				strRand = "0" + strRand;
			}

			Pair pair = new Pairimpl(strRand, "");
			
			vecPair.add(pair);
		}
		
	}
	
	int GetRequestValue_05Add(HttpServletRequest request,
			Integer[]	intAssy_unique_id,
			Integer[]	child,
			String[]	pl_no,
			Double[] 	dblQuan,
			Integer[]	intPj_unique_id,
			String[]	item_code,
			Double[] 	dblSales_price,
			Double[] 	dblSource_price) {
		
	   	String[] paerline_uids		= request.getParameterValues("chkBox");
	   	intAssy_unique_id[0] 		= this.GetRequestInteger(request, "target_assy_uid");
	   	intPj_unique_id[0] 			= this.GetRequestInteger(request, "target_pj_uid");		
		
	   	if(paerline_uids == null)
	   		return -1;
		int item_quan = paerline_uids.length;
		for(int i=0; i < item_quan; i++) {
			child[i] 			= GetRequestInteger(request, paerline_uids[i] + "_child");
			pl_no[i] 			= GetRequestString(request, paerline_uids[i] + "_pl_no");
			dblQuan[i]			= GetRequestDouble(request, paerline_uids[i] + "_quan");
			item_code[i] 		= GetRequestString(request, paerline_uids[i] + "_item_code");
			dblSales_price[i]	= GetRequestDouble(request, paerline_uids[i] + "_sales_price");
			dblSource_price[i]	= GetRequestDouble(request, paerline_uids[i] + "_source_price");
		}
		
		return item_quan;
		
	}
	
	
	public AssyLine MtrlProcess_05Modform(HttpServletRequest request) {
		
		Integer assymap_uid = this.GetRequestInteger(request, "target_assy_uid");
		if(assymap_uid<0) {
			return null;
		}
		return materialManager.getAssyLineByUid(assymap_uid);
		
	}
	
	private int GetMaxLevel(List assy_line_list) {
		
		int max_level = 0;
		for(Iterator i=assy_line_list.iterator(); i.hasNext();) {
			AssyLine assyline = (AssyLine)i.next();
			int level = assyline.getLevel();
			if(level>max_level)
			{
				max_level = level;
			}
		}
		return max_level;
		
	}
	public void MtrlProcess_08Def(int intPj_unique_id, int intAssy_unique_id,
			HttpServletRequest request, Map<String, Object> menu_info) {
		
		//Display PL -> ON/OFF
		String dispState = this.GetRequestString(request, "DISP_STATE");
		if(dispState.length() == 0)		{
			dispState = "ON";
		}
		//Pj Info / Part Regist / Assy Regist
		String menuState = this.GetRequestString(request, "MENU_STATE");
		if(menuState.length() == 0)	{
			menuState = "PJ_INFO";
		}
		
		//Ÿ
		String matType = this.GetRequestString(request, "STAN_FLAG");
		
		//assy   Parent Type
		String parentType = this.GetRequestString(request, "PARENT_TYPE");
		
		
		menu_info.put("DISP_STATE", dispState);
		menu_info.put("MENU_STATE", menuState);
		menu_info.put("STAN_FLAG",  matType);
		menu_info.put("PARENT_TYPE",  parentType);
		
		int max_level = -1;
		
		List assy_line_list = this.GetAssyLineList(intPj_unique_id, request);
		
		if(assy_line_list!=null) {
			
			max_level = this.GetMaxLevel(assy_line_list);
			
			menu_info.put("max_level", 	 new Integer(max_level));
			menu_info.put("assylist", 	 assy_line_list );
		}
		
		//Ʈ 
		Map<String, String> map = new HashMap<String, String>();
		map.put("is_complished",	"N");
		menu_info.put("projectlist", projectManager.getProjectList(map));
		
		// õ Assy
		if( intAssy_unique_id > 0) {
			menu_info.put("selected_assy_uid", new Integer( intAssy_unique_id) );
		}
		
		//  
		menu_info.put("COPIED_PARTS_NUM", this.myInfoManager.getEnvRaw(this.getThis_userid(request), "COPIED_PARTS_NUM"));

		
		// Auto completer
		PairList pair_list_material = this.myInfoManager.getEnvList("#SYSINFO#", "STAN_MATERIAL");
		menu_info.put("material_group",  pair_list_material.getVecPair() );
		//ó Auto completer
		PairList pair_list_treatment = this.myInfoManager.getEnvList("#SYSINFO#", "STAN_TREATMENT");
		menu_info.put("treatment_group",  pair_list_treatment.getVecPair() );
	}
	
	
	public void MtrlProcess_05Edit(HttpServletRequest request) {
		Integer assyline_unique_uid = this.GetRequestInteger(request, "assyline_unique_uid");
		String pl_no	= this.GetRequestString(request, "pl_no");
		Double bm_quan  = this.GetRequestDouble(request, "bm_quan");
		String item_name= this.GetRequestString(request, "item_name");
		Integer unique_id= this.GetRequestInteger(request, "unique_id");
		Double sales_price = this.GetRequestDouble(request, "sales_price");

		
		materialManager.modifyRelation(assyline_unique_uid, pl_no, bm_quan, sales_price);
		materialManager.modifyName(unique_id, item_name);
	}

		
	public void MtrlProcess_05Add(HttpServletRequest request) {
		Integer[]	intAssy_unique_id=	new Integer[1];
		Integer[]	intPj_unique_id=	new Integer[1];
		Integer[]	child=				new Integer[MAX_RECORD_QUAN];
		Double[] 	dblQuan= 			new Double[MAX_RECORD_QUAN];
		Double[] 	dblSales_price= 	new Double[MAX_RECORD_QUAN];
		Double[] 	dblSource_price= 	new Double[MAX_RECORD_QUAN];
		String[]	pl_no=		new String[MAX_RECORD_QUAN];
		String[]	item_code=		new String[MAX_RECORD_QUAN];

		
		int this_item_quan = GetRequestValue_05Add(request,
				intAssy_unique_id,
				child,
				pl_no,
				dblQuan,
				intPj_unique_id,
				item_code,
				dblSales_price,
				dblSource_price);


		for(int i=0; i<this_item_quan; i++) {
			materialManager.addRelation2Assembly(
					this.getThis_userid(request),
					this.getThis_useruid(request),
					intAssy_unique_id[0],
					child[i],
					pl_no[i],
					dblQuan[i],
					"N",
					intPj_unique_id[0],
					item_code[i],
					dblSales_price[i],
					dblSource_price[i],-1);
		}

	}
	
	public void DoMenuProcess(HttpServletRequest request, HttpServletResponse response, String menuType, Map<String, Object> menu_info) {
		String unique_id;
		String part_unique_id;
		String item_code;
		String item_name;
		String specification;
		String maker_name;
		String model_no;
		String class_code;
		String description;
		String standard_flag;
		String sales_price;
		String sales_price_str;
		String pj_unique_id;
		String assy_unique_id;
		String assy_item_code;
		String pl_code; 
		String quan;
		String is_new;
		String prev_code;	// item_code
		String[]chkBox;				//ũ 迭 . 06.3.20 	
		String[]rcvr_uid;			//μ ̵
		String[]rush_order_flag = null;
		Date[]	req_date;
		String[]rcvr_name;
		String[]req_flag;
		String[]delivery_info;
		String[]del_info_flag;
		String[]req_info;
		String[]quans;
		String[]rcvr_item_name;//ǰ
		String	real_delete;//PL  
		String	part_pl_no;//PL PL_NO
		String	part_quan;//PL quan
		String  is_add_quan;//ſû ߰(=Y)
		String  sg_code;
		
		Double dblQuan = 1.0;
		double dblSales_price =0;
		
		int intPj_unique_id = -1;
		int intAssy_unique_id = -1;
		int intPart_unique_id = -1;
//		Double dblPart_quan = 0.0;
		
		//ε   Ÿ ...
		if ( this.getServiceName() != JrServiceName.D_MTRL) {
			logger.info("D_MTRL     Դϴ.");
			return;
		}
		part_unique_id		=	request.getParameter("part_unique_id");
		unique_id 			=	request.getParameter("unique_id");
		item_code 			= 	request.getParameter("item_code");
		item_name 			= 	request.getParameter("item_name");
		specification 		= 	request.getParameter("specification");
		maker_name 			= 	request.getParameter("maker_name");
		sg_code 			= 	request.getParameter("sg_code");
		model_no 			= 	request.getParameter("model_no");
		class_code 			= 	request.getParameter("class_code");
		description 		=	request.getParameter("description");
		sales_price 		=	request.getParameter("sales_price");
		sales_price_str 	=	request.getParameter("sales_price_str");
		pj_unique_id 		=	request.getParameter("pj_unique_id");
		assy_unique_id 		=	request.getParameter("assy_unique_id");
		assy_item_code		=	request.getParameter("assy_item_code");
		pl_code 			=	request.getParameter("pl_code");
		quan 				=	request.getParameter("quan");
		standard_flag 		=	request.getParameter("standard_flag");
		is_new 				=	request.getParameter("is_new");
		prev_code 			= 	request.getParameter("prev_code");
		real_delete			=	request.getParameter("real_delete");
		part_pl_no			=	request.getParameter("part_pl_no");
		part_quan			=	request.getParameter("part_quan");
		is_add_quan			=	request.getParameter("is_add_quan");
		chkBox				=	request.getParameterValues("chkBox");
		start				= nullCk(request.getParameter("page")).equals("")? 0 : 	Integer.parseInt(request.getParameter("page"));	
		
		if(chkBox != null) //԰¥.
		{
			req_date    		=	new Date[chkBox.length];
			rush_order_flag		=	new String[chkBox.length];
			req_flag			=	new String[chkBox.length];
			del_info_flag		=	new String[chkBox.length];
			rcvr_uid			=	new String[chkBox.length];
			rcvr_name			=	new String[chkBox.length];
			delivery_info		=	new String[chkBox.length];
			req_info			=	new String[chkBox.length];
			quans				=	new String[chkBox.length];
			rcvr_item_name		=	new String[chkBox.length];

			for(int i=0; i<chkBox.length; i++)
			{
				if(chkBox[i] != null)
				{
					String req_date_str 			= request.getParameter("req_date"+chkBox[i]);
					String rush_order_flag_str 		= request.getParameter("rush_order_flag"+chkBox[i]);
					String req_flag_str				= request.getParameter("req_flag"+chkBox[i]);
					String del_info_flag_str		= request.getParameter("del_info_flag"+chkBox[i]);
					String rcvr_uid_str				= request.getParameter("rcvr_uid"+chkBox[i]);
					String rcvr_name_str			= request.getParameter("rcvr_name"+chkBox[i]);
					String delivery_info_str		= request.getParameter("delivery_info"+chkBox[i]);
					String req_info_str				= request.getParameter("req_info"+chkBox[i]);
					String quans_str				= request.getParameter("quans"+chkBox[i]);
					String rcvr_item_name_str		= request.getParameter("rcvr_item_name"+chkBox[i]);
					req_date[i]					= String2Date(req_date_str);
					rush_order_flag[i]			= rush_order_flag_str;
					req_flag[i]					= req_flag_str;
					del_info_flag[i]			= del_info_flag_str;
					rcvr_uid[i]					= rcvr_uid_str;
					rcvr_name[i]				= rcvr_name_str;
					delivery_info[i]			= delivery_info_str;
					req_info[i]					= req_info_str;
					quans[i]					= quans_str;
					rcvr_item_name[i]			= rcvr_item_name_str;
					
				}
			}
		}
		else {
			req_date = new Date[0];
			rush_order_flag= new  String[0];
			req_flag= new  String[0];
			del_info_flag= new  String[0];
			rcvr_uid= new  String[0];
			rcvr_name= new  String[0];
			delivery_info= new  String[0];
			req_info= new  String[0];
			quans= new  String[0];
			rcvr_item_name= new  String[0];
		}
			
		

		dblQuan = this.String2Double(quan);
		if( sales_price != null){
			dblSales_price = this.String2Double(sales_price);
		}
		else{
			dblSales_price = this.String2Double(sales_price_str);
		}


		//UsrAst usr = SessionSecurityManager.getUser(request); //   .
		
		//Vector result = new Vector();
		List<SrcAhd> arrSrcAhd = new ArrayList<SrcAhd>();
		
		if(pj_unique_id!=null)
			if(pj_unique_id.length()>0)
				intPj_unique_id = Integer.valueOf(pj_unique_id).intValue();

				
		if(assy_unique_id!=null)
			if(assy_unique_id.length()>0)
				intAssy_unique_id = Integer.valueOf(assy_unique_id).intValue();
		
		if(part_unique_id!=null)
			if(part_unique_id.length()>0)
				intPart_unique_id = Integer.valueOf(part_unique_id).intValue();
		
		if(intAssy_unique_id < 0)// Assembly  ... Default ....
		{
			intAssy_unique_id = getCurrentAssy(request);
		}
		
//		if(part_quan!=null)
//			if(part_quan.length()>0)
//				dblPart_quan = Double.valueOf(part_quan);
		

		switch(this.getMenuId()) {
		case MN01://˻/
			switch(this.getActivityName()){
				case MODFORM:
					if(GetPartByUnique(arrSrcAhd,  part_unique_id)	) {
						menu_info.put("materiallist", 	arrSrcAhd );
					}
					else {
						menu_info.put("data", 	"縦 ã  ϴ");
					}
					
					break;
				case EDIT:
				{
					String ret = ModifyPart( unique_id, item_code, class_code,
							item_name, specification, description, standard_flag,
							maker_name, model_no, dblSales_price		);
					menu_info.put("data", 	ret);
				}
				break;
				case DELETE:
					this.DeletePartByUnique(part_unique_id );
					menu_info.put("materiallist", 
					GetPartList(
							item_code,class_code,
							item_name, specification, description,
							maker_name, model_no, sg_code, this.getThis_wa_code(request), this.getThis_company_code(request),
							this.getThis_combstuid(request)
							)
					 );
					break;
				case LISTCOND:
				default:
					menu_info.put("materiallist", 
							this.GetPartList(
							item_code,class_code,
							item_name, specification, description,
							maker_name, model_no, sg_code, this.getThis_wa_code(request), this.getThis_company_code(request),
							this.getThis_combstuid(request)
							) );
					menu_info.put("pagging", 
						toStringPage(20, totalCnt,start, map));
					break;

			}
			break;
		case MN05://Ass'y-BOM˻/
			switch(this.getActivityName()){
				case ADD://Assy 纹
					MtrlProcess_05Add(request);
					menu_info.put("data", 	"Ʈ Ͽϴ.");
					menu_info.put("URL", "d_mtrl.html?menuId=d05");
					break;
				case MODFORM:
					AssyLine assyline = MtrlProcess_05Modform(request);
					if(assyline == null) {
						menu_info.put("data","Assyline ã  ϴ.");
						menu_info.put("URL", "BACK_WARD");
					} else {
						menu_info.put("assyline", 	assyline);
					}
					
					/*
					if(GetPartByUnique(lists,  part_unique_id) ) {
						menu_info.put("materiallist", 	result );
					}
					else {
						menu_info.put("data", "縦 ã  ϴ");
						menu_info.put("URL", "d_mtrl.html?menuId=d05");
					}
					menu_info.put("data", 	result);
					*/
					break;
				case EDIT:
					MtrlProcess_05Edit(request);
					menu_info.put("data", 	"Assembly Ǿϴ.");
					menu_info.put("URL", "d_mtrl.html?menuId=d05");
					menu_info.put("materiallist", materialManager.getAllAssyLine() );
					break;
				case DELETE:
					//AssyMap Ѵ.
					//Ʒ   ڵ....Ȯο060812
					
					Integer assy_uid 	= 	this.GetRequestInteger(request, "target_assy_uid");
					//Integer pj_uid 	= 	this.GetRequestInteger(request, "pj_unique_id");
					materialManager.removeRelation2Project(/*pj_uid, */assy_uid);
					/*
					if( real_delete.compareTo("1") == 0 ) { //DB 
						this.DeletePartByUnique(part_unique_id );
					}
					*/
					
					menu_info.put("materiallist", materialManager.getAllAssyLine() );
					menu_info.put("data", 	"Assembly Ǿϴ.");
					menu_info.put("URL", "d_mtrl.html?menuId=d05");
					
					//d08 ȣ  Ͽ 
					MtrlProcess_08Def(intPj_unique_id,intAssy_unique_id, request, menu_info);

					/*
					menu_info.put("materiallist",
							this.GetPartListOnlyAssy(
							item_code,class_code,
							item_name, specification, description,
							maker_name, model_no) );
							*/
					break;
				default:
					menu_info.put("materiallist", materialManager.getAllAssyLine() );
				/*
					menu_info.put("materiallist", 	this.GetPartListOnlyAssy(
							item_code,class_code,
							item_name, specification, description,
							maker_name, model_no) );
							*/
					break;
			}
			break;
		
		case MN02://ǥر԰ǰ
		case MN03://Ŀǰ
		case MN04://ǰ
			switch(this.getActivityName()){
				case MODFORM:
					//d08 °츦 Ͽ صд.
					String this_page = this.GetRequestString(request, "thisPage");
					menu_info.put("where_from", 	this_page);
					if(GetPartByUnique(arrSrcAhd,  part_unique_id) ) {
						menu_info.put("materiallist", 	arrSrcAhd );
						
						Integer assy_uid = this.GetRequestInteger(request, "assy_uid");
						
						Vector<Map<String, String>> pl_info_vec = new Vector<Map<String, String>>();
						Map<String, String> pl_info = new HashMap<String, String>();
						pl_info.put("part_pl_no", part_pl_no);
						pl_info.put("part_quan", part_quan);
						pl_info_vec.add(pl_info);
						
						menu_info.put("pl_info", 	pl_info_vec);
						menu_info.put("assy_uid",   assy_uid);

					}
					else {
						menu_info.put("data", 	"縦 ã  ϴ");
					}
					break;
				case ADD:
				{
				   	String my_part_item_code = this.GetRequestString(request, "my_part_item_code");
				   	Integer my_part_assy_uid = this.GetRequestInteger(request, "my_part_assy_uid");
				   	
					Object object = null;
					if( is_new.compareToIgnoreCase("N")== 0 && prev_code!=null){ //ڵ ̸
						
						//ǰ񿡼 Դٸ Update Ѵ.
						if(my_part_item_code.compareToIgnoreCase(prev_code)==0 && my_part_assy_uid>0)
						{
							object = UpdateRelation(menu_info, my_part_assy_uid, "N" , 
									intAssy_unique_id, intPj_unique_id, pl_code, dblQuan, pj_unique_id,
									my_part_item_code, this.getThis_userid(request)
									);
						}
						else {//ٸ ڵ̸ AssyMap ߰
							object = materialManager.getMaterialByItem_code(prev_code);
							AddRelation(menu_info, (SrcAhd)object, "N" , request,
									intAssy_unique_id, intPj_unique_id, pl_code, dblQuan, pj_unique_id,
									/*item_code*/prev_code, dblSales_price, false,-1);
						}
					}
					if(object == null)	{//űԵ̸
						object = AddMaterial(menu_info, request,
								standard_flag, item_code, class_code,
								item_name,  specification,  description,
								maker_name,  model_no,  dblSales_price
								);
						AddRelation(menu_info, (SrcAhd)object, "Y" , request,
								intAssy_unique_id, intPj_unique_id, pl_code, dblQuan, pj_unique_id,
								item_code, dblSales_price, false,-1);
					}
					//d08 ȣ  Ͽ 
					MtrlProcess_08Def(intPj_unique_id,intAssy_unique_id, request, menu_info);
				}
				break;
				case EDIT:
				{
					String where_from = this.GetRequestString(request, "where_from");
					//d08 ȣ  Ͽ 
					if(where_from.compareToIgnoreCase("d08")==0) {
						MtrlProcess_08Def(intPj_unique_id,intAssy_unique_id, request, menu_info);
					}
					if(is_add_quan!=null && is_add_quan.compareToIgnoreCase("Y") == 0) {//߰
						
						Integer assy_uid 	= 	this.GetRequestInteger(request, "assy_uid");
						Double	addQuan			=	this.GetRequestDouble(request, "part_quan");
						
						if(assy_uid>0) {
							materialManager.addPartQuan(assy_uid, addQuan, this.getThis_userid(request), this.getThis_useruid(request) );
							menu_info.put("data", 	"߰ ");
						}
						
					}
					else {//BOM 
						Integer assy_uid 	= 	this.GetRequestInteger(request, "assy_uid");
						materialManager.modifyRelation(assy_uid, pl_code, dblQuan, dblSales_price);

						String ret = ModifyPart( unique_id, item_code,class_code,
								item_name, specification, description, standard_flag,
								maker_name, model_no, dblSales_price		);
						menu_info.put("data", 	ret);
					}
				}
				break;
				case DELETE://Assembly 
				{
					Integer assy_uid 	= 	this.GetRequestInteger(request, "assy_uid");
					materialManager.removeRelation2Assembly(assy_uid, intAssy_unique_id, intPart_unique_id);
					
					if( real_delete.compareTo("1") == 0 ) { //DB 
						this.DeletePartByUnique(part_unique_id );
					}
					
					String where_from = this.GetRequestString(request, "thisPage");
					//d08 ȣ  Ͽ 
					if(where_from.compareToIgnoreCase("d08")==0) {
						MtrlProcess_08Def(intPj_unique_id,intAssy_unique_id, request, menu_info);
					}
				}
				break;
				default://Է
				{
					// Auto completer
					PairList pair_list_material = this.myInfoManager.getEnvList("#SYSINFO#", "STAN_MATERIAL");
					menu_info.put("material_group",  pair_list_material.getVecPair() );
					//ó Auto completer
					PairList pair_list_treatment = this.myInfoManager.getEnvList("#SYSINFO#", "STAN_TREATMENT");
					menu_info.put("treatment_group",  pair_list_treatment.getVecPair() );
				}

				break;
			}
			if( intAssy_unique_id > 0)
			{
				List listPL = materialManager.getPartListByParent(intAssy_unique_id);
				menu_info.put("partlist", 	listPL );
			}
			break;
		case MN19://ǥ
			switch(this.getActivityName()){
			case ADD:
				{
					String standard_key = this.GetRequestString(request, "standard_key");
					String is_my_part = this.GetRequestString(request, "registMyPart");
					SrcAhd srcahd = AddMaterial(menu_info, request,
							"S", item_code, class_code,
							item_name,  specification,  description,
							maker_name,  model_no,  dblSales_price
							);
					
					if(is_my_part!=null & is_my_part.compareToIgnoreCase("Y")==0)
					{
						int[] uid_array= new int[1];
						uid_array[0]=srcahd.getUnique_id();
						materialManager.addCart( this.getThis_user_name(request), this.getThis_userid(request), this.getThis_useruid(request), uid_array, 1, this.getThis_combstuid(request));
					}
					
					menu_info.put("standard_key", 	standard_key );
					menu_info.put("registMyPart", 	is_my_part );
				
				}
				break;
			}
			break;
		case MN11://Ass'y߰
			switch(this.getActivityName()){
				case ADD:
				{
					SrcAhd srcahd = AddMaterial(menu_info, request,
							"A", item_code, "A000000000",
							item_name,  specification,  description,
							maker_name,  model_no,  dblSales_price
							);
					
					boolean parent_is_project = true;//true: Assy, false: sub assy
					String parentType = this.GetRequestString(request, "PARENT_TYPE");
					if(parentType.compareToIgnoreCase("ASSEMBLY")==0) {//sub assy
						parent_is_project = false;
					}
					int hierarchy_level = -1;
					if(parent_is_project==true){
						hierarchy_level = 1;
					}
					else {
						hierarchy_level = this.GetRequestInteger(request, "assy_level")+1;
						
						if(hierarchy_level<1)
							hierarchy_level = 1;
					}

					//int intAssy_unique_id_new =-1;
					if( srcahd != null)
					{
						/*intAssy_unique_id_new = */AddRelation(menu_info, srcahd, "Y" , request,
							intAssy_unique_id, intPj_unique_id, pl_code, dblQuan, pj_unique_id, item_code, dblSales_price,
							parent_is_project,	hierarchy_level);
					}
					//d08 ȣ  Ͽ 
					MtrlProcess_08Def(intPj_unique_id,intAssy_unique_id, request, menu_info);

				}
					break;
				default://Է
				break;
			}
			break;
		case MN06://Ass'y-BOM ߰
			break;
		case MN07://Ass'yġ
			break;
		case MN08://ƮBOM˻/
			switch(this.getActivityName())
			{
				case ADD:
					
					String add_type= this.GetRequestString(request, "ADD_TYPE");
					
					if(add_type.compareToIgnoreCase("PART_COPY")==0) {
						Integer i=0;
						String retStrValue = "";
						for( ; i<chkBox.length; i++)
						{
							if(i!=0) {
								retStrValue = retStrValue + ",";
							}
							retStrValue = retStrValue + chkBox[i];

						}
						
						this.myInfoManager.setEnvRaw(this.getThis_userid(request), "COPIED_PARTS_NUM", i.toString());
						this.myInfoManager.setEnvRaw(this.getThis_userid(request), "COPIED_PARTS", retStrValue);

						MtrlProcess_08Def(intPj_unique_id,intAssy_unique_id, request, menu_info);

					}
					else if(add_type.compareToIgnoreCase("PART_PASTE")==0) {

						String retStrValue =  this.myInfoManager.getEnvRaw(this.getThis_userid(request), "COPIED_PARTS");

						if(retStrValue!=null && retStrValue.length()!=0) {
							String[] arrAssyUids = retStrValue.split(",");
							
							for(int i=0; i<arrAssyUids.length; i++) {
								materialManager.copyAssyMap(Integer.parseInt(arrAssyUids[i]), intAssy_unique_id, this.getThis_userid(request), intPj_unique_id, this.getThis_useruid(request));
							}
						}

						this.myInfoManager.setEnvRaw(this.getThis_userid(request), "COPIED_PARTS", "");
						this.myInfoManager.setEnvRaw(this.getThis_userid(request), "COPIED_PARTS_NUM", "0");
						
						MtrlProcess_08Def(intPj_unique_id,intAssy_unique_id, request, menu_info);

					}
					else {
						//ٷ ſû 
						//addPurchageRequestSimpleAssymapUniqueId(result);
						//īƮ 
						addCartSimpleAssymapUniqueId( request, chkBox );
						menu_info.put("data", "īƮ . ſû ȭ ̵մϴ.");
						menu_info.put("URL", "b_rtng.html?menuId=b02");
					}

					break;
				default:
					//this.myInfoManager.setEnv(this.getThis_userid(request), "COPIED_PARTS", "");
					//this.myInfoManager.setEnv(this.getThis_userid(request), "COPIED_PARTS_NUM", "0");
					MtrlProcess_08Def(intPj_unique_id,intAssy_unique_id, request, menu_info);
					break;
			}
			break;
		case MN09://BOM߰
			break;
		case MN10://ٸBOMҷ
			break;
		case MN12:
			break;	
		case MN16://īƮƮҷ. hyun suk oh
			switch(this.getActivityName())
			{
				case ADD:
					addCart( request, 	chkBox);
					menu_info.put("data","߰Ϸ");
					//menu_info.put("URL", "b_rtng.html?menuId=d01");
					menu_info.put("URL", "BACK_WARD");
					break;
				case DELETE: 
					DeleteCart2Bom( request,  chkBox);

					menu_info.put("data","īƮ Ϸ");
					menu_info.put("URL", "b_rtng.html?menuId=b02");
					break;
				case EDIT: //īƮ
				{
					String ret = editPurchangeRequestList( chkBox, quans,
							rcvr_uid, rcvr_name, rush_order_flag, req_date, req_flag, delivery_info,
							del_info_flag, req_info);
					
					menu_info.put("data", ret);	
					menu_info.put("URL", "BACK_WARD");
				}
				break;			
				default :
					//k1park
					menu_info.put("cartList", materialManager.getCartList(this.getThis_useruid(request) ) );
					//menu_info.put("cartList", this.getCartList(usr.getPr_po_type(),usr.getUnique_id()));
					break;
			}
			break;
		case MN17://ſû. 06.3.22 
			/*
			switch(this.getActivityName())
			{
				case ADD:
					addPurchageRequest( result, request,  chkBox,
								 rcvr_item_name,  quans, rcvr_uid,
								 rcvr_name,  rush_order_flag, req_date, req_flag, delivery_info,
								 del_info_flag,  req_info	 );
					menu_info.put("data",result);
					break;
				case DELETE: //ſû
					cancelPurchangeRequest(result, chkBox, request);
					menu_info.put("data",result);
					break;
				case EDIT: //ſû
					editPurchangeRequestList(result, chkBox, quans,
							rcvr_uid, rcvr_name, rush_order_flag, req_date, req_flag, delivery_info,
							del_info_flag, req_info);
					
					result.add("Ϸ");	
					result.add("d_mtrl.html?menuId=d17");						
					menu_info.put("data",result);
					break;					
				default :
					menu_info.put("cartList", materialManager.getPurchageRequestHeadList(this.getThis_userid(request) ) );
					break;
			}
			*/
			break;	
		case MN18://ǰ
			switch(this.getActivityName())
			{
				case DELETE: 
					DeleteCart2Bom( request,  chkBox);
					menu_info.put("data","ǰ񿡼 Ǿϴ.");
					menu_info.put("URL", "d_mtrl.html?menuId=d18");
					break;		
				default :
					menu_info.put("partlinelist", materialManager.getMyNeedList(this.getThis_useruid(request)) );
					break;
			}
			break;
		case MN22://˻/(PO)
			switch(this.getActivityName()){
				case MODFORM:
					if(GetPartByUnique(arrSrcAhd,  part_unique_id)	) {
						menu_info.put("materiallist", 	arrSrcAhd );
					}
					else {
						menu_info.put("data", 	"縦 ã  ϴ");
					}
					
					break;
				case EDIT:
				{
					String ret = ModifyPart( unique_id, item_code, class_code,
							item_name, specification, description, standard_flag,
							maker_name, model_no, dblSales_price		);
					menu_info.put("data", 	ret);
				}
				break;
				case DELETE:
					this.DeletePartByUnique(part_unique_id );
					menu_info.put("materiallist", 
					GetPartList(
							item_code,class_code,
							item_name, specification, description,
							maker_name, model_no, sg_code, this.getThis_wa_code(request), this.getThis_company_code(request),
							this.getThis_combstuid(request)
							)
					 );
					break;
				case LISTCOND:
				default:
					menu_info.put("materiallist", 
							this.GetPartList(
							item_code,class_code,
							item_name, specification, description,
							maker_name, model_no, sg_code, this.getThis_wa_code(request), this.getThis_company_code(request),
							this.getThis_combstuid(request)
							) );
					menu_info.put("pagging", 
							toStringPage(20, totalCnt,start, map));
					break;
				
			}
			break;
			
		case MN20:
		switch(this.getActivityName()){
			case ADD:
			{
				
				String file_group_code= this.GetRequestString(request, "file_group_code");
				String[] file_item_code= request.getParameterValues( "file_item_code" );
				String up_load_type = this.GetRequestString(request, "up_load_type");
				RegistType type= RegistType.valueOf(up_load_type);
				int quanFile=file_item_code.length;
				String excelPath = this.materialManager.getSystemInfo().getUploadPath();
				
				String mid_group_key=file_group_code.substring(0, 4);
				
				String ret = registMaterilaFromExcel( request,	type,
						quanFile,	excelPath,	file_group_code, file_item_code,	mid_group_key,
						intPj_unique_id, intAssy_unique_id, assy_item_code.substring(0, 8));
				
				menu_info.put("data",  ret + "/ ׷ڵ : " + mid_group_key);
				
			}
			break;
			default:
				menu_info.put("project",  getCurProjectForm(request) );
				break;
		}
		break;
		case MN31:	//ǥ 
		{
			switch(this.getActivityName())
			{
				case ADD:
				{
					String[] arrKey		= request.getParameterValues("varKey");
					String[] arrVal		= request.getParameterValues("varValue");
					
					String strEnv = "";
					int quanPair = 0;
					for(int i=0; (i<arrKey.length) && (i<arrVal.length); i++) {
						String first = arrKey[i];
						String second = arrVal[i];
						
						if(first!=null && first.length()>0 && second!=null && second.length()>0)
						{
							if(quanPair!=0) {
								strEnv = strEnv + ",";
							}
							strEnv = strEnv + first + ":" + second;
							quanPair++;
						}
						
						this.myInfoManager.setEnvRaw("#SYSINFO#", "STAN_MATERIAL", strEnv);
						
						menu_info.put("data","ǥ  Ͽϴ.");
						menu_info.put("URL", "d_mtrl.html?menuId=d31");
					}//end of for
				
				}//end of case
				break;
				default:
				{	
					/*
					Vector<String> stan_name_label = new Vector();
					
					stan_name_label.add("ǥ ");
					stan_name_label.add("ǥ ó");
					
					menu_info.put("stan_name_group",  stan_name_label );
					*/
					PairList pair_list_material = this.myInfoManager.getEnvList("#SYSINFO#", "STAN_MATERIAL");
					Vector<Pair> vecMat = pair_list_material.getVecPair();
					
					if (vecMat==null) {
						vecMat = new Vector<Pair>();			
					}//end of if
					
					FillMaxSize(vecMat);		
					menu_info.put("material_group",  vecMat );
				}//end of default
				break;
	
			}//end of switch
		}//end of case
		break;
		case MN32:
		{
			switch(this.getActivityName())
			{
				case ADD:
				{
					String[] arrKey		= request.getParameterValues("varKey");
					String[] arrVal		= request.getParameterValues("varValue");
					
					String strEnv = "";
					int quanPair = 0;
					for(int i=0; (i<arrKey.length) && (i<arrVal.length); i++) {
						String first = arrKey[i];
						String second = arrVal[i];
						
						if(first!=null && first.length()>0 && second!=null && second.length()>0)
						{
							if(quanPair!=0) {
								strEnv = strEnv + ",";
							}
							strEnv = strEnv + first + ":" + second;
							quanPair++;
						}
						
						this.myInfoManager.setEnvRaw("#SYSINFO#", "STAN_TREATMENT", strEnv);
						
						menu_info.put("data","ǥ ó  Ͽϴ.");
						menu_info.put("URL", "d_mtrl.html?menuId=d32");
					}//end of for
				
				}//end of case
				break;
				default:
				{	
					PairList pair_list_treatment = this.myInfoManager.getEnvList("#SYSINFO#", "STAN_TREATMENT");
					Vector<Pair> vecTrt = pair_list_treatment.getVecPair();
					
					if (vecTrt==null) {
						vecTrt = new Vector<Pair>();			
					}
					
					FillMaxSize(vecTrt);
					menu_info.put("treatment_group",  vecTrt );
				}//end of default
				break;
	
			}//end of switch
		}//end of case
		break;
		case MN40: //˾â
			//menu_info.put("list", materialManager.getMaterialByItem_code(item_code) );
			menu_info.put("material",materialManager.getDetail(item_code, this.getThis_combstuid(request)));
			break;
		default:
			logger.info("    Դϴ.");
			return;
			
		}
		
		//Default Project/Assembly Setting.....
		// Ʈ Assembly ǹǷ ߿ ؾ Ѵ.
		//-----------------------------------
		int pj_id = SetDefaultProject(intPj_unique_id, menu_info, request);
		if( pj_id > -1)
			SetDefaultAssembly(pj_id, menu_info, request);
		

	}

	enum RegistType { MASTR_ONLY, WITH_BOM }
	final private String PL_NO_KEY_CHARS = "_0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
	
	private String GetPlKey(String inStr) {
		String retStr = "";
		
		for(int i=0; i<inStr.length(); i++) {
			char ch = inStr.charAt(i);
			if(ch == '.')
				return retStr;
			if(PL_NO_KEY_CHARS.indexOf(ch) != -1)
			//	retStr = retStr + "_";
			//else
				retStr = retStr + ch;
		}
		return retStr;
	}
	
	private void 	convertBuffer2SrcAhd(RegistType type,  String[] buffer, String[] gubun, String[] item_name, String[] specification,
			String[] model_no, String[] description, String[] maker_name, Double[] bm_quan, String[] pl_no,
			String[] class_code, Double[] sales_price) {
		
		String my_class_code = buffer[GUBUN];
		
		if(my_class_code.length()>4)
			my_class_code = my_class_code.substring(0, 4);
		
		if(my_class_code.compareToIgnoreCase("BEAR")==0 ) {
			my_class_code = "BEAR000000";
		}
		else if(my_class_code.compareToIgnoreCase("PNEU")==0 ) {
			my_class_code = "PNEU000000";
		}
		else if(my_class_code.compareToIgnoreCase("MOTO")==0 ) {
			my_class_code = "MOTO000000";
		}
		else if(my_class_code.compareToIgnoreCase("MECH")==0 ) {
			my_class_code = "MECH000000";
		}
		else if(my_class_code.compareToIgnoreCase("SENS")==0 ) {
			my_class_code = "SENS000000";
		}
		else if(my_class_code.compareToIgnoreCase("PLCP")==0 ) {
			my_class_code = "PLCP000000";
		}
		else if(my_class_code.compareToIgnoreCase("CONN")==0 ) {
			my_class_code = "CONN000000";
		}
		else if(my_class_code.compareToIgnoreCase("ELEC")==0 ) {
			my_class_code = "ELEC000000";
		}
		else {
			my_class_code = "UNKN000000";
		}
		
		String my_gubun = buffer[GUBUN];
		
		if(my_gubun.length()>4)
			my_gubun = my_gubun.substring(0, 4);

		if(		my_gubun.compareToIgnoreCase("BEAR")!=0  &&
				my_gubun.compareToIgnoreCase("PNEU")!=0  &&
				my_gubun.compareToIgnoreCase("MOTO")!=0  &&
				my_gubun.compareToIgnoreCase("MECH")!=0  &&
				my_gubun.compareToIgnoreCase("SENS")!=0  &&
				my_gubun.compareToIgnoreCase("PLCP")!=0  &&
				my_gubun.compareToIgnoreCase("CONN")!=0  &&
				my_gubun.compareToIgnoreCase("ELEC")!=0 ) {
			my_gubun = "UNKN";
		}

		gubun[0]		= my_gubun;								//
		item_name[0]	= buffer[ITEM_NAME];					//ǰ
		specification[0]= buffer[SPECIFICATION];				//԰
		model_no[0]		= buffer[MODEL_NO];						//,
		description[0]	= buffer[DESCRIPTION];					//ó
		maker_name[0]	= buffer[MAKER_NAME];					//
		class_code[0]	= my_class_code;						//class code
		
		
		if(buffer[SALES_PRICE] == null)
			sales_price[0] = 0.0;
		else if(buffer[SALES_PRICE].length()==0)
			sales_price[0] = 0.0;
		else
			sales_price[0]	= Double.parseDouble( buffer[SALES_PRICE] );
		
		
		
		if(type == RegistType.WITH_BOM) {
			Integer unique_id = createRandNumber();
			String pl_key 	= Integer.toHexString(unique_id).toUpperCase();
			pl_key = pl_key.substring(0, 4);
			
			if(buffer[BM_QTY]==null)
				bm_quan[0] = 1.0;
			else if (buffer[BM_QTY].length()==0)
				bm_quan[0] = 1.0;
			else
				bm_quan[0]		= Double.parseDouble( buffer[BM_QTY] );	//()
			
			String strPl_no = "";
			strPl_no = strPl_no + buffer[PL_NO];						//ȣ(4)
			
			if(strPl_no==null){
				pl_no[0] = pl_key;
			}
			else if(strPl_no.length()==0){
				pl_no[0] = pl_key;
			}
			else if(strPl_no.compareToIgnoreCase("null")==0){
				pl_no[0] = pl_key;
			}
			else
			{
				strPl_no = GetPlKey(strPl_no);
				if(strPl_no.length()>4) {
					pl_no[0] = strPl_no.substring(0, 4);
				}

				else {
					while(strPl_no.length() < 4) {
						strPl_no = "0" + strPl_no;
					}
					pl_no[0] = strPl_no;
				}
			}
			
		}
	}

	private String returnNotNull(String in) {
		if (in==null) {
			return "";
		}
		else {
			return in;
		}
	}

	public String registMaterilaFromExcel( HttpServletRequest request,
			RegistType type,
			int file_length,
			String excelPath,
			String file_group_code,
			String[] file_item_code,
			String mid_group_key,
			int intPj_unique_id, int intAssy_unique_id, String strAssyCode8)
	{

		int minFieldQuan = 7;
		if(type==RegistType.WITH_BOM)
			minFieldQuan = 9;

		for(int j=0; j < file_length; j++)
		{
//			try
//			{
				String fileName 		= excelPath + file_group_code+ "-" + file_item_code[j];
				ExcelFileController efc = new ExcelFileController(fileName);
				Vector returned=null;
				try {
					returned = efc.readExcelFile(false/*ù° Ʈ д´*/);
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
				if(returned==null) {
					return " б Դϴ.";
				}
				
				String[] buffer = (String[])returned.get(0);
				
				
				if(buffer.length < minFieldQuan)
				{
					return "   ʵ  ʹ ϴ.(ּҰ: =6, BOM=8)";
				}
				
				
				
				for(int i = 1; i < returned.size(); i++)
				{
					buffer = (String[])returned.get(i);
					String[] output = new String[minFieldQuan];
					
					int k=0;
					for(; k< buffer.length && k<minFieldQuan ; k++) {
						output[k] = returnNotNull(buffer[k]);
					}
//					for(; k< minFieldQuan; k++) {
//						output[k] = "";
//					}
					
					String[] gubun			=  new String[1];		//籸
					String[] item_name		=  new String[1];	//ǰ
					String[] specification	=  new String[1];	//԰
					String[] model_no		=  new String[1];	///
					String[] description	=  new String[1];	//ó
					String[] maker_name		=  new String[1];	//
					Double[] sales_price		=  new Double[1];	//
					
					String[] class_code		=  new String[1];	//
					
					Double[] bm_quan		=  new Double[1];	//()
					String[] pl_no			=  new String[1];	//ȣ(4)			
					
					// ̰ 5Ÿũ item_code Ȱ
					boolean gubunIs_item_code = true;
					String item_code = output[GUBUN];
					String myClass_code = "O000000000";
					String standardFlag	= "O";
					if(	item_code != null &&
							item_code.length() > 0 &&
							item_code.length() < 6	//gubun length 1,2,3,4,5̸ ¥
							
					) {
						gubunIs_item_code = false;
					}
					
					convertBuffer2SrcAhd( type, output, gubun, item_name, specification,
							model_no, description, maker_name, bm_quan, pl_no, class_code, sales_price);
					
					if(item_name[0]!=null && item_name[0].length()>0) {//̸  Է¾.
					
					
						Integer unique_id = createRandNumber();
						
						if(gubunIs_item_code==false) {
							String end_key 	= Integer.toHexString(unique_id).toUpperCase();
							end_key = end_key.substring(0, 4);
							item_code = gubun[0] + mid_group_key + end_key;
							
							myClass_code = class_code[0];
							standardFlag = "S";
						}
						
						SrcAhd srcahd 	= new SrcAhd();
						srcahd.setUnique_id	(unique_id);
						srcahd.setClass_code(myClass_code);
						srcahd.setItem_code(item_code);
						srcahd.setItem_name(item_name[0]);
						srcahd.setSpecification(specification[0]);
						srcahd.setModel_no(model_no[0]);
						srcahd.setDescription(description[0]);
						srcahd.setMaker_name(maker_name[0]);
						srcahd.setSales_price(sales_price[0]);
						srcahd.setStandard_flag(standardFlag);
						srcahd.setSg_code(mid_group_key);
						
						//BOM  AssyCode  ä
						if(type==RegistType.WITH_BOM &&
								gubunIs_item_code==false/* ڵ  ʴ */) {
							String strPlNoTmp = pl_no[0];
							if(strPlNoTmp.length() > 4)
							{
								strPlNoTmp = strPlNoTmp.substring(0,4);
							}
							while(strPlNoTmp.length()<4)
								strPlNoTmp = "0" + strPlNoTmp;
								
							srcahd.setItem_code(strAssyCode8 + strPlNoTmp);
						}
						
						this.materialManager.addMtrl(this.getThis_userid(request), srcahd);
						
						if(type==RegistType.WITH_BOM) {
							materialManager.addRelation2Assembly(
									this.getThis_userid(request),
									this.getThis_useruid(request),
									intAssy_unique_id,
									unique_id,
									pl_no[0],
									bm_quan[0],
									"Y",
									intPj_unique_id,
									item_code,
									sales_price[0],
									sales_price[0],-1);	
						}
					
					}
				}
//			}
//			catch(Exception e)
//			{
//				return "[] " + e;
//			}
		}
		return " Է ";
	}
	
	
	/*
	 * 05.03.16 hyun suk oh
	 * ¹ Ÿ .
	 */
	public Map typeSet(String type)
	{
		String cartType 	= "";
		String assyStatus 	= "";
		
		Map<String, String> typeMap = new HashMap<String, String>();
		
	 	if(type.equals("PR")) //PRڸ
	 	{
	 		cartType 	= "R"; 
	 		assyStatus 	= "CR"; 
	 	}
	 	else if(type.equals("PO")) //POڸ
	 	{
	 		cartType 	= "O"; 
	 		assyStatus 	= "CO";      		
	 	}
	 	typeMap.put("cartType",cartType);
	 	typeMap.put("assyStatus",assyStatus);
	 	
	 	return typeMap;
	}
 	
	/*
	 * 05.03.16 hyun suk oh
	 * īƮƮ 
	 
	private List getCartList(String type, Integer unique_uid)
	{
		Map cartMap = new HashMap();
		Map cartMapInfo = new HashMap();
		cartMapInfo = this.typeSet(type);
		cartMap.put("type",cartMapInfo.get("cartType"));
		cartMap.put("unique_uid",unique_uid);
		logger.info(type);
		logger.info(unique_uid);
		return materialManager.getCartList(cartMap);
	}
	*/	

	//06.3.20 hyun suk oh  īƮ߰
	private void addCart( HttpServletRequest request, String[] 	chkBox) {
		
		int intUnique_id;
		
		int[] uid_array= new int[MAX_RECORD_QUAN];
		if(chkBox != null)
		{
			logger.info("all cartadd");
			logger.info(chkBox.length);
			int i=0;
			for(; i<chkBox.length; i++)
			{
				intUnique_id = Integer.parseInt(chkBox[i]);
				uid_array[i]=intUnique_id;
			}
			materialManager.addCart( this.getThis_user_name(request), this.getThis_userid(request), this.getThis_useruid(request), uid_array, i, this.getThis_combstuid(request));
		}
	}
	
	//06.3.20 hyun suk oh  īƮ
	@SuppressWarnings("unused")
	private void DeleteCart( Vector<String> result, HttpServletRequest request, String[] chkBox, String part_unique_id) {
		
		int child_id;
		result.add("Ϸ");	
		result.add("d_mtrl.html?menuId=d16");
		List<Integer> cartList = new ArrayList<Integer>();
		logger.info(chkBox);
		if(chkBox == null || part_unique_id != null)				//ϳǼ̸.
		{
			child_id = Integer.parseInt(part_unique_id);
			logger.info(child_id);
			materialManager.deleteCart(child_id, this.getThis_useruid(request) );
		}
		else														// ̸.
		{
			logger.info("all remove");
			logger.info(chkBox.length);
			
			for(int i=0; i<chkBox.length; i++)
			{
				child_id = Integer.parseInt(chkBox[i]);
				logger.info(child_id);
				cartList.add(child_id);
				
			}
			materialManager.deleteCart(cartList, this.getThis_useruid(request));
		}

	}	
	
	//īƮ BOM 
	private void DeleteCart2Bom( HttpServletRequest request, String[] chkBox) {
		
		Integer assymap_uids[] = new Integer[MAX_RECORD_QUAN];
		
		chkBox				=	request.getParameterValues("chkBox");
		
		int i=0;
		for(; i<chkBox.length; i++)
		{
			assymap_uids[i] = Integer.parseInt(chkBox[i]);
		}
		
		materialManager.deleteCart2Bom(new Integer(i), assymap_uids, this.getThis_userid(request));

	}	
	
	
	
	//06.3.22  : ſû
	/*
	private void addPurchageRequest(Vector result, HttpServletRequest request, String[] chkBox,
			String[] rcvr_item_name, String[] quans, String[] rcvr_uid,
			String[] rcvr_name, String[] rush_order_flag, Date[] req_date, String[]req_flag, String[] delivery_info,
			String[] del_info_flag, String[] req_info	 )
	{
		int item_uid = -1;

		int user_uid   = this.getThis_useruid(request);//α ̵
		String user_id	= this.getThis_userid(request);
		int po_user_uid = SessionSecurityManager.getThis_po_useruid(request);
		
		Integer item_quan =	chkBox.length;
		
		if( item_quan == 0) {
			result.add("縦 ã  ϴ.");
			return;
		}
		result.add("ſûϷ");	
		result.add("d_mtrl.html?menuId=d17");	
		
		//Controller  Ȯ  Ƿ user_uid Ұش.
		//int pr_uid = routingManager.pr_addRouting(chkBox.length, rcvr_item_name[0] ,SessionSecurityManager.getUser(request));
		int pr_uid = routingManager.pr_addRouting(chkBox.length, rcvr_item_name[0], user_uid, po_user_uid);

		logger.info("ÿ  ũ̵:"+pr_uid);	
		
		List itemList = new ArrayList();

		for(int i=0; i < item_quan; i++)
		{
			AssyMap assymap = new AssyMap();
			
			if(chkBox[i] != null)
			{
				item_uid = Integer.parseInt(chkBox[i]); //child
				
				//assymap update
				assymap.setParent(user_uid);//ڵ where  						// ̵, where 
				assymap.setChild(item_uid);//ڵ, where 
				assymap.setPr_uid(pr_uid);//pr_uid
				assymap.setAc_uid(0);// 0̸    
				assymap.setPr_quan(Double.parseDouble(quans[i]));
				assymap.setQuan(Double.parseDouble(quans[i]));
				assymap.setRcvr_uid(Integer.parseInt(rcvr_uid[i]));	//μ ̵
				assymap.setRcvr_name(rcvr_name[i]); //μ̸
				assymap.setUnique_id(item_uid);//unique_id  ʴ´ ׿ 
								
				if(rush_order_flag[i] != null)	assymap.setRush_order_flag(rush_order_flag[i]);
				if(req_date[i] != null)		assymap.setReq_date(req_date[i]);
				if(req_flag[i] != null)		assymap.setReq_flag(req_flag[i]);
				if(delivery_info[i] != null)	assymap.setDelivery_info(delivery_info[i]);
				if(del_info_flag[i] != null)	assymap.setDel_info_flag(del_info_flag[i]);
				if(req_info[i] != null)		assymap.setReq_info(req_info[i]);

			}
			
			itemList.add(assymap);
		}
		
		

		materialManager.addPurchageRequest(this.getThis_useruid(request), this.getThis_po_useruid(request), itemList, WhereType.BY_UNIQUE_ID);
	}
	*/
	
	// : ſû()
	@SuppressWarnings("unused")
	private void cancelPurchangeRequest(Vector<String> result, String[] chkBox, HttpServletRequest request)
	{
		
		materialManager.cancelPurchageRequest(chkBox,this.getThis_useruid(request));	
		result.add("ҿϷ");	
		result.add("d_mtrl.html?menuId=d17");
	}
	
	
	// : ſû
	private String editPurchangeRequestList( String[] chkBox, String[] quans,
			String[] rcvr_uid,String[] rcvr_name, String[] rush_order_flag, Date[] req_date, String[]req_flag, String[] delivery_info,
			String[] del_info_flag, String[] req_info)
	{
		int item_uid = -1;

		Integer item_quan =	chkBox.length;
		
		if( item_quan == 0) {
			return "縦 ã  ϴ.";
		}
		
		List<AssyMap> itemList = new ArrayList<AssyMap>();

		for(int i=0; i < item_quan; i++)
		{
			AssyMap assymap = new AssyMap();
			
			if(chkBox[i] != null)
			{
				item_uid = Integer.parseInt(chkBox[i]);
				assymap.setUnique_id(item_uid);								//assyũ̵
				assymap.setPr_quan(Double.parseDouble(quans[i]));
				assymap.setQuan(Double.parseDouble(quans[i]));		
				assymap.setRcvr_uid(Integer.parseInt(rcvr_uid[i]));	//μ ̵
				assymap.setRcvr_name(rcvr_name[i]);
				if(rush_order_flag[i] != null)	assymap.setRush_order_flag(rush_order_flag[i]);
				if(req_date[i] != null)		assymap.setReq_date(req_date[i]);
				if(req_flag[i] != null)		assymap.setReq_flag(req_flag[i]);
				if(delivery_info[i] != null)	assymap.setDelivery_info(delivery_info[i]);
				if(del_info_flag[i] != null)	assymap.setDel_info_flag(del_info_flag[i]);
				if(req_info[i] != null)		assymap.setReq_info(req_info[i]);	
				
				logger.info(item_uid);

			}
			itemList.add(assymap);
		}	
		
		materialManager.editPurchangeRequestList(itemList);
		return "ſû ";
	}
	
	
	//assymap unique_id  û
	private void addCartSimpleAssymapUniqueId(  HttpServletRequest request, String[] chkBox )
	{
		
		Integer[] uid_array= new Integer[MAX_RECORD_QUAN];
		
		int i=0;
		for(; i<chkBox.length; i++)
		{
			String status	= 	GetRequestString(request, chkBox[i] + "_status");
			Double add_quan	= 	GetRequestDouble(request, chkBox[i] + "_quan");
			Integer assymap_uid = Integer.parseInt(chkBox[i]);
			
			if(status.compareToIgnoreCase("BM")!=0) {//Status BOM ƴϸ ߰
				Integer new_part_assy = materialManager.addPartQuan(assymap_uid, add_quan, this.getThis_userid(request), this.getThis_useruid(request) );
				uid_array[i] = new_part_assy;
			}
			else {
				uid_array[i] = assymap_uid;
			}
		}	
		
		materialManager.addCartByAssyMapUniquId(this.getThis_useruid(request), uid_array, i);

	}
	
	/*Ұ
	//assymap unique_id  û
	private void addPurchageRequestSimpleAssymapUniqueId( Vector result )
	{
		List itemList = new ArrayList();
		
		for(int i=0; i<chkBox.length; i++)
		{
			Integer assymap_uid = Integer.parseInt(chkBox[i]);
			
			logger.info(assymap_uid);
			itemList.add(assymap_uid);
		}		

		int pr_id = routingManager.pr_addRouting(itemList.size(), "BOM Žû");
		materialManager.addPurchageRequest(pr_id, itemList);

		result.add("ſûϷ");
	}
	*/
	
	private void DeletePartByUnique(String part_unique_id ) {
		if(part_unique_id == null) {
			logger.info("cannot find part unique id");
			return;
		}
		
		int intUnique_id = Integer.parseInt(part_unique_id);
			
		materialManager.deleteMtrl(intUnique_id);

	}
		
	public String ModifyPart(  String unique_id, String item_code,String class_code,
			String item_name, String specification, String description, String standard_flag,
			String maker_name, String model_no, Double dblSales_price		) {

		if( unique_id == null || unique_id.length() == 0) {
			
			return "  : " + item_code + "/" + item_name + " ˼ Unique Id";
		}
		
		Integer int_unique_id=	new Integer(unique_id);
		
		SrcAhd srcahd = materialManager.getMaterialByUnique_id(int_unique_id);
		
		if( srcahd == null ) {

			return "  : " + item_code + "/" + item_name + " SrcAhd ã ";
		}
		
		if(item_code != null)		srcahd.setItem_code(item_code);
		if(class_code != null)		srcahd.setClass_code(class_code);
		if(item_name != null)		srcahd.setItem_name(item_name);
		if(specification != null)		srcahd.setSpecification(specification);
		if(description != null)		srcahd.setDescription(description);
		if(standard_flag != null)		srcahd.setStandard_flag(standard_flag);
		if(maker_name != null)		srcahd.setMaker_name(maker_name);
		if(model_no != null)		srcahd.setModel_no(model_no);
									srcahd.setSales_price(dblSales_price);

		materialManager.modifyMtrl(srcahd);
		
		return "  : " + srcahd.getItem_code() + "/" + srcahd.getItem_name();
	}
	
	private boolean GetPartByUnique(List<SrcAhd> lists, String part_unique_id) {

		
		if(part_unique_id == null) {
			logger.info("cannot find part unique id");
			return false;
		}
		
		int intUnique_id = Integer.parseInt(part_unique_id);
		
		SrcAhd srcahd = materialManager.getMaterialByUnique_id(intUnique_id);
		
		if(srcahd!=null) {
			lists.add(srcahd);
			return true;
		}
		return false;
		
	}
	
	
	private void SetDefaultAssembly(int pj_unique , Map<String, Object> menu_info, HttpServletRequest request) {
		
		Integer new_cur_assy = getCurrentAssy(request);
		boolean	is_in_cur_project = materialManager.is_inAssyMapParentChild(pj_unique, new_cur_assy);

		
		if(is_in_cur_project == false)//Default Assy ã...
		{
			// Ʈ  Ѵ.
			new_cur_assy = SetDefaultAssemblyByProject(pj_unique, request );
			if( new_cur_assy < 0) {
				menu_info.put("data", "Ass'y ã  ϴ");
				return;
			}
		}


		SrcAhd assembly;
		assembly = materialManager.getMaterialByUnique_id(new_cur_assy);
		
		//߸ Assey ȣ̸
		if(assembly==null) {
			// Ʈ  Ѵ.
			new_cur_assy = SetDefaultAssemblyByProject(pj_unique, request );
			if( new_cur_assy < 0) {
				menu_info.put("data", "Ass'y ã  ϴ");
				return;
			}
		}

		assembly = materialManager.getMaterialByUnique_id(new_cur_assy);
		
		Vector<SrcAhd> vectors = new Vector<SrcAhd>();
		vectors.add(assembly);
		menu_info.put("assembly", vectors);


	}
	
	private int SetDefaultAssemblyByProject(int pj_unique, HttpServletRequest request )
	{
		if(pj_unique < 0 )
			return -1;
		
		List assys = materialManager.getAssyListByPjUnique(pj_unique);
		
		for(Iterator i=assys.iterator(); i.hasNext();) {
			SrcAhd srcahd = (SrcAhd)i.next();
			int new_cur_assy = srcahd.getUnique_id();
			setCurrentAssy(request, new Integer(new_cur_assy).toString() );
			return new_cur_assy;
		}

		return -1;

	}
	
	private int SetDefaultProject(int intPj_unique_id, Map<String, Object> menu_info, HttpServletRequest request) {
			
		Integer pj_uid = intPj_unique_id;
		if(pj_uid<0) {
			pj_uid = getCurrentProject(request);
		}

		Project	project=this.materialManager.getProject(pj_uid);

		
		if(project!=null) {
			Vector<Project> vectors = new Vector<Project>();
			vectors.add(project);
			menu_info.put("project", vectors);
			return project.getUnique_id();
		}
		else {
			menu_info.put("data", "Ʈ ã  ϴ. ۾ Ʈ ϼ.");
			return -1;
		}
	}
	
	
	private SrcAhd AddMaterial(Map<String, Object> menu_info, HttpServletRequest request,
			String standard_flag,String item_code,String class_code,
			String item_name, String specification, String description,
			String maker_name, String model_no, Double dblSales_price
			)
	{
		
		SrcAhd	srcahd = new SrcAhd();
		srcahd.SetDefault();
		
		if(standard_flag==null) standard_flag = "S";
		String msg = " ߰ : ";
		
		logger.info(standard_flag);
		
		switch(this.getMenuId()) {
		case MN02://ǥؾ ߰
		case MN03://Ŀ ߰
		case MN04://ǰ ߰
		case MN19://縶߰
			srcahd.setStandard_flag(standard_flag);
			break;
		case MN11://Assembly ߰
			msg = "Ass'y ߰ : ";
			srcahd.setStandard_flag("A");
			break;
		}
		
		srcahd.setItem_code(item_code);
		srcahd.setClass_code(class_code);
		srcahd.setItem_name(item_name);
		srcahd.setSpecification(specification);
		srcahd.setDescription(description);
		srcahd.setMaker_name(maker_name);
		srcahd.setModel_no(model_no);
		srcahd.setSales_price(dblSales_price);
		srcahd.setCreator(	this.getThis_userid(request) );
		
		materialManager.addMtrl(this.getThis_userid(request), srcahd);
		
		menu_info.put("data", msg + item_code + "/" + item_name);
		
		return srcahd;
	}
	

//	private void DeleteRelation(Map<String, Object> menu_info, int assy_uid/*, int parent, int child*/) {
//		materialManager.removeRelation(assy_uid);
//		
//	}


	private AssyMap UpdateRelation(Map<String, Object> menu_info, Integer assy_uid,
			String is_new ,
			int intAssy_unique_id,
			int intPj_unique_id,
			String pl_code,
			Double dblQuan,
			String pj_unique_id, String item_code, String changer
	) {
		
		AssyMap assymap = materialManager.getAssyMap(assy_uid);
		if(assymap==null)
			return null;
		
		assymap.setPo_sec(assy_uid);
		assymap.setIs_new(is_new);
		assymap.setAc_uid(intPj_unique_id);
		assymap.setParent(intAssy_unique_id);
		assymap.setPl_no(pl_code);
		assymap.setBm_quan(dblQuan);
		assymap.setQuan(dblQuan);
		assymap.setItem_code(item_code);
		assymap.setStatus("BM");
		assymap.setChange_date(new Date());
		assymap.setChanger(changer);
		
		materialManager.updateAssyMap(assymap);
		
		return assymap;
		
	}
	private int AddRelation(Map<String, Object> menu_info, SrcAhd srcahd, String is_new , HttpServletRequest request,
			int intAssy_unique_id, int intPj_unique_id, String pl_code, Double dblQuan, String pj_unique_id, String item_code,
			Double dblSales_price, boolean parent_is_project,/*true:parent project, false:parent srcahd*/
			int hierachy_level
	) {

		if(parent_is_project==false) { //Assembly ߰
			if(intAssy_unique_id > -1) {// Assy ȮεǸ
				materialManager.addRelation2Assembly(this.getThis_userid(request), this.getThis_useruid(request), intAssy_unique_id, srcahd.getUnique_id(),
						pl_code, dblQuan, is_new, intPj_unique_id, item_code,
						dblSales_price, srcahd.getSource_price(), hierachy_level);

				// 縦 ϸ  Assembly ۾ Assy ٲ۴.
				//myInfoManager.SetCurrentAssy(this.getThis_userid(request), intAssy_unique_id);
		
			}
		}
		else {//Ʈ ߰
			if(intPj_unique_id > -1) {// Ʈ ȮεǸ
				materialManager.addRelation2Project(this.getThis_userid(request), this.getThis_useruid(request), intPj_unique_id, srcahd.getUnique_id(),pl_code, dblQuan, item_code,
						dblSales_price, srcahd.getSource_price());
				
				setCurrentProject(request, pj_unique_id);

			}
		}
		
		
		return srcahd.getUnique_id();

	}
	
/*
	private RtgAst NewRtgAst(String rtg_type, String head_name, String content, String user_id) {

		RtgAst rtgast = new RtgAst(rtg_type);
		
		rtgast.setName(head_name);
		rtgast.setContent(content);
		rtgast.setChange_date(rtgast.getCreate_date());
		rtgast.setChanger(rtgast.getCreator());
		rtgast.setState("S");
		rtgast.setUser_id(user_id);
		rtgast.setWork_quan(0);
		
		return rtgast;		
	}

*/

	
	@SuppressWarnings("unused")
	private List GetPartListOnlyAssy(
			String item_code,String class_code,
			String item_name, String specification, String description,
			String maker_name, String model_no
	) {
		
		Map<String, String> map = new HashMap<String, String>();

		//----- Assembly ----------------
		map.put("standard_flag",	"A");
		
		if(item_code != null && item_code.length()>0)
			map.put("item_code",	item_code);
		if(item_name != null && item_name.length()>0)
			map.put("item_name",		"%"+item_name+"%");
		if(specification != null && specification.length()>0)
			map.put("specification",	"%"+specification+"%");
		if(maker_name != null && maker_name.length()>0)
			map.put("maker_name",	"%"+maker_name+"%");
		if(model_no != null && model_no.length()>0)
			map.put("model_no",	"%"+model_no+"%");
		if(class_code != null && class_code.length()>0)
			map.put("class_code",	class_code);
		if(description != null && description.length()>0)
			map.put("description",	"%"+description+"%");
		
		return materialManager.getMtrlDynamic(map);
	}
	
	private List Filering4Exclusive(List all_list, String wa_codee) {
		//Exclusive_flag 'Y'̸鼭wa_code_code ش  List .
		
		return  all_list;
	}
	
	//  ˻
	private List GetPartList(
			String item_code,String class_code,
			String item_name, String specification, String description,
			String maker_name, String model_no, String sg_code, String wa_code, String company_code,
			Integer combst_uid
			) {
		
//		if(wa_code==null || wa_code.length()==0 ||
//				company_code==null || company_code.length()==0)
//			return null;
		
		//wa_code  Ǫ˻   srcmap  ˻ ...
		
		
		this.map  = new HashMap<String, Comparable>();
		if(item_code == null)			item_code = "";
		if(item_name == null)			item_name = "";
		if(specification == null)		specification = "";
		if(maker_name == null)			maker_name = "";
		if(model_no == null)			model_no = "";
		if(class_code == null)			class_code = "";
		if(description == null)			description = "";
		if(sg_code == null)				sg_code = "";
		
		if(item_code.length()==0 &&
				item_name.length()==0 &&
				specification.length()==0 &&
				maker_name.length()==0 &&
				model_no.length()==0 &&
				class_code.length()==0 &&
				description.length()==0 &&
				sg_code.length()==0
				)
			return null;

		map.put("standard_flag-exclude",	"A");		
		logger.info(item_code);
		logger.info(item_name);
		logger.info(specification);
		logger.info(maker_name);
		logger.info(model_no);
		
		if(item_code != null && item_code.length()>0)
			map.put("item_code",	item_code);
		if(item_name != null && item_name.length()>0)
			map.put("item_name",		"%"+item_name+"%");
		if(specification != null && specification.length()>0)
			map.put("specification",	"%"+specification+"%");
		if(maker_name != null && maker_name.length()>0)
			map.put("maker_name",	"%"+maker_name+"%");
		if(model_no != null && model_no.length()>0)
			map.put("model_no",	"%"+model_no+"%");
		if(class_code != null && class_code.length()>0)
			map.put("class_code",	class_code);
		if(description != null && description.length()>0)
			map.put("description",	"%"+description+"%");
		if(sg_code != null && sg_code.length()>0)
			map.put("sg_code",	sg_code);
		
		//map.put("combst_uid", getThis_company_uid(request));
		//map.put("offset", 6);
		//map.put("row_count", 6);
		map.put("combst_uid", combst_uid);
		totalCnt = materialManager.getSrcAhdTatalCnt(map);
		List all_list = materialManager.getSelectcond("srcahd", map, start*20, 20, "desc" );
		
		return Filering4Exclusive(all_list, wa_code);
	 
	}
	
	private List GetAssyLineList(int intPj_unique_id, HttpServletRequest request) {
		
		Integer pj_uid = intPj_unique_id;
		if(pj_uid <0)	{//Ʈ   ȯ溯 
			pj_uid = this.getCurrentProject(request);
		}
		else	{	//intPj_unique_id>0̸ Ʈ ˼(c01)   .
					//̶ ۾Ʈ ؾ.
			this.setCurrentProject(request, pj_uid.toString());
			this.setCurrentAssy(request, "-1");
		}
		//ֻ Assy  ´.
		return materialManager.getAssyLineByPjUid(pj_uid); // .getTopAssyLineByPjUid(intPj_unique_id);
	}
	
	/*
	private List GetAssyList(HttpServletRequest request) {
		
		Project project = this.myInfoManager.getCurrentProject(this.getThis_userid(request));
		
		if(project==null)
			return null;
		
		int intPj_unique_id = project.getUnique_id();
		
		return materialManager.getPartListByParent(intPj_unique_id);
	}
	*/
	
	private List getCurProjectForm(HttpServletRequest request) {
		
		List<Project> lists = new ArrayList<Project>();
		Integer pj_uid = this.getCurrentProject(request);
		Project	project=this.materialManager.getProject(pj_uid);

		
		if (project==null) {
			project =  new Project();
			project.setUnique_id(-1);
			project.setPj_code("-1");
			project.setPj_name("");
		}

//		lists = new ArrayList();
		lists.add(project);
		
		return lists;
		
	}
	private MtrlManager materialManager;
	private RtngManager routingManager;
	private PrjtManager	projectManager;	

	public PrjtManager getProjectManager() {
		return projectManager;
	}

	public void setProjectManager(PrjtManager projectManager) {
		this.projectManager = projectManager;
	}

	public MtrlManager getMaterialManager() {
		return materialManager;
	}

	public void setMaterialManager(MtrlManager materialManager) {
		this.materialManager = materialManager;
	}
	
	public final void afterPropertiesSet() throws Exception {
		if (menuManager == null) throw new BeanCreationException("Must set menuManager on MtrlManagerController");
		if (materialManager == null) throw new BeanCreationException("Must be set materialManager on MtrlManagerController");
		if (projectManager == null) throw new BeanCreationException("Must be set projectManager on MtrlManagerController");
		if (myInfoManager == null) throw new BeanCreationException("Must be set myInfoManager on MtrlManagerController");
	}

	public RtngManager getRoutingManager() {
		return routingManager;
	}

	public void setRoutingManager(RtngManager routingManager) {
		this.routingManager = routingManager;
	}
	
	public void DoPopupMenuProcess(HttpServletRequest request,HttpServletResponse response, String menuType, Map<String, Object> menu_info) {
		
	}
}
