package com.rfxsoft.justrfx.web.controller;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.BeanCreationException;
import org.springframework.beans.factory.InitializingBean;

import com.rfxsoft.justrfx.business.g_mynf.MynfManager;
import com.rfxsoft.justrfx.business.h_mynv.MynvManager;
import com.rfxsoft.justrfx.domain.UsrAst;
import com.rfxsoft.justrfx.domain.Board;
import com.rfxsoft.justrfx.domain.command.JrServiceName;

public class MynvManagerController extends AbstractMenuTileController implements InitializingBean {
	
	String unique_id;
	String user_id;
	String board_name;
	String board_email;
	String board_title;
	String board_content;
	String boardDate;
	String board_cond;
	String board_search;
	Date   board_date;
	Integer	 uniqueId;
	
	/*justrfx-servlet.xml Ӽ ؼ DefaultMynvManager .	*/
	private MynvManager mynvManager;
	private MynfManager myInfoManager;
	

	public MynfManager getMyInfoManager() {
		return myInfoManager;
	}

	public void setMyInfoManager(MynfManager myInfoManager) {
		this.myInfoManager = myInfoManager;
	}

	public MynvManager getMynvManager() {
		return mynvManager;
	}

	public void setMynvManager(MynvManager mynvManager) {
		this.mynvManager = mynvManager;
	}

	private void GetRequestValue(HttpServletRequest request) { //ĶͰ ޱ.
		unique_id		= request.getParameter("unique_id");
		user_id			= request.getParameter("user_id");
		board_name		= request.getParameter("board_name");
		board_email		= request.getParameter("board_email");
		board_title		= request.getParameter("board_title");
		board_content	= request.getParameter("board_content");
		boardDate		= request.getParameter("boardDate");
		board_cond		= request.getParameter("board_cond");
		board_search	= request.getParameter("board_search");
		
		board_date		= String2Date(boardDate);
		uniqueId		= String2Integer(unique_id);
	}
	
	public void DoMenuProcess(HttpServletRequest request, HttpServletResponse response, String menuType, Map<String, Object> menu_info) {

		//ε   Ÿ ...
		if ( this.getServiceName() != JrServiceName.H_MYNV) {
			logger.info("G_MYNF     Դϴ.");
			return;
		}
		
		
		GetRequestValue(request);//  б
		
		
//		UsrAst usr = SessionSecurityManager.getUser(request); //   .
		

		switch(this.getMenuId()) {
		case MN04://ԽǸϺ.
			switch(this.getActivityName())
			{
				case DELETE:
					this.deleteBoard(request);
					menu_info.put("data", "  Խñ Ͽϴ.");
					menu_info.put("URL", "h_mynv.html?menuId=h04");
					break;
				case MODFORM:
					menu_info.put("boardEditForm", getBoardView(this.uniqueId));
					menu_info.put("fileList",mynvManager.getFileList(this.uniqueId));

					break;
				
				case EDIT:
					modifyBoard(request);
					
					menu_info.put("data", "  Խñ Ͽϴ.");
					menu_info.put("URL", "h_mynv.html?menuId=h04");
					break;
					
				case DETAIL:
					menu_info.put("boardView",  getBoardView(this.uniqueId));
					menu_info.put("fileList",mynvManager.getFileList(this.uniqueId));

					break;
				case LISTALL:
				default:
					menu_info.put("boardlistAll", getBoardAllList());
					break;
			}
			break;
		case MN05://Խǿ ۾.
			UsrAst usr = (UsrAst)mynvManager.getUsrastByUid(this.getThis_useruid(request));
			switch(this.getActivityName())
			{
			case ADD:
				menu_info.put("boardInsert",addBoardInsert(usr, request));
				menu_info.put("data", "Խñ ߰Ͽϴ.");
				menu_info.put("URL", "h_mynv.html?menuId=h04");
				break;
				
			case FORM:
			{
				menu_info.put("my_info",  usr);
				
				
				Random ran = new Random();
				int iRand = ran.nextInt();
				
				if(iRand < 0) {
					iRand = (-1)* iRand;
				}
				
				menu_info.put("unique_id",  String.valueOf(iRand));
			}	
				break;
				default:
			}			
			break;
		default:
			logger.info("G_MYNF     Դϴ.");
		}		
		
	}

	private Board getBoardView(Integer uniqueId)
	{
		mynvManager.addBoardCount(uniqueId); //ī.
		Board board = mynvManager.getBoardView(uniqueId);
		return board;
	}
	
	private List modifyBoard(HttpServletRequest request)
	{
		String[] file_f_name=new String[MAX_RECORD_QUAN];			Integer[] file_group_code=new Integer[MAX_RECORD_QUAN];
		String[] file_item_code=new String[MAX_RECORD_QUAN];			String[] file_size=new String[MAX_RECORD_QUAN];
		
	
		
		
		int file_length = 
			GetRequestValue_Fileinfo(request, file_f_name, file_group_code, file_item_code, file_size);

		// ÷ .
		if(file_length>0)
		{
			mynvManager.deleteFileByGroupCode(file_group_code[0].toString());
		}
		
		Board brd = mynvManager.getBoardView(this.uniqueId);
		
		if(this.board_title!=null)
			brd.setBoard_title(this.board_title);
		if(this.board_content!=null)
		brd.setBoard_content(this.board_content);
		brd.setBoard_date(this.board_date);
		if(this.board_email!=null)
			brd.setBoard_email(this.board_email);
		
		mynvManager.modifyBoard(brd);

		
		if( file_length > 0)
			this.addFileInsert(this.getThis_userid(request), file_length, file_f_name,file_group_code, file_item_code);


		List<String> list = new ArrayList<String>();
		list.add("Խù"); // list ѱ?
		list.add("Ϸ");
		return list;
	}

	private List getBoardAllList() //üԽù
	{
		//if(this.board_cond == null)			this.board_cond = "";
		if(this.board_search == null)		this.board_search = "";
		
		if(this.board_search.length() == 0)
		{
			logger.info("all search");
			return mynvManager.getBoardAllList();
		}
		else
		{
			logger.info("searchcond");
			Map<String, String> searchMap = new HashMap<String, String>();
			
			if(board_cond.equals("board_name"))
				searchMap.put("board_name","%" + board_search + "%");
			if(board_cond.equals("board_title"))
				searchMap.put("board_title","%" + board_search + "%");
			if(board_cond.equals("board_content"))
				searchMap.put("board_content","%" + board_search + "%");
			/*
			if(board_title.length()>0)
				searchMap.put("board_title", "%" + board_title + "%");
			if(board_content.length()>0)
				searchMap.put("board_content", "%" + board_content + "%");
			*/
			logger.info(searchMap.get("board_cond"));
			
			return mynvManager.getBoardAllList(searchMap);
		}
	}
	
	public int GetRequestValue_Fileinfo(HttpServletRequest request,
			String[] file_f_name,
			Integer[] file_group_code,
			String[] file_item_code,
			String[] file_f_size) {
		
		// Ķ.
		String[] file_group_code_temp = request.getParameterValues("file_group_code");
		String[] file_item_code_temp = request.getParameterValues("file_item_code");
		String[] file_f_name_temp = request.getParameterValues("file_f_name");
		String[] file_f_size_temp = request.getParameterValues("file_f_size");
		
		
		int ret_val = this.copyArrStr2Int(file_group_code_temp, file_group_code);
		this.copyArrStr2Str(file_item_code_temp, file_item_code);
		this.copyArrStr2Str(file_f_name_temp, file_f_name);
		this.copyArrStr2Str(file_f_size_temp, file_f_size);
		
		if(ret_val > 0){
			return ret_val;
		}
		return 0;
	}
	
	//ϱ.
	private void addFileInsert(String this_user_id, int file_length, String[] file_f_name,Integer[] file_group_code,String[] file_item_code){
		//parameter : ̵,ϰ, ϸ, ׷ڵ, ũڵ(=ڵ)
		mynvManager.addFileInsert(this_user_id, file_length, file_f_name, file_group_code, file_item_code);

	}
	
	
	private void deleteBoard(HttpServletRequest request) {
		
		Integer target = this.GetRequestInteger(request, "unique_id");
		
		mynvManager.deleteBoard(target);
	}
	
	private List addBoardInsert(UsrAst usr, HttpServletRequest request) //Խù
	{
		
		String[] file_f_name=new String[MAX_RECORD_QUAN];			Integer[] file_group_code=new Integer[MAX_RECORD_QUAN];
		String[] file_item_code=new String[MAX_RECORD_QUAN];			String[] file_size=new String[MAX_RECORD_QUAN];
		
		int file_length = 
			GetRequestValue_Fileinfo(request, file_f_name, file_group_code, file_item_code, file_size);

		
		
		Board brd = new Board();
		
		brd.setUnique_id(this.GetRequestInteger(request, "unique_id"));
		
		brd.setUser_id(usr.getUser_id()); //ٲ.
		brd.setBoard_name(usr.getUser_name()); //ٲ.
		brd.setBoard_email(usr.getEmail());
		brd.setBoard_title(this.board_title);
		brd.setBoard_content(this.board_content);
		brd.setBoard_date(this.board_date);
		
		
		if( file_length > 0)
			this.addFileInsert(this.getThis_userid(request), file_length, file_f_name,file_group_code, file_item_code);

		
		mynvManager.addInsert(this.getThis_userid(request), brd);
		List<String> list = new ArrayList<String>();
		list.add("Խù"); // list ѱ?
		list.add("Ϸ");
		return list;
	}
	
	/*
	 *  üũ ޼ҵ.
	 */
	@SuppressWarnings("unused")
	private void getLevelCheck(String level)
	{
		
	}
	
	
	public final void afterPropertiesSet() throws Exception {
		if (menuManager == null) throw new BeanCreationException("Must set menuManager on MynvManagerController");
		if (mynvManager == null) throw new BeanCreationException("Must set mynvManager on MynvManagerController");
	}




	public void DoPopupMenuProcess(HttpServletRequest request,HttpServletResponse response, String menuType, Map<String, Object> menu_info) {
		
	}


}
