package com.rfxsoft.justrfx.web.f_admn;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.BeanCreationException;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.web.bind.ServletRequestDataBinder;
import org.springframework.web.servlet.mvc.SimpleFormController;

import com.rfxsoft.justrfx.UserType;
import com.rfxsoft.justrfx.business.f_admn.AdmnManager;
import com.rfxsoft.justrfx.domain.RegisterdMasterCompany;
import com.rfxsoft.justrfx.web.security.SessionSecurityManager;
import com.rfxsoft.justrfx.web.tiles.MenuManager;

/**
 * @author k1park
 */
public abstract class AbstractAdminManagerFormController extends SimpleFormController implements InitializingBean {

	private AdmnManager adminManager;
	private MenuManager menuManager;
	protected RegisterdMasterCompany masterCompany;
	
	public String getThis_userid(HttpServletRequest request) {

		return SessionSecurityManager.getThis_userid(request);
	}

	public Integer getThis_useruid(HttpServletRequest request) {

		return SessionSecurityManager.getThis_useruid(request);
	}
	
	public Integer getThis_po_useruid(HttpServletRequest request) {
		
		return SessionSecurityManager.getThis_po_useruid(request);
	}

	public UserType getThis_user_type(HttpServletRequest request) {
		
		return SessionSecurityManager.getThis_user_type(request);
	}
	
	public String getThis_user_name(HttpServletRequest request) {
		
		return SessionSecurityManager.getThis_user_name(request);
	}
	public String getThis_wa_code(HttpServletRequest request) {
		
		return SessionSecurityManager.getThis_wa_code(request);
	}
	
	public RegisterdMasterCompany getMasterCompany() {
		return masterCompany;
	}

	public void setMasterCompany(RegisterdMasterCompany masterCompany) {
		this.masterCompany = masterCompany;
	}
	
	public MenuManager getMenuManager() {
		return menuManager;
	}

	public void setMenuManager(MenuManager menuManager) {
		this.menuManager = menuManager;
	}

	/* (non-Javadoc)
	 * @see org.springframework.beans.factory.InitializingBean#afterPropertiesSet()
	 */
	public final void afterPropertiesSet() throws Exception {
		if (adminManager == null) throw new BeanCreationException("Must set adminManager on AbstractAdminManagerFormController");
		if (menuManager == null) throw new BeanCreationException("Must set menuManager on AbstractAdminManagerFormController");
	}

	/* (non-Javadoc)
	 * @see org.springframework.web.servlet.mvc.BaseCommandController#initBinder(javax.servlet.http.HttpServletRequest, org.springframework.web.bind.ServletRequestDataBinder)
	 */
	protected void initBinder(HttpServletRequest request, ServletRequestDataBinder binder) throws Exception {
		super.initBinder(request, binder);
//		SimpleDateFormat dateFormat = new SimpleDateFormat("dd/MM/yyyy H:m:s");
//		dateFormat.setLenient(false);
//		binder.registerCustomEditor(Date.class, null, new CustomDateEditor(dateFormat, false));		
	}

	public AdmnManager getAdminManager() {
		return adminManager;
	}

	public void setAdminManager(AdmnManager adminManager) {
		this.adminManager = adminManager;
	}



}