package com.rfxsoft.justrfx.web.f_admn;

import java.util.HashMap;
import java.util.Map;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.validation.BindException;
import org.springframework.validation.Errors;
import org.springframework.web.bind.ServletRequestDataBinder;
import org.springframework.web.multipart.support.ByteArrayMultipartFileEditor;
import org.springframework.web.servlet.ModelAndView;

import com.rfxsoft.justrfx.MenuObjectType;
import com.rfxsoft.justrfx.UserType;
import com.rfxsoft.justrfx.domain.ComDst;
import com.rfxsoft.justrfx.domain.RegisterdMasterCompany;
import com.rfxsoft.justrfx.web.security.SessionSecurityManager;

/**
 * @author k1park
 *
 */
public class ComdstFormController extends AbstractAdminManagerFormController {
	
	public ComdstFormController() {
		super();
		setCommandClass(ComDst.class);
		setFormView("f02-edit");
		setSuccessView("index");
		setBindOnNewForm(true);
		setSessionForm(false);
		
	}

//	protected Object formBackingObject(HttpServletRequest request) throws Exception {
//		int unique_id = RequestUtils.getIntParameter(request, "dept_unique_id", 0);
//		ComDst comdst = new ComDst();
////		String dept_code = RequestUtils.getStringParameter(request, "dept_code");
////		String dept_name = RequestUtils.getStringParameter(request, "dept_name");
//		if(unique_id !=0) {
//			comdst.setDept_code(this.getAdminManager().getDeptById(unique_id).getDept_code());
//			comdst.setDept_name(this.getAdminManager().getDeptById(unique_id).getDept_name());
//		}	else {
//
//			Random ran = new Random();
//			int iRand = ran.nextInt();	
//			comdst.setDept_code(Integer.toHexString(iRand));
//		}
//
//		return comdst;
//	}
	
	
	protected Map referenceData(HttpServletRequest request, Object command, Errors errors) throws Exception {
		return super.referenceData(request, command, errors);
	}
	

	
	protected ModelAndView onSubmit( HttpServletRequest request,
			HttpServletResponse response, Object command,
			BindException errors) throws Exception {
		
		Map<String, Object> menu_info = new HashMap<String, Object>();

		RegisterdMasterCompany m_com = this.getMasterCompany();
		String companyDisplay = "";
		String companyLogo	  = "";
		
		if(m_com!=null) {
			companyDisplay  = this.getMasterCompany().getCompanyDisplay();
			companyLogo		= this.getMasterCompany().getCompanyLogo();
		}

		UserType myUserType = this.getThis_user_type(request);
		String	 myUserId	= this.getThis_userid(request);
		String	 myUserName	= this.getThis_user_name(request);

		//MenuObject target=null;
		this.getMenuManager().GetMenuDisplay("f-result", menu_info, myUserType,
				companyDisplay, myUserId, myUserName, companyLogo, MenuObjectType.MN_RESULT
				/*,	target*/);
		Vector<String> result = new Vector<String>();
		
		result.add("μ : ");
		
		ComDst comdst = (ComDst)command;
		
		String user_id = SessionSecurityManager.getThis_userid(request);
		
		this.getAdminManager().addDept(user_id, comdst.getDept_code(), comdst.getDept_name(), 0);

		
		result.add("μڵ:" + comdst.getDept_name() +"() ϵǾϴ.");
		menu_info.put("data", 	result);
		menu_info.put("URL", "f_admn.html?menuId=f30");		

		
		return new ModelAndView(getSuccessView(), menu_info );
	}
	
	
	protected void onBindAndValidate(HttpServletRequest request, Object command, BindException errors) throws Exception {
	}
	
	protected void initBinder(HttpServletRequest request, ServletRequestDataBinder binder) throws Exception {
		binder.registerCustomEditor(byte[].class, new ByteArrayMultipartFileEditor());
	}	
}
