/*
 * Created on 08-Nov-2004
 */
package com.rfxsoft.justrfx.web.security;

import java.util.HashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import com.rfxsoft.justrfx.UserType;
import com.rfxsoft.justrfx.business.f_admn.AdmnManager;
import com.rfxsoft.justrfx.domain.SystemInfo;
import com.rfxsoft.justrfx.domain.UsrAst;
import com.rfxsoft.justrfx.web.CustomBindingListener;


/**
 * @author k1park
 */
public class SessionSecurityManager {

	private static final String USER_SESSION_KEY_USER_ID = "justrfx_user_2005_user_id";
	private static final String USER_SESSION_KEY_USER_UID = "justrfx_user_2005_user_uid";
	private static final String USER_SESSION_KEY_PO_USER_UID = "justrfx_user_2005_po_user_uid";
	private static final String USER_SESSION_KEY_PO_USER_TYPE = "justrfx_user_2005_user_type";
	private static final String USER_SESSION_KEY_PO_USER_NAME = "justrfx_user_2005_user_name";
	private static final String USER_SESSION_KEY_WA_CODE = "justrfx_user_2005_wa_code";
	private static final String USER_SESSION_KEY_COMPANY_CODE = "justrfx_user_2005_company_code";
	private static final String USER_SESSION_KEY_COMPANY_UID = "justrfx_user_2005_company_uid";
	private static final String USER_SESSION_KEY_COMBST_UID = "justrfx_user_2005_combst_uid";
	private static final String USER_SESSION_KEY_SYSTEM_INFO = "justrfx_system_info";
	private static final String USER_SESSION_MAP_TYPE = "justrfx_user_map_type";
	
	private static final String ENV_SESSION_KEY_CUR_PROJECT_UID = "justrfx_env_2006_cur_project_id";
	private static final String ENV_SESSION_KEY_CUR_ASSY_UID    = "justrfx_env_2006_cur_assy_id";

	public static void setCurProjectId(HttpServletRequest request, String project_uid) {
		HttpSession session = request.getSession(false);
		if(session!=null) {
			session.setAttribute(ENV_SESSION_KEY_CUR_PROJECT_UID, project_uid);
		}
	}
	
	public static void setCurAssyId(HttpServletRequest request, String assy_uid) {
		HttpSession session = request.getSession(false);
		if(session!=null) {
			session.setAttribute(ENV_SESSION_KEY_CUR_ASSY_UID, assy_uid);
		}
	}	

	/**
	 * Sets the usrast attribute to the sesssion
	 * 
	 * @param request The current request
	 * @param usrast The usrast to set. Cannot be null
	 */
	public static void setUser(HttpServletRequest request, UsrAst usrast, SystemInfo systemInfo,
			AdmnManager adminManager, String project_uid, String assy_uid) {
//		getSession(true):ο  
		if (usrast == null) throw new NullPointerException("User cannot be null");
		
		HttpSession session = request.getSession(true);
		String remoteAddr = request.getRemoteAddr();
		Map<String, UserType> typeMap = new HashMap<String, UserType>();
		
		session.setAttribute(USER_SESSION_KEY_USER_ID, usrast.getUser_id());
		session.setAttribute(USER_SESSION_KEY_USER_UID, usrast.getUnique_id());
		session.setAttribute(USER_SESSION_KEY_PO_USER_UID, usrast.getPo_user_uid());
		session.setAttribute(USER_SESSION_KEY_PO_USER_TYPE, usrast.getUserTypeEnum());
		session.setAttribute(USER_SESSION_KEY_PO_USER_NAME, usrast.getUser_name());
		session.setAttribute(USER_SESSION_KEY_WA_CODE, usrast.getWa_code());
		session.setAttribute(USER_SESSION_KEY_COMPANY_CODE, usrast.getCompany_code());
		session.setAttribute(USER_SESSION_KEY_COMPANY_UID, usrast.getUid_comast());
		session.setAttribute(USER_SESSION_KEY_COMBST_UID, usrast.getUid_combst());
		session.setAttribute(USER_SESSION_KEY_SYSTEM_INFO, systemInfo);
		session.setAttribute(USER_SESSION_MAP_TYPE, typeMap.put("user_type",usrast.getUserTypeEnum()));
	
		session.setAttribute(ENV_SESSION_KEY_CUR_PROJECT_UID, project_uid);
		session.setAttribute(ENV_SESSION_KEY_CUR_ASSY_UID, assy_uid);

		//login üũ
		session.setAttribute("bindings.listener",
				new CustomBindingListener( remoteAddr, adminManager, usrast.getUnique_id()));

	
	
	}
	/**
	 * Gets the User from the session
	 * 
	 * @param request The current request
	 * @return The User object
	 *   user_unique_id, po_user_uid, user_id ׻ Ǵ.(
	
	public static UsrAst getUser(HttpServletRequest request) {
		//getSession(false):  
		
		HttpSession session = request.getSession(false);
		if(session==null)
			return null;
		
		UsrAst usrast = (UsrAst)session.getAttribute(USER_SESSION_KEY);

		return usrast;
	}
	 */

	/**
	 * Indicates whether a usrast is logged in
	 * 
	 * @param request The request
	 * @return T/F
	 */
	public static boolean isUserLoggedIn(HttpServletRequest request) {
		
		HttpSession session = request.getSession(false);
		if(session==null)	return false;
		
		return session.getAttribute(USER_SESSION_KEY_USER_ID) != null;
	}

	public static String getThis_userid(HttpServletRequest request) {
		
		HttpSession session = request.getSession(false);
		if(session==null)
			return null;
		
		return (String)session.getAttribute(USER_SESSION_KEY_USER_ID);
	}

	public static Integer getThis_useruid(HttpServletRequest request) {
		HttpSession session = request.getSession(false);
		if(session==null)
			return null;
		
		return (Integer)session.getAttribute(USER_SESSION_KEY_USER_UID);
	}
	public static Integer getThis_po_useruid(HttpServletRequest request) {
		HttpSession session = request.getSession(false);
		if(session==null)
			return null;
		
		return (Integer)session.getAttribute(USER_SESSION_KEY_PO_USER_UID);
	}

	public static UserType getThis_user_type(HttpServletRequest request) {
		HttpSession session = request.getSession(false);
		if(session==null)
			return null;
		
		return (UserType)session.getAttribute(USER_SESSION_KEY_PO_USER_TYPE);
	}
	
	public static String getThis_user_name(HttpServletRequest request) {
		HttpSession session = request.getSession(false);
		if(session==null)
			return null;
		
		return (String)session.getAttribute(USER_SESSION_KEY_PO_USER_NAME);
	}
	public static String getThis_wa_code(HttpServletRequest request) {
		HttpSession session = request.getSession(false);
		if(session==null)
			return null;
		
		return (String)session.getAttribute(USER_SESSION_KEY_WA_CODE);
	}
	
	public static String getThis_company_code(HttpServletRequest request) {
		HttpSession session = request.getSession(false);
		if(session==null)
			return null;
		
		return (String)session.getAttribute(USER_SESSION_KEY_COMPANY_CODE);
	}
	public static Integer getThis_combst_uid(HttpServletRequest request) {
		HttpSession session = request.getSession(false);
		if(session==null)
			return null;
		
		return (Integer)session.getAttribute(USER_SESSION_KEY_COMBST_UID);
	}
	
	public static String getThis_company_uid(HttpServletRequest request) {
		HttpSession session = request.getSession(false);
		if(session==null)
			return null;
		
		return (String)session.getAttribute(USER_SESSION_KEY_COMPANY_UID);
	}

	public static SystemInfo getSystemInfo(HttpServletRequest request) {
		
		HttpSession session = request.getSession(false);
		if(session==null)
			return null;
		
		return (SystemInfo)session.getAttribute(USER_SESSION_KEY_SYSTEM_INFO);
	}
	
	public static Integer getCurrentProject(HttpServletRequest request) {
		HttpSession session = request.getSession(false);
		if(session==null)
			return null;
		
		String pj_uid = (String)session.getAttribute(ENV_SESSION_KEY_CUR_PROJECT_UID);
		
		if(pj_uid==null || pj_uid.length()==0)
			return new Integer(-1);

		return Integer.parseInt(pj_uid);
		
	}
	
	public static Integer getCurrentAssy(HttpServletRequest request) {
		HttpSession session = request.getSession(false);
		if(session==null)
			return null;
		
		String assy_uid = (String)session.getAttribute(ENV_SESSION_KEY_CUR_ASSY_UID);
		
		if(assy_uid==null || assy_uid.length()==0)
			return new Integer(-1);
		
		return Integer.parseInt(assy_uid);
	}
}
