package com.rfxsoft.justrfx.web.tiles;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.BeanCreationException;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.web.servlet.mvc.AbstractController;

import com.rfxsoft.justrfx.UserType;
import com.rfxsoft.justrfx.business.f_admn.AdmnManager;
import com.rfxsoft.justrfx.domain.RegisterdMasterCompany;
import com.rfxsoft.justrfx.web.security.SessionSecurityManager;


/**
 * @author k1park
 *
 */
public abstract class AbstractMenuController extends AbstractController implements /*Controller,*/ InitializingBean  {

	private MenuManager menuManager;
	private AdmnManager adminManager;
	protected RegisterdMasterCompany masterCompany;
	
	
	public AdmnManager getAdminManager() {
		return adminManager;
	}

	public void setAdminManager(AdmnManager adminManager) {
		this.adminManager = adminManager;
	}

	public String getThis_userid(HttpServletRequest request) {

		return SessionSecurityManager.getThis_userid(request);
	}

	public Integer getThis_useruid(HttpServletRequest request) {

		return SessionSecurityManager.getThis_useruid(request);
	}
	
	public Integer getThis_po_useruid(HttpServletRequest request) {
		
		return SessionSecurityManager.getThis_po_useruid(request);
	}

	public UserType getThis_user_type(HttpServletRequest request) {
		
		return SessionSecurityManager.getThis_user_type(request);
	}
	
	public String getThis_user_name(HttpServletRequest request) {
		
		return SessionSecurityManager.getThis_user_name(request);
	}
	public String getThis_wa_code(HttpServletRequest request) {
		
		return SessionSecurityManager.getThis_wa_code(request);
	}
	
	public final void afterPropertiesSet() throws Exception {
			if (menuManager == null) throw new BeanCreationException("Must set menuManager on AbstractMenuController");
	}

	public MenuManager getMenuManager() {
		return menuManager;
	}

	public void setMenuManager(MenuManager menuManager) {
		this.menuManager = menuManager;
	}

	public RegisterdMasterCompany getMasterCompany() {
		return masterCompany; 
	}

	public void setMasterCompany(RegisterdMasterCompany masterCompany) {
		this.masterCompany = masterCompany;
	}

	

}
