package com.rfxsoft.justrfx.web.tiles;


import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.Vector;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.rfxsoft.justrfx.MenuObjectType;
import com.rfxsoft.justrfx.Pair;
import com.rfxsoft.justrfx.Pairimpl;
import com.rfxsoft.justrfx.UserType;
import com.rfxsoft.justrfx.domain.command.JrServiceName;
import com.rfxsoft.justrfx.domain.command.MenuId;
import com.rfxsoft.justrfx.domain.menu.MenuObject;
import com.rfxsoft.justrfx.domain.menu.MenuStructure;


public class MenuManager {

	private List<MenuStructure> menuStructureList;
	private MenuStructure hiddenMenuStructure;


	public final Log logger = LogFactory.getLog( getClass() );

	
	MenuStructure GetMenuObjectByName(String name) {	//String name  ex)b01...
		
		for(Iterator i=menuStructureList.iterator(); i.hasNext();) {
			MenuStructure structure = (MenuStructure)i.next();
			if(structure.IsRightObjectByName(name) )
				return structure;
		}
		return null;
	}
	
	String getFullHtmlMenu(String groupName, String menuType) {
		String fullLine = "";
		for(Iterator i=menuStructureList.iterator(); i.hasNext();) {
			MenuStructure structure = (MenuStructure)i.next();
			fullLine = fullLine + structure.getPoweredGroupsHtml(groupName, menuType);
		}
		return fullLine;
	}
	
	String getMenuPositionHtml() {
		String strMenuPos ="";
		
		for(Iterator i=menuStructureList.iterator(); i.hasNext();) {
			MenuStructure structure = (MenuStructure)i.next();
			
			String menuPosition = structure.getMenuPositionStr();
			
			strMenuPos = strMenuPos+ structure.getKey() + "_pos = " + menuPosition + ";\n";
			strMenuPos = strMenuPos+ structure.getGroupMenuPosition();
		}
		
		return strMenuPos;
	}
	
	
	Vector getKeyList() {
		Vector<Pair> key_list = new Vector<Pair>();
		
		for(Iterator i=menuStructureList.iterator(); i.hasNext();) {
			MenuStructure structure = (MenuStructure)i.next();
			Pair pair = new Pairimpl( structure.getKey(), structure.getMenuTitle());
			key_list.add(pair);
		}
		return key_list;
	}
	
	private void CreateMenuGroups( UserType callerType) {

		for(Iterator i=menuStructureList.iterator(); i.hasNext();) {
			MenuStructure structure = (MenuStructure)i.next();
			structure.createMenuGroups(callerType);
		}
	}
	
	@SuppressWarnings("unused")
	private void DestroyMenuGroups() {
		for(Iterator i=menuStructureList.iterator(); i.hasNext();) {
			MenuStructure structure = (MenuStructure)i.next();
			structure.destroyMenuGroups();
		}
	}

	public MenuStructure GetSelectedParent(JrServiceName service) {

		String menu_name = service.toString();

		return GetMenuObjectByName(menu_name);
		
	}

	public MenuStructure GetSelectedParent(String menu_name) {

		if(menu_name==null)
			return null;

		return GetMenuObjectByName(menu_name);
		
	}

	
	//======================Setter ========================

	public List getMenuStructureList() {
		return menuStructureList;
	}

	public void setMenuStructureList(List<MenuStructure> menuStructureList) {
		this.menuStructureList = menuStructureList;
	}
	
	public void addMenuMap(MenuStructure menuStructure) {
		menuStructureList.add( menuStructure);
	}
	public void setMenuAdmn(MenuStructure structure) {
		addMenuMap(structure);
	}

	public void setMenuMtrl(MenuStructure structure) {
		addMenuMap(structure);
	}
	public void setMenuMynf(MenuStructure structure) {
		addMenuMap(structure);
	}
	public void setMenuMynv(MenuStructure structure) {
		addMenuMap(structure);
	}
	public void setMenuPrch(MenuStructure structure) {
		addMenuMap(structure);
	}

	public void setMenuPrjt(MenuStructure structure) {
		addMenuMap(structure);
	}
	public void setMenuPtnr(MenuStructure structure) {
		addMenuMap(structure);
	}
	public void setMenuRtng(MenuStructure structure) {
		addMenuMap(structure);
	}

	public void setMenuRfml(MenuStructure structure) {
		addMenuMap(structure);
	}
	
	public void setMenuHidden(MenuStructure structure) {
		hiddenMenuStructure = structure;
	}

	
	public void setOptionUserType(MenuStructure structure) {
		addMenuMap(structure);
	}

	//================================ end-of-Setter ==============

	protected void 	SetDefault(String menuType, Map<String, Object> menu_info) {

		if (menuType.compareToIgnoreCase("f02") ==0) {
			
			Random ran = new Random();
			int iRand = ran.nextInt();
			
			menu_info.put("dept_code", Integer.toHexString(iRand).toUpperCase());
			menu_info.put("dept_name", "");
		}
	}
	
	public boolean checkAuthority(MenuId menuId, JrServiceName service, String menuType) {
		
		//Ҷ  üũ ʴ´.--> Ϸ ö޼ҵ尡 Ƿ  ʿ
		return true;
		/*

		if(menuType==null || menuType.length()<3)
			return false;
		String searchKey = "";
		
		if( menuType.length() == 3 )
			searchKey = menuType;
		else
			searchKey = menuType.substring(0,3);
		
		MenuStructure selectedMenu = this. GetSelectedParent(searchKey);
		if(selectedMenu == null)
			return false;
		
		return selectedMenu.checkAuthority(menuId,service );
		*/
		
	}
	
	public void GetChildMenu(String structureName, UserType userType)
	{
		
	}

	public void GetMenuDisplay(String menuType, Map<String, Object> menu_info, UserType myType, String comDisplay,
			String userId, String userName, String comLogo, MenuObjectType mnuObjectType/*, MenuObject target*/) {

		menu_info.put("loginned_user_id", userId);
		menu_info.put("loginned_user_name", userName);
		menu_info.put("com_logo",	comLogo);//ȸΰ 
		menu_info.put("loginned_user_type", myType.toString());

		SimpleDateFormat dateFormatDetail 	= new SimpleDateFormat("yyyy,M,d,H,m,s,S");
		Date today =  new Date();
		menu_info.put("server_date_full", dateFormatDetail.format(today));
		String checkStr = menuType;
		String firstChar = menuType.substring(0,1);;
		
		JrServiceName service = JrServiceName.B_RTNG;
		if(firstChar.compareToIgnoreCase("a")==0 )
			service = JrServiceName.A_RFML;
		else if (firstChar.compareToIgnoreCase("b")==0 )
			service = JrServiceName.B_RTNG;
		else if (firstChar.compareToIgnoreCase("c")==0 )
			service = JrServiceName.C_PRJT;
		else if (firstChar.compareToIgnoreCase("d")==0 )
			service = JrServiceName.D_MTRL;
		else if (firstChar.compareToIgnoreCase("e")==0 )
			service = JrServiceName.E_PTNR;
		else if (firstChar.compareToIgnoreCase("f")==0 )
			service = JrServiceName.F_ADMN;
		else if (firstChar.compareToIgnoreCase("g")==0 )
			service = JrServiceName.G_MYNF;
		else if (firstChar.compareToIgnoreCase("h")==0 )
			service = JrServiceName.H_MYNV;
		else if (firstChar.compareToIgnoreCase("j")==0 )
			service = JrServiceName.J_PRCH;
		else if (firstChar.compareToIgnoreCase("k")==0 )
			service = JrServiceName.K_GATE;
		else if (firstChar.compareToIgnoreCase("y")==0 )
			service = JrServiceName.Y_AUDT;
		else if (firstChar.compareToIgnoreCase("z")==0 )
			service = JrServiceName.G_MYNF;
		

		if(mnuObjectType ==  MenuObjectType.MN_OBJECT && menuType!=null && menuType.length() > 3 )
			checkStr = menuType.substring(0,3);
		
		if(menuType!=null && mnuObjectType == MenuObjectType.MN_RESULT) {
			checkStr = menuType.substring(0,1);
		}
		
		String serviceTitle = "";
		String menuTitle = "";
		String groupTitle = "";
		String displayTitle = "";
		String menuPosition = "5";
		String menuGroupKey = "";
		String groupKey	= "NOT_FOUNDED";
		String menuPath = "";
		
		//ִ ޴׷ 
		CreateMenuGroups(myType);
		MenuStructure selectedMenu = this. GetSelectedParent(service);
		if(selectedMenu != null) {

			MenuObject menuObject = selectedMenu.GetMenuObjectByName(checkStr);
			serviceTitle = selectedMenu.getMenuTitle();
			menuTitle = selectedMenu.getMenuTitle();
			groupTitle = selectedMenu.getMenuGroupTitle(checkStr);
			displayTitle = selectedMenu.getMenuDisplayTitle(checkStr);
			menuPosition = selectedMenu.getMenuPositionStr();
			menuGroupKey = selectedMenu.getKey();
			groupKey	= selectedMenu.getGroupName(checkStr);
			menu_info.put("menulist", 		selectedMenu.getPoweredGroups());
			//menu_info.put("menu_full_info", selectedMenu.getPoweredGroupsHtml());
			if(groupKey!=null) {
				menu_info.put("menu_full_info", getFullHtmlMenu(groupKey, menuType));
			}
			menu_info.put("position_full_info", getMenuPositionHtml());
			menu_info.put("title_menu_list", this.getKeyList());
			
			// ִ üũ
			String hasWritePower="N";
			if(menuObject!=null) {
				if(menuObject.isWritePower(myType) == true) {
					hasWritePower = "Y";
				}
			}
			menu_info.put("hasWritePower", hasWritePower);
			
			menuPath = serviceTitle;
			if(groupTitle!=null)
				menuPath = menuPath + " > " + groupTitle;
			if(displayTitle!=null)
				menuPath = menuPath + " > " + displayTitle;
			
			//target = selectedMenu.getMenuFirst(myType);

		}
		
		String bodyPath = "main/";
		if( comDisplay!=null && comDisplay.length()>0)
			bodyPath = bodyPath + comDisplay + "/" + checkStr.substring(0,1) + "/" + menuType + ".jsp";
		else
			bodyPath = bodyPath +  checkStr.substring(0,1) + "/" + menuType + ".jsp";

		menu_info.put("menuType",	 	checkStr);	//Toolbar Menu Ѵ.
		menu_info.put("menubody",		bodyPath);

		///--------------------------------------////
		
		if( displayTitle != null)	menu_info.put("displaytitle", 	displayTitle);
		if( groupKey != null)		menu_info.put("menuGroup", 		groupKey);
		if( groupTitle != null)		menu_info.put("menugrouptitle", 	groupTitle);
		if( menuGroupKey != null)	menu_info.put("menuGroupKey", menuGroupKey);
		if( menuPosition != null)	menu_info.put("menuPosition", menuPosition);
		if( menuTitle != null)		menu_info.put("menutitle", 		menuTitle);
		if( menuPath != null)		menu_info.put("menuPath", 		menuPath);
		if( menuType != null)		menu_info.put("thisPage", 		menuType);
		///---------------------------------------////
		
		
		SetDefault(menuType, menu_info);


		// Ѹ޴ ÷ͷ....
		//DestroyMenuGroups(); :ʿ.createMenuGroups  clear ȣѴ.

	}


	public MenuStructure getHiddenMenuStructure() {
		return hiddenMenuStructure;
	}


	public void setHiddenMenuStructure(MenuStructure hiddenMenuStructure) {
		this.hiddenMenuStructure = hiddenMenuStructure;
	}



}
