package com.rfxsoft.justrfx.web.tiles;

import java.util.HashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.BeanCreationException;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.AbstractController;

import com.rfxsoft.justrfx.domain.RegisterdMasterCompany;
import com.rfxsoft.justrfx.web.security.SessionSecurityManager;


/**
 * @author janm
 */
public class ToolbarTileController extends AbstractController implements /*Controller,*/ InitializingBean{
	protected RegisterdMasterCompany masterCompany;

	public void afterPropertiesSet() throws Exception {
		if (masterCompany == null) throw new BeanCreationException("Must set masterCompany on ToolbarTileController");

		
	}

	/* (non-Javadoc)
	 * @see org.springframework.web.servlet.mvc.Controller#handleRequestInternal(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	public ModelAndView handleRequestInternal(HttpServletRequest request, HttpServletResponse response) throws Exception {
		if (SessionSecurityManager.isUserLoggedIn(request)) {
			
			Map<String, Object> menu_info = new HashMap<String, Object>();
			
			String toolbar = "toolbar-in";
			
			String companyDisplay  = masterCompany.getCompanyDisplay();
			if(companyDisplay!=null && companyDisplay.length()>0)
				toolbar = toolbar + companyDisplay;
			
			
			menu_info.put("com_tool",	 toolbar + ".jsp");
			
			return new ModelAndView("tile-toolbar-in", menu_info);
		} else {
			return new ModelAndView("tile-toolbar-off");
		}
	}

	public RegisterdMasterCompany getMasterCompany() {
		return masterCompany;
	}


	public void setMasterCompany(RegisterdMasterCompany masterCompany) {
		this.masterCompany = masterCompany;
	}

}
