
package com.rfxsoft.justrfx.web.views;

import java.awt.Color;
import java.io.IOException;
import java.net.MalformedURLException;
import java.util.Date;
import java.util.Random;

import com.lowagie.text.BadElementException;
import com.lowagie.text.Chunk;
import com.lowagie.text.Document;
import com.lowagie.text.DocumentException;
import com.lowagie.text.Element;
import com.lowagie.text.ExceptionConverter;
import com.lowagie.text.Font;
import com.lowagie.text.Image;
import com.lowagie.text.Paragraph;
import com.lowagie.text.Phrase;
import com.lowagie.text.Rectangle;
import com.lowagie.text.pdf.Barcode;
import com.lowagie.text.pdf.BarcodeEAN;
import com.lowagie.text.pdf.BarcodePDF417;
import com.lowagie.text.pdf.BaseFont;
import com.lowagie.text.pdf.PdfContentByte;
import com.lowagie.text.pdf.PdfPCell;
import com.lowagie.text.pdf.PdfPTable;
import com.lowagie.text.pdf.PdfPageEventHelper;
import com.lowagie.text.pdf.PdfSpotColor;
import com.lowagie.text.pdf.PdfWriter;
import com.lowagie.text.pdf.SpotColor;
/**
 * Demonstrates the use of templates to add Watermarks and Pagenumbers.
 */
public class RfxPdfDocuLayout extends PdfPageEventHelper {
	
	int intProgress;

    public Image headerImage;
    public PdfPTable table;
    public BaseFont helv;
   
    public Document doc;
    public PdfWriter writer;
    
    BaseFont bfKorea;
    Font FontKorea28;
    Font FontKorea12;
    Font FontKorea12b;
    Font FontKorea16;
    Font FontKorea10;
    Font FontKorea10s;
    Font FontKorea10b;
    Font FontKorea8;
    Font FontKorea8s;
    Font FixedEng8;
    
    Color clrBlack;
    Color clrWhite;
    Color clrCBack;
    Color clrDisp;
    Color clrPurple;
	
    Image bar2Dimg;
    Image logo;
	
    String strBarCode;	
	String strCode;
	final String strZero = "0";
	String strRfxNo;
	String attWho;
	String strTitle;
	
	PdfContentByte cb;

    PdfPTable hTable;
    PdfPTable gTable;
	PdfPCell cell;
	
	float global_width[] = {1.0f};
	
	private void CreateHeaderTable() {
		
		float[] widths = 			{0.40f, 0.20f, 0.40f};
		float[] inh_widths = 		{1.0f};
		float[] inh3_widths = 	{0.25f, 0.75f};
		
		hTable = new PdfPTable(widths);
		hTable.getDefaultCell().setBorder(Rectangle.NO_BORDER);
		
		PdfPTable inh1 = new PdfPTable(inh_widths);
		inh1.getDefaultCell().setBorder(Rectangle.NO_BORDER);
		inh1.addCell(new Phrase(new Chunk(logo, 0, 0)));
		inh1.addCell(new Phrase(new Chunk(attWho, FontKorea12)));
		
		PdfPTable inh2 = new PdfPTable(inh_widths);
		inh2.getDefaultCell().setBorder(Rectangle.NO_BORDER);
		Chunk chTitle = new Chunk(strTitle, FontKorea28);
		chTitle.setBackground(clrDisp);
		chTitle.setUnderline(clrPurple, 2.0f, 0.0f, 13.0f, 0.0f, PdfContentByte.LINE_CAP_BUTT);
		chTitle.setTextRenderMode(PdfContentByte.TEXT_RENDER_MODE_FILL_STROKE, 0.4f, clrBlack);
		
		Chunk chRfxno = new Chunk(strRfxNo, FontKorea12);
		
		inh2.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);
		inh2.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		inh2.addCell(new Phrase(chTitle) );
		inh2.getDefaultCell().setVerticalAlignment(Element.ALIGN_TOP);
		inh2.addCell(new Phrase(chRfxno) );

		
		PdfPTable inh3 = new PdfPTable(inh3_widths);
		inh3.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);
		inh3.getDefaultCell().setBackgroundColor(clrCBack);
		inh3.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		inh3.addCell(new Phrase("Ϲȣ", FontKorea10b) );
		inh3.getDefaultCell().setBackgroundColor(clrWhite);
		inh3.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
		inh3.addCell(new Phrase("104-81-58502", FontKorea10) );

		inh3.getDefaultCell().setBackgroundColor(clrCBack);
		inh3.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		inh3.addCell(new Phrase("ȣ", FontKorea10b) );
		inh3.getDefaultCell().setBackgroundColor(clrWhite);
		inh3.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
		//inh3.addCell(new Phrase("()̸ڸ", FontKorea10) );
		inh3.addCell(new Phrase("()", FontKorea10) );
		
		inh3.getDefaultCell().setBackgroundColor(clrCBack);
		inh3.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		inh3.addCell(new Phrase("ּ", FontKorea10b) );
		inh3.getDefaultCell().setBackgroundColor(clrWhite);
		inh3.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
		//inh3.addCell(new Phrase(" ߱ 湫3 60-1 ص 15", FontKorea10) );
		inh3.addCell(new Phrase("⵵ ȭ  ͷ 536-5", FontKorea10) );
		
		inh3.getDefaultCell().setBackgroundColor(clrCBack);
		inh3.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		inh3.addCell(new Phrase("ǥڸ", FontKorea10b) );
		inh3.getDefaultCell().setBackgroundColor(clrWhite);
		inh3.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
		//inh3.addCell(new Phrase("", FontKorea10) );
		inh3.addCell(new Phrase("", FontKorea10) );
		

		hTable.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);
		hTable.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
		hTable.addCell( inh1 );
		hTable.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		hTable.addCell( inh2 );
		hTable.getDefaultCell().setHorizontalAlignment(Element.ALIGN_RIGHT);
		hTable.addCell( inh3 );
	
		float global_width[] = {1.0f};

		gTable = new PdfPTable(global_width);
		gTable.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);
		gTable.setHorizontalAlignment(Element.ALIGN_CENTER);
   
		cb = writer.getDirectContent();
		BarcodeEAN codeEAN = new BarcodeEAN();
		codeEAN.setCodeType(Barcode.EAN13);
		codeEAN.setCode(strBarCode);
		Image imageEAN = codeEAN.createImageWithBarcode(cb, null, null);

		AddHeaderTable(gTable, imageEAN);
	
	}
	
	private void ResizeImage(Image attach) {
		float  height = attach.plainHeight();
		float  width = attach.plainWidth();
		
		if( height/width > 0.5f)
			attach.scalePercent(100*60/height);
		else
			attach.scalePercent(100*120/width);
		
	}
	
	
	private void AddHeaderTable(PdfPTable gTable, Image imageEAN) {
			
		float cus_ad_width[] = {0.1f, 0.4f, 0.1f, 0.4f};
		

		PdfPTable table = new PdfPTable(cus_ad_width);
		
		table.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);

		table.getDefaultCell().setBackgroundColor(clrCBack);
		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		table.addCell(new Phrase("  ", FontKorea10b) );
		table.getDefaultCell().setBackgroundColor(clrWhite);
		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
		table.addCell(new Phrase("LST\n(ȣ: 343567)", FontKorea10) );
		
		table.getDefaultCell().setBackgroundColor(clrCBack);
		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		table.addCell(new Phrase("", FontKorea10b) );
		table.getDefaultCell().setBackgroundColor(clrWhite);
		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
		table.addCell(new Phrase("ȫ浿/\nhonggildong@autowin.com", FontKorea10) );

		table.getDefaultCell().setBackgroundColor(clrCBack);
		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		table.addCell(new Phrase("", FontKorea10b) );
		table.getDefaultCell().setBackgroundColor(clrWhite);
		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
		table.addCell(new Phrase("迵 (T:02-3708-0979)\nyjkim@osung.co.kr", FontKorea10) );
		
		table.getDefaultCell().setBackgroundColor(clrCBack);
		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		table.addCell(new Phrase("ó", FontKorea10b) );
		table.getDefaultCell().setBackgroundColor(clrWhite);
		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
		table.addCell(new Phrase("(T)02-3708-5979 (F)02-3708-5990\n(H)017-322-6789", FontKorea10) );
		
		table.getDefaultCell().setBackgroundColor(clrCBack);
		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		table.addCell(new Phrase("ּ", FontKorea10b) );
		table.getDefaultCell().setBackgroundColor(clrWhite);
		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
		table.addCell(new Phrase("(ּ)⵵ ȭ ¾ ݿ 104 30-1\n(ǰּ)⵵ ȭ ¾ ݿ 104 â15  ", FontKorea10) );

		table.getDefaultCell().setBackgroundColor(clrCBack);
		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
		table.addCell(new Phrase("s.y.s.t.e.m\ni.n.f.o", FontKorea8) );
		table.getDefaultCell().setBackgroundColor(clrWhite);
		
        table.addCell(new Phrase(new Chunk(imageEAN, 0, 0)));
		gTable.addCell( table );
	}
	
    
    
    
    
    public RfxPdfDocuLayout(PdfWriter writer, Document doc, int progress, String strCode) {
		super();
		// TODO Auto-generated constructor stub
		this.doc = doc;
		this.writer = writer;
		this.intProgress = progress;
		
		strBarCode = "100";//1 ū 
		attWho = ": 迵 (T:02-3708-0979)\nyjkim@osung.co.kr";
		strTitle = "  ";
		
	
		strRfxNo="No:FQ";

		strRfxNo = strRfxNo + strCode.toUpperCase();

		String strCodeFormatted= strCode;
		while(strCodeFormatted.length()<10)
			strCodeFormatted = strCodeFormatted.concat(strCode);
		
		//880 ڵ
		strBarCode = strBarCode + strCodeFormatted;
	
		SetupDocument(writer, doc);
	}

	/**
     * Generates a document with a header containing Page x of y and with a Watermark on every page.
     * @param args no arguments needed
     */
    public  void DoWork() {
        try {

        	this.writer.setPageEvent(this);

    		table = new PdfPTable(global_width);

    		cell = new PdfPCell(new Phrase("- - -   - - -", FontKorea12b) );
    		cell.setHorizontalAlignment(Element.ALIGN_CENTER);
    		cell.setVerticalAlignment(Element.ALIGN_MIDDLE);
    		cell.setBackgroundColor(clrCBack);
    		table.addCell(cell );
    		
    		cell = new PdfPCell(new Paragraph("ͻ ¿  帳ϴ.\nƷ  ûϽ  帳ϴ.", FontKorea10));
    		cell.setHorizontalAlignment(Element.ALIGN_LEFT);
    		cell.setVerticalAlignment(Element.ALIGN_MIDDLE);
    		cell.setBackgroundColor(clrWhite);
    		table.addCell(cell );
    		
    		table.setTotalWidth(594-20);
    		table.setLockedWidth(true);
    		doc.add(table);
    		
    		float wide_width[] = {0.2f, 0.8f};
    		table = new PdfPTable(wide_width);
    		//table.getDefaultCell().setBorder(Rectangle.UNDEFINED);
    		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    		table.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);
    		table.getDefaultCell().setBackgroundColor(clrWhite);

    		float in_table_width[] = {0.42f, 0.58f};
    		float cell_height = 22f;
    		PdfPTable in_table = new PdfPTable(in_table_width);
    		in_table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    		in_table.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);
    		in_table.getDefaultCell().setBackgroundColor(clrCBack);

    		cell = new PdfPCell(new Paragraph("", FontKorea10));
    		cell.setMinimumHeight(cell_height);
    		cell.setHorizontalAlignment(Element.ALIGN_CENTER);
    		cell.setVerticalAlignment(Element.ALIGN_MIDDLE);
    		cell.setBackgroundColor(clrCBack);
    		in_table.addCell(cell );
    		in_table.getDefaultCell().setBackgroundColor(clrWhite);
    		in_table.getDefaultCell().setBorder(Rectangle.NO_BORDER);
    		in_table.addCell(new Phrase("2005/12/05", FontKorea10) );
    		in_table.getDefaultCell().setBorder(Rectangle.BOX);

    		cell = new PdfPCell(new Paragraph("ȿⰣ", FontKorea10));
    		cell.setMinimumHeight(cell_height);
    		cell.setHorizontalAlignment(Element.ALIGN_CENTER);
    		cell.setVerticalAlignment(Element.ALIGN_MIDDLE);
    		cell.setBackgroundColor(clrCBack);
    		in_table.addCell(cell );
    		in_table.getDefaultCell().setBackgroundColor(clrWhite);
    		in_table.getDefaultCell().setBorder(Rectangle.BOTTOM|Rectangle.TOP);
    		in_table.addCell(new Phrase("2005/12/15", FontKorea10) );

    		cell = new PdfPCell(new Paragraph("", FontKorea10));
    		cell.setMinimumHeight(cell_height);
    		cell.setHorizontalAlignment(Element.ALIGN_CENTER);
    		cell.setVerticalAlignment(Element.ALIGN_MIDDLE);
    		cell.setBackgroundColor(clrCBack);
    		in_table.addCell(cell );
    		in_table.getDefaultCell().setBackgroundColor(clrWhite);
    		in_table.getDefaultCell().setBorder(Rectangle.BOTTOM);
    		in_table.addCell(new Phrase("90 ", FontKorea10) );

    		cell = new PdfPCell(new Paragraph("ǰ", FontKorea10));
    		cell.setMinimumHeight(cell_height);
    		cell.setHorizontalAlignment(Element.ALIGN_CENTER);
    		cell.setVerticalAlignment(Element.ALIGN_MIDDLE);
    		cell.setBackgroundColor(clrCBack);
    		in_table.addCell(cell );
    		in_table.getDefaultCell().setBackgroundColor(clrWhite);
    		in_table.getDefaultCell().setBorder(Rectangle.NO_BORDER);
    		in_table.addCell(new Phrase("ǥ \nֹ 30", FontKorea8) );

    		table.addCell( in_table );

    		float content_width[] = {		0.10f,
    												0.24f,
    												0.30f,
    												0.15f,
    												0.06f,
    												0.15f		};
    		
    		in_table = new PdfPTable(content_width);
    		in_table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    		in_table.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);
    		in_table.getDefaultCell().setBackgroundColor(clrDisp);
    		
    		in_table.addCell(new Phrase("ǰڵ", FontKorea10) );
    		in_table.addCell(new Phrase("ǥ ǰ", FontKorea10) );
    		in_table.addCell(new Phrase("԰/", FontKorea10) );
    		in_table.addCell(new Phrase("ܰ()", FontKorea10) );
    		in_table.addCell(new Phrase("", FontKorea10) );
    		in_table.addCell(new Phrase("հ()", FontKorea10) );
    		
    		in_table.getDefaultCell().setBackgroundColor(clrWhite);
    		
    		cell = new PdfPCell(new Paragraph("80808080", FontKorea8));
    		cell.setMinimumHeight(35f);
    		cell.setHorizontalAlignment(Element.ALIGN_CENTER);
    		cell.setVerticalAlignment(Element.ALIGN_MIDDLE);
    		
    		in_table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    		in_table.addCell(cell );
    		in_table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
    		in_table.addCell(new Phrase("Inspection System (RGB 3 ) 9", FontKorea8) );
    		in_table.addCell(new Phrase("SEI500G9  ", FontKorea8) );
    		in_table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_RIGHT);
    		in_table.addCell(new Phrase("40,000,000", FontKorea8) );
    		in_table.addCell(new Phrase("2ST", FontKorea8) );
    		in_table.addCell(new Phrase("80,000,000", FontKorea8s) );
    		
    		cell = new PdfPCell(new Phrase("D/C 10% 밡", FontKorea10) );
    		cell.setHorizontalAlignment(Element.ALIGN_RIGHT);
    		cell.setBackgroundColor(clrWhite);
    		cell.setColspan(4);
    		in_table.addCell(cell );
    		cell = new PdfPCell(new Phrase("72,000,000", FontKorea10b) );
    		cell.setHorizontalAlignment(Element.ALIGN_RIGHT);
    		cell.setBackgroundColor(clrWhite);
    		cell.setColspan(2);
    		in_table.addCell(cell );


    		cell = new PdfPCell(new Phrase("ΰ(10%)", FontKorea10) );
    		cell.setHorizontalAlignment(Element.ALIGN_RIGHT);
    		cell.setBackgroundColor(clrWhite);
    		cell.setColspan(4);
    		in_table.addCell(cell );
    		cell = new PdfPCell(new Phrase("7,200,000", FontKorea10b) );
    		cell.setHorizontalAlignment(Element.ALIGN_RIGHT);
    		cell.setBackgroundColor(clrWhite);
    		cell.setColspan(2);
    		in_table.addCell(cell );

    		
    		cell = new PdfPCell(new Phrase("ΰ԰", FontKorea10) );
    		cell.setHorizontalAlignment(Element.ALIGN_RIGHT);
    		cell.setBackgroundColor(clrWhite);
    		cell.setColspan(4);
    		in_table.addCell(cell );
    		cell = new PdfPCell(new Phrase("79,200,000", FontKorea10b) );
    		cell.setHorizontalAlignment(Element.ALIGN_RIGHT);
    		cell.setBackgroundColor(clrWhite);
    		cell.setColspan(2);
    		in_table.addCell(cell );
    		
    		table.addCell( in_table );
    		
    		table.setTotalWidth(594-20);
    		table.setLockedWidth(true);
    		doc.add(table);

    		float detail_width[] = {		0.04f,
    											0.09f,
    											0.12f,
    											0.28f,
    											0.08f,
    											0.10f,
    											0.05f,
    											0.05f,
    											0.10f,
    											0.09f};

    		table = new PdfPTable(detail_width);
    		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    		table.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);
    		table.getDefaultCell().setBackgroundColor(clrCBack);
    		cell = new PdfPCell(new Phrase("- - -   - - -", FontKorea12b) );
    		cell.setHorizontalAlignment(Element.ALIGN_CENTER);
    		cell.setBackgroundColor(clrCBack);
    		cell.setColspan(10);
    		table.addCell(cell );
    		
    		
    		table.getDefaultCell().setBackgroundColor(clrDisp);
    		
    		table.addCell(new Phrase("No", FontKorea8) );
    		table.addCell(new Phrase("ǰڵ", FontKorea10) );
    		table.addCell(new Phrase("ǰ", FontKorea10) );
    		table.addCell(new Phrase("𵨸;԰;", FontKorea10) );
    		table.addCell(new Phrase("", FontKorea10) );
    		table.addCell(new Phrase("ܰ", FontKorea10) );
    		table.addCell(new Phrase("", FontKorea10) );
    		table.addCell(new Phrase("", FontKorea10) );
    		table.addCell(new Phrase("հ", FontKorea10) );
    		table.addCell(new Phrase(";Ÿ", FontKorea10) );
    		
    		for(int i=0; i<200; i++) {
    			Random ran = new Random();
    			Integer iRand = ran.nextInt();
    			strCode =Integer.toHexString(iRand.intValue()).toUpperCase();
    			while(strCode.length()<8)
    				strCode = strZero.concat(strCode);
    			
    			String strNo = Integer.toString(i+1);
    			while(strNo.length()<3)
    				strNo = strZero.concat(strNo);
    			
    			
    			table.getDefaultCell().setBackgroundColor(clrWhite);
    			table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    			table.addCell(new Phrase(strNo, FixedEng8) );
    			table.addCell(new Phrase(strCode, FixedEng8) );
    			table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
    			table.addCell(new Phrase("", FontKorea8) );
    			table.addCell(new Phrase("CM20-100-FNG-30RW24", FontKorea8) );
    			table.addCell(new Phrase("THK", FontKorea8) );
    			table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_RIGHT);
    			table.addCell(new Phrase("2,000,000", FontKorea8) );
    			table.addCell(new Phrase("2", FontKorea8) );
    			table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    			table.addCell(new Phrase("PC", FontKorea8) );
    			table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_RIGHT);
    			table.addCell(new Phrase("4,000,000", FontKorea8) );
    			table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_LEFT);
    			if(i%5==0)
    				table.addCell(new Phrase("ֹ 60", FontKorea8) );
    			else
    				table.addCell(new Phrase("", FontKorea8) );
    		}
    		
    		cell = new PdfPCell(new Phrase("   ", FontKorea10) );
    		cell.setHorizontalAlignment(Element.ALIGN_RIGHT);
    		cell.setVerticalAlignment(Element.ALIGN_MIDDLE);
    		cell.setBackgroundColor(clrDisp);
    		cell.setColspan(6);
    		table.addCell(cell );
    		
    		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_RIGHT);
    		table.addCell(new Phrase("20", FontKorea8) );
    		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    		table.addCell(new Phrase("-", FontKorea8) );
    		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_RIGHT);
    		table.addCell(new Phrase("40,000,000", FontKorea8) );
    		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    		table.addCell(new Phrase("-", FontKorea8) );

    		
    		table.setTotalWidth(594-20);
    		table.setLockedWidth(true);
    		doc.add(table);
    		
    		
    		
    		float image_width[] = {		0.25f,
    											0.25f,
    											0.25f,
    											0.25f};

    		table = new PdfPTable(image_width);
    		table.getDefaultCell().setHorizontalAlignment(Element.ALIGN_CENTER);
    		table.getDefaultCell().setVerticalAlignment(Element.ALIGN_MIDDLE);
    		table.getDefaultCell().setBackgroundColor(clrCBack);
    		cell = new PdfPCell(new Phrase("- - - ǰ ̹ - - -", FontKorea12b) );
    		cell.setHorizontalAlignment(Element.ALIGN_CENTER);
    		cell.setBackgroundColor(clrCBack);
    		cell.setColspan(4);
    		table.addCell(cell );
    		
    		
    		table.getDefaultCell().setBackgroundColor(clrDisp);
    		
    		table.addCell(new Phrase("001:", FontKorea8) );
    		table.addCell(new Phrase("002:Ź", FontKorea8) );
    		table.addCell(new Phrase("003:", FontKorea8) );
    		table.addCell(new Phrase("004:ûұ", FontKorea8) );

            Image attatch = Image.getInstance("C:/REPOSIT/IMAGE/att1.bmp");
            ResizeImage(attatch);
            table.addCell(new Phrase(new Chunk(attatch, 0, 0)));
            attatch = Image.getInstance("C:/REPOSIT/IMAGE/att2.bmp");
            ResizeImage(attatch); 
            table.addCell(new Phrase(new Chunk(attatch, 0, 0)));
            attatch = Image.getInstance("C:/REPOSIT/IMAGE/att3.bmp");
            ResizeImage(attatch);
            table.addCell(new Phrase(new Chunk(attatch, 0, 0)));
            attatch = Image.getInstance("C:/REPOSIT/IMAGE/att4.bmp");
            ResizeImage(attatch);
            table.addCell(new Phrase(new Chunk(attatch, 0, 0)));
            attatch = Image.getInstance("C:/REPOSIT/IMAGE/att5.bmp");

    		
    		table.addCell(new Phrase("005:ڷ", FontKorea8) );
    		table.addCell(new Phrase("006:", FontKorea8) );
    		table.addCell(new Phrase("007:", FontKorea8) );
    		table.addCell(new Phrase("s.y.s.t.e.m  i.n.f.o", FontKorea8) );
    		
            attatch = Image.getInstance("C:/REPOSIT/IMAGE/att5.bmp");
            ResizeImage(attatch);
            table.addCell(new Phrase(new Chunk(attatch, 0, 0)));
            attatch = Image.getInstance("C:/REPOSIT/IMAGE/att6.bmp");
            ResizeImage(attatch);
            table.addCell(new Phrase(new Chunk(attatch, 0, 0)));
            attatch = Image.getInstance("C:/REPOSIT/IMAGE/att7.bmp");
            ResizeImage(attatch);
            table.addCell(new Phrase(new Chunk(attatch, 0, 0)));
            attatch = Image.getInstance("C:/REPOSIT/IMAGE/att8.bmp");
            ResizeImage(attatch);
            
            table.addCell(new Phrase(new Chunk(bar2Dimg, 0, 0)));
            
    		table.setTotalWidth(594-20);
    		table.setLockedWidth(true);
    		doc.add(table);
    		
    		table.setSpacingAfter(15f);
    		
    		Chunk chEnd = new Chunk("-----   -----", FontKorea12);
    		chEnd.setBackground(clrDisp);
           Paragraph end = new Paragraph();
            end.setAlignment(PdfContentByte.ALIGN_CENTER);
            end.add(chEnd);
    		doc.add(end);

    		cb.beginText();
    		cb.setFontAndSize(bfKorea, 8);

    		String text = "This is End:";
     		cb.showTextAligned(PdfContentByte.ALIGN_RIGHT, text, 594-10-30, 5, 0);
    		cb.endText();
    		
    		intProgress = writer.getPageNumber();

        }
        catch ( Exception e ) {
            e.printStackTrace();
        }
    }
    
    /**
     * @see com.lowagie.text.pdf.PdfPageEventHelper#onOpenDocument(com.lowagie.text.pdf.PdfWriter, com.lowagie.text.Document)
     */
    public void onOpenDocument(PdfWriter writer, Document document) {
        try {

        }
        catch(Exception e) {
            throw new ExceptionConverter(e);
        }
    }    
    
    public void SetupDocument(PdfWriter writer, Document document) {
        try {
    		String pdfEncoding="UniKS-UCS2-H";
    		String fontName="HYGoThic-Medium";

            PdfSpotColor spc_font = new PdfSpotColor("PANTONE 147", 0.9f, new Color(0, 0, 0));
        
            
            bfKorea = BaseFont.createFont(fontName, pdfEncoding,  BaseFont.NOT_EMBEDDED);
            BaseFont bf = BaseFont.createFont("Helvetica", "winansi", false, false, null, null);
            bf.setForceWidthsOutput(true);
            
            FontKorea28 = new Font(bfKorea, 28, Font.NORMAL, new SpotColor(spc_font));
            FontKorea12 = new Font(bfKorea, 12, Font.NORMAL, new SpotColor(spc_font));
            FontKorea12b = new Font(bfKorea, 12, Font.BOLD, new SpotColor(spc_font));
            FontKorea16 = new Font(bfKorea, 16, Font.NORMAL, new SpotColor(spc_font));
            FontKorea10 = new Font(bfKorea, 10, Font.NORMAL, new SpotColor(spc_font));
            FontKorea10s = new Font(bfKorea, 10, Font.STRIKETHRU, new SpotColor(spc_font));
            FontKorea10b = new Font(bfKorea, 10, Font.BOLD, new SpotColor(spc_font));
            FontKorea8 = new Font(bfKorea, 8, Font.NORMAL, new SpotColor(spc_font));
            FontKorea8s = new Font(bfKorea, 8, Font.STRIKETHRU, new SpotColor(spc_font));
            FixedEng8 = new Font(bf, 8, Font.NORMAL, new SpotColor(spc_font));
            
            clrBlack = new Color(0x00, 0x00, 0x00);
            clrWhite = new Color(255, 255, 255);
            clrCBack = new Color(0xCC, 0x99, 0xFF);
            clrDisp = new Color(0xF5, 0xEB, 0xFF);
            clrPurple = new Color(0x80, 0x00, 0x80);
            
            cb = writer.getDirectContent();
            
    		
   		
    		//2 ڵ ִũ 1,800 byte.
            BarcodePDF417 pdf417 = new BarcodePDF417();
            String text = "It was the best of times, it was the worst of times, " + 
                "it was the age of wisdom, it was the age of foolishness, " +
                "it was the epoch of belief, it was the epoch of incredulity, " +
                "it was the season of Light, it was the season of Darkness, " +
                "it was the spring of hope, it was the winter of despair, " +
                "we had everything before us, we had nothing before us, " +
                "we were all going direct to Heaven, we were all going direct " +
                "the other way - in short, the period was so far like the present " +
                "period, that some of its noisiest authorities insisted on its " +
                "being received, for good or for evil, in the superlative degree " +
                "of comparison only.";
            pdf417.setText(text);
            bar2Dimg = pdf417.getImage();
            bar2Dimg.scalePercent(50, 50 * pdf417.getYHeight());
            bar2Dimg.setAlignment(Image.LEFT);
            bar2Dimg.setAbsolutePosition(0, 0);
            
            try {
    			logo = Image.getInstance("C:/REPOSIT/IMAGE/com_logo.gif");
    		} catch (BadElementException e2) {
    			// TODO Auto-generated catch block
    			e2.printStackTrace();
    		} catch (MalformedURLException e2) {
    			// TODO Auto-generated catch block
    			e2.printStackTrace();
    		} catch (IOException e2) {
    			// TODO Auto-generated catch block
    			e2.printStackTrace();
    		}
            float height = logo.plainHeight();
            logo.scalePercent(100*38/height);
            logo.setAlignment(Image.LEFT);

            CreateHeaderTable();

           
            onStartPage( writer,  document);
        }
        catch(Exception e) {
            throw new ExceptionConverter(e);
        }
    }    
    
 
    public void onEndPage(PdfWriter writer, Document document) {
        PdfContentByte cb = writer.getDirectContent();
        cb.saveState();
        
		hTable.setTotalWidth(document.right() - document.left());
		hTable.setLockedWidth(true);
		hTable.writeSelectedRows(0, -1, 5, 831, cb);
		hTable.setHeaderRows(4);
        
		//		ܺ 輱
		cb.moveTo(10, 841-85);
		cb.lineTo(594-10, 841-85);
		cb.stroke();
		cb.saveState();
		
		gTable.setTotalWidth(document.right() - document.left() -10);
		gTable.setLockedWidth(true);
		gTable.writeSelectedRows(0, -1, 10, 831-90+9, cb);

				
		//
		Date today = new Date();
		cb.beginText();
		cb.setFontAndSize(bfKorea, 8);
		//cb.setRGBColorFill(0x80, 0x00, 0x80);
		String text = "Printed:";
		text = text + today.toString() + ", Powered by justRFX(tm) / www.justrfx.com";
	  
		cb.showTextAligned(PdfContentByte.ALIGN_LEFT, text, 10, 5, 0);
		text = "Page " + writer.getPageNumber();
 		cb.showTextAligned(PdfContentByte.ALIGN_RIGHT, text, 594-10, 5, 0);
		cb.endText();
		
		//ϴܺ 輱
		cb.setLineDash(3, 3, 0);
		//cb.setColorStroke(clrDisp);
		
		cb.setLineWidth(0.8f);
		cb.moveTo(10, 20);
		cb.lineTo(594-10, 20);
		cb.stroke();


//        cb.beginText();
//        cb.setFontAndSize(bfKorea, 12);
//        //cb.setRGBColorFill(0x80, 0x00, 0x80);
//        cb.showTextAligned(PdfContentByte.ALIGN_CENTER, strRfxNo.toUpperCase(), 594/2, 841-65, 0);
//        cb.endText();
        
		Image sign=null;
		try {
			sign = Image.getInstance("C:/REPOSIT/IMAGE/com_sign.gif");
		} catch (BadElementException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		byte gradient[] = new byte[256];
		float height = sign.plainHeight();
		sign.scalePercent(100*56/height);
		sign.setAlignment(Image.RIGHT);
		sign.setAbsolutePosition(594-56, 841-115);
        for (int k = 0; k < 256; ++k)
            gradient[k] = (byte)200;//(byte)k;
		Image smask=null;
		try {
			smask = Image.getInstance(60, 1, 1, 8, gradient);
		} catch (BadElementException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			smask.makeMask();
		} catch (DocumentException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			sign.setImageMask(smask);
		} catch (DocumentException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
       
		try {
			cb.addImage(sign);
		} catch (DocumentException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

        cb.saveState();
        cb.restoreState();
        intProgress++;
    }
    
    /**
     * @see com.lowagie.text.pdf.PdfPageEventHelper#onStartPage(com.lowagie.text.pdf.PdfWriter, com.lowagie.text.Document)
     */
    public void onStartPage(PdfWriter writer, Document document) {

    	if( doc.isOpen() == false)
        	return;
        PdfContentByte cb = writer.getDirectContentUnder();
        cb.saveState();
	
    }
    
    /**
     * @see com.lowagie.text.pdf.PdfPageEventHelper#onCloseDocument(com.lowagie.text.pdf.PdfWriter, com.lowagie.text.Document)
     */
    public void onCloseDocument(PdfWriter writer, Document document) {

    }
}

